//
// Copyright 2020 FoxyUtils ehf. All rights reserved.
//
// This is a commercial product and requires a license to operate.
// A trial license can be obtained at https://unidoc.io
//
// DO NOT EDIT: generated by unitwist Go source code obfuscator.
//
// Use of this source code is governed by the UniDoc End User License Agreement
// terms that can be accessed at https://unidoc.io/eula/

package redactor ;import (_gg "errors";_g "fmt";_d "github.com/unidoc/unipdf/v3/common";_dg "github.com/unidoc/unipdf/v3/contentstream";_da "github.com/unidoc/unipdf/v3/core";_f "github.com/unidoc/unipdf/v3/creator";_fd "github.com/unidoc/unipdf/v3/extractor";
_fa "github.com/unidoc/unipdf/v3/model";_cf "io";_c "regexp";_ggc "sort";_e "strings";);

// New instantiates a Redactor object with given PdfReader and `regex` pattern.
func New (reader *_fa .PdfReader ,opts *RedactionOptions ,rectProps *RectangleProps )*Redactor {if rectProps ==nil {rectProps =RedactRectanglePropsNew ();};return &Redactor {_eca :reader ,_bfde :opts ,_bgeg :_f .New (),_ebc :rectProps };};func _ccdc (_ffg *_fd .TextMarkArray )(_da .PdfObject ,int ){var _fg _da .PdfObject ;
_fe :=-1;for _bfd ,_gee :=range _ffg .Elements (){_fg =_gee .DirectObject ;_fe =_bfd ;if _fg !=nil {break ;};};return _fg ,_fe ;};func _aef (_ecg ,_abd string )[]int {if len (_abd )==0{return nil ;};var _geab []int ;for _dfd :=0;_dfd < len (_ecg );{_fff :=_e .Index (_ecg [_dfd :],_abd );
if _fff < 0{return _geab ;};_geab =append (_geab ,_dfd +_fff );_dfd +=_fff +len (_abd );};return _geab ;};func _bcc (_gec ,_ceg ,_aeg float64 )float64 {_aeg =_aeg /100;_gfg :=(-1000*_gec )/(_ceg *_aeg );return _gfg ;};func _fga (_gfff string ,_eea *_fa .PdfFont )[]byte {_eaf ,_gade :=_eea .StringToCharcodeBytes (_gfff );
if _gade !=0{_d .Log .Debug ("\u0057\u0041\u0052\u004e\u003a\u0020\u0073\u006fm\u0065\u0020\u0072un\u0065\u0073\u0020\u0063\u006f\u0075l\u0064\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0065\u006e\u0063\u006f\u0064\u0065d\u002e\u000a\u0009\u0025\u0073\u0020\u002d\u003e \u0025\u0076",_gfff ,_eaf );
};return _eaf ;};type replacement struct{_a string ;_fad float64 ;_ad int ;};func _fbae (_ddf *_fa .PdfFont ,_aaa _fd .TextMark )float64 {_agg :=0.001;_dgd :=_aaa .Th /100;if _ddf .Subtype ()=="\u0054\u0079\u0070e\u0033"{_agg =1;};_abc ,_ccb :=_ddf .GetRuneMetrics (' ');
if !_ccb {_abc ,_ccb =_ddf .GetCharMetrics (32);};if !_ccb {_abc ,_ =_fa .DefaultFont ().GetRuneMetrics (' ');};_dgda :=_agg *((_abc .Wx *_aaa .FontSize +_aaa .Tc +_aaa .Tw )/_dgd );return _dgda ;};

// RectangleProps defines properties of the redaction rectangle to be drawn.
type RectangleProps struct{FillColor _f .Color ;BorderWidth float64 ;FillOpacity float64 ;};type placeHolders struct{_ggcc []int ;_cfg string ;_fab float64 ;};func _gde (_afb *_fd .TextMarkArray )*_fa .PdfFont {_ ,_efag :=_ccdc (_afb );_cbe :=_afb .Elements ()[_efag ];
_gga :=_cbe .Font ;return _gga ;};func _fec (_cccd _da .PdfObject ,_agfe *_fa .PdfFont )(string ,error ){_cgab ,_ebe :=_da .GetStringBytes (_cccd );if !_ebe {return "",_da .ErrTypeError ;};_fgb :=_agfe .BytesToCharcodes (_cgab );_cbg ,_dfba ,_ade :=_agfe .CharcodesToStrings (_fgb );
if _ade > 0{_d .Log .Debug ("\u0072\u0065nd\u0065\u0072\u0054e\u0078\u0074\u003a\u0020num\u0043ha\u0072\u0073\u003d\u0025\u0064\u0020\u006eum\u004d\u0069\u0073\u0073\u0065\u0073\u003d%\u0064",_dfba ,_ade );};_gafe :=_e .Join (_cbg ,"");return _gafe ,nil ;
};

// RedactionTerm holds the regexp pattern and the replacement string for the redaction process.
type RedactionTerm struct{Pattern *_c .Regexp ;};

// RedactRectanglePropsNew return a new pointer to a default RectangleProps object.
func RedactRectanglePropsNew ()*RectangleProps {return &RectangleProps {FillColor :_f .ColorBlack ,BorderWidth :0.0,FillOpacity :1.0};};

// WriteToFile writes the redacted document to file specified by `outputPath`.
func (_caeb *Redactor )WriteToFile (outputPath string )error {if _dacf :=_caeb ._bgeg .WriteToFile (outputPath );_dacf !=nil {return _g .Errorf ("\u0066\u0061\u0069l\u0065\u0064\u0020\u0074o\u0020\u0077\u0072\u0069\u0074\u0065\u0020t\u0068\u0065\u0020\u006f\u0075\u0074\u0070\u0075\u0074\u0020\u0066\u0069\u006c\u0065");
};return nil ;};func _dcbd (_bgcc *_fd .TextMarkArray ,_cddd int ,_fed int )int {_gbae :=_bgcc .Elements ();_dda :=_cddd -1;_edbf :=_cddd +1;_cecf :=-1;if _dda >=0{_efba :=_gbae [_dda ];_cefb :=_efba .ObjString ;_ded :=len (_cefb );_ggffg :=_efba .Index ;
if _ggffg +1< _ded {_cecf =_dda ;return _cecf ;};};if _edbf < len (_gbae ){_eddc :=_gbae [_edbf ];_dgdg :=_eddc .ObjString ;if _dgdg [0]!=_eddc .Text {_cecf =_edbf ;return _cecf ;};};return _cecf ;};func _fag (_baa string ,_agff []localSpanMarks )([]placeHolders ,error ){_gaa :="";
_adc :=[]placeHolders {};for _adg ,_dbeg :=range _agff {_abbe :=_dbeg ._aga ;_eac :=_dbeg ._cgag ;_fcb :=_gada (_abbe );_ccbe ,_dcc :=_bgd (_abbe );if _dcc !=nil {return nil ,_dcc ;};if _fcb !=_gaa {var _cdf []int ;if _adg ==0&&_eac !=_fcb {_cbf :=_e .Index (_baa ,_fcb );
_cdf =[]int {_cbf };}else if _adg ==len (_agff )-1{_cbba :=_e .LastIndex (_baa ,_fcb );_cdf =[]int {_cbba };}else {_cdf =_aef (_baa ,_fcb );};_acb :=placeHolders {_ggcc :_cdf ,_cfg :_fcb ,_fab :_ccbe };_adc =append (_adc ,_acb );};_gaa =_fcb ;};return _adc ,nil ;
};func _cg (_ef *_dg .ContentStreamOperations ,_ca string ,_bb int )error {_fac :=_dg .ContentStreamOperations {};var _cad _dg .ContentStreamOperation ;for _gb ,_ge :=range *_ef {if _gb ==_bb {if _ca =="\u0027"{_gf :=_dg .ContentStreamOperation {Operand :"\u0054\u002a"};
_fac =append (_fac ,&_gf );_cad .Params =_ge .Params ;_cad .Operand ="\u0054\u006a";_fac =append (_fac ,&_cad );}else if _ca =="\u0022"{_bgb :=_ge .Params [:2];Tc ,Tw :=_bgb [0],_bgb [1];_cff :=_dg .ContentStreamOperation {Params :[]_da .PdfObject {Tc },Operand :"\u0054\u0063"};
_fac =append (_fac ,&_cff );_cff =_dg .ContentStreamOperation {Params :[]_da .PdfObject {Tw },Operand :"\u0054\u0077"};_fac =append (_fac ,&_cff );_cad .Params =[]_da .PdfObject {_ge .Params [2]};_cad .Operand ="\u0054\u006a";_fac =append (_fac ,&_cad );
};};_fac =append (_fac ,_ge );};*_ef =_fac ;return nil ;};func _bbc (_cae *_fd .TextMarkArray )int {_ff :=0;_cec :=_cae .Elements ();if _cec [0].Text =="\u0020"{_ff ++;};if _cec [_cae .Len ()-1].Text =="\u0020"{_ff ++;};return _ff ;};func _gada (_ggg *_fd .TextMarkArray )string {_ecd :="";
for _ ,_fbe :=range _ggg .Elements (){_ecd +=_fbe .Text ;};return _ecd ;};func (_gac *Redactor )redactPage (_bbe *_dg .ContentStreamOperations ,_bce *_fa .PdfPageResources )([]matchedBBox ,*_dg .ContentStreamOperations ,error ){_cbef ,_gaca :=_fd .NewFromContents (_bbe .String (),_bce );
if _gaca !=nil {return nil ,nil ,_gaca ;};_ceec ,_ ,_ ,_gaca :=_cbef .ExtractPageText ();_bbe =_ceec .GetContentStreamOps ();if _gaca !=nil {return nil ,nil ,_gaca ;};_bceb :=_ceec .Marks ();_gcaf :=_ceec .Text ();_dbba :=[]matchedBBox {};_cbga :=make (map[_da .PdfObject ][]localSpanMarks );
for _ ,_dfa :=range _gac ._bfde .Terms {_bba ,_adee :=_egg (_dfa );if _adee !=nil {return nil ,nil ,_adee ;};_bdef ,_adee :=_bba .match (_gcaf );if _adee !=nil {return nil ,nil ,_adee ;};_bdcg :=_fbea (_bdef );for _ggff ,_bee :=range _bdcg {_ccab :=[]matchedBBox {};
for _ ,_gbb :=range _bee {_fbb ,_bfbc ,_gafd :=_dbed (_gbb ,_bceb ,_ggff );if _gafd !=nil {return nil ,nil ,_gafd ;};_cadd :=_ggd (_fbb );for _dace ,_eebg :=range _cadd {_baec :=localSpanMarks {_aga :_eebg ,_adcf :_dace ,_cgag :_ggff };_dacg ,_ :=_ccdc (_eebg );
if _ecdf ,_abdd :=_cbga [_dacg ];_abdd {_cbga [_dacg ]=append (_ecdf ,_baec );}else {_cbga [_dacg ]=[]localSpanMarks {_baec };};};_ccab =append (_ccab ,_bfbc );};_dbba =append (_dbba ,_ccab ...);};};_gaca =_ce (_bbe ,_cbga );if _gaca !=nil {return nil ,nil ,_gaca ;
};return _dbba ,_bbe ,nil ;};

// Redact executes the redact operation on a pdf file and updates the content streams of all pages of the file.
func (_abg *Redactor )Redact ()error {_afde ,_gbac :=_abg ._eca .GetNumPages ();if _gbac !=nil {return _g .Errorf ("\u0066\u0061\u0069\u006c\u0065\u0064 \u0074\u006f\u0020\u0067\u0065\u0074\u0020\u0074\u0068\u0065\u0020\u006e\u0075m\u0062\u0065\u0072\u0020\u006f\u0066\u0020P\u0061\u0067\u0065\u0073");
};_bffc :=_abg ._ebc .FillColor ;_efb :=_abg ._ebc .BorderWidth ;_edd :=_abg ._ebc .FillOpacity ;for _ddce :=1;_ddce <=_afde ;_ddce ++{_bbgf ,_fgd :=_abg ._eca .GetPage (_ddce );if _fgd !=nil {return _fgd ;};_gab ,_fgd :=_fd .New (_bbgf );if _fgd !=nil {return _fgd ;
};_acce ,_ ,_ ,_fgd :=_gab .ExtractPageText ();if _fgd !=nil {return _fgd ;};_dfda :=_acce .GetContentStreamOps ();_dbbg ,_dcb ,_fgd :=_abg .redactPage (_dfda ,_bbgf .Resources );if _dcb ==nil {_d .Log .Info ("N\u006f\u0020\u006d\u0061\u0074\u0063\u0068\u0020\u0066\u006f\u0075\u006e\u0064\u0020\u0066\u006f\u0072\u0020t\u0068\u0065\u0020\u0070\u0072\u006f\u0076\u0069\u0064\u0065d \u0070\u0061\u0074t\u0061r\u006e\u002e");
_dcb =_dfda ;};_bbgf .SetContentStreams ([]string {_dcb .String ()},_da .NewFlateEncoder ());if _fgd !=nil {return _fgd ;};_aaae ,_fgd :=_bbgf .GetMediaBox ();if _fgd !=nil {return _fgd ;};if _bbgf .MediaBox ==nil {_bbgf .MediaBox =_aaae ;};if _ggbb :=_abg ._bgeg .AddPage (_bbgf );
_ggbb !=nil {return _ggbb ;};_baeg :=_aaae .Ury ;for _ ,_gaea :=range _dbbg {_geeb :=_gaea ._bfa ;_gbg :=_abg ._bgeg .NewRectangle (_geeb .Llx ,_baeg -_geeb .Lly ,_geeb .Urx -_geeb .Llx ,-(_geeb .Ury -_geeb .Lly ));_gbg .SetFillColor (_bffc );_gbg .SetBorderWidth (_efb );
_gbg .SetFillOpacity (_edd );if _ffd :=_abg ._bgeg .Draw (_gbg );_ffd !=nil {return nil ;};};};_abg ._bgeg .SetOutlineTree (_abg ._eca .GetOutlineTree ());return nil ;};type matchedBBox struct{_bfa _fa .PdfRectangle ;_fdd string ;};func (_acceg *regexMatcher )match (_agb string )([]*matchedIndex ,error ){_aad :=_acceg ._ddg .Pattern ;
if _aad ==nil {return nil ,_gg .New ("\u006e\u006f\u0020\u0070at\u0074\u0065\u0072\u006e\u0020\u0063\u006f\u006d\u0070\u0069\u006c\u0065\u0064");};var (_fbd =_aad .FindAllStringIndex (_agb ,-1);_fgbb []*matchedIndex ;);for _ ,_bef :=range _fbd {_fgbb =append (_fgbb ,&matchedIndex {_ggb :_bef [0],_fbgb :_bef [1],_adb :_agb [_bef [0]:_bef [1]]});
};return _fgbb ,nil ;};type matchedIndex struct{_ggb int ;_fbgb int ;_adb string ;};func _gaga (_bdc *_dg .ContentStreamOperation ,_aff _da .PdfObject ,_gdc []localSpanMarks )error {var _abb *_da .PdfObjectArray ;_fda ,_cag :=_gagd (_gdc );if len (_cag )==1{_ddb :=_cag [0];
_dcf :=_fda [_ddb ];if len (_dcf )==1{_eeg :=_dcf [0];_bggb :=_eeg ._aga ;_eb :=_gde (_bggb );_gdb ,_gca :=_fec (_aff ,_eb );if _gca !=nil {return _gca ;};_adf ,_gca :=_gcae (_eeg ,_bggb ,_eb ,_gdb ,_ddb );if _gca !=nil {return _gca ;};_abb =_da .MakeArray (_adf ...);
}else {_beb :=_dcf [0]._aga ;_eafg :=_gde (_beb );_bde ,_bbg :=_fec (_aff ,_eafg );if _bbg !=nil {return _bbg ;};_bfb ,_bbg :=_fag (_bde ,_dcf );if _bbg !=nil {return _bbg ;};_bcg :=_cbfd (_bfb );_cdd :=_agd (_bde ,_bcg ,_eafg );_abb =_da .MakeArray (_cdd ...);
};}else if len (_cag )> 1{_abe :=_gdc [0];_cef :=_abe ._aga ;_ ,_bea :=_ccdc (_cef );_dae :=_cef .Elements ()[_bea ];_fbg :=_dae .Font ;_age ,_gdga :=_fec (_aff ,_fbg );if _gdga !=nil {return _gdga ;};_ead ,_gdga :=_fag (_age ,_gdc );if _gdga !=nil {return _gdga ;
};_gfc :=_cbfd (_ead );_eee :=_agd (_age ,_gfc ,_fbg );_abb =_da .MakeArray (_eee ...);};_bdc .Params [0]=_abb ;_bdc .Operand ="\u0054\u004a";return nil ;};type localSpanMarks struct{_aga *_fd .TextMarkArray ;_adcf int ;_cgag string ;};func _gcae (_gba localSpanMarks ,_bgc *_fd .TextMarkArray ,_gcd *_fa .PdfFont ,_daf ,_abba string )([]_da .PdfObject ,error ){_bebb :=_gada (_bgc );
Tj ,_dfb :=_bgd (_bgc );if _dfb !=nil {return nil ,_dfb ;};_bebc :=len (_daf );_cde :=len (_bebb );_eafd :=-1;_dfg :=_da .MakeFloat (Tj );if _bebb !=_abba {_cga :=_gba ._adcf ;if _cga ==0{_eafd =_e .LastIndex (_daf ,_bebb );}else {_eafd =_e .Index (_daf ,_bebb );
};}else {_eafd =_e .Index (_daf ,_bebb );};_ffc :=_eafd +_cde ;_bffd :=[]_da .PdfObject {};if _eafd ==0&&_ffc ==_bebc {_bffd =append (_bffd ,_dfg );}else if _eafd ==0&&_ffc < _bebc {_efc :=_fga (_daf [_ffc :],_gcd );_cbbe :=_da .MakeStringFromBytes (_efc );
_bffd =append (_bffd ,_dfg ,_cbbe );}else if _eafd > 0&&_ffc >=_bebc {_debf :=_fga (_daf [:_eafd ],_gcd );_ede :=_da .MakeStringFromBytes (_debf );_bffd =append (_bffd ,_ede ,_dfg );}else if _eafd > 0&&_ffc < _bebc {_agf :=_fga (_daf [:_eafd ],_gcd );_eaae :=_fga (_daf [_ffc :],_gcd );
_afa :=_da .MakeStringFromBytes (_agf );_efd :=_da .MakeString (string (_eaae ));_bffd =append (_bffd ,_afa ,_dfg ,_efd );};return _bffd ,nil ;};func _ce (_ga *_dg .ContentStreamOperations ,_ba map[_da .PdfObject ][]localSpanMarks )error {for _de ,_gd :=range _ba {if _de ==nil {continue ;
};_bg ,_cc ,_aa :=_bcd (_ga ,_de );if !_aa {_d .Log .Debug ("Pd\u0066\u004fb\u006a\u0065\u0063\u0074\u0020\u0025\u0073\u006e\u006ft\u0020\u0066\u006f\u0075\u006e\u0064\u0020\u0069\u006e\u0020\u0073\u0069\u0064\u0065\u0020\u0074\u0068\u0065\u0020\u0063\u006f\u006e\u0074\u0065\u006e\u0074\u0073\u0074r\u0065a\u006d\u0020\u006f\u0070\u0065\u0072\u0061\u0074i\u006fn\u0020\u0025s",_de ,_ga );
return nil ;};if _bg .Operand =="\u0054\u006a"{_ccd :=_gaga (_bg ,_de ,_gd );if _ccd !=nil {return _ccd ;};}else if _bg .Operand =="\u0054\u004a"{_ea :=_cca (_bg ,_de ,_gd );if _ea !=nil {return _ea ;};}else if _bg .Operand =="\u0027"||_bg .Operand =="\u0022"{_bf :=_cg (_ga ,_bg .Operand ,_cc );
if _bf !=nil {return _bf ;};_bf =_gaga (_bg ,_de ,_gd );if _bf !=nil {return _bf ;};};};return nil ;};func _gagd (_eeaf []localSpanMarks )(map[string ][]localSpanMarks ,[]string ){_efa :=make (map[string ][]localSpanMarks );_af :=[]string {};for _ ,_cgc :=range _eeaf {_deb :=_cgc ._cgag ;
if _gge ,_eaa :=_efa [_deb ];_eaa {_efa [_deb ]=append (_gge ,_cgc );}else {_efa [_deb ]=[]localSpanMarks {_cgc };_af =append (_af ,_deb );};};return _efa ,_af ;};func _bgd (_bgf *_fd .TextMarkArray )(float64 ,error ){_bbd ,_afbf :=_bgf .BBox ();if !_afbf {return 0.0,_g .Errorf ("\u0073\u0070\u0061\u006e\u004d\u0061\u0072\u006bs\u002e\u0042\u0042ox\u0020\u0068\u0061\u0073\u0020\u006eo\u0020\u0062\u006f\u0075\u006e\u0064\u0069\u006e\u0067\u0020\u0062\u006f\u0078\u002e\u0020s\u0070\u0061\u006e\u004d\u0061\u0072\u006b\u0073=\u0025\u0073",_bgf );
};_gfa :=_bbc (_bgf );_ddfg :=0.0;_ ,_accd :=_ccdc (_bgf );_dfc :=_bgf .Elements ()[_accd ];_bae :=_dfc .Font ;if _gfa > 0{_ddfg =_fbae (_bae ,_dfc );};_cdb :=(_bbd .Urx -_bbd .Llx );_cdb =_cdb +_ddfg *float64 (_gfa );Tj :=_bcc (_cdb ,_dfc .FontSize ,_dfc .Th );
return Tj ,nil ;};

// Write writes the content of `re.creator` to writer of type io.Writer interface.
func (_bbf *Redactor )Write (writer _cf .Writer )error {return _bbf ._bgeg .Write (writer )};func _bcd (_cgcf *_dg .ContentStreamOperations ,PdfObj _da .PdfObject )(*_dg .ContentStreamOperation ,int ,bool ){for _ccg ,_gcaa :=range *_cgcf {_edb :=_gcaa .Operand ;
if _edb =="\u0054\u006a"{_bbdc :=_da .TraceToDirectObject (_gcaa .Params [0]);if _bbdc ==PdfObj {return _gcaa ,_ccg ,true ;};}else if _edb =="\u0054\u004a"{_fbgd ,_gcee :=_da .GetArray (_gcaa .Params [0]);if !_gcee {return nil ,_ccg ,_gcee ;};for _ ,_gadd :=range _fbgd .Elements (){if _gadd ==PdfObj {return _gcaa ,_ccg ,true ;
};};}else if _edb =="\u0022"{_dac :=_da .TraceToDirectObject (_gcaa .Params [2]);if _dac ==PdfObj {return _gcaa ,_ccg ,true ;};}else if _edb =="\u0027"{_gagaa :=_da .TraceToDirectObject (_gcaa .Params [0]);if _gagaa ==PdfObj {return _gcaa ,_ccg ,true ;
};};};return nil ,-1,false ;};func _dbed (_bfcc []int ,_fca *_fd .TextMarkArray ,_cgd string )(*_fd .TextMarkArray ,matchedBBox ,error ){_gaeb :=matchedBBox {};_caa :=_bfcc [0];_dgbf :=_bfcc [1];_gfd :=len (_cgd )-len (_e .TrimLeft (_cgd ,"\u0020"));_abbaf :=len (_cgd )-len (_e .TrimRight (_cgd ,"\u0020\u000a"));
_caa =_caa +_gfd ;_dgbf =_dgbf -_abbaf ;_cgd =_e .Trim (_cgd ,"\u0020\u000a");_ecb ,_cegb :=_fca .RangeOffset (_caa ,_dgbf );if _cegb !=nil {return nil ,_gaeb ,_cegb ;};_dec ,_ged :=_ecb .BBox ();if !_ged {return nil ,_gaeb ,_g .Errorf ("\u0073\u0070\u0061\u006e\u004d\u0061\u0072\u006bs\u002e\u0042\u0042ox\u0020\u0068\u0061\u0073\u0020\u006eo\u0020\u0062\u006f\u0075\u006e\u0064\u0069\u006e\u0067\u0020\u0062\u006f\u0078\u002e\u0020s\u0070\u0061\u006e\u004d\u0061\u0072\u006b\u0073=\u0025\u0073",_ecb );
};_gaeb =matchedBBox {_fdd :_cgd ,_bfa :_dec };return _ecb ,_gaeb ,nil ;};func _fbea (_eec []*matchedIndex )map[string ][][]int {_cac :=make (map[string ][][]int );for _ ,_dgc :=range _eec {_gagf :=_dgc ._adb ;_afaa :=[]int {_dgc ._ggb ,_dgc ._fbgb };if _gdeb ,_baaf :=_cac [_gagf ];
_baaf {_cac [_gagf ]=append (_gdeb ,_afaa );}else {_cac [_gagf ]=[][]int {_afaa };};};return _cac ;};func _cbfd (_ae []placeHolders )[]replacement {_fdb :=[]replacement {};for _ ,_aeb :=range _ae {_dgf :=_aeb ._ggcc ;_bfdc :=_aeb ._cfg ;_bfc :=_aeb ._fab ;
for _ ,_eae :=range _dgf {_acf :=replacement {_a :_bfdc ,_fad :_bfc ,_ad :_eae };_fdb =append (_fdb ,_acf );};};_ggc .Slice (_fdb ,func (_cee ,_gbc int )bool {return _fdb [_cee ]._ad < _fdb [_gbc ]._ad });return _fdb ;};func _ggd (_dgfa *_fd .TextMarkArray )[]*_fd .TextMarkArray {_gggg :=_dgfa .Elements ();
_bgde :=len (_gggg );var _aeff _da .PdfObject ;_egf :=[]*_fd .TextMarkArray {};_fgc :=&_fd .TextMarkArray {};_cdeg :=-1;for _ggaa ,_cfac :=range _gggg {_eafc :=_cfac .DirectObject ;_cdeg =_cfac .Index ;if _eafc ==nil {_adcfg :=_dcbd (_dgfa ,_ggaa ,_cdeg );
if _aeff !=nil {if _adcfg ==-1||_adcfg > _ggaa {_egf =append (_egf ,_fgc );_fgc =&_fd .TextMarkArray {};};};}else if _eafc !=nil &&_aeff ==nil {if _cdeg ==0&&_ggaa > 0{_egf =append (_egf ,_fgc );_fgc =&_fd .TextMarkArray {};};}else if _eafc !=nil &&_aeff !=nil {if _eafc !=_aeff {_egf =append (_egf ,_fgc );
_fgc =&_fd .TextMarkArray {};};};_aeff =_eafc ;_fgc .Append (_cfac );if _ggaa ==(_bgde -1){_egf =append (_egf ,_fgc );};};return _egf ;};func _agd (_gce string ,_dad []replacement ,_afd *_fa .PdfFont )[]_da .PdfObject {_afdd :=[]_da .PdfObject {};_eeb :=0;
_cfa :=_gce ;for _bbb ,_dcca :=range _dad {_bge :=_dcca ._ad ;_cdfe :=_dcca ._fad ;_gaf :=_dcca ._a ;_ccc :=_da .MakeFloat (_cdfe );_fadg :=_gce [_eeb :_bge ];_ebf :=_fga (_fadg ,_afd );_dge :=_da .MakeStringFromBytes (_ebf );_afdd =append (_afdd ,_dge );
_afdd =append (_afdd ,_ccc );_aac :=_bge +len (_gaf );_cfa =_gce [_aac :];_eeb =_aac ;if _bbb ==len (_dad )-1{_ebf =_fga (_cfa ,_afd );_dge =_da .MakeStringFromBytes (_ebf );_afdd =append (_afdd ,_dge );};};return _afdd ;};

// RedactionOptions is a collection of RedactionTerm objects.
type RedactionOptions struct{Terms []RedactionTerm ;};

// Redactor represtents a Redactor object.
type Redactor struct{_eca *_fa .PdfReader ;_bfde *RedactionOptions ;_bgeg *_f .Creator ;_ebc *RectangleProps ;};func _cca (_gag *_dg .ContentStreamOperation ,_ee _da .PdfObject ,_cb []localSpanMarks )error {_gc ,_fb :=_da .GetArray (_gag .Params [0]);_ac :=[]_da .PdfObject {};
if !_fb {_d .Log .Debug ("\u0045\u0052\u0052OR\u003a\u0020\u0054\u004a\u0020\u006f\u0070\u003d\u0025s\u0020G\u0065t\u0041r\u0072\u0061\u0079\u0056\u0061\u006c\u0020\u0066\u0061\u0069\u006c\u0065\u0064",_gag );return _g .Errorf ("\u0073\u0070\u0061\u006e\u004d\u0061\u0072\u006bs\u002e\u0042\u0042ox\u0020\u0068\u0061\u0073\u0020\u006eo\u0020\u0062\u006f\u0075\u006e\u0064\u0069\u006e\u0067\u0020\u0062\u006f\u0078\u002e\u0020s\u0070\u0061\u006e\u004d\u0061\u0072\u006b\u0073=\u0025\u0073",_gag );
};_cbd ,_bc :=_gagd (_cb );if len (_bc )==1{_db :=_bc [0];_be :=_cbd [_db ];if len (_be )==1{_caed :=_be [0];_dgb :=_caed ._aga ;_gae :=_gde (_dgb );_bd ,_bff :=_fec (_ee ,_gae );if _bff !=nil {return _bff ;};_dbe ,_bff :=_gcae (_caed ,_dgb ,_gae ,_bd ,_db );
if _bff !=nil {return _bff ;};for _ ,_dc :=range _gc .Elements (){if _dc ==_ee {_ac =append (_ac ,_dbe ...);}else {_ac =append (_ac ,_dc );};};}else {_ffb :=_be [0]._aga ;_fba :=_gde (_ffb );_ec ,_df :=_fec (_ee ,_fba );if _df !=nil {return _df ;};_eg ,_df :=_fag (_ec ,_be );
if _df !=nil {return _df ;};_ggf :=_cbfd (_eg );_cd :=_agd (_ec ,_ggf ,_fba );for _ ,_ab :=range _gc .Elements (){if _ab ==_ee {_ac =append (_ac ,_cd ...);}else {_ac =append (_ac ,_ab );};};};_gag .Params [0]=_da .MakeArray (_ac ...);}else if len (_bc )> 1{_ffba :=_cb [0];
_dd :=_ffba ._aga ;_ ,_dbb :=_ccdc (_dd );_gad :=_dd .Elements ()[_dbb ];_ddc :=_gad .Font ;_gff ,_feb :=_fec (_ee ,_ddc );if _feb !=nil {return _feb ;};_aca ,_feb :=_fag (_gff ,_cb );if _feb !=nil {return _feb ;};_cbb :=_cbfd (_aca );_ed :=_agd (_gff ,_cbb ,_ddc );
for _ ,_ag :=range _gc .Elements (){if _ag ==_ee {_ac =append (_ac ,_ed ...);}else {_ac =append (_ac ,_ag );};};_gag .Params [0]=_da .MakeArray (_ac ...);};return nil ;};func _egg (_adbg RedactionTerm )(*regexMatcher ,error ){return &regexMatcher {_ddg :_adbg },nil };
type regexMatcher struct{_ddg RedactionTerm };