//
// Copyright 2020 FoxyUtils ehf. All rights reserved.
//
// This is a commercial product and requires a license to operate.
// A trial license can be obtained at https://unidoc.io
//
// DO NOT EDIT: generated by unitwist Go source code obfuscator.
//
// Use of this source code is governed by the UniDoc End User License Agreement
// terms that can be accessed at https://unidoc.io/eula/

// Package pdfa provides abstraction to optimize and verify documents with respect to the PDF/A standards.
// NOTE: This implementation is in experimental development state.
// 	Keep in mind that it might change in the subsequent minor versions.
package pdfa ;import (_age "errors";_d "fmt";_gf "github.com/adrg/sysfont";_db "github.com/trimmer-io/go-xmp/models/dc";_c "github.com/trimmer-io/go-xmp/models/pdf";_g "github.com/trimmer-io/go-xmp/models/xmp_base";_df "github.com/trimmer-io/go-xmp/models/xmp_mm";
_dd "github.com/trimmer-io/go-xmp/models/xmp_rights";_ec "github.com/trimmer-io/go-xmp/xmp";_ae "github.com/unidoc/unipdf/v3/common";_dc "github.com/unidoc/unipdf/v3/contentstream";_gd "github.com/unidoc/unipdf/v3/core";_ecd "github.com/unidoc/unipdf/v3/internal/cmap";
_fg "github.com/unidoc/unipdf/v3/internal/imageutil";_bc "github.com/unidoc/unipdf/v3/internal/timeutils";_b "github.com/unidoc/unipdf/v3/model";_aa "github.com/unidoc/unipdf/v3/model/internal/colorprofile";_da "github.com/unidoc/unipdf/v3/model/internal/docutil";
_ee "github.com/unidoc/unipdf/v3/model/internal/fonts";_daa "github.com/unidoc/unipdf/v3/model/xmputil";_fb "github.com/unidoc/unipdf/v3/model/xmputil/pdfaextension";_ecdf "github.com/unidoc/unipdf/v3/model/xmputil/pdfaid";_ag "image/color";_a "math";_de "sort";
_ef "strings";_f "time";);func _dade (_baga *_b .PdfInfo ,_bgde *_daa .Document )bool {_efed ,_dcaa :=_bgde .GetPdfInfo ();if !_dcaa {return false ;};if _efed .InfoDict ==nil {return false ;};_ecedf ,_daddb :=_b .NewPdfInfoFromObject (_efed .InfoDict );
if _daddb !=nil {return false ;};if _baga .Creator !=nil {if _ecedf .Creator ==nil ||_ecedf .Creator .String ()!=_baga .Creator .String (){return false ;};};if _baga .CreationDate !=nil {if _ecedf .CreationDate ==nil ||!_ecedf .CreationDate .ToGoTime ().Equal (_baga .CreationDate .ToGoTime ()){return false ;
};};if _baga .ModifiedDate !=nil {if _ecedf .ModifiedDate ==nil ||!_ecedf .ModifiedDate .ToGoTime ().Equal (_baga .ModifiedDate .ToGoTime ()){return false ;};};if _baga .Producer !=nil {if _ecedf .Producer ==nil ||_ecedf .Producer .String ()!=_baga .Producer .String (){return false ;
};};if _baga .Keywords !=nil {if _ecedf .Keywords ==nil ||_ecedf .Keywords .String ()!=_baga .Keywords .String (){return false ;};};if _baga .Trapped !=nil {if _ecedf .Trapped ==nil {return false ;};switch _baga .Trapped .String (){case "\u0054\u0072\u0075\u0065":if _ecedf .Trapped .String ()!="\u0054\u0072\u0075\u0065"{return false ;
};case "\u0046\u0061\u006cs\u0065":if _ecedf .Trapped .String ()!="\u0046\u0061\u006cs\u0065"{return false ;};default:if _ecedf .Trapped .String ()!="\u0046\u0061\u006cs\u0065"{return false ;};};};if _baga .Title !=nil {if _ecedf .Title ==nil ||_ecedf .Title .String ()!=_baga .Title .String (){return false ;
};};if _baga .Subject !=nil {if _ecedf .Subject ==nil ||_ecedf .Subject .String ()!=_baga .Subject .String (){return false ;};};return true ;};

// ValidateStandard checks if provided input CompliancePdfReader matches rules that conforms PDF/A-1 standard.
func (_gfeg *profile1 )ValidateStandard (r *_b .CompliancePdfReader )error {_agf :=VerificationError {ConformanceLevel :_gfeg ._gaeg ._gb ,ConformanceVariant :_gfeg ._gaeg ._dcd };if _cffc :=_efbg (r );_cffc !=_fc {_agf .ViolatedRules =append (_agf .ViolatedRules ,_cffc );
};if _dbga :=_fccbc (r );_dbga !=_fc {_agf .ViolatedRules =append (_agf .ViolatedRules ,_dbga );};if _fegc :=_cgge (r );_fegc !=_fc {_agf .ViolatedRules =append (_agf .ViolatedRules ,_fegc );};if _beea :=_dadd (r );_beea !=_fc {_agf .ViolatedRules =append (_agf .ViolatedRules ,_beea );
};if _begd :=_bbcb (r );_begd !=_fc {_agf .ViolatedRules =append (_agf .ViolatedRules ,_begd );};if _adaa :=_edbf (r );len (_adaa )!=0{_agf .ViolatedRules =append (_agf .ViolatedRules ,_adaa ...);};if _fbfe :=_ecfd (r );_fbfe !=_fc {_agf .ViolatedRules =append (_agf .ViolatedRules ,_fbfe );
};if _cfce :=_dcda (r );len (_cfce )!=0{_agf .ViolatedRules =append (_agf .ViolatedRules ,_cfce ...);};if _ggb :=_edaa (r );len (_ggb )!=0{_agf .ViolatedRules =append (_agf .ViolatedRules ,_ggb ...);};if _abea :=_dffb (r );len (_abea )!=0{_agf .ViolatedRules =append (_agf .ViolatedRules ,_abea ...);
};if _afba :=_fdb (r );_afba !=_fc {_agf .ViolatedRules =append (_agf .ViolatedRules ,_afba );};if _aagga :=_cbed (r );len (_aagga )!=0{_agf .ViolatedRules =append (_agf .ViolatedRules ,_aagga ...);};if _efde :=_daee (r );len (_efde )!=0{_agf .ViolatedRules =append (_agf .ViolatedRules ,_efde ...);
};if _abgb :=_bbag (r );_abgb !=_fc {_agf .ViolatedRules =append (_agf .ViolatedRules ,_abgb );};if _ccd :=_bgbg (r ,false );len (_ccd )!=0{_agf .ViolatedRules =append (_agf .ViolatedRules ,_ccd ...);};if _gbbc :=_badf (r );len (_gbbc )!=0{_agf .ViolatedRules =append (_agf .ViolatedRules ,_gbbc ...);
};if _bega :=_bgbb (r );_bega !=_fc {_agf .ViolatedRules =append (_agf .ViolatedRules ,_bega );};if _ccdg :=_cadc (r );_ccdg !=_fc {_agf .ViolatedRules =append (_agf .ViolatedRules ,_ccdg );};if _gbae :=_acbad (r );_gbae !=_fc {_agf .ViolatedRules =append (_agf .ViolatedRules ,_gbae );
};if _gcaec :=_dffd (r );_gcaec !=_fc {_agf .ViolatedRules =append (_agf .ViolatedRules ,_gcaec );};if _egbf :=_fcbfa (r );_egbf !=_fc {_agf .ViolatedRules =append (_agf .ViolatedRules ,_egbf );};if _dfa :=_degc (r );len (_dfa )!=0{_agf .ViolatedRules =append (_agf .ViolatedRules ,_dfa ...);
};if _fgaf :=_gegfg (r ,_gfeg ._gaeg );len (_fgaf )!=0{_agf .ViolatedRules =append (_agf .ViolatedRules ,_fgaf ...);};if _fgac :=_bbdd (r );len (_fgac )!=0{_agf .ViolatedRules =append (_agf .ViolatedRules ,_fgac ...);};if _ecda :=_cbgc (r );_ecda !=_fc {_agf .ViolatedRules =append (_agf .ViolatedRules ,_ecda );
};if _cdeb :=_aedg (r );_cdeb !=_fc {_agf .ViolatedRules =append (_agf .ViolatedRules ,_cdeb );};if _gda :=_geef (r );len (_gda )!=0{_agf .ViolatedRules =append (_agf .ViolatedRules ,_gda ...);};if _bbcf :=_abge (r );len (_bbcf )!=0{_agf .ViolatedRules =append (_agf .ViolatedRules ,_bbcf ...);
};if _gafg :=_edcc (r );_gafg !=_fc {_agf .ViolatedRules =append (_agf .ViolatedRules ,_gafg );};if _acac :=_egcf (r );_acac !=_fc {_agf .ViolatedRules =append (_agf .ViolatedRules ,_acac );};if _dbad :=_gaedg (r ,_gfeg ._gaeg ,false );len (_dbad )!=0{_agf .ViolatedRules =append (_agf .ViolatedRules ,_dbad ...);
};if _gfeg ._gaeg ==_dba (){if _gcce :=_fdffe (r );len (_gcce )!=0{_agf .ViolatedRules =append (_agf .ViolatedRules ,_gcce ...);};};if _ddf :=_ceef (r );len (_ddf )!=0{_agf .ViolatedRules =append (_agf .ViolatedRules ,_ddf ...);};if len (_agf .ViolatedRules )> 0{_de .Slice (_agf .ViolatedRules ,func (_ceec ,_aacg int )bool {return _agf .ViolatedRules [_ceec ].RuleNo < _agf .ViolatedRules [_aacg ].RuleNo ;
});return _agf ;};return nil ;};func _ccac (_dbcf *_b .CompliancePdfReader )[]ViolatedRule {return nil };

// Profile2A is the implementation of the PDF/A-2A standard profile.
// Implements model.StandardImplementer, Profile interfaces.
type Profile2A struct{profile2 };func _eaccc (_fgfg *_gd .PdfObjectStream ,_aaef map[*_gd .PdfObjectStream ][]byte ,_bddd map[*_gd .PdfObjectStream ]*_ecd .CMap )(*_ecd .CMap ,error ){_cbgb ,_dbeb :=_bddd [_fgfg ];if !_dbeb {var _cbd error ;_dafb ,_ebec :=_aaef [_fgfg ];
if !_ebec {_dafb ,_cbd =_gd .DecodeStream (_fgfg );if _cbd !=nil {_ae .Log .Debug ("\u0064\u0065\u0063\u006f\u0064\u0069\u006e\u0067\u0020\u0073\u0074r\u0065\u0061\u006d\u0020\u0066\u0061\u0069\u006c\u0065\u0064:\u0020\u0025\u0076",_cbd );return nil ,_cbd ;
};_aaef [_fgfg ]=_dafb ;};_cbgb ,_cbd =_ecd .LoadCmapFromData (_dafb ,false );if _cbd !=nil {return nil ,_cbd ;};_bddd [_fgfg ]=_cbgb ;};return _cbgb ,nil ;};func _gfedg (_bfab *_gd .PdfObjectDictionary ,_cddf map[*_gd .PdfObjectStream ][]byte ,_bdfa map[*_gd .PdfObjectStream ]*_ecd .CMap )ViolatedRule {const (_agcgf ="\u0036\u002e\u0032\u002e\u0031\u0031\u002e\u0033\u002d\u0034";
_acdafe ="\u0046\u006f\u0072\u0020\u0074\u0068\u006fs\u0065\u0020\u0043\u004d\u0061\u0070\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0061\u0072e\u0020\u0065m\u0062\u0065\u0064de\u0064\u002c\u0020\u0074\u0068\u0065\u0020\u0069\u006et\u0065\u0067\u0065\u0072 \u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0057\u004d\u006f\u0064\u0065\u0020\u0065\u006e\u0074r\u0079\u0020i\u006e t\u0068\u0065\u0020CM\u0061\u0070\u0020\u0064\u0069\u0063\u0074\u0069o\u006ea\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0069\u0064\u0065\u006e\u0074\u0069\u0063\u0061\u006c\u0020\u0074\u006f \u0074h\u0065\u0020\u0057\u004d\u006f\u0064e\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0069\u006e\u0020\u0074h\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064ed\u0020\u0043\u004d\u0061\u0070\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u002e";
);var _gecbd string ;if _bbeb ,_gebd :=_gd .GetName (_bfab .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_gebd {_gecbd =_bbeb .String ();};if _gecbd !="\u0054\u0079\u0070e\u0030"{return _fc ;};_gddg :=_bfab .Get ("\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067");
if _ ,_gcg :=_gd .GetName (_gddg );_gcg {return _fc ;};_fecd ,_ffac :=_gd .GetStream (_gddg );if !_ffac {return _ab (_agcgf ,_acdafe );};_daga ,_gfca :=_eaccc (_fecd ,_cddf ,_bdfa );if _gfca !=nil {return _ab (_agcgf ,_acdafe );};_accfa ,_gfbdf :=_gd .GetIntVal (_fecd .Get ("\u0057\u004d\u006fd\u0065"));
_gdgag ,_dadf :=_daga .WMode ();if _gfbdf &&_dadf {if _gdgag !=_accfa {return _ab (_agcgf ,_acdafe );};};if (_gfbdf &&!_dadf )||(!_gfbdf &&_dadf ){return _ab (_agcgf ,_acdafe );};return _fc ;};func _daee (_baag *_b .CompliancePdfReader )(_beae []ViolatedRule ){var (_fdga ,_fege ,_aeee ,_caceg ,_gddd ,_fcbf ,_cgde bool ;
_cbfg func (_gd .PdfObject ););_cbfg =func (_gfgf _gd .PdfObject ){switch _cfed :=_gfgf .(type ){case *_gd .PdfObjectInteger :if !_fdga &&(int64 (*_cfed )> _a .MaxInt32 ||int64 (*_cfed )< -_a .MaxInt32 ){_beae =append (_beae ,_ab ("\u0036\u002e\u0031\u002e\u0031\u0032\u002d\u0031","L\u0061\u0072\u0067e\u0073\u0074\u0020\u0049\u006e\u0074\u0065\u0067\u0065\u0072\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0069\u0073\u0020\u0032\u002c\u0031\u0034\u0037,\u0034\u0038\u0033,\u0036\u0034\u0037\u002e\u0020\u0053\u006d\u0061\u006c\u006c\u0065\u0073\u0074 \u0069\u006e\u0074\u0065g\u0065\u0072\u0020\u0076a\u006c\u0075\u0065\u0020\u0069\u0073\u0020\u002d\u0032\u002c\u0031\u0034\u0037\u002c\u0034\u0038\u0033,\u0036\u0034\u0038\u002e"));
_fdga =true ;};case *_gd .PdfObjectFloat :if !_fege &&(_a .Abs (float64 (*_cfed ))> 32767.0){_beae =append (_beae ,_ab ("\u0036\u002e\u0031\u002e\u0031\u0032\u002d\u0032","\u0041\u0062\u0073\u006f\u006c\u0075\u0074\u0065\u0020\u0072\u0065\u0061\u006c\u0020\u0076\u0061\u006c\u0075\u0065\u0020m\u0075\u0073\u0074\u0020\u0062\u0065\u0020\u006c\u0065s\u0073\u0020\u0074\u0068\u0061\u006e\u0020\u006f\u0072\u0020\u0065\u0071\u0075a\u006c\u0020\u0074\u006f\u0020\u00332\u0037\u0036\u0037.\u0030\u002e"));
};case *_gd .PdfObjectString :if !_aeee &&len ([]byte (_cfed .Str ()))> 65535{_beae =append (_beae ,_ab ("\u0036\u002e\u0031\u002e\u0031\u0032\u002d\u0033","M\u0061\u0078\u0069\u006d\u0075\u006d\u0020\u006c\u0065n\u0067\u0074\u0068\u0020\u006f\u0066\u0020a \u0073\u0074\u0072\u0069n\u0067\u0020\u0028\u0069\u006e\u0020\u0062\u0079\u0074es\u0029\u0020i\u0073\u0020\u0036\u0035\u0035\u0033\u0035\u002e"));
_aeee =true ;};case *_gd .PdfObjectName :if !_caceg &&len ([]byte (*_cfed ))> 127{_beae =append (_beae ,_ab ("\u0036\u002e\u0031\u002e\u0031\u0032\u002d\u0034","\u004d\u0061\u0078\u0069\u006d\u0075\u006d \u006c\u0065\u006eg\u0074\u0068\u0020\u006ff\u0020\u0061\u0020\u006e\u0061\u006d\u0065\u0020\u0028\u0069\u006e\u0020\u0062\u0079\u0074\u0065\u0073\u0029\u0020\u0069\u0073\u0020\u0031\u0032\u0037\u002e"));
_caceg =true ;};case *_gd .PdfObjectArray :if !_gddd &&_cfed .Len ()> 8191{_beae =append (_beae ,_ab ("\u0036\u002e\u0031\u002e\u0031\u0032\u002d\u0035","\u004d\u0061\u0078\u0069\u006d\u0075m\u0020\u006c\u0065\u006e\u0067\u0074\u0068\u0020\u006f\u0066\u0020\u0061\u006e\u0020\u0061\u0072\u0072\u0061\u0079\u0020(\u0069\u006e\u0020\u0065\u006c\u0065\u006d\u0065\u006e\u0074\u0073\u0029\u0020\u0069s\u00208\u0031\u0039\u0031\u002e"));
_gddd =true ;};for _ ,_daacc :=range _cfed .Elements (){_cbfg (_daacc );};if !_cgde &&(_cfed .Len ()==4||_cfed .Len ()==5){_gdef ,_adfe :=_gd .GetName (_cfed .Get (0));if !_adfe {return ;};if *_gdef !="\u0044e\u0076\u0069\u0063\u0065\u004e"{return ;};_fdec :=_cfed .Get (1);
_fdec =_gd .TraceToDirectObject (_fdec );_baage ,_adfe :=_gd .GetArray (_fdec );if !_adfe {return ;};if _baage .Len ()> 8{_beae =append (_beae ,_ab ("\u0036\u002e\u0031\u002e\u0031\u0032\u002d\u0039","\u004d\u0061\u0078i\u006d\u0075\u006d\u0020\u006e\u0075\u006d\u0062\u0065\u0072\u0020\u006f\u0066\u0020\u0044\u0065\u0076\u0069\u0063\u0065\u004e\u0020\u0063\u006f\u006d\u0070\u006f\u006e\u0065n\u0074\u0073\u0020\u0069\u0073\u0020\u0038\u002e"));
_cgde =true ;};};case *_gd .PdfObjectDictionary :_cgdee :=_cfed .Keys ();if !_fcbf &&len (_cgdee )> 4095{_beae =append (_beae ,_ab ("\u0036.\u0031\u002e\u0031\u0032\u002d\u00311","\u004d\u0061\u0078\u0069\u006d\u0075\u006d\u0020\u0063\u0061\u0070\u0061\u0063\u0069\u0074y\u0020\u006f\u0066\u0020\u0061\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006ea\u0072\u0079\u0020\u0028\u0069\u006e\u0020\u0065\u006e\u0074\u0072\u0069es\u0029\u0020\u0069\u0073\u0020\u0034\u0030\u0039\u0035\u002e"));
_fcbf =true ;};for _gebg ,_aace :=range _cgdee {_cbfg (&_cgdee [_gebg ]);_cbfg (_cfed .Get (_aace ));};case *_gd .PdfObjectStream :_cbfg (_cfed .PdfObjectDictionary );case *_gd .PdfObjectStreams :for _ ,_bbcba :=range _cfed .Elements (){_cbfg (_bbcba );
};case *_gd .PdfObjectReference :_cbfg (_cfed .Resolve ());};};_acge :=_baag .GetObjectNums ();if len (_acge )> 8388607{_beae =append (_beae ,_ab ("\u0036\u002e\u0031\u002e\u0031\u0032\u002d\u0037","\u004d\u0061\u0078\u0069\u006d\u0075\u006d\u0020\u006e\u0075\u006d\u0062\u0065\u0072\u0020\u006f\u0066\u0020in\u0064i\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0073 \u0069\u006e\u0020\u0061\u0020\u0050\u0044\u0046\u0020\u0066\u0069\u006c\u0065\u0020\u0069\u0073\u00208\u002c\u0033\u0038\u0038\u002c\u0036\u0030\u0037\u002e"));
};for _ ,_bfdac :=range _acge {_gdcab ,_fdgf :=_baag .GetIndirectObjectByNumber (_bfdac );if _fdgf !=nil {continue ;};_gddaf :=_gd .TraceToDirectObject (_gdcab );_cbfg (_gddaf );};return _beae ;};func _bdeb (_cced *_da .Document )error {_aac ,_ffcgf :=_cced .GetPages ();
if !_ffcgf {return nil ;};for _ ,_aagg :=range _aac {_agaa ,_efge :=_gd .GetArray (_aagg .Object .Get ("\u0041\u006e\u006e\u006f\u0074\u0073"));if !_efge {continue ;};for _ ,_aagc :=range _agaa .Elements (){_aagc =_gd .ResolveReference (_aagc );if _ ,_aadc :=_aagc .(*_gd .PdfObjectNull );
_aadc {continue ;};_fbgg ,_bfbb :=_gd .GetDict (_aagc );if !_bfbb {continue ;};_efgd ,_ :=_gd .GetIntVal (_fbgg .Get ("\u0046"));_efgd &=^(1<<0);_efgd &=^(1<<1);_efgd &=^(1<<5);_efgd &=^(1<<8);_efgd |=1<<2;_fbgg .Set ("\u0046",_gd .MakeInteger (int64 (_efgd )));
_bcg :=false ;if _eafa :=_fbgg .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065");_eafa !=nil {_ece ,_faffa :=_gd .GetName (_eafa );if _faffa &&_ece .String ()=="\u0057\u0069\u0064\u0067\u0065\u0074"{_bcg =true ;if _fbgg .Get ("\u0041\u0041")!=nil {_fbgg .Remove ("\u0041\u0041");
};if _fbgg .Get ("\u0041")!=nil {_fbgg .Remove ("\u0041");};};if _faffa &&_ece .String ()=="\u0054\u0065\u0078\u0074"{_cece ,_ :=_gd .GetIntVal (_fbgg .Get ("\u0046"));_cece |=1<<3;_cece |=1<<4;_fbgg .Set ("\u0046",_gd .MakeInteger (int64 (_cece )));};
};_dcfa ,_bfbb :=_gd .GetDict (_fbgg .Get ("\u0041\u0050"));if _bfbb {_cgdg :=_dcfa .Get ("\u004e");if _cgdg ==nil {continue ;};if len (_dcfa .Keys ())> 1{_dcfa .Clear ();_dcfa .Set ("\u004e",_cgdg );};if _bcg {_baef ,_fbdc :=_gd .GetName (_fbgg .Get ("\u0046\u0054"));
if _fbdc &&*_baef =="\u0042\u0074\u006e"{continue ;};};};};};return nil ;};

// String gets a string representation of the violated rule.
func (_bgf ViolatedRule )String ()string {return _d .Sprintf ("\u0025\u0073\u003a\u0020\u0025\u0073",_bgf .RuleNo ,_bgf .Detail );};func _cec (_ac []*_da .Image ,_af bool )error {_fec :=_gd .PdfObjectName ("\u0044e\u0076\u0069\u0063\u0065\u0052\u0047B");
if _af {_fec ="\u0044\u0065\u0076\u0069\u0063\u0065\u0043\u004d\u0059\u004b";};for _ ,_bce :=range _ac {if _bce .Colorspace ==_fec {continue ;};_fd ,_gddb :=_b .NewXObjectImageFromStream (_bce .Stream );if _gddb !=nil {return _gddb ;};_gbg ,_gddb :=_fd .ToImage ();
if _gddb !=nil {return _gddb ;};_fbc ,_gddb :=_gbg .ToGoImage ();if _gddb !=nil {return _gddb ;};var _gfg _b .PdfColorspace ;if _af {_gfg =_b .NewPdfColorspaceDeviceCMYK ();_fbc ,_gddb =_fg .CMYKConverter .Convert (_fbc );}else {_gfg =_b .NewPdfColorspaceDeviceRGB ();
_fbc ,_gddb =_fg .NRGBAConverter .Convert (_fbc );};if _gddb !=nil {return _gddb ;};_bcd ,_dee :=_fbc .(_fg .Image );if !_dee {return _age .New ("\u0069\u006d\u0061\u0067\u0065\u0020\u0064\u006f\u0065\u0073\u006e\u0027\u0074 \u0069\u006d\u0070\u006c\u0065\u006de\u006e\u0074\u0020\u0069\u006d\u0061\u0067\u0065\u0075\u0074\u0069\u006c\u002eI\u006d\u0061\u0067\u0065");
};_bd :=_bcd .Base ();_dce :=&_b .Image {Width :int64 (_bd .Width ),Height :int64 (_bd .Height ),BitsPerComponent :int64 (_bd .BitsPerComponent ),ColorComponents :_bd .ColorComponents ,Data :_bd .Data };_dce .SetDecode (_bd .Decode );_dce .SetAlpha (_bd .Alpha );
if _gddb =_fd .SetImage (_dce ,_gfg );_gddb !=nil {return _gddb ;};_fd .ToPdfObject ();_bce .ColorComponents =_bd .ColorComponents ;_bce .Colorspace =_fec ;};return nil ;};func _edbc (_cdaf *_da .Document ,_bcba standardType ,_bbb XmpOptions )error {_dde ,_eae :=_cdaf .FindCatalog ();
if !_eae {return nil ;};var _fgf *_daa .Document ;_ccb ,_eae :=_dde .GetMetadata ();if !_eae {_fgf =_daa .NewDocument ();}else {var _bba error ;_fgf ,_bba =_daa .LoadDocument (_ccb .Stream );if _bba !=nil {return _bba ;};};_dbag :=_daa .PdfInfoOptions {InfoDict :_cdaf .Info ,PdfVersion :_d .Sprintf ("\u0025\u0064\u002e%\u0064",_cdaf .Version .Major ,_cdaf .Version .Minor ),Copyright :_bbb .Copyright ,Overwrite :true };
_gcda ,_eae :=_dde .GetMarkInfo ();if _eae {_bcbg ,_dgf :=_gd .GetBool (_gcda .Get ("\u004d\u0061\u0072\u006b\u0065\u0064"));if _dgf &&bool (*_bcbg ){_dbag .Marked =true ;};};if _cde :=_fgf .SetPdfInfo (&_dbag );_cde !=nil {return _cde ;};if _dcc :=_fgf .SetPdfAID (_bcba ._gb ,_bcba ._dcd );
_dcc !=nil {return _dcc ;};_bgce :=_daa .MediaManagementOptions {OriginalDocumentID :_bbb .OriginalDocumentID ,DocumentID :_bbb .DocumentID ,InstanceID :_bbb .InstanceID ,NewDocumentID :!_bbb .NewDocumentVersion ,ModifyComment :"O\u0070\u0074\u0069\u006d\u0069\u007ae\u0020\u0064\u006f\u0063\u0075\u006de\u006e\u0074\u0020\u0074\u006f\u0020\u0050D\u0046\u002f\u0041\u0020\u0073\u0074\u0061\u006e\u0064\u0061r\u0064"};
_afb ,_eae :=_gd .GetDict (_cdaf .Info );if _eae {if _dfg ,_geg :=_gd .GetString (_afb .Get ("\u004do\u0064\u0044\u0061\u0074\u0065"));_geg &&_dfg .String ()!=""{_ebb ,_fcd :=_bc .ParsePdfTime (_dfg .String ());if _fcd !=nil {return _d .Errorf ("\u0069n\u0076\u0061\u006c\u0069d\u0020\u004d\u006f\u0064\u0044a\u0074e\u0020f\u0069\u0065\u006c\u0064\u003a\u0020\u0025w",_fcd );
};_bgce .ModifyDate =_ebb ;};};if _egfg :=_fgf .SetMediaManagement (&_bgce );_egfg !=nil {return _egfg ;};if _ffe :=_fgf .SetPdfAExtension ();_ffe !=nil {return _ffe ;};_fbcc ,_dbda :=_fgf .MarshalIndent (_bbb .MarshalPrefix ,_bbb .MarshalIndent );if _dbda !=nil {return _dbda ;
};if _bdb :=_dde .SetMetadata (_fbcc );_bdb !=nil {return _bdb ;};return nil ;};func (_bf standardType )String ()string {return _d .Sprintf ("\u0050\u0044\u0046\u002f\u0041\u002d\u0025\u0064\u0025\u0073",_bf ._gb ,_bf ._dcd );};func _gag (_bga *_da .Document ,_edd []pageColorspaceOptimizeFunc ,_faf []documentColorspaceOptimizeFunc )error {_eddg ,_fga :=_bga .GetPages ();
if !_fga {return nil ;};var _acb []*_da .Image ;for _cac ,_acd :=range _eddg {_aee ,_egb :=_acd .FindXObjectImages ();if _egb !=nil {return _egb ;};for _ ,_debf :=range _edd {if _egb =_debf (_bga ,&_eddg [_cac ],_aee );_egb !=nil {return _egb ;};};_acb =append (_acb ,_aee ...);
};for _ ,_bbec :=range _faf {if _cba :=_bbec (_bga ,_acb );_cba !=nil {return _cba ;};};return nil ;};func _ddbg (_cbaf *_gd .PdfObjectDictionary )ViolatedRule {const (_baae ="\u0036.\u0033\u002e\u0033\u002d\u0032";_edaaeg ="\u0046\u006f\u0072\u0020\u0061\u006c\u006c\u0020\u0054y\u0070\u0065\u0020\u0032\u0020\u0043\u0049\u0044\u0046\u006f\u006e\u0074\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0061\u0072\u0065\u0020\u0075\u0073\u0065\u0064\u0020f\u006f\u0072 \u0072\u0065\u006e\u0064\u0065\u0072\u0069\u006e\u0067,\u0020\u0074\u0068\u0065\u0020\u0043\u0049\u0044\u0046\u006fn\u0074\u0020\u0064\u0069c\u0074\u0069o\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c \u0063\u006f\u006e\u0074\u0061i\u006e\u0020\u0061\u0020\u0043\u0049\u0044\u0054\u006f\u0047\u0049D\u004d\u0061\u0070\u0020\u0065\u006e\u0074\u0072\u0079\u0020\u0074\u0068\u0061\u0074\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065\u0020a\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006d\u0061\u0070\u0070\u0069\u006e\u0067\u0020\u0066\u0072\u006f\u006d\u0020\u0043\u0049\u0044\u0073\u0020\u0074\u006f\u0020\u0067\u006c\u0079\u0070\u0068\u0020\u0069\u006e\u0064\u0069c\u0065\u0073\u0020\u006f\u0072\u0020\u0074\u0068\u0065\u0020\u006e\u0061\u006d\u0065\u0020\u0049d\u0065\u006e\u0074\u0069\u0074\u0079\u002c\u0020\u0061s d\u0065\u0073\u0063\u0072\u0069\u0062\u0065\u0064\u0020\u0069n\u0020P\u0044\u0046\u0020\u0052\u0065\u0066\u0065\u0072e\u006e\u0063\u0065\u0020\u0054a\u0062\u006c\u0065\u0020\u0035\u002e\u00313";
);var _ggbd string ;if _ecdfg ,_aeed :=_gd .GetName (_cbaf .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_aeed {_ggbd =_ecdfg .String ();};if _ggbd !="\u0043\u0049\u0044F\u006f\u006e\u0074\u0054\u0079\u0070\u0065\u0032"{return _fc ;};if _cbaf .Get ("C\u0049\u0044\u0054\u006f\u0047\u0049\u0044\u004d\u0061\u0070")==nil {return _ab (_baae ,_edaaeg );
};return _fc ;};func _cf ()standardType {return standardType {_gb :1,_dcd :"\u0042"}};

// Error implements error interface.
func (_gbed VerificationError )Error ()string {_aeb :=_ef .Builder {};_aeb .WriteString ("\u0053\u0074\u0061\u006e\u0064\u0061\u0072\u0064\u003a\u0020");_aeb .WriteString (_d .Sprintf ("\u0050\u0044\u0046\u002f\u0041\u002d\u0025\u0064\u0025\u0073",_gbed .ConformanceLevel ,_gbed .ConformanceVariant ));
_aeb .WriteString ("\u0020\u0056\u0069\u006f\u006c\u0061\u0074\u0065\u0064\u0020\u0072\u0075l\u0065\u0073\u003a\u0020");for _gff ,_ecf :=range _gbed .ViolatedRules {_aeb .WriteString (_ecf .String ());if _gff !=len (_gbed .ViolatedRules )-1{_aeb .WriteRune ('\n');
};};return _aeb .String ();};func _ab (_cg string ,_dec string )ViolatedRule {return ViolatedRule {RuleNo :_cg ,Detail :_dec }};func _dffd (_aaggf *_b .CompliancePdfReader )ViolatedRule {return _fc };func _fgg (_fde *_da .Document )error {_bgdf :=func (_aadf *_gd .PdfObjectDictionary )error {if _aadf .Get ("\u0054\u0052")!=nil {_ae .Log .Debug ("\u0045\u0078\u0074\u0047\u0053\u0074\u0061\u0074\u0065\u0020\u006f\u0062\u006a\u0065\u0063t\u0020c\u006f\u006e\u0074\u0061\u0069\u006e\u0073\u0020\u0054\u0052\u0020\u006b\u0065\u0079");
_aadf .Remove ("\u0054\u0052");};_fbde :=_aadf .Get ("\u0054\u0052\u0032");if _fbde !=nil {_eabg :=_fbde .String ();if _eabg !="\u0044e\u0066\u0061\u0075\u006c\u0074"{_ae .Log .Debug ("\u0045x\u0074\u0047\u0053\u0074\u0061\u0074\u0065 o\u0062\u006a\u0065\u0063\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0073 \u0054\u00522\u0020\u006b\u0065y\u0020\u0077\u0069\u0074\u0068\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0074\u0068\u0065r\u0020\u0074ha\u006e\u0020\u0044e\u0066\u0061\u0075\u006c\u0074");
_aadf .Set ("\u0054\u0052\u0032",_gd .MakeName ("\u0044e\u0066\u0061\u0075\u006c\u0074"));};};if _aadf .Get ("\u0048\u0054\u0050")!=nil {_ae .Log .Debug ("\u0045\u0078\u0074\u0047\u0053\u0074a\u0074\u0065\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0063\u006f\u006et\u0061\u0069\u006e\u0073\u0020\u0048\u0054P\u0020\u006b\u0065\u0079");
_aadf .Remove ("\u0048\u0054\u0050");};_gage :=_aadf .Get ("\u0042\u004d");if _gage !=nil {_fcbe ,_bbcg :=_gd .GetName (_gage );if !_bbcg {_ae .Log .Debug ("E\u0078\u0074\u0047\u0053\u0074\u0061t\u0065\u0020\u006f\u0062\u006a\u0065c\u0074\u0020\u0027\u0042\u004d\u0027\u0020i\u0073\u0020\u006e\u006f\u0074\u0020\u0061\u0020\u004e\u0061m\u0065");
_fcbe =_gd .MakeName ("");};_eebfe :=_fcbe .String ();switch _eebfe {case "\u004e\u006f\u0072\u006d\u0061\u006c","\u0043\u006f\u006d\u0070\u0061\u0074\u0069\u0062\u006c\u0065","\u004d\u0075\u006c\u0074\u0069\u0070\u006c\u0079","\u0053\u0063\u0072\u0065\u0065\u006e","\u004fv\u0065\u0072\u006c\u0061\u0079","\u0044\u0061\u0072\u006b\u0065\u006e","\u004ci\u0067\u0068\u0074\u0065\u006e","\u0043\u006f\u006c\u006f\u0072\u0044\u006f\u0064\u0067\u0065","\u0043o\u006c\u006f\u0072\u0042\u0075\u0072n","\u0048a\u0072\u0064\u004c\u0069\u0067\u0068t","\u0053o\u0066\u0074\u004c\u0069\u0067\u0068t","\u0044\u0069\u0066\u0066\u0065\u0072\u0065\u006e\u0063\u0065","\u0045x\u0063\u006c\u0075\u0073\u0069\u006fn","\u0048\u0075\u0065","\u0053\u0061\u0074\u0075\u0072\u0061\u0074\u0069\u006f\u006e","\u0043\u006f\u006co\u0072","\u004c\u0075\u006d\u0069\u006e\u006f\u0073\u0069\u0074\u0079":default:_aadf .Set ("\u0042\u004d",_gd .MakeName ("\u004e\u006f\u0072\u006d\u0061\u006c"));
};};return nil ;};_eegf ,_cggf :=_fde .GetPages ();if !_cggf {return nil ;};for _ ,_ggg :=range _eegf {_cfb ,_cdd :=_ggg .GetResources ();if !_cdd {continue ;};_faef ,_ddad :=_gd .GetDict (_cfb .Get ("\u0045x\u0074\u0047\u0053\u0074\u0061\u0074e"));if !_ddad {return nil ;
};_ddb :=_faef .Keys ();for _ ,_ddcf :=range _ddb {_fggg ,_gdf :=_gd .GetDict (_faef .Get (_ddcf ));if !_gdf {continue ;};_bafc :=_bgdf (_fggg );if _bafc !=nil {continue ;};};};for _ ,_cgbb :=range _eegf {_gbba ,_cdcaa :=_cgbb .GetContents ();if !_cdcaa {return nil ;
};for _ ,_aae :=range _gbba {_acbd ,_dfbb :=_aae .GetData ();if _dfbb !=nil {continue ;};_dggg :=_dc .NewContentStreamParser (string (_acbd ));_ffea ,_dfbb :=_dggg .Parse ();if _dfbb !=nil {continue ;};for _ ,_gdcc :=range *_ffea {if len (_gdcc .Params )==0{continue ;
};_ ,_efb :=_gd .GetName (_gdcc .Params [0]);if !_efb {continue ;};_dacb ,_bfeb :=_cgbb .GetResourcesXObject ();if !_bfeb {continue ;};for _ ,_dbc :=range _dacb .Keys (){_deede ,_ceg :=_gd .GetStream (_dacb .Get (_dbc ));if !_ceg {continue ;};_bffe ,_ceg :=_gd .GetDict (_deede .Get ("\u0052e\u0073\u006f\u0075\u0072\u0063\u0065s"));
if !_ceg {continue ;};_fbb ,_ceg :=_gd .GetDict (_bffe .Get ("\u0045x\u0074\u0047\u0053\u0074\u0061\u0074e"));if !_ceg {continue ;};for _ ,_fccae :=range _fbb .Keys (){_ddcg ,_faaf :=_gd .GetDict (_fbb .Get (_fccae ));if !_faaf {continue ;};_ecdc :=_bgdf (_ddcg );
if _ecdc !=nil {continue ;};};};};};};return nil ;};func _dadd (_fcge *_b .CompliancePdfReader )ViolatedRule {if _fcge .ParserMetadata ().HasDataAfterEOF (){return _ab ("\u0036.\u0031\u002e\u0033\u002d\u0033","\u004e\u006f\u0020\u0064\u0061ta\u0020\u0073h\u0061\u006c\u006c\u0020\u0066\u006f\u006c\u006c\u006f\u0077\u0020\u0074\u0068\u0065\u0020\u006c\u0061\u0073\u0074\u0020\u0065\u006e\u0064\u002d\u006f\u0066\u002d\u0066\u0069l\u0065\u0020\u006da\u0072\u006b\u0065\u0072\u0020\u0065\u0078\u0063\u0065\u0070\u0074\u0020\u0061 \u0073\u0069\u006e\u0067\u006ce\u0020\u006f\u0070\u0074\u0069\u006f\u006e\u0061\u006c \u0065\u006ed\u002do\u0066\u002d\u006c\u0069\u006e\u0065\u0020m\u0061\u0072\u006b\u0065\u0072\u002e");
};return _fc ;};

// Conformance gets the PDF/A conformance.
func (_cefe *profile2 )Conformance ()string {return _cefe ._efbd ._dcd };func _abge (_ecg *_b .CompliancePdfReader )(_cdbe []ViolatedRule ){var _fbbb ,_cccf bool ;_efdg :=func ()bool {return _fbbb &&_cccf };for _ ,_cgef :=range _ecg .GetObjectNums (){_ggdb ,_cedc :=_ecg .GetIndirectObjectByNumber (_cgef );
if _cedc !=nil {_ae .Log .Debug ("G\u0065\u0074\u0074\u0069\u006e\u0067\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068 \u006e\u0075\u006d\u0062\u0065\u0072\u0020\u0025\u0064\u0020fa\u0069\u006c\u0065d\u003a \u0025\u0076",_cgef ,_cedc );
continue ;};_deeb ,_ggff :=_gd .GetDict (_ggdb );if !_ggff {continue ;};_ddaac ,_ggff :=_gd .GetName (_deeb .Get ("\u0054\u0079\u0070\u0065"));if !_ggff {continue ;};if *_ddaac !="\u0041\u0063\u0074\u0069\u006f\u006e"{continue ;};_edad ,_ggff :=_gd .GetName (_deeb .Get ("\u0053"));
if !_ggff {if !_fbbb {_cdbe =append (_cdbe ,_ab ("\u0036.\u0036\u002e\u0031\u002d\u0031","\u0054\u0068\u0065\u0020\u004c\u0061\u0075\u006e\u0063\u0068\u002c\u0020\u0053\u006f\u0075\u006e\u0064\u002c\u0020\u004d\u006f\u0076\u0069\u0065\u002c\u0020\u0052\u0065\u0073\u0065\u0074\u0046o\u0072\u006d\u002c\u0020\u0049\u006d\u0070\u006f\u0072\u0074\u0044\u0061\u0074\u0061\u0020\u0061\u006e\u0064 \u004a\u0061\u0076a\u0053\u0063\u0072\u0069\u0070\u0074\u0020\u0061\u0063\u0074\u0069\u006f\u006e\u0073\u0020s\u0068\u0061\u006c\u006c\u0020\u006eo\u0074\u0020\u0062\u0065\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074e\u0064\u002e \u0041\u0064\u0064\u0069\u0074\u0069\u006f\u006e\u0061\u006c\u006c\u0079\u002c\u0020th\u0065\u0020\u0064\u0065p\u0072\u0065\u0063\u0061\u0074\u0065\u0064\u0020s\u0065\u0074\u002d\u0073\u0074\u0061\u0074\u0065\u0020\u0061\u006e\u0064\u0020\u006e\u006f\u002d\u006f\u0070\u0020\u0061\u0063\u0074\u0069\u006f\u006e\u0073\u0020\u0073\u0068a\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062e\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074e\u0064\u002e\u0020T\u0068\u0065\u0020\u0048\u0069\u0064\u0065\u0020a\u0063\u0074\u0069\u006f\u006e \u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074\u0065\u0064\u002e"));
_fbbb =true ;if _efdg (){return _cdbe ;};};continue ;};switch _b .PdfActionType (*_edad ){case _b .ActionTypeLaunch ,_b .ActionTypeSound ,_b .ActionTypeMovie ,_b .ActionTypeResetForm ,_b .ActionTypeImportData ,_b .ActionTypeJavaScript :if !_fbbb {_cdbe =append (_cdbe ,_ab ("\u0036.\u0036\u002e\u0031\u002d\u0031","\u0054\u0068\u0065\u0020\u004c\u0061\u0075\u006e\u0063\u0068\u002c\u0020\u0053\u006f\u0075\u006e\u0064\u002c\u0020\u004d\u006f\u0076\u0069\u0065\u002c\u0020\u0052\u0065\u0073\u0065\u0074\u0046o\u0072\u006d\u002c\u0020\u0049\u006d\u0070\u006f\u0072\u0074\u0044\u0061\u0074\u0061\u0020\u0061\u006e\u0064 \u004a\u0061\u0076a\u0053\u0063\u0072\u0069\u0070\u0074\u0020\u0061\u0063\u0074\u0069\u006f\u006e\u0073\u0020s\u0068\u0061\u006c\u006c\u0020\u006eo\u0074\u0020\u0062\u0065\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074e\u0064\u002e \u0041\u0064\u0064\u0069\u0074\u0069\u006f\u006e\u0061\u006c\u006c\u0079\u002c\u0020th\u0065\u0020\u0064\u0065p\u0072\u0065\u0063\u0061\u0074\u0065\u0064\u0020s\u0065\u0074\u002d\u0073\u0074\u0061\u0074\u0065\u0020\u0061\u006e\u0064\u0020\u006e\u006f\u002d\u006f\u0070\u0020\u0061\u0063\u0074\u0069\u006f\u006e\u0073\u0020\u0073\u0068a\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062e\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074e\u0064\u002e\u0020T\u0068\u0065\u0020\u0048\u0069\u0064\u0065\u0020a\u0063\u0074\u0069\u006f\u006e \u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074\u0065\u0064\u002e"));
_fbbb =true ;if _efdg (){return _cdbe ;};};continue ;case _b .ActionTypeNamed :if !_cccf {_geaa ,_deacd :=_gd .GetName (_deeb .Get ("\u004e"));if !_deacd {_cdbe =append (_cdbe ,_ab ("\u0036.\u0036\u002e\u0031\u002d\u0032","N\u0061\u006d\u0065\u0064\u0020\u0061\u0063t\u0069\u006f\u006e\u0073\u0020\u006f\u0074\u0068e\u0072\u0020\u0074h\u0061\u006e\u0020\u004e\u0065\u0078\u0074\u0050\u0061\u0067\u0065\u002c\u0020P\u0072\u0065v\u0050\u0061\u0067\u0065\u002c\u0020\u0046\u0069\u0072\u0073\u0074\u0050a\u0067e\u002c\u0020\u0061\u006e\u0064\u0020\u004c\u0061\u0073\u0074\u0050\u0061\u0067\u0065\u0020\u0073h\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074\u0065\u0064\u002e"));
_cccf =true ;if _efdg (){return _cdbe ;};continue ;};switch *_geaa {case "\u004e\u0065\u0078\u0074\u0050\u0061\u0067\u0065","\u0050\u0072\u0065\u0076\u0050\u0061\u0067\u0065","\u0046i\u0072\u0073\u0074\u0050\u0061\u0067e","\u004c\u0061\u0073\u0074\u0050\u0061\u0067\u0065":default:_cdbe =append (_cdbe ,_ab ("\u0036.\u0036\u002e\u0031\u002d\u0032","N\u0061\u006d\u0065\u0064\u0020\u0061\u0063t\u0069\u006f\u006e\u0073\u0020\u006f\u0074\u0068e\u0072\u0020\u0074h\u0061\u006e\u0020\u004e\u0065\u0078\u0074\u0050\u0061\u0067\u0065\u002c\u0020P\u0072\u0065v\u0050\u0061\u0067\u0065\u002c\u0020\u0046\u0069\u0072\u0073\u0074\u0050a\u0067e\u002c\u0020\u0061\u006e\u0064\u0020\u004c\u0061\u0073\u0074\u0050\u0061\u0067\u0065\u0020\u0073h\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074\u0065\u0064\u002e"));
_cccf =true ;if _efdg (){return _cdbe ;};continue ;};};};};return _cdbe ;};func _fegg (_deegf *_b .CompliancePdfReader )(_fffc []ViolatedRule ){var _egcb ,_dgbdef bool ;_fadeg :=func ()bool {return _egcb &&_dgbdef };for _ ,_adaaa :=range _deegf .GetObjectNums (){_cfegf ,_gfadf :=_deegf .GetIndirectObjectByNumber (_adaaa );
if _gfadf !=nil {_ae .Log .Debug ("G\u0065\u0074\u0074\u0069\u006e\u0067\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068 \u006e\u0075\u006d\u0062\u0065\u0072\u0020\u0025\u0064\u0020fa\u0069\u006c\u0065d\u003a \u0025\u0076",_adaaa ,_gfadf );
continue ;};_afegee ,_agfe :=_gd .GetDict (_cfegf );if !_agfe {continue ;};_facb ,_agfe :=_gd .GetName (_afegee .Get ("\u0054\u0079\u0070\u0065"));if !_agfe {continue ;};if *_facb !="\u0041\u0063\u0074\u0069\u006f\u006e"{continue ;};_gfcg ,_agfe :=_gd .GetName (_afegee .Get ("\u0053"));
if !_agfe {if !_egcb {_fffc =append (_fffc ,_ab ("\u0036.\u0035\u002e\u0031\u002d\u0031","\u0054\u0068\u0065\u0020\u004caun\u0063\u0068\u002c\u0020S\u006f\u0075\u006e\u0064,\u0020\u004d\u006f\u0076\u0069\u0065\u002c\u0020\u0052\u0065\u0073\u0065\u0074\u0046\u006f\u0072\u006d\u002c\u0020\u0049\u006d\u0070\u006f\u0072\u0074\u0044a\u0074\u0061,\u0020\u0048\u0069\u0064\u0065\u002c\u0020\u0053\u0065\u0074\u004f\u0043\u0047\u0053\u0074\u0061\u0074\u0065\u002c\u0020\u0052\u0065\u006e\u0064\u0069\u0074\u0069\u006f\u006e\u002c\u0020T\u0072\u0061\u006e\u0073\u002c\u0020\u0047o\u0054\u006f\u0033\u0044\u0056\u0069\u0065\u0077\u0020\u0061\u006e\u0064\u0020\u004a\u0061v\u0061Sc\u0072\u0069p\u0074\u0020\u0061\u0063\u0074\u0069\u006f\u006e\u0073\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074 \u0062\u0065\u0020\u0070\u0065\u0072m\u0069\u0074\u0074\u0065\u0064\u002e \u0041\u0064d\u0069\u0074\u0069\u006f\u006e\u0061\u006c\u006c\u0079\u002c\u0020t\u0068\u0065\u0020\u0064\u0065\u0070\u0072\u0065\u0063\u0061\u0074\u0065\u0064\u0020\u0073\u0065\u0074\u002d\u0073\u0074\u0061\u0074\u0065\u0020\u0061\u006e\u0064\u0020\u006e\u006f\u006f\u0070\u0020\u0061c\u0074\u0069\u006f\u006e\u0073\u0020\u0073\u0068\u0061l\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0070e\u0072\u006d\u0069\u0074\u0074\u0065\u0064\u002e"));
_egcb =true ;if _fadeg (){return _fffc ;};};continue ;};switch _b .PdfActionType (*_gfcg ){case _b .ActionTypeLaunch ,_b .ActionTypeSound ,_b .ActionTypeMovie ,_b .ActionTypeResetForm ,_b .ActionTypeImportData ,_b .ActionTypeJavaScript ,_b .ActionTypeHide ,_b .ActionTypeSetOCGState ,_b .ActionTypeRendition ,_b .ActionTypeTrans ,_b .ActionTypeGoTo3DView :if !_egcb {_fffc =append (_fffc ,_ab ("\u0036.\u0035\u002e\u0031\u002d\u0031","\u0054\u0068\u0065\u0020\u004caun\u0063\u0068\u002c\u0020S\u006f\u0075\u006e\u0064,\u0020\u004d\u006f\u0076\u0069\u0065\u002c\u0020\u0052\u0065\u0073\u0065\u0074\u0046\u006f\u0072\u006d\u002c\u0020\u0049\u006d\u0070\u006f\u0072\u0074\u0044a\u0074\u0061,\u0020\u0048\u0069\u0064\u0065\u002c\u0020\u0053\u0065\u0074\u004f\u0043\u0047\u0053\u0074\u0061\u0074\u0065\u002c\u0020\u0052\u0065\u006e\u0064\u0069\u0074\u0069\u006f\u006e\u002c\u0020T\u0072\u0061\u006e\u0073\u002c\u0020\u0047o\u0054\u006f\u0033\u0044\u0056\u0069\u0065\u0077\u0020\u0061\u006e\u0064\u0020\u004a\u0061v\u0061Sc\u0072\u0069p\u0074\u0020\u0061\u0063\u0074\u0069\u006f\u006e\u0073\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074 \u0062\u0065\u0020\u0070\u0065\u0072m\u0069\u0074\u0074\u0065\u0064\u002e \u0041\u0064d\u0069\u0074\u0069\u006f\u006e\u0061\u006c\u006c\u0079\u002c\u0020t\u0068\u0065\u0020\u0064\u0065\u0070\u0072\u0065\u0063\u0061\u0074\u0065\u0064\u0020\u0073\u0065\u0074\u002d\u0073\u0074\u0061\u0074\u0065\u0020\u0061\u006e\u0064\u0020\u006e\u006f\u006f\u0070\u0020\u0061c\u0074\u0069\u006f\u006e\u0073\u0020\u0073\u0068\u0061l\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0070e\u0072\u006d\u0069\u0074\u0074\u0065\u0064\u002e"));
_egcb =true ;if _fadeg (){return _fffc ;};};continue ;case _b .ActionTypeNamed :if !_dgbdef {_fcefe ,_gfaaf :=_gd .GetName (_afegee .Get ("\u004e"));if !_gfaaf {_fffc =append (_fffc ,_ab ("\u0036.\u0035\u002e\u0031\u002d\u0032","N\u0061\u006d\u0065\u0064\u0020\u0061\u0063t\u0069\u006f\u006e\u0073\u0020\u006f\u0074\u0068e\u0072\u0020\u0074h\u0061\u006e\u0020\u004e\u0065\u0078\u0074\u0050\u0061\u0067\u0065\u002c\u0020P\u0072\u0065v\u0050\u0061\u0067\u0065\u002c\u0020\u0046\u0069\u0072\u0073\u0074\u0050a\u0067e\u002c\u0020\u0061\u006e\u0064\u0020\u004c\u0061\u0073\u0074\u0050\u0061\u0067\u0065\u0020\u0073h\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074\u0065\u0064\u002e"));
_dgbdef =true ;if _fadeg (){return _fffc ;};continue ;};switch *_fcefe {case "\u004e\u0065\u0078\u0074\u0050\u0061\u0067\u0065","\u0050\u0072\u0065\u0076\u0050\u0061\u0067\u0065","\u0046i\u0072\u0073\u0074\u0050\u0061\u0067e","\u004c\u0061\u0073\u0074\u0050\u0061\u0067\u0065":default:_fffc =append (_fffc ,_ab ("\u0036.\u0035\u002e\u0031\u002d\u0032","N\u0061\u006d\u0065\u0064\u0020\u0061\u0063t\u0069\u006f\u006e\u0073\u0020\u006f\u0074\u0068e\u0072\u0020\u0074h\u0061\u006e\u0020\u004e\u0065\u0078\u0074\u0050\u0061\u0067\u0065\u002c\u0020P\u0072\u0065v\u0050\u0061\u0067\u0065\u002c\u0020\u0046\u0069\u0072\u0073\u0074\u0050a\u0067e\u002c\u0020\u0061\u006e\u0064\u0020\u004c\u0061\u0073\u0074\u0050\u0061\u0067\u0065\u0020\u0073h\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074\u0065\u0064\u002e"));
_dgbdef =true ;if _fadeg (){return _fffc ;};continue ;};};};};return _fffc ;};func _dafdf (_aceea *_b .CompliancePdfReader )ViolatedRule {_dcebc :=_aceea .ParserMetadata ().HeaderCommentBytes ();if _dcebc [0]> 127&&_dcebc [1]> 127&&_dcebc [2]> 127&&_dcebc [3]> 127{return _fc ;
};return _ab ("\u0036.\u0031\u002e\u0032\u002d\u0032","\u0054\u0068\u0065\u0020\u0066\u0069\u006c\u0065\u0020\u0068\u0065\u0061\u0064\u0065\u0072\u0020\u006c\u0069\u006e\u0065\u0020\u0073\u0068\u0061\u006c\u006c b\u0065\u0020i\u006d\u006d\u0065\u0064\u0069a\u0074\u0065\u006c\u0079 \u0066\u006f\u006c\u006co\u0077\u0065\u0064\u0020\u0062\u0079\u0020\u0061\u0020\u0063\u006f\u006d\u006d\u0065n\u0074\u0020\u0063\u006f\u006e\u0073\u0069s\u0074\u0069\u006e\u0067\u0020o\u0066\u0020\u0061\u0020\u0025\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u0066\u006f\u006c\u006c\u006fwe\u0064\u0020\u0062y\u0020a\u0074\u0009\u006c\u0065a\u0073\u0074\u0020f\u006f\u0075\u0072\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065r\u0073\u002c\u0020e\u0061\u0063\u0068\u0020\u006f\u0066\u0020\u0077\u0068\u006f\u0073\u0065 \u0065\u006e\u0063\u006f\u0064e\u0064\u0020\u0062\u0079\u0074e\u0020\u0076\u0061\u006c\u0075\u0065s\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0068\u0061\u0076\u0065\u0020\u0061\u0020\u0064e\u0063\u0069\u006d\u0061\u006c \u0076\u0061\u006c\u0075\u0065\u0020\u0067\u0072\u0065\u0061\u0074\u0065\u0072\u0020\u0074\u0068\u0061\u006e\u0020\u0031\u0032\u0037\u002e");
};func (_eb *documentImages )hasOnlyDeviceGray ()bool {return _eb ._ad &&!_eb ._ce &&!_eb ._ff };func _cgbbf (_gecb *_gd .PdfObjectDictionary ,_eced map[*_gd .PdfObjectStream ][]byte ,_gffe map[*_gd .PdfObjectStream ]*_ecd .CMap )ViolatedRule {const (_efce ="\u0036.\u0033\u002e\u0033\u002d\u0034";
_bbbd ="\u0046\u006f\u0072\u0020\u0074\u0068\u006fs\u0065\u0020\u0043\u004d\u0061\u0070\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0061\u0072e\u0020\u0065m\u0062\u0065\u0064de\u0064\u002c\u0020\u0074\u0068\u0065\u0020\u0069\u006et\u0065\u0067\u0065\u0072 \u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0057\u004d\u006f\u0064\u0065\u0020\u0065\u006e\u0074r\u0079\u0020i\u006e t\u0068\u0065\u0020CM\u0061\u0070\u0020\u0064\u0069\u0063\u0074\u0069o\u006ea\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0069\u0064\u0065\u006e\u0074\u0069\u0063\u0061\u006c\u0020\u0074\u006f \u0074h\u0065\u0020\u0057\u004d\u006f\u0064e\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0069\u006e\u0020\u0074h\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064ed\u0020\u0043\u004d\u0061\u0070\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u002e";
);var _gefc string ;if _abdfd ,_cedf :=_gd .GetName (_gecb .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_cedf {_gefc =_abdfd .String ();};if _gefc !="\u0054\u0079\u0070e\u0030"{return _fc ;};_bdebf :=_gecb .Get ("\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067");
if _ ,_bfad :=_gd .GetName (_bdebf );_bfad {return _fc ;};_abedd ,_fcac :=_gd .GetStream (_bdebf );if !_fcac {return _ab (_efce ,_bbbd );};_dfgbe ,_aecbc :=_eaccc (_abedd ,_eced ,_gffe );if _aecbc !=nil {return _ab (_efce ,_bbbd );};_cgag ,_abaf :=_gd .GetIntVal (_abedd .Get ("\u0057\u004d\u006fd\u0065"));
_aecf ,_dbdaf :=_dfgbe .WMode ();if _abaf &&_dbdaf {if _aecf !=_cgag {return _ab (_efce ,_bbbd );};};if (_abaf &&!_dbdaf )||(!_abaf &&_dbdaf ){return _ab (_efce ,_bbbd );};return _fc ;};func _edb (_dead *_da .Document )error {_aba ,_cea :=_dead .FindCatalog ();
if !_cea {return nil ;};_ ,_cea =_gd .GetDict (_aba .Object .Get ("\u0053\u0074\u0072\u0075\u0063\u0074\u0054\u0072\u0065e\u0052\u006f\u006f\u0074"));if !_cea {_fgdg :=_gd .MakeDict ();_fgdg .Set ("\u0054\u0079\u0070\u0065",_gd .MakeName ("\u0053\u0074\u0072\u0075\u0063\u0074\u0054\u0072\u0065e\u0052\u006f\u006f\u0074"));
_aba .Object .Set ("\u0053\u0074\u0072\u0075\u0063\u0074\u0054\u0072\u0065e\u0052\u006f\u006f\u0074",_fgdg );};return nil ;};

// NewProfile1B creates a new Profile1B with the given options.
func NewProfile1B (options *Profile1Options )*Profile1B {if options ==nil {options =DefaultProfile1Options ();};_dfdd (options );return &Profile1B {profile1 {_cgfb :*options ,_gaeg :_cf ()}};};type documentImages struct{_ce ,_ff ,_ad bool ;_bb map[_gd .PdfObject ]struct{};
_dg []*imageInfo ;};func _deee (_fgacf *_b .CompliancePdfReader )(_dgbdc []ViolatedRule ){_fba ,_eafg :=_dbce (_fgacf );if !_eafg {return _dgbdc ;};_edee :=_ab ("\u0036.\u0032\u002e\u0032\u002d\u0031","\u0041\u0020\u0050\u0044\u0046\u002f\u0041\u002d\u0031\u0020\u004f\u0075\u0074p\u0075\u0074\u0049\u006e\u0074e\u006e\u0074\u0020\u0069\u0073\u0020a\u006e \u004f\u0075\u0074\u0070\u0075\u0074\u0049n\u0074\u0065\u006e\u0074\u0020\u0064i\u0063\u0074\u0069\u006fn\u0061\u0072\u0079\u002c\u0020\u0061\u0073\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0062y\u0020\u0050\u0044F\u0020\u0052\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065 \u0039\u002e\u0031\u0030.4\u002c\u0020\u0074\u0068\u0061\u0074\u0020\u0069\u0073 \u0069\u006e\u0063\u006c\u0075\u0064e\u0064\u0020i\u006e\u0020\u0074\u0068\u0065\u0020\u0066\u0069\u006c\u0065\u0027\u0073\u0020O\u0075\u0074p\u0075\u0074I\u006e\u0074\u0065\u006e\u0074\u0073\u0020\u0061\u0072\u0072\u0061\u0079\u0020a\u006e\u0064\u0020h\u0061\u0073\u0020\u0047\u0054\u0053\u005f\u0050\u0044\u0046\u0041\u0031\u0020\u0061\u0073 \u0074\u0068\u0065\u0020\u0076a\u006c\u0075e\u0020\u006f\u0066\u0020i\u0074\u0073 \u0053\u0020\u006b\u0065\u0079\u0020\u0061\u006e\u0064\u0020\u0061\u0020\u0076\u0061\u006c\u0069\u0064\u0020I\u0043\u0043\u0020\u0070\u0072\u006f\u0066\u0069\u006ce\u0020s\u0074\u0072\u0065\u0061\u006d \u0061\u0073\u0020\u0074h\u0065\u0020\u0076a\u006c\u0075\u0065\u0020\u0069\u0074\u0073\u0020\u0044\u0065\u0073t\u004f\u0075t\u0070\u0075\u0074P\u0072\u006f\u0066\u0069\u006c\u0065 \u006b\u0065\u0079\u002e");
_edeb ,_eafg :=_gd .GetArray (_fba .Get ("\u004f\u0075\u0074\u0070\u0075\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0073"));if !_eafg {_dgbdc =append (_dgbdc ,_edee );return _dgbdc ;};_gdgb :=_ab ("\u0036.\u0032\u002e\u0032\u002d\u0032","\u0049\u0066\u0020\u0061\u0020\u0066\u0069\u006c\u0065's\u0020O\u0075\u0074\u0070u\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0073 \u0061\u0072\u0072a\u0079\u0020\u0063\u006f\u006e\u0074\u0061\u0069n\u0073\u0020\u006d\u006f\u0072\u0065\u0020\u0074\u0068a\u006e\u0020\u006f\u006ee\u0020\u0065\u006e\u0074\u0072\u0079\u002c\u0020\u0074\u0068\u0065\u006e\u0020\u0061\u006c\u006c\u0020\u0065n\u0074\u0072\u0069\u0065\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e a \u0044\u0065\u0073\u0074\u004f\u0075\u0074\u0070\u0075\u0074\u0050\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u006b\u0065y\u0020\u0073\u0068\u0061\u006cl\u0020\u0068\u0061\u0076\u0065 \u0061\u0073\u0020\u0074\u0068\u0065 \u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068a\u0074\u0020\u006b\u0065\u0079 \u0074\u0068\u0065\u0020\u0073\u0061\u006d\u0065\u0020\u0069\u006e\u0064\u0069\u0072\u0065c\u0074\u0020\u006fb\u006ae\u0063t\u002c\u0020\u0077h\u0069\u0063\u0068\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065\u0020\u0061\u0020\u0076\u0061\u006c\u0069d\u0020\u0049\u0043\u0043\u0020\u0070\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u0073\u0074r\u0065\u0061m\u002e");
if _edeb .Len ()> 1{_ffgf :=map[*_gd .PdfObjectDictionary ]struct{}{};for _gfac :=0;_gfac < _edeb .Len ();_gfac ++{_ffaa ,_fcfa :=_gd .GetDict (_edeb .Get (_gfac ));if !_fcfa {_dgbdc =append (_dgbdc ,_edee );return _dgbdc ;};if _gfac ==0{_ffgf [_ffaa ]=struct{}{};
continue ;};if _ ,_cefg :=_ffgf [_ffaa ];!_cefg {_dgbdc =append (_dgbdc ,_gdgb );break ;};};}else if _edeb .Len ()==0{_dgbdc =append (_dgbdc ,_edee );return _dgbdc ;};_gfbb ,_eafg :=_gd .GetDict (_edeb .Get (0));if !_eafg {_dgbdc =append (_dgbdc ,_edee );
return _dgbdc ;};if _aaba ,_dfbca :=_gd .GetName (_gfbb .Get ("\u0053"));!_dfbca ||(*_aaba )!="\u0047T\u0053\u005f\u0050\u0044\u0046\u00411"{_dgbdc =append (_dgbdc ,_edee );return _dgbdc ;};_acgf ,_bec :=_b .NewPdfOutputIntentFromPdfObject (_gfbb );if _bec !=nil {_ae .Log .Debug ("\u0070\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u006f\u0075\u0074\u0070\u0075\u0074\u0020i\u006et\u0065\u006e\u0074\u0020\u0066\u0061\u0069\u006c\u0065\u0064\u003a\u0020\u0025\u0076",_bec );
return _dgbdc ;};_ebdf ,_bec :=_aa .ParseHeader (_acgf .DestOutputProfile );if _bec !=nil {_ae .Log .Debug ("\u0070\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u0063\u006f\u006c\u006f\u0072\u0070\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u0068\u0065\u0061d\u0065\u0072\u0020\u0066\u0061i\u006c\u0065d\u003a\u0020\u0025\u0076",_bec );
return _dgbdc ;};if (_ebdf .DeviceClass ==_aa .DeviceClassPRTR ||_ebdf .DeviceClass ==_aa .DeviceClassMNTR )&&(_ebdf .ColorSpace ==_aa .ColorSpaceRGB ||_ebdf .ColorSpace ==_aa .ColorSpaceCMYK ||_ebdf .ColorSpace ==_aa .ColorSpaceGRAY ){return _dgbdc ;};
_dgbdc =append (_dgbdc ,_edee );return _dgbdc ;};func _adb (_fgdb *_da .Document )error {for _ ,_ebg :=range _fgdb .Objects {_edbb ,_ggf :=_gd .GetDict (_ebg );if !_ggf {continue ;};_eac :=_edbb .Get ("\u0054\u0079\u0070\u0065");if _eac ==nil {continue ;
};if _dcdc ,_dccae :=_gd .GetName (_eac );_dccae &&_dcdc .String ()!="\u0041\u0063\u0072\u006f\u0046\u006f\u0072\u006d"{continue ;};_gagf ,_caaec :=_gd .GetBool (_edbb .Get ("\u004ee\u0065d\u0041\u0070\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0073"));
if _caaec &&bool (*_gagf ){_edbb .Set ("\u004ee\u0065d\u0041\u0070\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0073",_gd .MakeBool (false ));};if _edbb .Get ("\u0058\u0046\u0041")!=nil {_edbb .Remove ("\u0058\u0046\u0041");};};_cdce ,_dcbb :=_fgdb .FindCatalog ();
if !_dcbb {return _age .New ("\u0063\u0061\u0074\u0061\u006c\u006f\u0067\u0020\u006e\u006f\u0074\u0020f\u006f\u0075\u006e\u0064");};if _cdce .Object .Get ("\u004e\u0065\u0065\u0064\u0073\u0052\u0065\u006e\u0064e\u0072\u0069\u006e\u0067")!=nil {_cdce .Object .Remove ("\u004e\u0065\u0065\u0064\u0073\u0052\u0065\u006e\u0064e\u0072\u0069\u006e\u0067");
};return nil ;};

// NewProfile2B creates a new Profile2B with the given options.
func NewProfile2B (options *Profile2Options )*Profile2B {if options ==nil {options =DefaultProfile2Options ();};_ecfe (options );return &Profile2B {profile2 {_cfg :*options ,_efbd :_gbe ()}};};func _bgeg (_gde standardType ,_bfac *_da .OutputIntents )error {_afbec ,_bdd :=_aa .NewCmykIsoCoatedV2OutputIntent (_gde .outputIntentSubtype ());
if _bdd !=nil {return _bdd ;};if _bdd =_bfac .Add (_afbec .ToPdfObject ());_bdd !=nil {return _bdd ;};return nil ;};func _gbgb (_abcb *_da .Document ,_cdga bool )error {_deef ,_gagc :=_abcb .GetPages ();if !_gagc {return nil ;};for _ ,_cdbgd :=range _deef {_eba ,_dfe :=_gd .GetArray (_cdbgd .Object .Get ("\u0041\u006e\u006e\u006f\u0074\u0073"));
if !_dfe {continue ;};for _ ,_caab :=range _eba .Elements (){_cdaff ,_dcfc :=_gd .GetDict (_caab );if !_dcfc {continue ;};_fafa :=_cdaff .Get ("\u0043");if _fafa ==nil {continue ;};_fdc ,_dcfc :=_gd .GetArray (_fafa );if !_dcfc {continue ;};_cbbe ,_cacg :=_fdc .GetAsFloat64Slice ();
if _cacg !=nil {return _cacg ;};switch _fdc .Len (){case 0,1:if _cdga {_cdaff .Set ("\u0043",_gd .MakeArrayFromIntegers ([]int {1,1,1,1}));}else {_cdaff .Set ("\u0043",_gd .MakeArrayFromIntegers ([]int {1,1,1}));};case 3:if _cdga {_egcd ,_cbf ,_aea ,_afbb :=_ag .RGBToCMYK (uint8 (_cbbe [0]*255),uint8 (_cbbe [1]*255),uint8 (_cbbe [2]*255));
_cdaff .Set ("\u0043",_gd .MakeArrayFromFloats ([]float64 {float64 (_egcd )/255,float64 (_cbf )/255,float64 (_aea )/255,float64 (_afbb )/255}));};case 4:if !_cdga {_afac ,_beg ,_gcae :=_ag .CMYKToRGB (uint8 (_cbbe [0]*255),uint8 (_cbbe [1]*255),uint8 (_cbbe [2]*255),uint8 (_cbbe [3]*255));
_cdaff .Set ("\u0043",_gd .MakeArrayFromFloats ([]float64 {float64 (_afac )/255,float64 (_beg )/255,float64 (_gcae )/255}));};};};};return nil ;};func _cbed (_bgaa *_b .CompliancePdfReader )(_caeb []ViolatedRule ){_dece :=_bgaa .GetObjectNums ();for _ ,_gfgc :=range _dece {_acda ,_fee :=_bgaa .GetIndirectObjectByNumber (_gfgc );
if _fee !=nil {continue ;};_agbd ,_badg :=_gd .GetDict (_acda );if !_badg {continue ;};_faaff ,_badg :=_gd .GetName (_agbd .Get ("\u0054\u0079\u0070\u0065"));if !_badg {continue ;};if _faaff .String ()!="\u0046\u0069\u006c\u0065\u0073\u0070\u0065\u0063"{continue ;
};if _agbd .Get ("\u0045\u0046")!=nil {_caeb =append (_caeb ,_ab ("\u0036\u002e\u0031\u002e\u0031\u0031\u002d\u0031","\u0041 \u0066\u0069\u006c\u0065 \u0073p\u0065\u0063\u0069\u0066\u0069\u0063\u0061\u0074\u0069o\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006fn\u0061\u0072\u0079\u002c\u0020\u0061\u0073\u0020\u0064\u0065\u0066i\u006e\u0065\u0064\u0020\u0069\u006e\u0020\u0050\u0044\u0046 \u0033\u002e\u0031\u0030\u002e\u0032\u002c\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063o\u006e\u0074\u0061\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0045\u0046 \u006be\u0079\u002e"));
break ;};};_effg ,_abbd :=_dbce (_bgaa );if !_abbd {return _caeb ;};_ebfe ,_abbd :=_gd .GetDict (_effg .Get ("\u004e\u0061\u006de\u0073"));if !_abbd {return _caeb ;};if _ebfe .Get ("\u0045\u006d\u0062\u0065\u0064\u0064\u0065\u0064\u0046\u0069\u006c\u0065\u0073")!=nil {_caeb =append (_caeb ,_ab ("\u0036\u002e\u0031\u002e\u0031\u0031\u002d\u0032","\u0041\u0020\u0066i\u006c\u0065\u0027\u0073\u0020\u006e\u0061\u006d\u0065\u0020d\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002c\u0020\u0061\u0073\u0020d\u0065\u0066\u0069\u006ee\u0064\u0020\u0069\u006e\u0020PD\u0046 \u0052\u0065\u0066er\u0065\u006e\u0063\u0065\u0020\u0033\u002e6\u002e\u0033\u002c\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074h\u0065\u0020\u0045m\u0062\u0065\u0064\u0064\u0065\u0064\u0046i\u006c\u0065\u0073\u0020\u006b\u0065\u0079\u002e"));
};return _caeb ;};func _acagg (_badgc *_b .CompliancePdfReader )ViolatedRule {if _badgc .ParserMetadata ().HasDataAfterEOF (){return _ab ("\u0036.\u0031\u002e\u0033\u002d\u0033","\u004e\u006f\u0020\u0064\u0061ta\u0020\u0073h\u0061\u006c\u006c\u0020\u0066\u006f\u006c\u006c\u006f\u0077\u0020\u0074\u0068\u0065\u0020\u006c\u0061\u0073\u0074\u0020\u0065\u006e\u0064\u002d\u006f\u0066\u002d\u0066\u0069l\u0065\u0020\u006da\u0072\u006b\u0065\u0072\u0020\u0065\u0078\u0063\u0065\u0070\u0074\u0020\u0061 \u0073\u0069\u006e\u0067\u006ce\u0020\u006f\u0070\u0074\u0069\u006f\u006e\u0061\u006c \u0065\u006ed\u002do\u0066\u002d\u006c\u0069\u006e\u0065\u0020m\u0061\u0072\u006b\u0065\u0072\u002e");
};return _fc ;};func _dfdd (_dfbd *Profile1Options ){if _dfbd .Now ==nil {_dfbd .Now =_f .Now ;};};func _daabd (_eedb *_gd .PdfObjectDictionary ,_dgae map[*_gd .PdfObjectStream ][]byte ,_add map[*_gd .PdfObjectStream ]*_ecd .CMap )ViolatedRule {const (_fcfd ="\u0046\u006f\u0072\u0020\u0061\u006e\u0079\u0020\u0067\u0069\u0076\u0065\u006e\u0020\u0063\u006f\u006d\u0070o\u0073\u0069\u0074e\u0020\u0028\u0054\u0079\u0070\u0065\u0020\u0030\u0029 \u0066\u006fn\u0074\u0020\u0077\u0069\u0074\u0068\u0069\u006e \u0061\u0020\u0063\u006fn\u0066\u006fr\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u002c\u0020\u0074\u0068\u0065\u0020\u0043\u0049\u0044\u0053\u0079\u0073\u0074\u0065\u006d\u0049\u006e\u0066\u006f \u0065\u006e\u0074\u0072\u0079\u0020\u0069\u006e\u0020\u0069\u0074\u0073 \u0043\u0049\u0044\u0046\u006f\u006e\u0074\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0061\u006e\u0064\u0020\u0069\u0074\u0073\u0020\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072y\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0068\u0061\u0076\u0065\u0020\u0074\u0068\u0065\u0020\u0066\u006fl\u006c\u006f\u0077\u0069\u006e\u0067\u0020\u0072\u0065l\u0061t\u0069\u006f\u006e\u0073\u0068\u0069\u0070. \u0049\u0066\u0020\u0074\u0068\u0065\u0020\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067\u0020\u006b\u0065\u0079 \u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0054\u0079\u0070\u0065\u0020\u0030 \u0066\u006f\u006e\u0074\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079 \u0069\u0073\u0020I\u0064\u0065n\u0074\u0069\u0074\u0079\u002d\u0048\u0020\u006f\u0072\u0020\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0056\u002c\u0020\u0061\u006e\u0079\u0020v\u0061\u006c\u0075\u0065\u0073\u0020\u006f\u0066\u0020\u0052\u0065\u0067\u0069\u0073\u0074\u0072\u0079\u002c\u0020\u004f\u0072\u0064\u0065\u0072\u0069\u006e\u0067\u002c\u0020\u0061\u006e\u0064\u0020\u0053up\u0070\u006c\u0065\u006d\u0065\u006e\u0074\u0020\u006d\u0061\u0079\u0020\u0062\u0065\u0020\u0075\u0073\u0065\u0064\u0020\u0069n\u0020\u0074h\u0065\u0020\u0043\u0049\u0044\u0053\u0079\u0073\u0074\u0065\u006d\u0049\u006e\u0066\u006f\u0020\u0065\u006e\u0074r\u0079\u0020\u006ff\u0020\u0074\u0068\u0065\u0020\u0043\u0049\u0044F\u006f\u006e\u0074\u002e\u0020\u004f\u0074\u0068\u0065\u0072\u0077\u0069\u0073\u0065\u002c\u0020\u0074\u0068\u0065\u0020\u0063\u006f\u0072\u0072\u0065\u0073\u0070\u006f\u006e\u0064\u0069\u006e\u0067\u0020\u0052\u0065\u0067\u0069\u0073\u0074\u0072\u0079\u0020a\u006e\u0064\u0020\u004f\u0072\u0064\u0065\u0072\u0069\u006e\u0067\u0020s\u0074\u0072\u0069\u006e\u0067\u0073\u0020\u0069\u006e\u0020\u0062\u006f\u0074h\u0020\u0043\u0049\u0044\u0053\u0079\u0073\u0074\u0065m\u0049\u006e\u0066\u006f\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0069\u0065\u0073\u0020\u0073\u0068\u0061\u006cl\u0020\u0062\u0065\u0020i\u0064en\u0074\u0069\u0063\u0061\u006c\u002c \u0061n\u0064\u0020\u0074\u0068\u0065\u0020v\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0053\u0075\u0070\u0070l\u0065\u006d\u0065\u006e\u0074 \u006b\u0065\u0079\u0020\u0069\u006e\u0020t\u0068\u0065\u0020\u0043I\u0044S\u0079\u0073\u0074\u0065\u006d\u0049\u006e\u0066o\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u006ff\u0020\u0074\u0068\u0065\u0020\u0043\u0049\u0044\u0046\u006f\u006e\u0074\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0067re\u0061\u0074\u0065\u0072\u0020\u0074\u0068\u0061\u006e\u0020\u006f\u0072\u0020\u0065\u0071\u0075\u0061\u006c\u0020\u0074\u006f t\u0068\u0065\u0020\u0053\u0075\u0070\u0070\u006c\u0065\u006d\u0065\u006e\u0074\u0020\u006b\u0065\u0079\u0020\u0069\u006e\u0020\u0074h\u0065\u0020\u0043\u0049\u0044\u0053\u0079\u0073\u0074\u0065\u006d\u0049\u006e\u0066o\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u006ff\u0020\u0074\u0068\u0065\u0020\u0043M\u0061p\u002e";
_fbffg ="\u0036\u002e\u0032\u002e\u0031\u0031\u002e\u0033\u002d\u0031";);var _cddd string ;if _bgee ,_eabbd :=_gd .GetName (_eedb .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_eabbd {_cddd =_bgee .String ();};if _cddd !="\u0054\u0079\u0070e\u0030"{return _fc ;
};_ddfbf :=_eedb .Get ("\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067");if _acdf ,_abfba :=_gd .GetName (_ddfbf );_abfba {switch _acdf .String (){case "\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0048","\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0056":return _fc ;
};_bbbdg ,_cacd :=_ecd .LoadPredefinedCMap (_acdf .String ());if _cacd !=nil {return _ab (_fbffg ,_fcfd );};_ffff :=_bbbdg .CIDSystemInfo ();if _ffff .Ordering !=_ffff .Registry {return _ab (_fbffg ,_fcfd );};return _fc ;};_edge ,_cccfa :=_gd .GetStream (_ddfbf );
if !_cccfa {return _ab (_fbffg ,_fcfd );};_daaca ,_ebcg :=_eaccc (_edge ,_dgae ,_add );if _ebcg !=nil {return _ab (_fbffg ,_fcfd );};_bfcde :=_daaca .CIDSystemInfo ();if _bfcde .Ordering !=_bfcde .Registry {return _ab (_fbffg ,_fcfd );};return _fc ;};func _egcf (_fcga *_b .CompliancePdfReader )(_aecff ViolatedRule ){_geffa ,_cgeb :=_dbce (_fcga );
if !_cgeb {return _fc ;};if _geffa .Get ("\u0041\u0041")!=nil {return _ab ("\u0036.\u0036\u002e\u0032\u002d\u0033","\u0054\u0068e\u0020\u0064\u006f\u0063\u0075\u006d\u0065n\u0074 \u0063\u0061\u0074a\u006c\u006f\u0067\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006eo\u0074\u0020\u0069\u006e\u0063\u006c\u0075\u0064\u0065\u0020\u0061\u006e\u0020\u0041\u0041\u0020\u0065n\u0074r\u0079 \u0066\u006f\u0072 \u0061\u006e\u0020\u0061\u0064\u0064\u0069\u0074\u0069\u006f\u006e\u0061\u006c\u002d\u0061\u0063\u0074i\u006f\u006e\u0073\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002e");
};return _fc ;};func _cgge (_cdcef *_b .CompliancePdfReader )ViolatedRule {_ddcb ,_cfgd :=_cdcef .PdfReader .GetTrailer ();if _cfgd !=nil {return _ab ("\u0036.\u0031\u002e\u0033\u002d\u0031","\u006d\u0069\u0073s\u0069\u006e\u0067\u0020t\u0072\u0061\u0069\u006c\u0065\u0072\u0020i\u006e\u0020\u0074\u0068\u0065\u0020\u0064\u006f\u0063\u0075\u006d\u0065\u006e\u0074");
};if _ddcb .Get ("\u0049\u0044")==nil {return _ab ("\u0036.\u0031\u002e\u0033\u002d\u0031","\u0054\u0068\u0065\u0020\u0066\u0069\u006c\u0065\u0020\u0074\u0072\u0061\u0069\u006c\u0065\u0072\u0020\u0064\u0069\u0063t\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068a\u006c\u006c\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074\u0068e\u0020\u0027\u0049\u0044\u0027\u0020k\u0065\u0079\u0077o\u0072\u0064");
};if _ddcb .Get ("\u0045n\u0063\u0072\u0079\u0070\u0074")!=nil {return _ab ("\u0036.\u0031\u002e\u0033\u002d\u0032","\u0054\u0068\u0065\u0020\u006b\u0065y\u0077\u006f\u0072\u0064\u0020'\u0045\u006e\u0063\u0072\u0079\u0070t\u0027\u0020\u0073\u0068\u0061l\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0075\u0073\u0065d\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0074\u0072\u0061\u0069\u006c\u0065\u0072 \u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061r\u0079\u002e\u0020");
};return _fc ;};func _ceeb (_ddbe *_da .Document )error {_dfbf ,_ageg :=_ddbe .FindCatalog ();if !_ageg {return _age .New ("\u0063\u0061\u0074\u0061\u006c\u006f\u0067\u0020\u006e\u006f\u0074\u0020f\u006f\u0075\u006e\u0064");};if _dfbf .Object .Get ("\u0052\u0065\u0071u\u0069\u0072\u0065\u006d\u0065\u006e\u0074\u0073")!=nil {_dfbf .Object .Remove ("\u0052\u0065\u0071u\u0069\u0072\u0065\u006d\u0065\u006e\u0074\u0073");
};return nil ;};func _deec (_cage *_b .CompliancePdfReader )(_gcfd []ViolatedRule ){_ebeb ,_beeb :=_dbce (_cage );if !_beeb {return _gcfd ;};_acafe ,_beeb :=_gd .GetDict (_ebeb .Get ("\u0050\u0065\u0072m\u0073"));if !_beeb {return _gcfd ;};_dgeg :=_acafe .Keys ();
for _ ,_ffga :=range _dgeg {if _ffga .String ()!="\u0055\u0052\u0033"&&_ffga .String ()!="\u0044\u006f\u0063\u004d\u0044\u0050"{_gcfd =append (_gcfd ,_ab ("\u0036\u002e\u0031\u002e\u0031\u0032\u002d\u0031","\u004e\u006f\u0020\u006b\u0065\u0079\u0073 \u006f\u0074\u0068\u0065\u0072\u0020\u0074\u0068\u0061\u006e\u0020\u0055\u0052\u0033 \u0061n\u0064\u0020\u0044\u006f\u0063\u004dD\u0050\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065\u0020\u0070\u0072\u0065\u0073\u0065\u006e\u0074\u0020\u0069\u006e\u0020\u0061\u0020\u0070\u0065\u0072\u006d\u0069\u0073\u0073i\u006f\u006e\u0073\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072y\u002e"));
};};return _gcfd ;};

// Profile2B is the implementation of the PDF/A-2B standard profile.
// Implements model.StandardImplementer, Profile interfaces.
type Profile2B struct{profile2 };func _cdgea (_fcg *_da .Document ,_aga func ()_f .Time )error {_aecg ,_cbge :=_b .NewPdfInfoFromObject (_fcg .Info );if _cbge !=nil {return _cbge ;};if _gdg :=_efcc (_aecg ,_aga );_gdg !=nil {return _gdg ;};_fcg .Info =_aecg .ToPdfObject ();
return nil ;};type pageColorspaceOptimizeFunc func (_cgg *_da .Document ,_cca *_da .Page ,_cdfc []*_da .Image )error ;func _aacfe (_cfda *_gd .PdfObjectDictionary ,_efdde map[*_gd .PdfObjectStream ][]byte ,_ecef map[*_gd .PdfObjectStream ]*_ecd .CMap )ViolatedRule {const (_eaabd ="\u0036\u002e\u0032\u002e\u0031\u0031\u002e\u0037\u002d\u0031";
_acab ="\u0054\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006ea\u0072\u0079\u0020\u0073\u0068\u0061\u006cl\u0020\u0069\u006e\u0063l\u0075\u0064e\u0020\u0061 \u0054\u006f\u0055\u006e\u0069\u0063\u006f\u0064\u0065\u0020\u0065\u006e\u0074\u0072\u0079\u0020w\u0068\u006f\u0073\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0069\u0073 \u0061\u0020\u0043M\u0061\u0070\u0020\u0073\u0074\u0072\u0065\u0061\u006d \u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0074\u0068\u0061\u0074\u0020\u006d\u0061p\u0073\u0020\u0063\u0068\u0061\u0072ac\u0074\u0065\u0072\u0020\u0063\u006fd\u0065s\u0020\u0074\u006f\u0020\u0055\u006e\u0069\u0063\u006f\u0064e \u0076a\u006c\u0075\u0065\u0073,\u0020\u0061\u0073\u0020\u0064\u0065\u0073\u0063r\u0069\u0062\u0065\u0064\u0020\u0069\u006e\u0020P\u0044\u0046\u0020\u0052\u0065f\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0035.\u0039\u002c\u0020\u0075\u006e\u006ce\u0073\u0073\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0020\u006d\u0065\u0065\u0074\u0073 \u0061\u006e\u0079\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006c\u006c\u006f\u0077\u0069\u006e\u0067\u0020\u0074\u0068\u0072\u0065\u0065\u0020\u0063\u006f\u006e\u0064\u0069\u0074\u0069\u006f\u006e\u0073\u003a\u000a\u0020\u002d\u0020\u0066o\u006e\u0074\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0075\u0073\u0065\u0020\u0074\u0068\u0065\u0020\u0070\u0072\u0065\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0065\u006e\u0063\u006f\u0064\u0069n\u0067\u0073\u0020M\u0061\u0063\u0052o\u006d\u0061\u006e\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067\u002c\u0020\u004d\u0061\u0063\u0045\u0078\u0070\u0065\u0072\u0074E\u006e\u0063\u006f\u0064\u0069\u006e\u0067\u0020\u006f\u0072\u0020\u0057\u0069\u006e\u0041n\u0073\u0069\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067\u002c\u0020\u006f\u0072\u0020\u0074\u0068\u0061\u0074\u0020\u0075\u0073\u0065\u0020t\u0068\u0065\u0020\u0070\u0072\u0065d\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0048\u0020\u006f\u0072\u0020\u0049\u0064\u0065n\u0074\u0069\u0074\u0079\u002d\u0056\u0020C\u004d\u0061\u0070s\u003b\u000a\u0020\u002d\u0020\u0054\u0079\u0070\u0065\u0020\u0031\u0020\u0066\u006f\u006e\u0074\u0073\u0020\u0077\u0068\u006f\u0073\u0065\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u006e\u0061\u006d\u0065\u0073\u0020a\u0072\u0065 \u0074\u0061k\u0065\u006e\u0020\u0066\u0072\u006f\u006d\u0020\u0074\u0068\u0065\u0020\u0041\u0064\u006f\u0062\u0065\u0020\u0073\u0074\u0061n\u0064\u0061\u0072\u0064\u0020L\u0061t\u0069\u006e\u0020\u0063\u0068a\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u0073\u0065\u0074\u0020\u006fr\u0020\u0074\u0068\u0065 \u0073\u0065\u0074\u0020\u006f\u0066 \u006e\u0061\u006d\u0065\u0064\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065r\u0073\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0053\u0079\u006d\u0062\u006f\u006c\u0020\u0066\u006f\u006e\u0074\u002c\u0020\u0061\u0073\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020i\u006e\u0020\u0050\u0044\u0046 \u0052\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0041\u0070\u0070\u0065\u006e\u0064\u0069\u0078 \u0044\u003b\u000a\u0020\u002d\u0020\u0054\u0079\u0070\u0065\u0020\u0030\u0020\u0066\u006f\u006e\u0074\u0073\u0020w\u0068\u006f\u0073e\u0020d\u0065\u0073\u0063\u0065n\u0064\u0061\u006e\u0074 \u0043\u0049\u0044\u0046\u006f\u006e\u0074\u0020\u0075\u0073\u0065\u0073\u0020\u0074\u0068\u0065\u0020\u0041\u0064\u006f\u0062\u0065\u002d\u0047B\u0031\u002c\u0020\u0041\u0064\u006fb\u0065\u002d\u0043\u004e\u0053\u0031\u002c\u0020\u0041\u0064\u006f\u0062\u0065\u002d\u004a\u0061\u0070\u0061\u006e\u0031\u0020\u006f\u0072\u0020\u0041\u0064\u006f\u0062\u0065\u002d\u004b\u006fr\u0065\u0061\u0031\u0020\u0063\u0068\u0061r\u0061\u0063\u0074\u0065\u0072\u0020\u0063\u006f\u006c\u006c\u0065\u0063\u0074\u0069\u006f\u006e\u0073\u002e";
);_cefa ,_cafg :=_gd .GetStream (_cfda .Get ("\u0054o\u0055\u006e\u0069\u0063\u006f\u0064e"));if _cafg {_ ,_bccd :=_eaccc (_cefa ,_efdde ,_ecef );if _bccd !=nil {return _ab (_eaabd ,_acab );};return _fc ;};_eabde ,_cafg :=_gd .GetName (_cfda .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));
if !_cafg {return _ab (_eaabd ,_acab );};switch _eabde .String (){case "\u0054\u0079\u0070e\u0031":return _fc ;};return _ab (_eaabd ,_acab );};

// Validate checks if provided input document reader matches given PDF/A profile.
func Validate (d *_b .CompliancePdfReader ,profile Profile )error {return profile .ValidateStandard (d )};func _adge (_abbea *_b .CompliancePdfReader )(_gbeaa []ViolatedRule ){var (_dfaa ,_bcdbb ,_gfgfb ,_adeb ,_gedf bool ;_effbg func (_gd .PdfObject );
);_effbg =func (_dcdd _gd .PdfObject ){switch _cgbbc :=_dcdd .(type ){case *_gd .PdfObjectInteger :if !_dfaa &&(int64 (*_cgbbc )> _a .MaxInt32 ||int64 (*_cgbbc )< -_a .MaxInt32 ){_gbeaa =append (_gbeaa ,_ab ("\u0036\u002e\u0031\u002e\u0031\u0033\u002d\u0031","L\u0061\u0072\u0067e\u0073\u0074\u0020\u0049\u006e\u0074\u0065\u0067\u0065\u0072\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0069\u0073\u0020\u0032\u002c\u0031\u0034\u0037,\u0034\u0038\u0033,\u0036\u0034\u0037\u002e\u0020\u0053\u006d\u0061\u006c\u006c\u0065\u0073\u0074 \u0069\u006e\u0074\u0065g\u0065\u0072\u0020\u0076a\u006c\u0075\u0065\u0020\u0069\u0073\u0020\u002d\u0032\u002c\u0031\u0034\u0037\u002c\u0034\u0038\u0033,\u0036\u0034\u0038\u002e"));
_dfaa =true ;};case *_gd .PdfObjectFloat :if !_bcdbb &&(_a .Abs (float64 (*_cgbbc ))> _a .MaxFloat32 ){_gbeaa =append (_gbeaa ,_ab ("\u0036\u002e\u0031\u002e\u0031\u0033\u002d\u0032","\u0041 \u0063\u006f\u006e\u0066orm\u0069\u006e\u0067\u0020f\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020n\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u006e\u0079\u0020\u0072\u0065\u0061\u006c\u0020\u006e\u0075\u006db\u0065\u0072\u0020\u006f\u0075\u0074\u0073\u0069de\u0020\u0074\u0068e\u0020\u0072\u0061\u006e\u0067e\u0020o\u0066\u0020\u002b\u002f\u002d\u0033\u002e\u0034\u00303\u0020\u0078\u0020\u0031\u0030\u005e\u0033\u0038\u002e"));
};case *_gd .PdfObjectString :if !_gfgfb &&len ([]byte (_cgbbc .Str ()))> 32767{_gbeaa =append (_gbeaa ,_ab ("\u0036\u002e\u0031\u002e\u0031\u0033\u002d\u0033","M\u0061\u0078\u0069\u006d\u0075\u006d\u0020\u006c\u0065n\u0067\u0074\u0068\u0020\u006f\u0066\u0020a \u0073\u0074\u0072\u0069n\u0067\u0020\u0028\u0069\u006e\u0020\u0062\u0079\u0074es\u0029\u0020i\u0073\u0020\u0033\u0032\u0037\u0036\u0037\u002e"));
_gfgfb =true ;};case *_gd .PdfObjectName :if !_adeb &&len ([]byte (*_cgbbc ))> 127{_gbeaa =append (_gbeaa ,_ab ("\u0036\u002e\u0031\u002e\u0031\u0033\u002d\u0034","\u004d\u0061\u0078\u0069\u006d\u0075\u006d \u006c\u0065\u006eg\u0074\u0068\u0020\u006ff\u0020\u0061\u0020\u006e\u0061\u006d\u0065\u0020\u0028\u0069\u006e\u0020\u0062\u0079\u0074\u0065\u0073\u0029\u0020\u0069\u0073\u0020\u0031\u0032\u0037\u002e"));
_adeb =true ;};case *_gd .PdfObjectArray :for _ ,_fgdbe :=range _cgbbc .Elements (){_effbg (_fgdbe );};if !_gedf &&(_cgbbc .Len ()==4||_cgbbc .Len ()==5){_dbdac ,_fddb :=_gd .GetName (_cgbbc .Get (0));if !_fddb {return ;};if *_dbdac !="\u0044e\u0076\u0069\u0063\u0065\u004e"{return ;
};_eafe :=_cgbbc .Get (1);_eafe =_gd .TraceToDirectObject (_eafe );_bcfb ,_fddb :=_gd .GetArray (_eafe );if !_fddb {return ;};if _bcfb .Len ()> 32{_gbeaa =append (_gbeaa ,_ab ("\u0036\u002e\u0031\u002e\u0031\u0033\u002d\u0039","\u004d\u0061\u0078\u0069\u006d\u0075\u006d \u006e\u0075\u006db\u0065\u0072\u0020\u006ff\u0020\u0044\u0065\u0076\u0069\u0063\u0065\u004e\u0020\u0063\u006f\u006d\u0070\u006f\u006e\u0065\u006e\u0074\u0073\u0020\u0069\u0073\u0020\u0033\u0032\u002e"));
_gedf =true ;};};case *_gd .PdfObjectDictionary :_eagg :=_cgbbc .Keys ();for _gfec ,_aebf :=range _eagg {_effbg (&_eagg [_gfec ]);_effbg (_cgbbc .Get (_aebf ));};case *_gd .PdfObjectStream :_effbg (_cgbbc .PdfObjectDictionary );case *_gd .PdfObjectStreams :for _ ,_bafec :=range _cgbbc .Elements (){_effbg (_bafec );
};case *_gd .PdfObjectReference :_effbg (_cgbbc .Resolve ());};};_deda :=_abbea .GetObjectNums ();if len (_deda )> 8388607{_gbeaa =append (_gbeaa ,_ab ("\u0036\u002e\u0031\u002e\u0031\u0033\u002d\u0037","\u004d\u0061\u0078\u0069\u006d\u0075\u006d\u0020\u006e\u0075\u006d\u0062\u0065\u0072\u0020\u006f\u0066\u0020in\u0064i\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0073 \u0069\u006e\u0020\u0061\u0020\u0050\u0044\u0046\u0020\u0066\u0069\u006c\u0065\u0020\u0069\u0073\u00208\u002c\u0033\u0038\u0038\u002c\u0036\u0030\u0037\u002e"));
};for _ ,_feag :=range _deda {_dgcc ,_gafb :=_abbea .GetIndirectObjectByNumber (_feag );if _gafb !=nil {continue ;};_dfab :=_gd .TraceToDirectObject (_dgcc );_effbg (_dfab );};return _gbeaa ;};func _bbag (_egee *_b .CompliancePdfReader )ViolatedRule {_bcca ,_eeff :=_egee .GetTrailer ();
if _eeff !=nil {_ae .Log .Debug ("\u0043\u0061\u006en\u006f\u0074\u0020\u0067e\u0074\u0020\u0064\u006f\u0063\u0075\u006de\u006e\u0074\u0020\u0074\u0072\u0061\u0069\u006c\u0065\u0072\u003a\u0020\u0025\u0076",_eeff );return _fc ;};_ggac ,_ecdb :=_bcca .Get ("\u0052\u006f\u006f\u0074").(*_gd .PdfObjectReference );
if !_ecdb {_ae .Log .Debug ("\u0043a\u006e\u006e\u006f\u0074 \u0066\u0069\u006e\u0064\u0020d\u006fc\u0075m\u0065\u006e\u0074\u0020\u0072\u006f\u006ft");return _fc ;};_dffc ,_ecdb :=_gd .GetDict (_gd .ResolveReference (_ggac ));if !_ecdb {_ae .Log .Debug ("\u0063\u0061\u006e\u006e\u006f\u0074 \u0072\u0065\u0073\u006f\u006c\u0076\u0065\u0020\u0063\u0061\u0074\u0061\u006co\u0067\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079");
return _fc ;};if _dffc .Get ("\u004f\u0043\u0050r\u006f\u0070\u0065\u0072\u0074\u0069\u0065\u0073")!=nil {return _ab ("\u0036\u002e\u0031\u002e\u0031\u0033\u002d\u0031","\u0054\u0068\u0065\u0020\u0064\u006f\u0063u\u006d\u0065\u006e\u0074\u0020\u0063\u0061\u0074\u0061\u006c\u006f\u0067\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0020s\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020c\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u0020\u006b\u0065\u0079\u0020\u0077\u0069\u0074\u0068\u0020\u0074\u0068\u0065\u0020\u006e\u0061\u006d\u0065\u0020\u004f\u0043\u0050\u0072\u006f\u0070\u0065\u0072\u0074\u0069\u0065\u0073");
};return _fc ;};

// VerificationError is the PDF/A verification error structure, that contains all violated rules.
type VerificationError struct{

// ViolatedRules are the rules that were violated during error verification.
ViolatedRules []ViolatedRule ;

// ConformanceLevel defines the standard on verification failed.
ConformanceLevel int ;

// ConformanceVariant is the standard variant used on verification.
ConformanceVariant string ;};func _dbef (_acdd *_da .Document )error {_dff ,_cbfd :=_acdd .FindCatalog ();if !_cbfd {return _age .New ("\u0063\u0061\u0074\u0061\u006c\u006f\u0067\u0020\u006e\u006f\u0074\u0020f\u006f\u0075\u006e\u0064");};_geeb ,_cbfd :=_gd .GetDict (_dff .Object .Get ("\u004e\u0061\u006de\u0073"));
if !_cbfd {return nil ;};if _geeb .Get ("\u0041\u006c\u0074\u0065rn\u0061\u0074\u0065\u0050\u0072\u0065\u0073\u0065\u006e\u0074\u0061\u0074\u0069\u006fn\u0073")!=nil {_geeb .Remove ("\u0041\u006c\u0074\u0065rn\u0061\u0074\u0065\u0050\u0072\u0065\u0073\u0065\u006e\u0074\u0061\u0074\u0069\u006fn\u0073");
};return nil ;};func _dbf (_eee bool ,_bcee standardType )(pageColorspaceOptimizeFunc ,documentColorspaceOptimizeFunc ){var _gbbb ,_fccb ,_acg bool ;_fdae :=func (_bcf *_da .Document ,_fcde *_da .Page ,_bae []*_da .Image )error {for _ ,_gfc :=range _bae {switch _gfc .Colorspace {case "\u0044\u0065\u0076\u0069\u0063\u0065\u0047\u0072\u0061\u0079":_fccb =true ;
case "\u0044e\u0076\u0069\u0063\u0065\u0052\u0047B":_gbbb =true ;case "\u0044\u0065\u0076\u0069\u0063\u0065\u0043\u004d\u0059\u004b":_acg =true ;};};_gceb ,_adfc :=_fcde .GetContents ();if !_adfc {return nil ;};for _ ,_deed :=range _gceb {_faac ,_efc :=_deed .GetData ();
if _efc !=nil {continue ;};_ggdg :=_dc .NewContentStreamParser (string (_faac ));_caa ,_efc :=_ggdg .Parse ();if _efc !=nil {continue ;};for _ ,_gac :=range *_caa {switch _gac .Operand {case "\u0047","\u0067":_fccb =true ;case "\u0052\u0047","\u0072\u0067":_gbbb =true ;
case "\u004b","\u006b":_acg =true ;case "\u0043\u0053","\u0063\u0073":if len (_gac .Params )==0{continue ;};_bcbc ,_fge :=_gd .GetName (_gac .Params [0]);if !_fge {continue ;};switch _bcbc .String (){case "\u0052\u0047\u0042","\u0044e\u0076\u0069\u0063\u0065\u0052\u0047B":_gbbb =true ;
case "\u0047","\u0044\u0065\u0076\u0069\u0063\u0065\u0047\u0072\u0061\u0079":_fccb =true ;case "\u0043\u004d\u0059\u004b","\u0044\u0065\u0076\u0069\u0063\u0065\u0043\u004d\u0059\u004b":_acg =true ;};};};};_bcdd :=_fcde .FindXObjectForms ();for _ ,_dcdf :=range _bcdd {_bbea :=_dc .NewContentStreamParser (string (_dcdf .Stream ));
_dgb ,_cdbb :=_bbea .Parse ();if _cdbb !=nil {continue ;};for _ ,_cdca :=range *_dgb {switch _cdca .Operand {case "\u0047","\u0067":_fccb =true ;case "\u0052\u0047","\u0072\u0067":_gbbb =true ;case "\u004b","\u006b":_acg =true ;case "\u0043\u0053","\u0063\u0073":if len (_cdca .Params )==0{continue ;
};_cbc ,_dgbf :=_gd .GetName (_cdca .Params [0]);if !_dgbf {continue ;};switch _cbc .String (){case "\u0052\u0047\u0042","\u0044e\u0076\u0069\u0063\u0065\u0052\u0047B":_gbbb =true ;case "\u0047","\u0044\u0065\u0076\u0069\u0063\u0065\u0047\u0072\u0061\u0079":_fccb =true ;
case "\u0043\u004d\u0059\u004b","\u0044\u0065\u0076\u0069\u0063\u0065\u0043\u004d\u0059\u004b":_acg =true ;};};};_ddc ,_fgb :=_gd .GetArray (_fcde .Object .Get ("\u0041\u006e\u006e\u006f\u0074\u0073"));if !_fgb {return nil ;};for _ ,_ffcd :=range _ddc .Elements (){_geec ,_aaa :=_gd .GetDict (_ffcd );
if !_aaa {continue ;};_ccgg :=_geec .Get ("\u0043");if _ccgg ==nil {continue ;};_cdgg ,_aaa :=_gd .GetArray (_ccgg );if !_aaa {continue ;};switch _cdgg .Len (){case 0:case 1:_fccb =true ;case 3:_gbbb =true ;case 4:_acg =true ;};};};return nil ;};_eff :=func (_dgbd *_da .Document ,_acf []*_da .Image )error {_fbgd ,_gdbe :=_dgbd .FindCatalog ();
if !_gdbe {return nil ;};_afga ,_gdbe :=_fbgd .GetOutputIntents ();if _gdbe &&_afga .Len ()> 0{return nil ;};if !_gdbe {_afga =_fbgd .NewOutputIntents ();};if !(_gbbb ||_acg ||_fccb ){return nil ;};defer _fbgd .SetOutputIntents (_afga );if _gbbb &&!_acg &&!_fccb {return _fafae (_dgbd ,_bcee ,_afga );
};if _acg &&!_gbbb &&!_fccb {return _bgeg (_bcee ,_afga );};if _fccb &&!_gbbb &&!_acg {return _bdgd (_bcee ,_afga );};if _gbbb &&_acg {if _ceb :=_cec (_acf ,_eee );_ceb !=nil {return _ceb ;};if _bef :=_deba (_dgbd ,_eee );_bef !=nil {return _bef ;};if _gcebc :=_dged (_dgbd ,_eee );
_gcebc !=nil {return _gcebc ;};if _bffb :=_gbgb (_dgbd ,_eee );_bffb !=nil {return _bffb ;};if _eee {return _bgeg (_bcee ,_afga );};return _fafae (_dgbd ,_bcee ,_afga );};return nil ;};return _fdae ,_eff ;};func _ddcgg (_cfde *_b .CompliancePdfReader )(_gcaf []ViolatedRule ){var _cdbc ,_cggbf ,_edebe bool ;
if _cfde .ParserMetadata ().HasNonConformantStream (){_gcaf =[]ViolatedRule {_ab ("\u0036.\u0031\u002e\u0037\u002d\u0032","T\u0068\u0065\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006b\u0065\u0079\u0077\u006fr\u0064\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065\u0020f\u006f\u006cl\u006fw\u0065\u0064\u0020e\u0069\u0074h\u0065\u0072\u0020\u0062\u0079\u0020\u0061 \u0043\u0041\u0052\u0052I\u0041\u0047\u0045\u0020\u0052E\u0054\u0055\u0052\u004e\u0020\u00280\u0044\u0068\u0029\u0020\u0061\u006e\u0064\u0020\u004c\u0049\u004e\u0045\u0020F\u0045\u0045\u0044\u0020\u0028\u0030\u0041\u0068\u0029\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u0073\u0065\u0071\u0075\u0065\u006e\u0063\u0065\u0020o\u0072\u0020\u0062\u0079\u0020\u0061 \u0073\u0069ng\u006c\u0065\u0020\u004cIN\u0045 \u0046\u0045\u0045\u0044 \u0063\u0068\u0061r\u0061\u0063\u0074\u0065\u0072\u002e\u0020T\u0068\u0065\u0020e\u006e\u0064\u0073\u0074r\u0065\u0061\u006d\u0020\u006b\u0065\u0079\u0077\u006fr\u0064\u0020\u0073\u0068\u0061\u006c\u006c \u0062e\u0020p\u0072\u0065\u0063\u0065\u0064\u0065\u0064\u0020\u0062\u0079\u0020\u0061n\u0020\u0045\u004f\u004c \u006d\u0061\u0072\u006b\u0065\u0072\u002e")};
};for _ ,_ffcf :=range _cfde .GetObjectNums (){_efcec ,_ :=_cfde .GetIndirectObjectByNumber (_ffcf );if _efcec ==nil {continue ;};_bgacb ,_cgbgb :=_gd .GetStream (_efcec );if !_cgbgb {continue ;};if !_cdbc {_bfce :=_bgacb .Get ("\u004c\u0065\u006e\u0067\u0074\u0068");
if _bfce ==nil {_gcaf =append (_gcaf ,_ab ("\u0036.\u0031\u002e\u0037\u002d\u0031","\u006e\u006f\u0020'\u004c\u0065\u006e\u0067\u0074\u0068\u0027\u0020\u006b\u0065\u0079\u0020\u0066\u006f\u0075\u006e\u0064\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0073\u0074\u0072\u0065a\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074"));
_cdbc =true ;}else {_bdbb ,_fgbc :=_gd .GetIntVal (_bfce );if !_fgbc {_gcaf =append (_gcaf ,_ab ("\u0036.\u0031\u002e\u0037\u002d\u0031","s\u0074\u0072\u0065\u0061\u006d\u0020\u0027\u004c\u0065\u006e\u0067\u0074\u0068\u0027\u0020\u006b\u0065\u0079 \u0073\u0068\u006f\u0075\u006c\u0064\u0020\u0062\u0065\u0020an\u0020\u0069\u006et\u0065g\u0065\u0072"));
_cdbc =true ;}else {if len (_bgacb .Stream )!=_bdbb {_gcaf =append (_gcaf ,_ab ("\u0036.\u0031\u002e\u0037\u002d\u0031","\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u006c\u0065\u006e\u0067th\u0020v\u0061\u006c\u0075\u0065\u0020\u0073\u0068\u006f\u0075\u006c\u0064\u0020m\u0061\u0074\u0063\u0068\u0020\u0074\u0068\u0065\u0020\u0073\u0069\u007a\u0065\u0020\u006f\u0066\u0020t\u0068\u0065\u0020\u0073\u0074\u0072\u0065\u0061\u006d"));
_cdbc =true ;};};};};if !_cggbf {if _bgacb .Get ("\u0046")!=nil {_cggbf =true ;_gcaf =append (_gcaf ,_ab ("\u0036.\u0031\u002e\u0037\u002d\u0033","\u0073\u0074r\u0065\u0061\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0068\u006f\u0075\u006c\u0064\u0020\u006eo\u0074\u0020\u0063\u006f\u006e\u0074a\u0069\u006e\u0020\u0027\u0046\u0027\u002c\u0027\u0046\u0046\u0069\u006c\u0074\u0065r\u0027\u002c'\u0046\u0044\u0065\u0063o\u0064\u0065\u0050\u0061\u0072a\u006d\u0073\u0027\u0020\u006b\u0065\u0079"));
};if _bgacb .Get ("\u0046F\u0069\u006c\u0074\u0065\u0072")!=nil &&!_cggbf {_cggbf =true ;_gcaf =append (_gcaf ,_ab ("\u0036.\u0031\u002e\u0037\u002d\u0033","\u0073\u0074r\u0065\u0061\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0068\u006f\u0075\u006c\u0064\u0020\u006eo\u0074\u0020\u0063\u006f\u006e\u0074a\u0069\u006e\u0020\u0027\u0046\u0027\u002c\u0027\u0046\u0046\u0069\u006c\u0074\u0065r\u0027\u002c'\u0046\u0044\u0065\u0063o\u0064\u0065\u0050\u0061\u0072a\u006d\u0073\u0027\u0020\u006b\u0065\u0079"));
continue ;};if _bgacb .Get ("\u0046\u0044\u0065\u0063\u006f\u0064\u0065\u0050\u0061\u0072\u0061\u006d\u0073")!=nil &&!_cggbf {_cggbf =true ;_gcaf =append (_gcaf ,_ab ("\u0036.\u0031\u002e\u0037\u002d\u0033","\u0073\u0074r\u0065\u0061\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0068\u006f\u0075\u006c\u0064\u0020\u006eo\u0074\u0020\u0063\u006f\u006e\u0074a\u0069\u006e\u0020\u0027\u0046\u0027\u002c\u0027\u0046\u0046\u0069\u006c\u0074\u0065r\u0027\u002c'\u0046\u0044\u0065\u0063o\u0064\u0065\u0050\u0061\u0072a\u006d\u0073\u0027\u0020\u006b\u0065\u0079"));
continue ;};};if !_edebe {_dggedb ,_dbgd :=_gd .GetName (_gd .TraceToDirectObject (_bgacb .Get ("\u0046\u0069\u006c\u0074\u0065\u0072")));if !_dbgd {continue ;};if *_dggedb ==_gd .StreamEncodingFilterNameLZW {_edebe =true ;_gcaf =append (_gcaf ,_ab ("\u0036.\u0031\u002e\u0037\u002d\u0034","\u0054h\u0065\u0020L\u005a\u0057\u0044\u0065c\u006f\u0064\u0065 \u0066\u0069\u006c\u0074\u0065\u0072\u0020\u0073\u0068al\u006c\u0020\u006eo\u0074\u0020b\u0065\u0020\u0070\u0065\u0072\u006di\u0074\u0074e\u0064\u002e"));
};};};return _gcaf ;};func _bbdd (_geab *_b .CompliancePdfReader )(_bbcef []ViolatedRule ){var _bbcbd ,_cffg ,_bbcca ,_ffec ,_bebgd ,_dfad bool ;_dbdb :=func ()bool {return _bbcbd &&_cffg &&_bbcca &&_ffec &&_bebgd &&_dfad };_cebce :=func (_fdeg *_gd .PdfObjectDictionary )bool {if !_bbcbd &&_fdeg .Get ("\u0054\u0052")!=nil {_bbcbd =true ;
_bbcef =append (_bbcef ,_ab ("\u0036.\u0032\u002e\u0038\u002d\u0031","\u0041\u006e\u0020\u0045\u0078\u0074\u0047\u0053\u0074\u0061\u0074e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006ea\u0072y\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e \u0074\u0068\u0065\u0020\u0054\u0052\u0020\u006b\u0065\u0079\u002e"));
};if _ffaab :=_fdeg .Get ("\u0054\u0052\u0032");!_cffg &&_ffaab !=nil {_aggf ,_eggac :=_gd .GetName (_ffaab );if !_eggac ||(_eggac &&*_aggf !="\u0044e\u0066\u0061\u0075\u006c\u0074"){_cffg =true ;_bbcef =append (_bbcef ,_ab ("\u0036.\u0032\u002e\u0038\u002d\u0032","\u0041\u006e \u0045\u0078\u0074G\u0053\u0074\u0061\u0074\u0065 \u0064\u0069\u0063\u0074\u0069on\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074a\u0069n\u0020\u0074\u0068\u0065\u0020\u0054R2 \u006b\u0065\u0079\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u0020\u0076al\u0075e\u0020\u006f\u0074\u0068e\u0072 \u0074h\u0061\u006e \u0044\u0065fa\u0075\u006c\u0074\u002e"));
if _dbdb (){return true ;};};};if _agbb :=_fdeg .Get ("\u0053\u004d\u0061s\u006b");!_bbcca &&_agbb !=nil {_fbeea ,_dceg :=_gd .GetName (_agbb );if !_dceg ||(_dceg &&*_fbeea !="\u004e\u006f\u006e\u0065"){_bbcca =true ;_bbcef =append (_bbcef ,_ab ("\u0036\u002e\u0034-\u0031","\u0049\u0066\u0020\u0061\u006e \u0053\u004d\u0061\u0073\u006b\u0020\u006be\u0079\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0073\u0020\u0069\u006e\u0020\u0061\u006e\u0020\u0045\u0078\u0074\u0047\u0053\u0074\u0061\u0074\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002c\u0020\u0069\u0074s\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065\u0020\u004e\u006f\u006ee\u002e"));
if _dbdb (){return true ;};};};if _gabc :=_fdeg .Get ("\u0043\u0041");!_bebgd &&_gabc !=nil {_bebbd ,_face :=_gd .GetNumberAsFloat (_gabc );if _face ==nil &&_bebbd !=1.0{_bebgd =true ;_bbcef =append (_bbcef ,_ab ("\u0036\u002e\u0034-\u0035","\u0054\u0068\u0065\u0020\u0066ol\u006c\u006fw\u0069\u006e\u0067\u0020\u006b\u0065\u0079\u0073\u002c\u0020\u0069\u0066\u0020\u0070\u0072\u0065\u0073\u0065\u006e\u0074\u0020\u0069\u006e\u0020\u0061\u006e\u0020\u0045\u0078t\u0047\u0053\u0074a\u0074\u0065\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u002c\u0020\u0073\u0068a\u006c\u006c\u0020\u0068\u0061v\u0065\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006cu\u0065\u0073 \u0073h\u006f\u0077\u006e\u003a\u0020\u0043\u0041 \u002d\u0020\u0031\u002e\u0030\u002e"));
if _dbdb (){return true ;};};};if _bagc :=_fdeg .Get ("\u0063\u0061");!_dfad &&_bagc !=nil {_dbagg ,_abffc :=_gd .GetNumberAsFloat (_bagc );if _abffc ==nil &&_dbagg !=1.0{_dfad =true ;_bbcef =append (_bbcef ,_ab ("\u0036\u002e\u0034-\u0036","\u0054\u0068\u0065\u0020\u0066ol\u006c\u006fw\u0069\u006e\u0067\u0020\u006b\u0065\u0079\u0073\u002c\u0020\u0069\u0066\u0020\u0070\u0072\u0065\u0073\u0065\u006e\u0074\u0020\u0069\u006e\u0020\u0061\u006e\u0020\u0045\u0078t\u0047\u0053\u0074a\u0074\u0065\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u002c\u0020\u0073\u0068a\u006c\u006c\u0020\u0068\u0061v\u0065\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006cu\u0065\u0073 \u0073h\u006f\u0077\u006e\u003a\u0020\u0063\u0061 \u002d\u0020\u0031\u002e\u0030\u002e"));
if _dbdb (){return true ;};};};if _ecdgd :=_fdeg .Get ("\u0042\u004d");!_ffec &&_ecdgd !=nil {_gcagg ,_ebfff :=_gd .GetName (_ecdgd );if _ebfff {switch _gcagg .String (){case "\u004e\u006f\u0072\u006d\u0061\u006c","\u0043\u006f\u006d\u0070\u0061\u0074\u0069\u0062\u006c\u0065":default:_ffec =true ;
_bbcef =append (_bbcef ,_ab ("\u0036\u002e\u0034-\u0034","T\u0068\u0065\u0020\u0066\u006f\u006cl\u006f\u0077\u0069\u006e\u0067 \u006b\u0065y\u0073\u002c\u0020\u0069\u0066 \u0070res\u0065\u006e\u0074\u0020\u0069\u006e\u0020\u0061\u006e\u0020\u0045\u0078\u0074\u0047S\u0074\u0061t\u0065\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u002c\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0068\u0061\u0076\u0065 \u0074\u0068\u0065 \u0076\u0061\u006c\u0075\u0065\u0073\u0020\u0073\u0068\u006f\u0077n\u003a\u0020\u0042\u004d\u0020\u002d\u0020\u004e\u006f\u0072m\u0061\u006c\u0020\u006f\u0072\u0020\u0043\u006f\u006d\u0070\u0061t\u0069\u0062\u006c\u0065\u002e"));
if _dbdb (){return true ;};};};};return false ;};for _ ,_bgbgdg :=range _geab .PageList {_bdbdd :=_bgbgdg .Resources ;if _bdbdd ==nil {continue ;};if _bdbdd .ExtGState ==nil {continue ;};_dbbc ,_aebeg :=_gd .GetDict (_bdbdd .ExtGState );if !_aebeg {continue ;
};_dedg :=_dbbc .Keys ();for _ ,_cfbb :=range _dedg {_dcgab ,_cdffa :=_gd .GetDict (_dbbc .Get (_cfbb ));if !_cdffa {continue ;};if _cebce (_dcgab ){return _bbcef ;};};};for _ ,_bgbd :=range _geab .PageList {_fbgcf :=_bgbd .Resources ;if _fbgcf ==nil {continue ;
};_eeeb ,_gcea :=_gd .GetDict (_fbgcf .XObject );if !_gcea {continue ;};for _ ,_cecf :=range _eeeb .Keys (){_eebb ,_ddbgf :=_gd .GetStream (_eeeb .Get (_cecf ));if !_ddbgf {continue ;};_aebgb ,_ddbgf :=_gd .GetDict (_eebb .Get ("\u0052e\u0073\u006f\u0075\u0072\u0063\u0065s"));
if !_ddbgf {continue ;};_bgdcf ,_ddbgf :=_gd .GetDict (_aebgb .Get ("\u0045x\u0074\u0047\u0053\u0074\u0061\u0074e"));if !_ddbgf {continue ;};for _ ,_cgdc :=range _bgdcf .Keys (){_gffd ,_gfdc :=_gd .GetDict (_bgdcf .Get (_cgdc ));if !_gfdc {continue ;};
if _cebce (_gffd ){return _bbcef ;};};};};return _bbcef ;};var _fc =ViolatedRule {};func _cbeaf (_ccaf *_gd .PdfObjectDictionary ,_fdgc map[*_gd .PdfObjectStream ][]byte ,_bcgd map[*_gd .PdfObjectStream ]*_ecd .CMap )ViolatedRule {const (_bfbbg ="\u0036.\u0033\u002e\u0038\u002d\u0031";
_ddbec ="\u0054\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006ea\u0072\u0079\u0020\u0073\u0068\u0061\u006cl\u0020\u0069\u006e\u0063l\u0075\u0064e\u0020\u0061 \u0054\u006f\u0055\u006e\u0069\u0063\u006f\u0064\u0065\u0020\u0065\u006e\u0074\u0072\u0079\u0020w\u0068\u006f\u0073\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0069\u0073 \u0061\u0020\u0043M\u0061\u0070\u0020\u0073\u0074\u0072\u0065\u0061\u006d \u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0074\u0068\u0061\u0074\u0020\u006d\u0061p\u0073\u0020\u0063\u0068\u0061\u0072ac\u0074\u0065\u0072\u0020\u0063\u006fd\u0065s\u0020\u0074\u006f\u0020\u0055\u006e\u0069\u0063\u006f\u0064e \u0076a\u006c\u0075\u0065\u0073,\u0020\u0061\u0073\u0020\u0064\u0065\u0073\u0063r\u0069\u0062\u0065\u0064\u0020\u0069\u006e\u0020P\u0044\u0046\u0020\u0052\u0065f\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0035.\u0039\u002c\u0020\u0075\u006e\u006ce\u0073\u0073\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0020\u006d\u0065\u0065\u0074\u0073 \u0061\u006e\u0079\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006c\u006c\u006f\u0077\u0069\u006e\u0067\u0020\u0074\u0068\u0072\u0065\u0065\u0020\u0063\u006f\u006e\u0064\u0069\u0074\u0069\u006f\u006e\u0073\u003a\u000a\u0020\u002d\u0020\u0066o\u006e\u0074\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0075\u0073\u0065\u0020\u0074\u0068\u0065\u0020\u0070\u0072\u0065\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0065\u006e\u0063\u006f\u0064\u0069n\u0067\u0073\u0020M\u0061\u0063\u0052o\u006d\u0061\u006e\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067\u002c\u0020\u004d\u0061\u0063\u0045\u0078\u0070\u0065\u0072\u0074E\u006e\u0063\u006f\u0064\u0069\u006e\u0067\u0020\u006f\u0072\u0020\u0057\u0069\u006e\u0041n\u0073\u0069\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067\u002c\u0020\u006f\u0072\u0020\u0074\u0068\u0061\u0074\u0020\u0075\u0073\u0065\u0020t\u0068\u0065\u0020\u0070\u0072\u0065d\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0048\u0020\u006f\u0072\u0020\u0049\u0064\u0065n\u0074\u0069\u0074\u0079\u002d\u0056\u0020C\u004d\u0061\u0070s\u003b\u000a\u0020\u002d\u0020\u0054\u0079\u0070\u0065\u0020\u0031\u0020\u0066\u006f\u006e\u0074\u0073\u0020\u0077\u0068\u006f\u0073\u0065\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u006e\u0061\u006d\u0065\u0073\u0020a\u0072\u0065 \u0074\u0061k\u0065\u006e\u0020\u0066\u0072\u006f\u006d\u0020\u0074\u0068\u0065\u0020\u0041\u0064\u006f\u0062\u0065\u0020\u0073\u0074\u0061n\u0064\u0061\u0072\u0064\u0020L\u0061t\u0069\u006e\u0020\u0063\u0068a\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u0073\u0065\u0074\u0020\u006fr\u0020\u0074\u0068\u0065 \u0073\u0065\u0074\u0020\u006f\u0066 \u006e\u0061\u006d\u0065\u0064\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065r\u0073\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0053\u0079\u006d\u0062\u006f\u006c\u0020\u0066\u006f\u006e\u0074\u002c\u0020\u0061\u0073\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020i\u006e\u0020\u0050\u0044\u0046 \u0052\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0041\u0070\u0070\u0065\u006e\u0064\u0069\u0078 \u0044\u003b\u000a\u0020\u002d\u0020\u0054\u0079\u0070\u0065\u0020\u0030\u0020\u0066\u006f\u006e\u0074\u0073\u0020w\u0068\u006f\u0073e\u0020d\u0065\u0073\u0063\u0065n\u0064\u0061\u006e\u0074 \u0043\u0049\u0044\u0046\u006f\u006e\u0074\u0020\u0075\u0073\u0065\u0073\u0020\u0074\u0068\u0065\u0020\u0041\u0064\u006f\u0062\u0065\u002d\u0047B\u0031\u002c\u0020\u0041\u0064\u006fb\u0065\u002d\u0043\u004e\u0053\u0031\u002c\u0020\u0041\u0064\u006f\u0062\u0065\u002d\u004a\u0061\u0070\u0061\u006e\u0031\u0020\u006f\u0072\u0020\u0041\u0064\u006f\u0062\u0065\u002d\u004b\u006fr\u0065\u0061\u0031\u0020\u0063\u0068\u0061r\u0061\u0063\u0074\u0065\u0072\u0020\u0063\u006f\u006c\u006c\u0065\u0063\u0074\u0069\u006f\u006e\u0073\u002e";
);_egfdf ,_cdbd :=_gd .GetStream (_ccaf .Get ("\u0054o\u0055\u006e\u0069\u0063\u006f\u0064e"));if _cdbd {_ ,_bfcba :=_eaccc (_egfdf ,_fdgc ,_bcgd );if _bfcba !=nil {return _ab (_bfbbg ,_ddbec );};return _fc ;};_defd ,_cdbd :=_gd .GetName (_ccaf .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));
if !_cdbd {return _ab (_bfbbg ,_ddbec );};switch _defd .String (){case "\u0054\u0079\u0070e\u0031":return _fc ;};return _ab (_bfbbg ,_ddbec );};var _ Profile =(*Profile2U )(nil );func _acag (_gcbc *_b .PdfFont ,_egdfg *_gd .PdfObjectDictionary ,_cbaae bool )ViolatedRule {const (_afef ="\u0036.\u0033\u002e\u0034\u002d\u0031";
_gbbcg ="\u0054\u0068\u0065\u0020\u0066\u006f\u006et\u0020\u0070\u0072\u006f\u0067\u0072\u0061\u006d\u0073\u0020\u0066\u006f\u0072\u0020\u0061\u006c\u006c\u0020\u0066\u006f\u006e\u0074\u0073\u0020\u0075\u0073\u0065\u0064\u0020\u0077\u0069\u0074\u0068\u0069\u006e \u0061\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069l\u0065\u0020s\u0068\u0061\u006cl\u0020\u0062\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065\u0064\u0020\u0077\u0069\u0074\u0068i\u006e\u0020\u0074h\u0061\u0074\u0020\u0066\u0069\u006ce\u002c\u0020a\u0073\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0069\u006e\u0020\u0050\u0044\u0046\u0020\u0052e\u0066\u0065\u0072\u0065\u006e\u0063\u0065 \u0035\u002e\u0038\u002c\u0020\u0065\u0078\u0063\u0065\u0070\u0074\u0020\u0077h\u0065\u006e\u0020\u0074\u0068\u0065 \u0066\u006f\u006e\u0074\u0073\u0020\u0061\u0072\u0065\u0020\u0075\u0073\u0065\u0064\u0020\u0065\u0078\u0063\u006cu\u0073i\u0076\u0065\u006c\u0079\u0020\u0077\u0069t\u0068\u0020\u0074\u0065\u0078\u0074\u0020\u0072e\u006ed\u0065\u0072\u0069\u006e\u0067\u0020\u006d\u006f\u0064\u0065\u0020\u0033\u002e";
);if _cbaae {return _fc ;};_aada :=_gcbc .FontDescriptor ();var _cdcfa string ;if _gbfcb ,_bafg :=_gd .GetName (_egdfg .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_bafg {_cdcfa =_gbfcb .String ();};switch _cdcfa {case "\u0054\u0079\u0070e\u0031":if _aada .FontFile ==nil {return _ab (_afef ,_gbbcg );
};case "\u0054\u0072\u0075\u0065\u0054\u0079\u0070\u0065":if _aada .FontFile2 ==nil {return _ab (_afef ,_gbbcg );};case "\u0054\u0079\u0070e\u0030","\u0054\u0079\u0070e\u0033":default:if _aada .FontFile3 ==nil {return _ab (_afef ,_gbbcg );};};return _fc ;
};func _efbg (_ccgc *_b .CompliancePdfReader )ViolatedRule {if _ccgc .ParserMetadata ().HeaderPosition ()!=0{return _ab ("\u0036.\u0031\u002e\u0032\u002d\u0031","h\u0065\u0061\u0064\u0065\u0072\u0020\u0070\u006f\u0073\u0069\u0074\u0069\u006f\u006e\u0020\u0069\u0073\u0020n\u006f\u0074\u0020\u0061\u0074\u0020\u0074\u0068\u0065\u0020fi\u0072\u0073\u0074 \u0062y\u0074\u0065");
};return _fc ;};func _edfc (_bdfc *_da .Document ){_daac ,_bddf :=_bdfc .FindCatalog ();if !_bddf {return ;};_eecgg ,_bddf :=_daac .GetMarkInfo ();if !_bddf {_eecgg =_gd .MakeDict ();};_eacd ,_bddf :=_gd .GetBool (_eecgg .Get ("\u004d\u0061\u0072\u006b\u0065\u0064"));
if !_bddf ||!bool (*_eacd ){_eecgg .Set ("\u004d\u0061\u0072\u006b\u0065\u0064",_gd .MakeBool (true ));_daac .SetMarkInfo (_eecgg );};};func _cbeba (_caga *_b .CompliancePdfReader )(_bbgab []ViolatedRule ){var _cfeg ,_fcadg ,_gccb ,_fddfb ,_gfad ,_ddfgf bool ;
_dbcg :=func ()bool {return _cfeg &&_fcadg &&_gccb &&_fddfb &&_gfad &&_ddfgf };for _ ,_bfge :=range _caga .PageList {if _bfge .Resources ==nil {continue ;};_bead ,_abda :=_gd .GetDict (_bfge .Resources .Font );if !_abda {continue ;};for _ ,_dggbe :=range _bead .Keys (){_dcgbe ,_ddbgd :=_gd .GetDict (_bead .Get (_dggbe ));
if !_ddbgd {if !_cfeg {_bbgab =append (_bbgab ,_ab ("\u0036\u002e\u0032\u002e\u0031\u0031\u002e\u0032\u002d\u0031","\u0041\u006c\u006c\u0020\u0066\u006f\u006e\u0074\u0073\u0020\u0061\u006e\u0064\u0020\u0066on\u0074 \u0070\u0072\u006fg\u0072\u0061\u006ds\u0020\u0075\u0073\u0065\u0064\u0020\u0069\u006e\u0020\u0061\u0020\u0063\u006f\u006e\u0066\u006f\u0072mi\u006e\u0067\u0020\u0066\u0069\u006ce\u002c\u0020\u0072\u0065\u0067\u0061\u0072\u0064\u006c\u0065s\u0073\u0020\u006f\u0066\u0020\u0072\u0065\u006e\u0064\u0065\u0072\u0069\u006eg m\u006f\u0064\u0065\u0020\u0075\u0073\u0061\u0067\u0065\u002c\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0020\u0074o\u0020\u0074\u0068e\u0020\u0070\u0072o\u0076\u0069\u0073\u0069\u006f\u006e\u0073\u0020\u0069\u006e \u0049\u0053\u004f\u0020\u0033\u0032\u0030\u0030\u0030\u002d\u0031:\u0032\u0030\u0030\u0038\u002c \u0039\u002e\u0036\u0020a\u006e\u0064\u0020\u0039.\u0037\u002e"));
_cfeg =true ;if _dbcg (){return _bbgab ;};};continue ;};if _ddadc ,_bbbb :=_gd .GetName (_dcgbe .Get ("\u0054\u0079\u0070\u0065"));!_cfeg &&(!_bbbb ||_ddadc .String ()!="\u0046\u006f\u006e\u0074"){_bbgab =append (_bbgab ,_ab ("\u0036\u002e\u0032\u002e\u0031\u0031\u002e\u0032\u002d\u0031","\u0054\u0079\u0070e\u0020\u002d\u0020\u006e\u0061\u006d\u0065\u0020\u002d\u0020\u0028\u0052\u0065\u0071\u0075i\u0072\u0065\u0064\u0029 Th\u0065\u0020\u0074\u0079\u0070\u0065\u0020\u006f\u0066 \u0050\u0044\u0046\u0020\u006fbj\u0065\u0063\u0074\u0020\u0074\u0068\u0061t\u0020\u0074\u0068\u0069s\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0064\u0065\u0073c\u0072\u0069\u0062\u0065\u0073\u003b\u0020\u006d\u0075\u0073t\u0020\u0062\u0065\u0020\u0046\u006f\u006e\u0074\u0020\u0066\u006fr\u0020\u0061\u0020\u0066\u006f\u006e\u0074\u0020\u0064\u0069\u0063t\u0069\u006f\u006e\u0061\u0072\u0079\u002e"));
_cfeg =true ;if _dbcg (){return _bbgab ;};};_faefe ,_bgcaa :=_b .NewPdfFontFromPdfObject (_dcgbe );if _bgcaa !=nil {continue ;};var _gabb string ;if _gaede ,_caaf :=_gd .GetName (_dcgbe .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_caaf {_gabb =_gaede .String ();
};if !_fcadg {switch _gabb {case "\u0054\u0079\u0070e\u0030","\u0054\u0079\u0070e\u0031","\u004dM\u0054\u0079\u0070\u0065\u0031","\u0054\u0072\u0075\u0065\u0054\u0079\u0070\u0065","\u0043\u0049\u0044F\u006f\u006e\u0074\u0054\u0079\u0070\u0065\u0030","\u0043\u0049\u0044F\u006f\u006e\u0074\u0054\u0079\u0070\u0065\u0032":default:_fcadg =true ;
_bbgab =append (_bbgab ,_ab ("\u0036\u002e\u0032\u002e\u0031\u0031\u002e\u0032\u002d\u0032","\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0020\u002d\u0020\u006e\u0061\u006d\u0065\u0020\u002d\u0020\u0028\u0052\u0065\u0071\u0075\u0069\u0072\u0065d\u0029\u0020\u0054\u0068e \u0074\u0079\u0070\u0065 \u006f\u0066\u0020\u0066\u006f\u006et\u003b\u0020\u006d\u0075\u0073\u0074\u0020b\u0065\u0020\u0022\u0054\u0079\u0070\u0065\u0031\u0022\u0020f\u006f\u0072\u0020\u0054\u0079\u0070\u0065\u0020\u0031\u0020f\u006f\u006e\u0074\u0073\u002c\u0020\u0022\u004d\u004d\u0054\u0079\u0070\u0065\u0031\u0022\u0020\u0066\u006f\u0072\u0020\u006d\u0075\u006c\u0074\u0069\u0070\u006c\u0065\u0020\u006da\u0073\u0074e\u0072\u0020\u0066\u006f\u006e\u0074s\u002c\u0020\u0022\u0054\u0072\u0075\u0065T\u0079\u0070\u0065\u0022\u0020\u0066\u006f\u0072\u0020\u0054\u0072\u0075\u0065T\u0079\u0070\u0065\u0020\u0066\u006f\u006e\u0074\u0073\u0020\u0022\u0054\u0079\u0070\u0065\u0033\u0022\u0020\u0066\u006f\u0072\u0020\u0054\u0079\u0070e\u0020\u0033\u0020\u0066\u006f\u006e\u0074\u0073\u002c\u0020\"\u0054\u0079\u0070\u0065\u0030\"\u0020\u0066\u006f\u0072\u0020\u0054\u0079\u0070\u0065\u0020\u0030\u0020\u0066\u006f\u006e\u0074\u0073\u0020\u0061\u006ed\u0020\u0022\u0043\u0049\u0044\u0046\u006fn\u0074\u0054\u0079\u0070\u0065\u0030\u0022 \u006f\u0072\u0020\u0022\u0043\u0049\u0044\u0046\u006f\u006e\u0074T\u0079\u0070e\u0032\u0022\u0020\u0066\u006f\u0072\u0020\u0043\u0049\u0044\u0020\u0066\u006f\u006e\u0074\u0073\u002e"));
if _dbcg (){return _bbgab ;};};};if !_gccb {if _gabb !="\u0054\u0079\u0070e\u0033"{_eeac ,_bgba :=_gd .GetName (_dcgbe .Get ("\u0042\u0061\u0073\u0065\u0046\u006f\u006e\u0074"));if !_bgba ||_eeac .String ()==""{_bbgab =append (_bbgab ,_ab ("\u0036\u002e\u0032\u002e\u0031\u0031\u002e\u0032\u002d\u0033","B\u0061\u0073\u0065\u0046\u006f\u006e\u0074\u0020\u002d\u0020\u006e\u0061\u006d\u0065\u0020\u002d\u0020\u0028\u0052\u0065\u0071\u0075\u0069\u0072\u0065\u0064)\u0020T\u0068\u0065\u0020\u0050o\u0073\u0074S\u0063\u0072\u0069\u0070\u0074\u0020\u006e\u0061\u006d\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u002e"));
_gccb =true ;if _dbcg (){return _bbgab ;};};};};if _gabb !="\u0054\u0079\u0070e\u0031"{continue ;};_ebacb :=_ee .IsStdFont (_ee .StdFontName (_faefe .BaseFont ()));if _ebacb {continue ;};_ecfde ,_cdee :=_gd .GetIntVal (_dcgbe .Get ("\u0046i\u0072\u0073\u0074\u0043\u0068\u0061r"));
if !_cdee &&!_fddfb {_bbgab =append (_bbgab ,_ab ("\u0036\u002e\u0032\u002e\u0031\u0031\u002e\u0032\u002d\u0034","\u0046\u0069r\u0073t\u0043\u0068\u0061\u0072\u0020\u002d\u0020\u0069\u006e\u0074\u0065\u0067\u0065\u0072\u0020\u002d\u0020\u0028\u0052\u0065\u0071\u0075i\u0072\u0065\u0064\u0020\u0065\u0078\u0063\u0065\u0070t\u0020\u0066\u006f\u0072\u0020\u0074h\u0065\u0020\u0073\u0074\u0061\u006e\u0064\u0061\u0072d\u0020\u0031\u0034\u0020\u0066\u006f\u006e\u0074\u0073\u0029\u0020\u0054\u0068\u0065\u0020\u0066\u0069\u0072\u0073\u0074\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u0063\u006f\u0064e\u0020\u0064\u0065\u0066i\u006ee\u0064\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0027\u0073\u0020\u0057i\u0064\u0074\u0068\u0073 \u0061r\u0072\u0061y\u002e"));
_fddfb =true ;if _dbcg (){return _bbgab ;};};_fdacb ,_aaafb :=_gd .GetIntVal (_dcgbe .Get ("\u004c\u0061\u0073\u0074\u0043\u0068\u0061\u0072"));if !_aaafb &&!_gfad {_bbgab =append (_bbgab ,_ab ("\u0036\u002e\u0032\u002e\u0031\u0031\u002e\u0032\u002d\u0035","\u004c\u0061\u0073t\u0043\u0068\u0061\u0072\u0020\u002d\u0020\u0069n\u0074\u0065\u0067e\u0072 \u002d\u0020\u0028\u0052\u0065\u0071u\u0069\u0072\u0065d\u0020\u0065\u0078\u0063\u0065\u0070\u0074\u0020\u0066\u006f\u0072\u0020t\u0068\u0065 s\u0074\u0061\u006e\u0064\u0061\u0072\u0064\u0020\u0031\u0034\u0020\u0066\u006f\u006ets\u0029\u0020\u0054\u0068\u0065\u0020\u006c\u0061\u0073t\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u0063\u006f\u0064\u0065\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0027\u0073\u0020\u0057\u0069\u0064\u0074h\u0073\u0020\u0061\u0072\u0072\u0061\u0079\u002e"));
_gfad =true ;if _dbcg (){return _bbgab ;};};if !_ddfgf {_fccc ,_gdfef :=_gd .GetArray (_dcgbe .Get ("\u0057\u0069\u0064\u0074\u0068\u0073"));if !_gdfef ||!_cdee ||!_aaafb ||_fccc .Len ()!=_fdacb -_ecfde +1{_bbgab =append (_bbgab ,_ab ("\u0036\u002e\u0032\u002e\u0031\u0031\u002e\u0032\u002d\u0036","\u0057\u0069\u0064\u0074\u0068\u0073\u0020\u002d a\u0072\u0072\u0061y \u002d\u0020\u0028\u0052\u0065\u0071\u0075\u0069\u0072\u0065\u0064\u0020\u0065\u0078\u0063\u0065\u0070t\u0020\u0066\u006f\u0072\u0020\u0074\u0068\u0065\u0020\u0073\u0074a\u006e\u0064a\u0072\u0064\u00201\u0034\u0020\u0066\u006f\u006e\u0074\u0073\u003b\u0020\u0069\u006ed\u0069\u0072\u0065\u0063\u0074\u0020\u0072\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0070\u0072\u0065\u0066e\u0072\u0072e\u0064\u0029\u0020\u0041\u006e \u0061\u0072\u0072\u0061\u0079\u0020\u006f\u0066\u0020\u0028\u004c\u0061\u0073\u0074\u0043\u0068\u0061\u0072\u0020\u2212 F\u0069\u0072\u0073\u0074\u0043\u0068\u0061\u0072\u0020\u002b\u00201\u0029\u0020\u0077\u0069\u0064\u0074\u0068\u0073."));
_ddfgf =true ;if _dbcg (){return _bbgab ;};};};};};return _bbgab ;};func _gaedg (_gedgf *_b .CompliancePdfReader ,_bfed standardType ,_cgdb bool )(_geca []ViolatedRule ){_fdfec ,_gcef :=_dbce (_gedgf );if !_gcef {return []ViolatedRule {_ab ("\u0036.\u0037\u002e\u0032\u002d\u0031","\u0063a\u0074a\u006c\u006f\u0067\u0020\u006eo\u0074\u0020f\u006f\u0075\u006e\u0064\u002e")};
};_ccef :=_fdfec .Get ("\u004d\u0065\u0074\u0061\u0064\u0061\u0074\u0061");if _ccef ==nil {return []ViolatedRule {_ab ("\u0036.\u0037\u002e\u0032\u002d\u0031","\u006e\u006f\u0020\u0027\u004d\u0065\u0074\u0061d\u0061\u0074\u0061' \u006b\u0065\u0079\u0020\u0066\u006fu\u006e\u0064\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0064\u006f\u0063\u0075\u006de\u006e\u0074\u0020\u0063\u0061\u0074\u0061\u006co\u0067\u002e"),_ab ("\u0036.\u0037\u002e\u0033\u002d\u0031","\u0049\u0066\u0020\u005b\u0061\u0020\u0064\u006fc\u0075\u006d\u0065\u006e\u0074\u0020\u0069\u006e\u0066o\u0072\u006d\u0061t\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0061\u0070p\u0065\u0061r\u0073\u0020\u0069n\u0020\u0061 \u0064\u006f\u0063um\u0065\u006e\u0074\u005d\u002c\u0020\u0074\u0068\u0065n\u0020\u0061\u006c\u006c\u0020\u006f\u0066\u0020\u0069\u0074\u0073\u0020\u0065\u006e\u0074\u0072\u0069\u0065\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0068\u0061\u0076\u0065\u0020\u0061\u006e\u0061\u006c\u006f\u0067\u006fu\u0073\u0020\u0070\u0072\u006f\u0070\u0065\u0072\u0074\u0069\u0065\u0073 \u0069\u006e\u0020\u0070\u0072\u0065\u0064e\u0066\u0069\u006e\u0065\u0064\u0020\u0058\u004d\u0050\u0020\u0073\u0063\u0068\u0065\u006d\u0061\u0073\u0020\u2026 \u0073\u0068\u0061\u006c\u006c\u0020\u0061\u006c\u0073\u006f\u0020\u0062\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065d\u0020\u0069\u006e\u0020\u0074he\u0020\u0066i\u006c\u0065 \u0069\u006e\u0020\u0058\u004d\u0050\u0020\u0066\u006f\u0072\u006d\u0020\u0077\u0069\u0074\u0068\u0020\u0065\u0071\u0075\u0069\u0076\u0061\u006c\u0065\u006e\u0074\u0020\u0076\u0061\u006c\u0075\u0065\u0073\u002e")};
};_fade ,_gcef :=_gd .GetStream (_ccef );if !_gcef {return []ViolatedRule {_ab ("\u0036.\u0037\u002e\u0032\u002d\u0032","\u0063\u0061\u0074a\u006c\u006f\u0067\u0020\u0027\u004d\u0065\u0074\u0061\u0064\u0061\u0074\u0061\u0027\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0069\u0073\u0020\u006e\u006f\u0074\u0020a\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u002e"),_ab ("\u0036.\u0037\u002e\u0033\u002d\u0031","\u0049\u0066\u0020\u005b\u0061\u0020\u0064\u006fc\u0075\u006d\u0065\u006e\u0074\u0020\u0069\u006e\u0066o\u0072\u006d\u0061t\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0061\u0070p\u0065\u0061r\u0073\u0020\u0069n\u0020\u0061 \u0064\u006f\u0063um\u0065\u006e\u0074\u005d\u002c\u0020\u0074\u0068\u0065n\u0020\u0061\u006c\u006c\u0020\u006f\u0066\u0020\u0069\u0074\u0073\u0020\u0065\u006e\u0074\u0072\u0069\u0065\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0068\u0061\u0076\u0065\u0020\u0061\u006e\u0061\u006c\u006f\u0067\u006fu\u0073\u0020\u0070\u0072\u006f\u0070\u0065\u0072\u0074\u0069\u0065\u0073 \u0069\u006e\u0020\u0070\u0072\u0065\u0064e\u0066\u0069\u006e\u0065\u0064\u0020\u0058\u004d\u0050\u0020\u0073\u0063\u0068\u0065\u006d\u0061\u0073\u0020\u2026 \u0073\u0068\u0061\u006c\u006c\u0020\u0061\u006c\u0073\u006f\u0020\u0062\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065d\u0020\u0069\u006e\u0020\u0074he\u0020\u0066i\u006c\u0065 \u0069\u006e\u0020\u0058\u004d\u0050\u0020\u0066\u006f\u0072\u006d\u0020\u0077\u0069\u0074\u0068\u0020\u0065\u0071\u0075\u0069\u0076\u0061\u006c\u0065\u006e\u0074\u0020\u0076\u0061\u006c\u0075\u0065\u0073\u002e")};
};if _fade .Get ("\u0046\u0069\u006c\u0074\u0065\u0072")!=nil {_geca =append (_geca ,_ab ("\u0036.\u0037\u002e\u0032\u002d\u0032","M\u0065\u0074a\u0064\u0061\u0074\u0061\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u0064i\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0069\u0065\u0073\u0020\u0073\u0068\u0061\u006c\u006c \u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074h\u0065\u0020\u0046\u0069\u006c\u0074\u0065\u0072\u0020\u006b\u0065y\u002e"));
};_cedcc ,_bbbc :=_daa .LoadDocument (_fade .Stream );if _bbbc !=nil {return []ViolatedRule {_ab ("\u0036.\u0037\u002e\u0039\u002d\u0031","The\u0020\u006d\u0065\u0074a\u0064\u0061t\u0061\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063o\u006e\u0066\u006f\u0072\u006d\u0020\u0074o\u0020\u0058\u004d\u0050\u0020\u0053\u0070\u0065\u0063\u0069\u0066\u0069\u0063\u0061\u0074\u0069\u006f\u006e\u0020\u0061\u006e\u0064\u0020\u0077\u0065\u006c\u006c\u0020\u0066\u006f\u0072\u006de\u0064\u0020\u0050\u0044\u0046\u0041\u0045\u0078\u0074e\u006e\u0073\u0069\u006f\u006e\u0020\u0053\u0063\u0068\u0065\u006da\u0020\u0066\u006fr\u0020\u0061\u006c\u006c\u0020\u0065\u0078\u0074\u0065\u006e\u0073\u0069\u006f\u006e\u0073\u002e")};
};_feee :=_cedcc .GetGoXmpDocument ();var _cfca []*_ec .Namespace ;for _ ,_gadb :=range _feee .Namespaces (){switch _gadb .Name {case _db .NsDc .Name ,_c .NsPDF .Name ,_g .NsXmp .Name ,_dd .NsXmpRights .Name ,_ecdf .Namespace .Name ,_fb .Namespace .Name ,_df .NsXmpMM .Name ,_fb .FieldNS .Name ,_fb .SchemaNS .Name ,_fb .PropertyNS .Name ,"\u0073\u0074\u0045v\u0074","\u0073\u0074\u0056e\u0072","\u0073\u0074\u0052e\u0066","\u0073\u0074\u0044i\u006d","\u0078a\u0070\u0047\u0049\u006d\u0067","\u0073\u0074\u004ao\u0062","\u0078\u006d\u0070\u0069\u0064\u0071":continue ;
};_cfca =append (_cfca ,_gadb );};_dcad :=true ;_eccf ,_bbbc :=_cedcc .GetPdfaExtensionSchemas ();if _bbbc ==nil {for _ ,_agecf :=range _cfca {var _fgbag bool ;for _ebea :=range _eccf {if _agecf .URI ==_eccf [_ebea ].NamespaceURI {_fgbag =true ;break ;
};};if !_fgbag {_dcad =false ;break ;};};}else {_dcad =false ;};if !_dcad {_geca =append (_geca ,_ab ("\u0036.\u0037\u002e\u0039\u002d\u0032","\u0050\u0072\u006f\u0070\u0065\u0072\u0074i\u0065\u0073 \u0073\u0070\u0065\u0063\u0069\u0066\u0069ed\u0020\u0069\u006e\u0020\u0058M\u0050\u0020\u0066\u006f\u0072\u006d\u0020\u0073\u0068\u0061\u006cl\u0020\u0075\u0073\u0065\u0020\u0065\u0069\u0074\u0068\u0065\u0072\u0020\u0074\u0068\u0065\u0020\u0070\u0072\u0065\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0073\u0063\u0068\u0065\u006d\u0061\u0073 \u0064\u0065\u0066i\u006e\u0065\u0064\u0020\u0069\u006e\u0020\u0058\u004d\u0050\u0020\u0053\u0070\u0065\u0063\u0069\u0066\u0069\u0063\u0061\u0074\u0069\u006fn\u002c\u0020\u006f\u0072\u0020\u0065\u0078\u0074\u0065ns\u0069\u006f\u006e\u0020\u0073\u0063\u0068\u0065\u006d\u0061\u0073\u0020\u0074\u0068\u0061\u0074 \u0063\u006f\u006d\u0070\u006c\u0079\u0020\u0077\u0069\u0074h\u0020\u0058\u004d\u0050\u0020\u0053\u0070e\u0063\u0069\u0066\u0069\u0063\u0061\u0074\u0069\u006f\u006e\u002e"));
};_bcge ,_bbbc :=_gedgf .GetPdfInfo ();if _bbbc ==nil {if !_dade (_bcge ,_cedcc ){_geca =append (_geca ,_ab ("\u0036.\u0037\u002e\u0033\u002d\u0031","\u0049\u0066\u0020\u005b\u0061\u0020\u0064\u006fc\u0075\u006d\u0065\u006e\u0074\u0020\u0069\u006e\u0066o\u0072\u006d\u0061t\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0061\u0070p\u0065\u0061r\u0073\u0020\u0069n\u0020\u0061 \u0064\u006f\u0063um\u0065\u006e\u0074\u005d\u002c\u0020\u0074\u0068\u0065n\u0020\u0061\u006c\u006c\u0020\u006f\u0066\u0020\u0069\u0074\u0073\u0020\u0065\u006e\u0074\u0072\u0069\u0065\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0068\u0061\u0076\u0065\u0020\u0061\u006e\u0061\u006c\u006f\u0067\u006fu\u0073\u0020\u0070\u0072\u006f\u0070\u0065\u0072\u0074\u0069\u0065\u0073 \u0069\u006e\u0020\u0070\u0072\u0065\u0064e\u0066\u0069\u006e\u0065\u0064\u0020\u0058\u004d\u0050\u0020\u0073\u0063\u0068\u0065\u006d\u0061\u0073\u0020\u2026 \u0073\u0068\u0061\u006c\u006c\u0020\u0061\u006c\u0073\u006f\u0020\u0062\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065d\u0020\u0069\u006e\u0020\u0074he\u0020\u0066i\u006c\u0065 \u0069\u006e\u0020\u0058\u004d\u0050\u0020\u0066\u006f\u0072\u006d\u0020\u0077\u0069\u0074\u0068\u0020\u0065\u0071\u0075\u0069\u0076\u0061\u006c\u0065\u006e\u0074\u0020\u0076\u0061\u006c\u0075\u0065\u0073\u002e"));
};}else if _ ,_fabc :=_cedcc .GetMediaManagement ();_fabc {_geca =append (_geca ,_ab ("\u0036.\u0037\u002e\u0033\u002d\u0031","\u0049\u0066\u0020\u005b\u0061\u0020\u0064\u006fc\u0075\u006d\u0065\u006e\u0074\u0020\u0069\u006e\u0066o\u0072\u006d\u0061t\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0061\u0070p\u0065\u0061r\u0073\u0020\u0069n\u0020\u0061 \u0064\u006f\u0063um\u0065\u006e\u0074\u005d\u002c\u0020\u0074\u0068\u0065n\u0020\u0061\u006c\u006c\u0020\u006f\u0066\u0020\u0069\u0074\u0073\u0020\u0065\u006e\u0074\u0072\u0069\u0065\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0068\u0061\u0076\u0065\u0020\u0061\u006e\u0061\u006c\u006f\u0067\u006fu\u0073\u0020\u0070\u0072\u006f\u0070\u0065\u0072\u0074\u0069\u0065\u0073 \u0069\u006e\u0020\u0070\u0072\u0065\u0064e\u0066\u0069\u006e\u0065\u0064\u0020\u0058\u004d\u0050\u0020\u0073\u0063\u0068\u0065\u006d\u0061\u0073\u0020\u2026 \u0073\u0068\u0061\u006c\u006c\u0020\u0061\u006c\u0073\u006f\u0020\u0062\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065d\u0020\u0069\u006e\u0020\u0074he\u0020\u0066i\u006c\u0065 \u0069\u006e\u0020\u0058\u004d\u0050\u0020\u0066\u006f\u0072\u006d\u0020\u0077\u0069\u0074\u0068\u0020\u0065\u0071\u0075\u0069\u0076\u0061\u006c\u0065\u006e\u0074\u0020\u0076\u0061\u006c\u0075\u0065\u0073\u002e"));
};_ccfee ,_gcef :=_cedcc .GetPdfAID ();if !_gcef {_geca =append (_geca ,_ab ("\u0036\u002e\u0037\u002e\u0031\u0031\u002d\u0031","\u0054\u0068\u0065\u0020\u0050\u0044\u0046\u002f\u0041\u0020\u0076\u0065\u0072\u0073\u0069\u006f\u006e\u0020\u0061n\u0064\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006ec\u0065\u0020\u006c\u0065\u0076\u0065l\u0020\u006f\u0066\u0020\u0061\u0020\u0066\u0069\u006c\u0065\u0020\u0073h\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0073\u0070e\u0063\u0069\u0066\u0069\u0065\u0064\u0020\u0075\u0073\u0069\u006e\u0067\u0020\u0074\u0068\u0065\u0020\u0050\u0044\u0046\u002f\u0041\u0020\u0049\u0064\u0065\u006e\u0074\u0069\u0066\u0069\u0063\u0061\u0074\u0069\u006f\u006e\u0020\u0065\u0078\u0074\u0065\u006e\u0073\u0069\u006f\u006e\u0020\u0073\u0063h\u0065\u006da."));
}else {if _ccfee .Part !=_bfed ._gb {_geca =append (_geca ,_ab ("\u0036\u002e\u0037\u002e\u0031\u0031\u002d\u0032","\u0054h\u0065\u0020\u0076\u0061lue\u0020\u006f\u0066\u0020p\u0064\u0066\u0061\u0069\u0064\u003a\u0070\u0061\u0072\u0074 \u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0074\u0068\u0065\u0020\u0070\u0061\u0072\u0074\u0020\u006e\u0075\u006d\u0062\u0065r\u0020\u006f\u0066\u0020\u0049\u0053\u004f\u002019\u0030\u0030\u0035 \u0074\u006f\u0020\u0077\u0068i\u0063h\u0020\u0074\u0068\u0065\u0020\u0066\u0069\u006c\u0065 \u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0073\u002e"));
};if _bfed ._dcd =="\u0041"&&_ccfee .Conformance !="\u0041"{_geca =append (_geca ,_ab ("\u0036\u002e\u0037\u002e\u0031\u0031\u002d\u0033","\u0041\u0020\u004c\u0065\u0076e\u006c\u0020\u0041\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065 \u0073\u0068\u0061\u006c\u006c\u0020s\u0070\u0065\u0063i\u0066\u0079\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0070\u0064\u0066\u0061\u0069\u0064\u003a\u0063o\u006e\u0066\u006fr\u006d\u0061\u006e\u0063\u0065\u0020\u0061\u0073\u0020\u0041\u002e\u0020\u0041\u0020\u004c\u0065\u0076e\u006c\u0020\u0042\u0020\u0063\u006f\u006e\u0066o\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0073\u0070e\u0063\u0069\u0066\u0079\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0070\u0064\u0066\u0061\u0069d\u003a\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006e\u0063\u0065\u0020\u0061\u0073\u0020\u0042\u002e"));
}else if _bfed ._dcd =="\u0042"&&(_ccfee .Conformance !="\u0041"&&_ccfee .Conformance !="\u0042"){_geca =append (_geca ,_ab ("\u0036\u002e\u0037\u002e\u0031\u0031\u002d\u0033","\u0041\u0020\u004c\u0065\u0076e\u006c\u0020\u0041\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065 \u0073\u0068\u0061\u006c\u006c\u0020s\u0070\u0065\u0063i\u0066\u0079\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0070\u0064\u0066\u0061\u0069\u0064\u003a\u0063o\u006e\u0066\u006fr\u006d\u0061\u006e\u0063\u0065\u0020\u0061\u0073\u0020\u0041\u002e\u0020\u0041\u0020\u004c\u0065\u0076e\u006c\u0020\u0042\u0020\u0063\u006f\u006e\u0066o\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0073\u0070e\u0063\u0069\u0066\u0079\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0070\u0064\u0066\u0061\u0069d\u003a\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006e\u0063\u0065\u0020\u0061\u0073\u0020\u0042\u002e"));
};};return _geca ;};func _edag (_baaga *_b .CompliancePdfReader )(_gdace []ViolatedRule ){return _gdace };func _efaae (_fffa *_b .CompliancePdfReader )ViolatedRule {return _fc };

// ValidateStandard checks if provided input CompliancePdfReader matches rules that conforms PDF/A-2 standard.
func (_fcad *profile2 )ValidateStandard (r *_b .CompliancePdfReader )error {_acba :=VerificationError {ConformanceLevel :_fcad ._efbd ._gb ,ConformanceVariant :_fcad ._efbd ._dcd };if _ddfd :=_aegb (r );_ddfd !=_fc {_acba .ViolatedRules =append (_acba .ViolatedRules ,_ddfd );
};if _ced :=_dafdf (r );_ced !=_fc {_acba .ViolatedRules =append (_acba .ViolatedRules ,_ced );};if _fgec :=_efaa (r );_fgec !=_fc {_acba .ViolatedRules =append (_acba .ViolatedRules ,_fgec );};if _fbdcg :=_acagg (r );_fbdcg !=_fc {_acba .ViolatedRules =append (_acba .ViolatedRules ,_fbdcg );
};if _afgac :=_dbadf (r );_afgac !=_fc {_acba .ViolatedRules =append (_acba .ViolatedRules ,_afgac );};if _efeab :=_bbcee (r );len (_efeab )!=0{_acba .ViolatedRules =append (_acba .ViolatedRules ,_efeab ...);};if _acea :=_ddcgg (r );len (_acea )!=0{_acba .ViolatedRules =append (_acba .ViolatedRules ,_acea ...);
};if _gbaee :=_ccac (r );len (_gbaee )!=0{_acba .ViolatedRules =append (_acba .ViolatedRules ,_gbaee ...);};if _fgag :=_ageeb (r );_fgag !=_fc {_acba .ViolatedRules =append (_acba .ViolatedRules ,_fgag );};if _edbce :=_deec (r );len (_edbce )!=0{_acba .ViolatedRules =append (_acba .ViolatedRules ,_edbce ...);
};if _bfbc :=_adge (r );len (_bfbc )!=0{_acba .ViolatedRules =append (_acba .ViolatedRules ,_bfbc ...);};if _cdde :=_ggbg (r );_cdde !=_fc {_acba .ViolatedRules =append (_acba .ViolatedRules ,_cdde );};if _dcgc :=_daba (r );len (_dcgc )!=0{_acba .ViolatedRules =append (_acba .ViolatedRules ,_dcgc ...);
};if _egdd :=_fdgd (r );len (_egdd )!=0{_acba .ViolatedRules =append (_acba .ViolatedRules ,_egdd ...);};if _fgafd :=_efaae (r );_fgafd !=_fc {_acba .ViolatedRules =append (_acba .ViolatedRules ,_fgafd );};if _bdde :=_aecc (r );len (_bdde )!=0{_acba .ViolatedRules =append (_acba .ViolatedRules ,_bdde ...);
};if _cbacg :=_eceda (r );len (_cbacg )!=0{_acba .ViolatedRules =append (_acba .ViolatedRules ,_cbacg ...);};if _gga :=_bdgec (r );_gga !=_fc {_acba .ViolatedRules =append (_acba .ViolatedRules ,_gga );};if _ffaf :=_cbeba (r );len (_ffaf )!=0{_acba .ViolatedRules =append (_acba .ViolatedRules ,_ffaf ...);
};if _gadd :=_fbgcd (r ,_fcad ._efbd );len (_gadd )!=0{_acba .ViolatedRules =append (_acba .ViolatedRules ,_gadd ...);};if _accf :=_ebce (r );len (_accf )!=0{_acba .ViolatedRules =append (_acba .ViolatedRules ,_accf ...);};if _bfeba :=_efdgb (r );len (_bfeba )!=0{_acba .ViolatedRules =append (_acba .ViolatedRules ,_bfeba ...);
};if _egga :=_edag (r );len (_egga )!=0{_acba .ViolatedRules =append (_acba .ViolatedRules ,_egga ...);};if _fad :=_fccfe (r );_fad !=_fc {_acba .ViolatedRules =append (_acba .ViolatedRules ,_fad );};if _afdg :=_fegg (r );len (_afdg )!=0{_acba .ViolatedRules =append (_acba .ViolatedRules ,_afdg ...);
};if _dgbc :=_edcab (r );_dgbc !=_fc {_acba .ViolatedRules =append (_acba .ViolatedRules ,_dgbc );};if _aecb :=_ffgb (r ,_fcad ._efbd ,false );len (_aecb )!=0{_acba .ViolatedRules =append (_acba .ViolatedRules ,_aecb ...);};if _fcad ._efbd ==_bge (){if _bccfd :=_eebe (r );
len (_bccfd )!=0{_acba .ViolatedRules =append (_acba .ViolatedRules ,_bccfd ...);};};if _acaf :=_efga (r );len (_acaf )!=0{_acba .ViolatedRules =append (_acba .ViolatedRules ,_acaf ...);};if _fabd :=_gaddeg (r );len (_fabd )!=0{_acba .ViolatedRules =append (_acba .ViolatedRules ,_fabd ...);
};if _efef :=_cdddb (r );len (_efef )!=0{_acba .ViolatedRules =append (_acba .ViolatedRules ,_efef ...);};if _ffcaa :=_gbdd (r );_ffcaa !=_fc {_acba .ViolatedRules =append (_acba .ViolatedRules ,_ffcaa );};if len (_acba .ViolatedRules )> 0{_de .Slice (_acba .ViolatedRules ,func (_dagc ,_cbag int )bool {return _acba .ViolatedRules [_dagc ].RuleNo < _acba .ViolatedRules [_cbag ].RuleNo ;
});return _acba ;};return nil ;};func _dgc (_eef *_b .XObjectImage ,_dae imageModifications )error {_eg ,_fbd :=_eef .ToImage ();if _fbd !=nil {return _fbd ;};if _dae ._abg !=nil {_eef .Filter =_dae ._abg ;};_dbd :=_gd .MakeDict ();_dbd .Set ("\u0051u\u0061\u006c\u0069\u0074\u0079",_gd .MakeInteger (100));
_dbd .Set ("\u0050r\u0065\u0064\u0069\u0063\u0074\u006fr",_gd .MakeInteger (1));_eef .Decode =nil ;if _fbd =_eef .SetImage (_eg ,nil );_fbd !=nil {return _fbd ;};_eef .ToPdfObject ();return nil ;};func _edcab (_ddffc *_b .CompliancePdfReader )(_cbbae ViolatedRule ){_gabbc ,_cafcf :=_dbce (_ddffc );
if !_cafcf {return _fc ;};if _gabbc .Get ("\u0041\u0041")!=nil {return _ab ("\u0036.\u0035\u002e\u0032\u002d\u0031","\u0054h\u0065\u0020\u0064\u006fc\u0075m\u0065\u006e\u0074\u0020\u0063\u0061\u0074\u0061\u006co\u0067\u0020\u0073\u0068\u0061\u006c\u006c\u0020n\u006f\u0074\u0020\u0069\u006e\u0063\u006c\u0075\u0064\u0065\u0020a\u006e\u0020\u0041\u0041\u0020\u0065\u006e\u0074\u0072\u0079 \u0066\u006f\u0072\u0020\u0061\u006e\u0020\u0061\u0064\u0064\u0069\u0074\u0069\u006f\u006e\u0061\u006c\u002d\u0061c\u0074\u0069\u006f\u006e\u0073\u0020\u0064\u0069\u0063\u0074\u0069\u006fn\u0061r\u0079\u002e");
};return _fc ;};func _dba ()standardType {return standardType {_gb :1,_dcd :"\u0041"}};

// NewProfile2A creates a new Profile2A with given options.
func NewProfile2A (options *Profile2Options )*Profile2A {if options ==nil {options =DefaultProfile2Options ();};_ecfe (options );return &Profile2A {profile2 {_cfg :*options ,_efbd :_bge ()}};};

// StandardName gets the name of the standard.
func (_cgee *profile1 )StandardName ()string {return _d .Sprintf ("\u0050D\u0046\u002f\u0041\u002d\u0031\u0025s",_cgee ._gaeg ._dcd );};func _efga (_ebab *_b .CompliancePdfReader )(_gfegd []ViolatedRule ){_gdgg :=_ebab .GetObjectNums ();for _ ,_cfaf :=range _gdgg {_ccgcd ,_afgf :=_ebab .GetIndirectObjectByNumber (_cfaf );
if _afgf !=nil {continue ;};_fgcag ,_cfbaa :=_gd .GetDict (_ccgcd );if !_cfbaa {continue ;};_cadf ,_cfbaa :=_gd .GetName (_fgcag .Get ("\u0054\u0079\u0070\u0065"));if !_cfbaa {continue ;};if _cadf .String ()!="\u0046\u0069\u006c\u0065\u0073\u0070\u0065\u0063"{continue ;
};if _fgcag .Get ("\u0045\u0046")!=nil {if _fgcag .Get ("\u0046")==nil ||_fgcag .Get ("\u0045\u0046")==nil {_gfegd =append (_gfegd ,_ab ("\u0036\u002e\u0038-\u0032","\u0054h\u0065\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0070\u0065\u0063\u0069\u0066i\u0063\u0061\u0074i\u006f\u006e\u0020\u0064\u0069\u0063t\u0069\u006fn\u0061\u0072\u0079\u0020\u0066\u006f\u0072\u0020\u0061\u006e\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065\u0064\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006cl\u0020\u0063\u006f\u006e\u0074a\u0069\u006e\u0020t\u0068\u0065\u0020\u0046\u0020a\u006e\u0064\u0020\u0055\u0046\u0020\u006b\u0065\u0079\u0073\u002e"));
};if _fgcag .Get ("\u0041\u0046\u0052\u0065\u006c\u0061\u0074\u0069\u006fn\u0073\u0068\u0069\u0070")==nil {_gfegd =append (_gfegd ,_ab ("\u0036\u002e\u0038-\u0033","\u0049\u006e\u0020\u006f\u0072d\u0065\u0072\u0020\u0074\u006f\u0020\u0065\u006e\u0061\u0062\u006c\u0065\u0020i\u0064\u0065nt\u0069\u0066\u0069c\u0061\u0074\u0069o\u006e\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0072\u0065\u006c\u0061\u0074\u0069\u006f\u006e\u0073h\u0069\u0070\u0020\u0062\u0065\u0074\u0077\u0065\u0065\u006e\u0020\u0074\u0068\u0065\u0020fi\u006ce\u0020\u0073\u0070\u0065\u0063\u0069f\u0069c\u0061\u0074\u0069o\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0061\u006e\u0064\u0020\u0074\u0068\u0065\u0020c\u006f\u006e\u0074e\u006e\u0074\u0020\u0074\u0068\u0061\u0074\u0020\u0069\u0073\u0020\u0072\u0065\u0066\u0065\u0072\u0072\u0069\u006e\u0067\u0020\u0074\u006f\u0020\u0069\u0074\u002c\u0020\u0061\u0020\u006e\u0065\u0077\u0020(\u0072\u0065\u0071\u0075i\u0072\u0065\u0064\u0029\u0020\u006be\u0079\u0020h\u0061\u0073\u0020\u0062e\u0065\u006e\u0020\u0064\u0065\u0066i\u006e\u0065\u0064\u0020a\u006e\u0064\u0020\u0069\u0074s \u0070\u0072e\u0073\u0065n\u0063\u0065\u0020\u0028\u0069\u006e\u0020\u0074\u0068e\u0020\u0064\u0069\u0063\u0074i\u006f\u006e\u0061\u0072\u0079\u0029\u0020\u0069\u0073\u0020\u0072\u0065q\u0075\u0069\u0072e\u0064\u002e"));
};break ;};};return _gfegd ;};func (_aag *documentImages )hasUncalibratedImages ()bool {return _aag ._ce ||_aag ._ff ||_aag ._ad };

// StandardName gets the name of the standard.
func (_aceg *profile2 )StandardName ()string {return _d .Sprintf ("\u0050D\u0046\u002f\u0041\u002d\u0032\u0025s",_aceg ._efbd ._dcd );};func _cadc (_acbae *_b .CompliancePdfReader )(_gbag ViolatedRule ){for _ ,_daae :=range _acbae .GetObjectNums (){_bcdb ,_egeee :=_acbae .GetIndirectObjectByNumber (_daae );
if _egeee !=nil {continue ;};_dabe ,_egdg :=_gd .GetStream (_bcdb );if !_egdg {continue ;};_gdgeg ,_egdg :=_gd .GetName (_dabe .Get ("\u0054\u0079\u0070\u0065"));if !_egdg {continue ;};if *_gdgeg !="\u0058O\u0062\u006a\u0065\u0063\u0074"{continue ;};if _dabe .Get ("\u0052\u0065\u0066")!=nil {return _ab ("\u0036.\u0032\u002e\u0036\u002d\u0031","\u0041\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068a\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u006e\u0079\u0020\u0072\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0058O\u0062\u006a\u0065\u0063\u0074s\u002e");
};};return _gbag ;};type colorspaceModification struct{_dgg _fg .ColorConverter ;_dcb _b .PdfColorspace ;};func _dbce (_affe *_b .CompliancePdfReader )(*_gd .PdfObjectDictionary ,bool ){_eebfa ,_abfc :=_affe .GetTrailer ();if _abfc !=nil {_ae .Log .Debug ("\u0043\u0061\u006en\u006f\u0074\u0020\u0067e\u0074\u0020\u0064\u006f\u0063\u0075\u006de\u006e\u0074\u0020\u0074\u0072\u0061\u0069\u006c\u0065\u0072\u003a\u0020\u0025\u0076",_abfc );
return nil ,false ;};_egccd ,_fgggg :=_eebfa .Get ("\u0052\u006f\u006f\u0074").(*_gd .PdfObjectReference );if !_fgggg {_ae .Log .Debug ("\u0043a\u006e\u006e\u006f\u0074 \u0066\u0069\u006e\u0064\u0020d\u006fc\u0075m\u0065\u006e\u0074\u0020\u0072\u006f\u006ft");
return nil ,false ;};_abag ,_fgggg :=_gd .GetDict (_gd .ResolveReference (_egccd ));if !_fgggg {_ae .Log .Debug ("\u0063\u0061\u006e\u006e\u006f\u0074 \u0072\u0065\u0073\u006f\u006c\u0076\u0065\u0020\u0063\u0061\u0074\u0061\u006co\u0067\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079");
return nil ,false ;};return _abag ,true ;};func _acbad (_fdff *_b .CompliancePdfReader )(_aeaf ViolatedRule ){for _ ,_cgacd :=range _fdff .GetObjectNums (){_daab ,_ffeeb :=_fdff .GetIndirectObjectByNumber (_cgacd );if _ffeeb !=nil {continue ;};_ceab ,_aaea :=_gd .GetStream (_daab );
if !_aaea {continue ;};_gged ,_aaea :=_gd .GetName (_ceab .Get ("\u0054\u0079\u0070\u0065"));if !_aaea {continue ;};if *_gged !="\u0058O\u0062\u006a\u0065\u0063\u0074"{continue ;};_bbga ,_aaea :=_gd .GetName (_ceab .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));
if !_aaea {continue ;};if *_bbga =="\u0050\u0053"{return _ab ("\u0036.\u0032\u002e\u0037\u002d\u0031","A \u0063\u006fn\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066i\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u006e\u0079\u0020\u0050\u006f\u0073t\u0053c\u0072\u0069\u0070\u0074\u0020\u0058\u004f\u0062j\u0065c\u0074\u0073.");
};};return _aeaf ;};func _ecfe (_eacf *Profile2Options ){if _eacf .Now ==nil {_eacf .Now =_f .Now ;};};

// NewProfile2U creates a new Profile2U with the given options.
func NewProfile2U (options *Profile2Options )*Profile2U {if options ==nil {options =DefaultProfile2Options ();};_ecfe (options );return &Profile2U {profile2 {_cfg :*options ,_efbd :_gg ()}};};var _ Profile =(*Profile1B )(nil );

// ApplyStandard tries to change the content of the writer to match the PDF/A-1 standard.
// Implements model.StandardApplier.
func (_fdd *profile1 )ApplyStandard (document *_da .Document )(_fed error ){_afc (document ,4);if _fed =_cdgea (document ,_fdd ._cgfb .Now );_fed !=nil {return _fed ;};if _fed =_ecdg (document );_fed !=nil {return _fed ;};_cafaf ,_cbbb :=_dbf (_fdd ._cgfb .CMYKDefaultColorSpace ,_fdd ._gaeg );
_fed =_gag (document ,[]pageColorspaceOptimizeFunc {_effb ,_cafaf },[]documentColorspaceOptimizeFunc {_cbbb });if _fed !=nil {return _fed ;};_beef (document );if _fed =_cdgfg (document ,_fdd ._gaeg ._gb );_fed !=nil {return _fed ;};if _fed =_egfd (document );
_fed !=nil {return _fed ;};if _fed =_eda (document );_fed !=nil {return _fed ;};if _fed =_dbg (document );_fed !=nil {return _fed ;};if _fed =_cae (document );_fed !=nil {return _fed ;};if _fdd ._gaeg ._dcd =="\u0041"{_edfc (document );};if _fed =_efgb (document ,_fdd ._gaeg ._gb );
_fed !=nil {return _fed ;};if _fed =_eecg (document );_fed !=nil {return _fed ;};if _ffcb :=_edbc (document ,_fdd ._gaeg ,_fdd ._cgfb .Xmp );_ffcb !=nil {return _ffcb ;};if _fdd ._gaeg ==_dba (){if _fed =_edb (document );_fed !=nil {return _fed ;};};if _fed =_gca (document );
_fed !=nil {return _fed ;};return nil ;};func _gc (_aed []_gd .PdfObject )(*documentImages ,error ){_abc :=_gd .PdfObjectName ("\u0053u\u0062\u0074\u0079\u0070\u0065");_dbae :=make (map[*_gd .PdfObjectStream ]struct{});_fe :=make (map[_gd .PdfObject ]struct{});
var (_fa ,_ded ,_bcc bool ;_ba []*imageInfo ;_deb error ;);for _ ,_fag :=range _aed {_abb ,_ffa :=_gd .GetStream (_fag );if !_ffa {continue ;};if _ ,_dda :=_dbae [_abb ];_dda {continue ;};_dbae [_abb ]=struct{}{};_cd :=_abb .PdfObjectDictionary .Get (_abc );
_ea ,_ffa :=_gd .GetName (_cd );if !_ffa ||string (*_ea )!="\u0049\u006d\u0061g\u0065"{continue ;};if _cc :=_abb .PdfObjectDictionary .Get ("\u0053\u004d\u0061s\u006b");_cc !=nil {_fe [_cc ]=struct{}{};};_ca :=imageInfo {BitsPerComponent :8,Stream :_abb };
_ca .ColorSpace ,_deb =_b .DetermineColorspaceNameFromPdfObject (_abb .PdfObjectDictionary .Get ("\u0043\u006f\u006c\u006f\u0072\u0053\u0070\u0061\u0063\u0065"));if _deb !=nil {return nil ,_deb ;};if _dgd ,_ebc :=_gd .GetIntVal (_abb .PdfObjectDictionary .Get ("\u0042\u0069t\u0073\u0050\u0065r\u0043\u006f\u006d\u0070\u006f\u006e\u0065\u006e\u0074"));
_ebc {_ca .BitsPerComponent =_dgd ;};if _eec ,_cdg :=_gd .GetIntVal (_abb .PdfObjectDictionary .Get ("\u0057\u0069\u0064t\u0068"));_cdg {_ca .Width =_eec ;};if _cb ,_bfe :=_gd .GetIntVal (_abb .PdfObjectDictionary .Get ("\u0048\u0065\u0069\u0067\u0068\u0074"));
_bfe {_ca .Height =_cb ;};switch _ca .ColorSpace {case "\u0044\u0065\u0076\u0069\u0063\u0065\u0047\u0072\u0061\u0079":_bcc =true ;_ca .ColorComponents =1;case "\u0044e\u0076\u0069\u0063\u0065\u0052\u0047B":_fa =true ;_ca .ColorComponents =3;case "\u0044\u0065\u0076\u0069\u0063\u0065\u0043\u004d\u0059\u004b":_ded =true ;
_ca .ColorComponents =4;default:_ca ._gdd =true ;};_ba =append (_ba ,&_ca );};if len (_fe )> 0{if len (_fe )==len (_ba ){_ba =nil ;}else {_faa :=make ([]*imageInfo ,len (_ba )-len (_fe ));var _bfee int ;for _ ,_faaa :=range _ba {if _ ,_be :=_fe [_faaa .Stream ];
_be {continue ;};_faa [_bfee ]=_faaa ;_bfee ++;};_ba =_faa ;};};return &documentImages {_ce :_fa ,_ff :_ded ,_ad :_bcc ,_bb :_fe ,_dg :_ba },nil ;};

// Profile2Options are the options that changes the way how optimizer may try to adapt document into PDF/A standard.
type Profile2Options struct{

// CMYKDefaultColorSpace is an option that refers PDF/A
CMYKDefaultColorSpace bool ;

// Now is a function that returns current time.
Now func ()_f .Time ;

// Xmp is the xmp options information.
Xmp XmpOptions ;};

// Conformance gets the PDF/A conformance.
func (_eaa *profile1 )Conformance ()string {return _eaa ._gaeg ._dcd };type profile2 struct{_efbd standardType ;_cfg Profile2Options ;};func _edgfc (_cfaee *_b .PdfFont ,_abeg *_gd .PdfObjectDictionary )ViolatedRule {const (_cebb ="\u0036.\u0033\u002e\u0037\u002d\u0031";
_efad ="\u0041\u006cl \u006e\u006f\u006e\u002d\u0073\u0079\u006db\u006f\u006c\u0069\u0063\u0020\u0054\u0072\u0075\u0065\u0054\u0079\u0070\u0065\u0020\u0066o\u006e\u0074s\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0068\u0061\u0076\u0065\u0020e\u0069\u0074h\u0065\u0072\u0020\u004d\u0061\u0063\u0052\u006f\u006d\u0061\u006e\u0045\u006e\u0063\u006fd\u0069\u006e\u0067\u0020\u006f\u0072\u0020\u0057\u0069\u006e\u0041\u006e\u0073i\u0045n\u0063\u006f\u0064\u0069n\u0067\u0020\u0061\u0073\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0066o\u0072\u0020t\u0068\u0065 \u0045n\u0063\u006f\u0064\u0069\u006e\u0067\u0020\u006b\u0065\u0079 \u0069\u006e\u0020t\u0068e\u0020\u0046o\u006e\u0074\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u006f\u0072\u0020\u0061\u0073\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0066\u006f\u0072 \u0074\u0068\u0065\u0020\u0042\u0061\u0073\u0065\u0045\u006e\u0063\u006fd\u0069\u006e\u0067\u0020\u006b\u0065\u0079\u0020\u0069\u006e\u0020\u0074\u0068\u0065 \u0064i\u0063\u0074i\u006fn\u0061\u0072\u0079\u0020\u0077\u0068\u0069\u0063\u0068\u0020\u0069s\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006ff\u0020\u0074\u0068e\u0020\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067\u0020\u006be\u0079\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0046\u006f\u006e\u0074 \u0064\u0069\u0063\u0074i\u006f\u006e\u0061\u0072\u0079\u002e\u0020\u0049\u006e\u0020\u0061\u0064\u0064\u0069\u0074\u0069\u006f\u006e, \u006eo\u0020n\u006f\u006e\u002d\u0073\u0079\u006d\u0062\u006f\u006c\u0069\u0063\u0020\u0054\u0072\u0075\u0065\u0054\u0079p\u0065 \u0066\u006f\u006e\u0074\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0020\u0061\u0020\u0044\u0069\u0066\u0066e\u0072\u0065\u006e\u0063\u0065\u0073\u0020a\u0072\u0072\u0061\u0079\u0020\u0075n\u006c\u0065s\u0073\u0020\u0061\u006c\u006c\u0020\u006f\u0066\u0020\u0074h\u0065\u0020\u0067\u006c\u0079\u0070\u0068\u0020\u006e\u0061\u006d\u0065\u0073 \u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0044\u0069f\u0066\u0065\u0072\u0065\u006ec\u0065\u0073\u0020a\u0072\u0072\u0061\u0079\u0020\u0061\u0072\u0065\u0020\u006c\u0069\u0073\u0074\u0065\u0064 \u0069\u006e \u0074\u0068\u0065\u0020\u0041\u0064\u006f\u0062\u0065 G\u006c\u0079\u0070\u0068\u0020\u004c\u0069\u0073t\u0020\u0061\u006e\u0064\u0020\u0074h\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065\u0064\u0020\u0066o\u006e\u0074\u0020\u0070\u0072\u006f\u0067\u0072a\u006d\u0020\u0063\u006f\u006e\u0074\u0061\u0069n\u0073\u0020\u0061\u0074\u0020\u006c\u0065\u0061\u0073t\u0020\u0074\u0068\u0065\u0020\u004d\u0069\u0063\u0072o\u0073o\u0066\u0074\u0020\u0055\u006e\u0069\u0063\u006f\u0064\u0065\u0020\u0028\u0033\u002c\u0031 \u2013 P\u006c\u0061\u0074\u0066\u006f\u0072\u006d\u0020I\u0044\u003d\u0033\u002c\u0020\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067 I\u0044\u003d\u0031\u0029\u0020\u0065\u006e\u0063\u006f\u0064i\u006e\u0067 \u0069\u006e\u0020t\u0068\u0065\u0020'\u0063\u006d\u0061\u0070\u0027\u0020\u0074\u0061\u0062\u006c\u0065\u002e";
);var _ffbcf string ;if _fdgbd ,_egfgc :=_gd .GetName (_abeg .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_egfgc {_ffbcf =_fdgbd .String ();};if _ffbcf !="\u0054\u0072\u0075\u0065\u0054\u0079\u0070\u0065"{return _fc ;};_eada :=_cfaee .FontDescriptor ();
_ecfc ,_gdeg :=_gd .GetIntVal (_eada .Flags );if !_gdeg {_ae .Log .Debug ("\u0066\u006c\u0061\u0067\u0073 \u006e\u006f\u0074\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0066o\u0072\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0020\u0064\u0065\u0073\u0063\u0072\u0069\u0070\u0074\u006f\u0072");
return _ab (_cebb ,_efad );};_egbc :=(uint32 (_ecfc )>>3)!=0;if _egbc {return _fc ;};_gaba ,_gdeg :=_gd .GetName (_abeg .Get ("\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067"));if !_gdeg {return _ab (_cebb ,_efad );};switch _gaba .String (){case "\u004d\u0061c\u0052\u006f\u006da\u006e\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067","\u0057i\u006eA\u006e\u0073\u0069\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067":return _fc ;
default:return _ab (_cebb ,_efad );};};func _eebe (_gdfa *_b .CompliancePdfReader )(_defb []ViolatedRule ){_gafc :=true ;_cbgea ,_fgbea :=_gdfa .GetCatalogMarkInfo ();if !_fgbea {_gafc =false ;}else {_fgea ,_eecbf :=_gd .GetDict (_cbgea );if _eecbf {_cbdf ,_aefd :=_gd .GetBool (_fgea .Get ("\u004d\u0061\u0072\u006b\u0065\u0064"));
if !bool (*_cbdf )||!_aefd {_gafc =false ;};}else {_gafc =false ;};};if !_gafc {_defb =append (_defb ,_ab ("\u0036.\u0037\u002e\u0032\u002d\u0031","\u0054\u0068\u0065\u0020\u0064\u006f\u0063\u0075\u006d\u0065\u006e\u0074\u0020\u0063\u0061\u0074\u0061\u006cog\u0020d\u0069\u0063\u0074\u0069\u006f\u006e\u0061r\u0079 \u0073\u0068\u0061\u006c\u006c\u0020\u0069\u006e\u0063\u006c\u0075\u0064\u0065\u0020\u0061\u0020M\u0061r\u006b\u0049\u006e\u0066\u006f\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006ea\u0072\u0079\u0020\u0077\u0069\u0074\u0068\u0020\u0061 \u004d\u0061\u0072\u006b\u0065\u0064\u0020\u0065\u006et\u0072\u0079\u0020\u0069\u006e\u0020\u0069\u0074,\u0020\u0077\u0068\u006f\u0073\u0065\u0020\u0076\u0061lu\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0074\u0072\u0075\u0065"));
};_bbgbb ,_fgbea :=_gdfa .GetCatalogStructTreeRoot ();if !_fgbea {_defb =append (_defb ,_ab ("\u0036.\u0037\u002e\u0033\u002d\u0031","\u0054\u0068\u0065\u0020\u006c\u006f\u0067\u0069\u0063\u0061\u006c\u0020\u0073\u0074\u0072\u0075\u0063\u0074\u0075r\u0065\u0020\u006f\u0066\u0020\u0074\u0068e\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067 \u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0064\u0065\u0073\u0063\u0072\u0069\u0062\u0065d \u0062\u0079\u0020a\u0020s\u0074\u0072\u0075\u0063\u0074\u0075\u0072e\u0020\u0068\u0069\u0065\u0072\u0061\u0072\u0063\u0068\u0079\u0020\u0072\u006f\u006ft\u0065\u0064\u0020i\u006e\u0020\u0074\u0068\u0065\u0020\u0053\u0074\u0072\u0075\u0063\u0074\u0054\u0072\u0065\u0065\u0052\u006f\u006f\u0074\u0020\u0065\u006e\u0074r\u0079\u0020\u006f\u0066\u0020\u0074h\u0065\u0020d\u006fc\u0075\u006d\u0065\u006e\u0074\u0020\u0063\u0061t\u0061\u006c\u006fg \u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002c\u0020\u0061\u0073\u0020\u0064\u0065\u0073\u0063\u0072\u0069\u0062\u0065\u0064\u0020\u0069n\u0020\u0050\u0044\u0046\u0020\u0052\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065 \u0039\u002e\u0036\u002e"));
};_gecc ,_fgbea :=_gd .GetDict (_bbgbb );if _fgbea {_fgef ,_adbgb :=_gd .GetName (_gecc .Get ("\u0052o\u006c\u0065\u004d\u0061\u0070"));if _adbgb {_accg ,_facbc :=_gd .GetDict (_fgef );if _facbc {for _ ,_eedbb :=range _accg .Keys (){_aefe :=_accg .Get (_eedbb );
if _aefe ==nil {_defb =append (_defb ,_ab ("\u0036.\u0037\u002e\u0033\u002d\u0032","\u0041\u006c\u006c\u0020\u006eo\u006e\u002ds\u0074\u0061\u006e\u0064\u0061\u0072\u0064\u0020\u0073t\u0072\u0075\u0063\u0074ure\u0020\u0074\u0079\u0070\u0065s\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065\u0020\u006d\u0061\u0070\u0070\u0065d\u0020\u0074\u006f\u0020\u0074\u0068\u0065\u0020n\u0065\u0061\u0072\u0065\u0073\u0074\u0020\u0066\u0075\u006e\u0063t\u0069\u006f\u006e\u0061\u006c\u006c\u0079\u0020\u0065\u0071\u0075\u0069\u0076\u0061\u006c\u0065\u006e\u0074\u0020\u0073\u0074a\u006ed\u0061r\u0064\u0020\u0074\u0079\u0070\u0065\u002c\u0020\u0061\u0073\u0020\u0064\u0065\u0066\u0069\u006ee\u0064\u0020\u0069\u006e\u0020\u0050\u0044\u0046\u0020\u0052\u0065\u0066\u0065re\u006e\u0063e\u0020\u0039\u002e\u0037\u002e\u0034\u002c\u0020i\u006e\u0020\u0074\u0068e\u0020\u0072\u006fl\u0065\u0020\u006d\u0061p \u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u006f\u0066 \u0074h\u0065\u0020\u0073\u0074\u0072\u0075c\u0074\u0075r\u0065\u0020\u0074\u0072e\u0065\u0020\u0072\u006f\u006ft\u002e"));
};};};};};return _defb ;};func _dffb (_dggb *_b .CompliancePdfReader )[]ViolatedRule {return nil };func _acfd (_aebeb *_da .Document )error {_ddge ,_dcgf :=_aebeb .FindCatalog ();if !_dcgf {return _age .New ("\u0063\u0061\u0074\u0061\u006c\u006f\u0067\u0020\u006e\u006f\u0074\u0020f\u006f\u0075\u006e\u0064");
};_acdg ,_dcgf :=_gd .GetDict (_ddge .Object .Get ("\u0050\u0065\u0072m\u0073"));if _dcgf {_fcf :=_gd .MakeDict ();_gcff :=_acdg .Keys ();for _ ,_agad :=range _gcff {if _agad .String ()=="\u0055\u0052\u0033"||_agad .String ()=="\u0044\u006f\u0063\u004d\u0044\u0050"{_fcf .Set (_agad ,_acdg .Get (_agad ));
};};_ddge .Object .Set ("\u0050\u0065\u0072m\u0073",_fcf );};return nil ;};func _gdde (_ccgce *_gd .PdfObjectDictionary )ViolatedRule {const (_gaea ="\u0036\u002e\u0032\u002e\u0031\u0031\u002e\u0033\u002d\u0032";_gdccd ="IS\u004f\u0020\u0033\u0032\u0030\u0030\u0030\u002d\u0031\u003a\u0032\u0030\u0030\u0038\u002c\u00209\u002e\u0037\u002e\u0034\u002c\u0020\u0054\u0061\u0062\u006c\u0065\u0020\u0031\u0031\u0037\u0020\u0072\u0065\u0071\u0075\u0069\u0072\u0065\u0073\u0020\u0074\u0068a\u0074\u0020\u0061\u006c\u006c\u0020\u0065m\u0062\u0065\u0064\u0064\u0065\u0064\u0020\u0054\u0079\u0070\u0065\u0020\u0032\u0020\u0043\u0049\u0044\u0046\u006fn\u0074\u0073\u0020\u0069n\u0020t\u0068e\u0020\u0043\u0049D\u0046\u006f\u006e\u0074\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061r\u0079\u0020\u0073\u0068a\u006c\u006c\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u0020\u0043\u0049\u0044\u0054\u006fG\u0049\u0044M\u0061\u0070\u0020\u0065\u006e\u0074\u0072\u0079 \u0074\u0068\u0061\u0074\u0020\u0073\u0068\u0061\u006c\u006c \u0062e\u0020\u0061\u0020\u0073t\u0072\u0065\u0061\u006d\u0020\u006d\u0061\u0070p\u0069\u006e\u0067 f\u0072\u006f\u006d \u0043\u0049\u0044\u0073\u0020\u0074\u006f\u0020\u0067\u006c\u0079p\u0068 \u0069\u006e\u0064\u0069c\u0065\u0073\u0020\u006fr\u0020\u0074\u0068\u0065\u0020\u006e\u0061\u006d\u0065\u0020\u0049d\u0065\u006e\u0074\u0069\u0074\u0079\u002c\u0020\u0061\u0073\u0020\u0064\u0065\u0073\u0063\u0072\u0069\u0062\u0065\u0064\u0020\u0069\u006e\u0020\u0049\u0053\u004f\u0020\u0033\u0032\u0030\u0030\u0030\u002d\u0031\u003a\u0032\u0030\u0030\u0038\u002c\u0020\u0039\u002e\u0037\u002e\u0034\u002c\u0020\u0054\u0061\u0062\u006c\u0065\u0020\u0031\u0031\u0037\u002e";
);var _gaaf string ;if _ddff ,_acbgf :=_gd .GetName (_ccgce .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_acbgf {_gaaf =_ddff .String ();};if _gaaf !="\u0043\u0049\u0044F\u006f\u006e\u0074\u0054\u0079\u0070\u0065\u0032"{return _fc ;};if _ccgce .Get ("C\u0049\u0044\u0054\u006f\u0047\u0049\u0044\u004d\u0061\u0070")==nil {return _ab (_gaea ,_gdccd );
};return _fc ;};func _ffgb (_eefg *_b .CompliancePdfReader ,_afdc standardType ,_ebfcc bool )(_aabg []ViolatedRule ){_agace ,_aega :=_dbce (_eefg );if !_aega {return []ViolatedRule {_ab ("\u0036.\u0036\u002e\u0032\u002e\u0031\u002d1","\u0063a\u0074a\u006c\u006f\u0067\u0020\u006eo\u0074\u0020f\u006f\u0075\u006e\u0064\u002e")};
};_dgbca :=_agace .Get ("\u004d\u0065\u0074\u0061\u0064\u0061\u0074\u0061");if _dgbca ==nil {return []ViolatedRule {_ab ("\u0036.\u0036\u002e\u0032\u002e\u0031\u002d1","\u0054\u0068\u0065\u0020\u0043\u0061\u0074\u0061\u006c\u006f\u0067\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072y\u0020\u006f\u0066\u0020\u0061\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073h\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0074ai\u006e\u0020\u0074\u0068\u0065\u0020\u004d\u0065\u0074\u0061\u0064\u0061\u0074\u0061\u0020\u006b\u0065\u0079\u0020\u0077\u0068\u006f\u0073\u0065\u0020v\u0061\u006c\u0075\u0065\u0020\u0069\u0073\u0020\u0061\u0020m\u0065\u0074\u0061\u0064\u0061\u0074\u0061\u0020s\u0074\u0072\u0065\u0061\u006d")};
};_ggef ,_aega :=_gd .GetStream (_dgbca );if !_aega {return []ViolatedRule {_ab ("\u0036.\u0036\u002e\u0032\u002e\u0031\u002d1","\u0054\u0068\u0065\u0020\u0043\u0061\u0074\u0061\u006c\u006f\u0067\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072y\u0020\u006f\u0066\u0020\u0061\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073h\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0074ai\u006e\u0020\u0074\u0068\u0065\u0020\u004d\u0065\u0074\u0061\u0064\u0061\u0074\u0061\u0020\u006b\u0065\u0079\u0020\u0077\u0068\u006f\u0073\u0065\u0020v\u0061\u006c\u0075\u0065\u0020\u0069\u0073\u0020\u0061\u0020m\u0065\u0074\u0061\u0064\u0061\u0074\u0061\u0020s\u0074\u0072\u0065\u0061\u006d")};
};_ddgc ,_fbge :=_daa .LoadDocument (_ggef .Stream );if _fbge !=nil {return []ViolatedRule {_ab ("\u0036.\u0036\u002e\u0032\u002e\u0031\u002d4","\u0041\u006c\u006c\u0020\u006de\u0074\u0061\u0064a\u0074\u0061\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u0073\u0020\u0070\u0072\u0065\u0073\u0065\u006e\u0074\u0020i\u006e \u0074\u0068\u0065\u0020\u0050\u0044\u0046 \u0073\u0068\u0061\u006c\u006c\u0020\u0063o\u006e\u0066\u006f\u0072\u006d\u0020\u0074\u006f\u0020\u0074\u0068\u0065\u0020\u0058\u004d\u0050\u0020\u0053\u0070\u0065ci\u0066\u0069\u0063\u0061\u0074\u0069\u006fn\u002e\u0020\u0041\u006c\u006c\u0020c\u006fn\u0074\u0065\u006e\u0074\u0020\u006f\u0066\u0020\u0061\u006c\u006c\u0020\u0058\u004d\u0050\u0020p\u0061\u0063\u006b\u0065\u0074\u0073 \u0073h\u0061\u006c\u006c \u0062\u0065\u0020\u0077\u0065\u006c\u006c\u002d\u0066o\u0072\u006de\u0064")};
};_dede :=_ddgc .GetGoXmpDocument ();var _gabd []*_ec .Namespace ;for _ ,_eggag :=range _dede .Namespaces (){switch _eggag .Name {case _db .NsDc .Name ,_c .NsPDF .Name ,_g .NsXmp .Name ,_dd .NsXmpRights .Name ,_ecdf .Namespace .Name ,_fb .Namespace .Name ,_df .NsXmpMM .Name ,_fb .FieldNS .Name ,_fb .SchemaNS .Name ,_fb .PropertyNS .Name ,"\u0073\u0074\u0045v\u0074","\u0073\u0074\u0056e\u0072","\u0073\u0074\u0052e\u0066","\u0073\u0074\u0044i\u006d","\u0078a\u0070\u0047\u0049\u006d\u0067","\u0073\u0074\u004ao\u0062","\u0078\u006d\u0070\u0069\u0064\u0071":continue ;
};_gabd =append (_gabd ,_eggag );};_daeg :=true ;_ebffa ,_fbge :=_ddgc .GetPdfaExtensionSchemas ();if _fbge ==nil {for _ ,_dcaaa :=range _gabd {var _bfgea bool ;for _edfcf :=range _ebffa {if _dcaaa .URI ==_ebffa [_edfcf ].NamespaceURI {_bfgea =true ;break ;
};};if !_bfgea {_daeg =false ;break ;};};}else {_daeg =false ;};if !_daeg {_aabg =append (_aabg ,_ab ("\u0036.\u0036\u002e\u0032\u002e\u0033\u002d7","\u0041\u006c\u006c\u0020\u0070\u0072\u006f\u0070e\u0072\u0074\u0069e\u0073\u0020\u0073\u0070\u0065\u0063i\u0066\u0069\u0065\u0064\u0020\u0069\u006e\u0020\u0058\u004d\u0050\u0020\u0066\u006f\u0072m\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0075s\u0065\u0020\u0065\u0069\u0074\u0068\u0065\u0072\u0020\u0074\u0068\u0065\u0020\u0070\u0072\u0065\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0073\u0063he\u006da\u0073 \u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0058\u004d\u0050\u0020\u0053\u0070\u0065\u0063\u0069\u0066\u0069\u0063\u0061\u0074\u0069\u006f\u006e\u002c\u0020\u0049\u0053\u004f\u0020\u0031\u00390\u0030\u0035-\u0031\u0020\u006f\u0072\u0020\u0074h\u0069s\u0020\u0070\u0061\u0072\u0074\u0020\u006f\u0066\u0020\u0049\u0053\u004f\u0020\u0031\u0039\u0030\u0030\u0035\u002c\u0020o\u0072\u0020\u0061\u006e\u0079\u0020e\u0078\u0074\u0065\u006e\u0073\u0069\u006f\u006e\u0020\u0073c\u0068\u0065\u006das\u0020\u0074\u0068\u0061\u0074\u0020\u0063\u006fm\u0070\u006c\u0079\u0020\u0077\u0069\u0074\u0068\u0020\u0036\u002e\u0036\u002e\u0032.\u0033\u002e\u0032\u002e"));
};_bccg ,_aega :=_ddgc .GetPdfAID ();if !_aega {_aabg =append (_aabg ,_ab ("\u0036.\u0036\u002e\u0034\u002d\u0031","\u0054\u0068\u0065\u0020\u0050\u0044\u0046\u002f\u0041\u0020\u0076\u0065\u0072\u0073\u0069\u006f\u006e\u0020\u0061n\u0064\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006ec\u0065\u0020\u006c\u0065\u0076\u0065l\u0020\u006f\u0066\u0020\u0061\u0020\u0066\u0069\u006c\u0065\u0020\u0073h\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0073\u0070e\u0063\u0069\u0066\u0069\u0065\u0064\u0020\u0075\u0073\u0069\u006e\u0067\u0020\u0074\u0068\u0065\u0020\u0050\u0044\u0046\u002f\u0041\u0020\u0049\u0064\u0065\u006e\u0074\u0069\u0066\u0069\u0063\u0061\u0074\u0069\u006f\u006e\u0020\u0065\u0078\u0074\u0065\u006e\u0073\u0069\u006f\u006e\u0020\u0073\u0063h\u0065\u006da."));
}else {if _bccg .Part !=_afdc ._gb {_aabg =append (_aabg ,_ab ("\u0036.\u0036\u002e\u0034\u002d\u0032","\u0054h\u0065\u0020\u0076\u0061lue\u0020\u006f\u0066\u0020p\u0064\u0066\u0061\u0069\u0064\u003a\u0070\u0061\u0072\u0074 \u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0074\u0068\u0065\u0020\u0070\u0061\u0072\u0074\u0020\u006e\u0075\u006d\u0062\u0065r\u0020\u006f\u0066\u0020\u0049\u0053\u004f\u002019\u0030\u0030\u0035 \u0074\u006f\u0020\u0077\u0068i\u0063h\u0020\u0074\u0068\u0065\u0020\u0066\u0069\u006c\u0065 \u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0073\u002e"));
};if _afdc ._dcd =="\u0041"&&_bccg .Conformance !="\u0041"{_aabg =append (_aabg ,_ab ("\u0036.\u0036\u002e\u0034\u002d\u0033","\u0041\u0020\u004c\u0065\u0076\u0065\u006c\u0020\u0041\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065 \u0073\u0068\u0061l\u006c\u0020\u0073\u0070ec\u0069\u0066\u0079\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006cu\u0065\u0020\u006f\u0066\u0020\u0070\u0064\u0066\u0061\u0069\u0064\u003a\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006ec\u0065\u0020as\u0020\u0041\u002e\u0020\u0041 \u004c\u0065v\u0065\u006c\u0020\u0042\u0020c\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006cl\u0020\u0073\u0070\u0065\u0063\u0069\u0066\u0079\u0020\u0074\u0068\u0065\u0020\u0076\u0061lu\u0065\u0020o\u0066 \u0070\u0064\u0066\u0061\u0069d\u003a\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006e\u0063\u0065\u0020\u0061\u0073\u0020\u0042\u002e\u0020\u0041\u0020\u004c\u0065\u0076\u0065\u006c \u0055\u0020\u0063\u006f\u006e\u0066\u006fr\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020s\u0070\u0065\u0063\u0069\u0066\u0079 \u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006ff\u0020\u0070\u0064f\u0061i\u0064\u003ac\u006fn\u0066\u006f\u0072\u006d\u0061\u006e\u0063\u0065 \u0061\u0073\u0020\u0055."));
}else if _afdc ._dcd =="\u0055"&&(_bccg .Conformance !="\u0041"&&_bccg .Conformance !="\u0055"){_aabg =append (_aabg ,_ab ("\u0036.\u0036\u002e\u0034\u002d\u0033","\u0041\u0020\u004c\u0065\u0076\u0065\u006c\u0020\u0041\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065 \u0073\u0068\u0061l\u006c\u0020\u0073\u0070ec\u0069\u0066\u0079\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006cu\u0065\u0020\u006f\u0066\u0020\u0070\u0064\u0066\u0061\u0069\u0064\u003a\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006ec\u0065\u0020as\u0020\u0041\u002e\u0020\u0041 \u004c\u0065v\u0065\u006c\u0020\u0042\u0020c\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006cl\u0020\u0073\u0070\u0065\u0063\u0069\u0066\u0079\u0020\u0074\u0068\u0065\u0020\u0076\u0061lu\u0065\u0020o\u0066 \u0070\u0064\u0066\u0061\u0069d\u003a\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006e\u0063\u0065\u0020\u0061\u0073\u0020\u0042\u002e\u0020\u0041\u0020\u004c\u0065\u0076\u0065\u006c \u0055\u0020\u0063\u006f\u006e\u0066\u006fr\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020s\u0070\u0065\u0063\u0069\u0066\u0079 \u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006ff\u0020\u0070\u0064f\u0061i\u0064\u003ac\u006fn\u0066\u006f\u0072\u006d\u0061\u006e\u0063\u0065 \u0061\u0073\u0020\u0055."));
}else if _afdc ._dcd =="\u0042"&&(_bccg .Conformance !="\u0041"&&_bccg .Conformance !="\u0042"&&_bccg .Conformance !="\u0055"){_aabg =append (_aabg ,_ab ("\u0036.\u0036\u002e\u0034\u002d\u0033","\u0041\u0020\u004c\u0065\u0076\u0065\u006c\u0020\u0041\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065 \u0073\u0068\u0061l\u006c\u0020\u0073\u0070ec\u0069\u0066\u0079\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006cu\u0065\u0020\u006f\u0066\u0020\u0070\u0064\u0066\u0061\u0069\u0064\u003a\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006ec\u0065\u0020as\u0020\u0041\u002e\u0020\u0041 \u004c\u0065v\u0065\u006c\u0020\u0042\u0020c\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006cl\u0020\u0073\u0070\u0065\u0063\u0069\u0066\u0079\u0020\u0074\u0068\u0065\u0020\u0076\u0061lu\u0065\u0020o\u0066 \u0070\u0064\u0066\u0061\u0069d\u003a\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006e\u0063\u0065\u0020\u0061\u0073\u0020\u0042\u002e\u0020\u0041\u0020\u004c\u0065\u0076\u0065\u006c \u0055\u0020\u0063\u006f\u006e\u0066\u006fr\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020s\u0070\u0065\u0063\u0069\u0066\u0079 \u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006ff\u0020\u0070\u0064f\u0061i\u0064\u003ac\u006fn\u0066\u006f\u0072\u006d\u0061\u006e\u0063\u0065 \u0061\u0073\u0020\u0055."));
};};return _aabg ;};func _gg ()standardType {return standardType {_gb :2,_dcd :"\u0055"}};func _afc (_dab *_da .Document ,_dgdg int ){if _dab .Version .Major ==0{_dab .Version .Major =1;};if _dab .Version .Minor < _dgdg {_dab .Version .Minor =_dgdg ;};
};func _dbg (_bcb *_da .Document )error {_dea :=func (_gge *_gd .PdfObjectDictionary )error {if _bgc :=_gge .Get ("\u0053\u004d\u0061s\u006b");_bgc !=nil {_gge .Set ("\u0053\u004d\u0061s\u006b",_gd .MakeName ("\u004e\u006f\u006e\u0065"));};_gbge :=_gge .Get ("\u0043\u0041");
if _gbge !=nil {_gcb ,_ffg :=_gd .GetNumberAsFloat (_gbge );if _ffg !=nil {_ae .Log .Debug ("\u0045x\u0074\u0047S\u0074\u0061\u0074\u0065 \u006f\u0062\u006ae\u0063\u0074\u0020\u0043\u0041\u0020\u0076\u0061\u006cue\u0020\u0069\u0073 \u006e\u006ft\u0020\u0061\u0020\u0066\u006c\u006fa\u0074\u003a \u0025\u0076",_ffg );
_gcb =0;};if _gcb !=1.0{_gge .Set ("\u0043\u0041",_gd .MakeFloat (1.0));};};_gbge =_gge .Get ("\u0063\u0061");if _gbge !=nil {_aaf ,_gcba :=_gd .GetNumberAsFloat (_gbge );if _gcba !=nil {_ae .Log .Debug ("\u0045\u0078t\u0047\u0053\u0074\u0061\u0074\u0065\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0027\u0063\u0061\u0027\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0069\u0073\u0020\u006e\u006f\u0074\u0020\u0061\u0020\u0066\u006c\u006f\u0061\u0074\u003a\u0020\u0025\u0076",_gcba );
_aaf =0;};if _aaf !=1.0{_gge .Set ("\u0063\u0061",_gd .MakeFloat (1.0));};};_bdg :=_gge .Get ("\u0042\u004d");if _bdg !=nil {_fbg ,_bcbd :=_gd .GetName (_bdg );if !_bcbd {_ae .Log .Debug ("E\u0078\u0074\u0047\u0053\u0074\u0061t\u0065\u0020\u006f\u0062\u006a\u0065c\u0074\u0020\u0027\u0042\u004d\u0027\u0020i\u0073\u0020\u006e\u006f\u0074\u0020\u0061\u0020\u004e\u0061m\u0065");
_fbg =_gd .MakeName ("");};_ed :=_fbg .String ();switch _ed {case "\u004e\u006f\u0072\u006d\u0061\u006c","\u0043\u006f\u006d\u0070\u0061\u0074\u0069\u0062\u006c\u0065":default:_gge .Set ("\u0042\u004d",_gd .MakeName ("\u004e\u006f\u0072\u006d\u0061\u006c"));
};};_afd :=_gge .Get ("\u0054\u0052");if _afd !=nil {_ae .Log .Debug ("\u0045\u0078\u0074\u0047\u0053\u0074\u0061\u0074\u0065\u0020\u006f\u0062\u006a\u0065\u0063t\u0020c\u006f\u006e\u0074\u0061\u0069\u006e\u0073\u0020\u0054\u0052\u0020\u006b\u0065\u0079");
_gge .Remove ("\u0054\u0052");};_cgf :=_gge .Get ("\u0054\u0052\u0032");if _cgf !=nil {_deg :=_cgf .String ();if _deg !="\u0044e\u0066\u0061\u0075\u006c\u0074"{_ae .Log .Debug ("\u0045x\u0074\u0047\u0053\u0074\u0061\u0074\u0065 o\u0062\u006a\u0065\u0063\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0073 \u0054\u00522\u0020\u006b\u0065y\u0020\u0077\u0069\u0074\u0068\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0074\u0068\u0065r\u0020\u0074ha\u006e\u0020\u0044e\u0066\u0061\u0075\u006c\u0074");
_gge .Set ("\u0054\u0052\u0032",_gd .MakeName ("\u0044e\u0066\u0061\u0075\u006c\u0074"));};};return nil ;};_dbb ,_fcb :=_bcb .GetPages ();if !_fcb {return nil ;};for _ ,_aad :=range _dbb {_dgga ,_gbedd :=_aad .GetResources ();if !_gbedd {continue ;};_faga ,_ade :=_gd .GetDict (_dgga .Get ("\u0045x\u0074\u0047\u0053\u0074\u0061\u0074e"));
if !_ade {return nil ;};_egf :=_faga .Keys ();for _ ,_cda :=range _egf {_ge ,_cdb :=_gd .GetDict (_faga .Get (_cda ));if !_cdb {continue ;};_bff :=_dea (_ge );if _bff !=nil {continue ;};};};for _ ,_dfd :=range _dbb {_ffca ,_deeg :=_dfd .GetContents ();
if !_deeg {return nil ;};for _ ,_ddab :=range _ffca {_gee ,_bfa :=_ddab .GetData ();if _bfa !=nil {continue ;};_cdc :=_dc .NewContentStreamParser (string (_gee ));_deae ,_bfa :=_cdc .Parse ();if _bfa !=nil {continue ;};for _ ,_gcc :=range *_deae {if len (_gcc .Params )==0{continue ;
};_ ,_cff :=_gd .GetName (_gcc .Params [0]);if !_cff {continue ;};_ageb ,_ccg :=_dfd .GetResourcesXObject ();if !_ccg {continue ;};for _ ,_fce :=range _ageb .Keys (){_bad ,_fdg :=_gd .GetStream (_ageb .Get (_fce ));if !_fdg {continue ;};_cdf ,_fdg :=_gd .GetDict (_bad .Get ("\u0052e\u0073\u006f\u0075\u0072\u0063\u0065s"));
if !_fdg {continue ;};_fgc ,_fdg :=_gd .GetDict (_cdf .Get ("\u0045x\u0074\u0047\u0053\u0074\u0061\u0074e"));if !_fdg {continue ;};for _ ,_ga :=range _fgc .Keys (){_ebd ,_bdf :=_gd .GetDict (_fgc .Get (_ga ));if !_bdf {continue ;};_fda :=_dea (_ebd );if _fda !=nil {continue ;
};};};};};};return nil ;};func _dbadf (_gdfec *_b .CompliancePdfReader )ViolatedRule {_bece :=_gdfec .ParserMetadata ();if _bece .HasInvalidSeparationAfterXRef (){return _ab ("\u0036.\u0031\u002e\u0034\u002d\u0032","\u0054\u0068\u0065 \u0078\u0072\u0065\u0066\u0020\u006b\u0065\u0079\u0077\u006fr\u0064\u0020\u0061\u006e\u0064\u0020\u0074\u0068\u0065\u0020\u0063\u0072\u006f\u0073s\u0020\u0072\u0065\u0066e\u0072\u0065\u006e\u0063\u0065 s\u0075b\u0073\u0065\u0063ti\u006f\u006e\u0020\u0068\u0065\u0061\u0064e\u0072\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0073\u0065\u0070\u0061\u0072\u0061\u0074\u0065\u0064\u0020\u0062\u0079 \u0061\u0020\u0073i\u006e\u0067\u006c\u0065\u0020\u0045\u004fL\u0020\u006d\u0061\u0072\u006b\u0065\u0072\u002e");
};return _fc ;};func _eecg (_dac *_da .Document )error {_ffce ,_gce :=_dac .FindCatalog ();if !_gce {return _age .New ("\u0063\u0061\u0074\u0061\u006c\u006f\u0067\u0020\u006e\u006f\u0074\u0020f\u006f\u0075\u006e\u0064");};_ ,_gce =_gd .GetDict (_ffce .Object .Get ("\u0041\u0041"));
if !_gce {return nil ;};_ffce .Object .Remove ("\u0041\u0041");return nil ;};func _daba (_gcecg *_b .CompliancePdfReader )(_gdgd []ViolatedRule ){var _feae ,_cbdc ,_fdgbde ,_abad bool ;_ddgb :=func ()bool {return _feae &&_cbdc &&_fdgbde &&_abad };_ddde ,_bafbe :=_eadb (_gcecg );
var _dega _aa .ProfileHeader ;if _bafbe {_dega ,_ =_aa .ParseHeader (_ddde .DestOutputProfile );};_afegeg :=map[_gd .PdfObject ]struct{}{};var _cabb func (_cgcd _b .PdfColorspace )bool ;_cabb =func (_dfga _b .PdfColorspace )bool {switch _fece :=_dfga .(type ){case *_b .PdfColorspaceDeviceGray :if !_feae {if !_bafbe {_gdgd =append (_gdgd ,_ab ("\u0036.\u0032\u002e\u0034\u002e\u0033\u002d4","\u0044\u0065\u0076\u0069\u0063\u0065\u0047\u0072\u0061\u0079 \u0073\u0068\u0061\u006c\u006c\u0020\u006f\u006e\u006c\u0079\u0020\u0062\u0065\u0020\u0075\u0073\u0065\u0064 \u0069\u0066\u0020\u0061\u0020\u0064\u0065v\u0069\u0063\u0065\u0020\u0069\u006e\u0064\u0065p\u0065\u006e\u0064\u0065\u006e\u0074\u0020\u0044\u0065\u0066\u0061\u0075\u006c\u0074\u0047\u0072\u0061\u0079\u0020\u0063\u006f\u006c\u006f\u0075r \u0073\u0070\u0061\u0063\u0065\u0020\u0068\u0061\u0073\u0020\u0062\u0065\u0065\u006e \u0073\u0065\u0074\u0020\u0077\u0068\u0065n \u0074\u0068\u0065\u0020\u0044\u0065\u0076\u0069\u0063\u0065\u0047\u0072a\u0079\u0020\u0063\u006f\u006c\u006f\u0075\u0072\u0020\u0073\u0070\u0061\u0063\u0065\u0020\u0069\u0073\u0020\u0075\u0073\u0065\u0064\u002c o\u0072\u0020\u0069\u0066\u0020\u0061\u0020\u0050\u0044\u0046\u002fA\u0020\u004f\u0075tp\u0075\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0020\u0069\u0073\u0020\u0070\u0072\u0065\u0073\u0065\u006e\u0074\u002e"));
_feae =true ;if _ddgb (){return true ;};};};case *_b .PdfColorspaceDeviceRGB :if !_cbdc {if !_bafbe ||_dega .ColorSpace !=_aa .ColorSpaceRGB {_gdgd =append (_gdgd ,_ab ("\u0036.\u0032\u002e\u0034\u002e\u0033\u002d2","\u0044\u0065\u0076\u0069c\u0065\u0052\u0047\u0042\u0020\u0073\u0068\u0061\u006cl\u0020\u006f\u006e\u006c\u0079\u0020\u0062e\u0020\u0075\u0073\u0065\u0064\u0020\u0069f\u0020\u0061\u0020\u0064\u0065\u0076\u0069\u0063e\u0020\u0069n\u0064\u0065\u0070e\u006e\u0064\u0065\u006et \u0044\u0065\u0066\u0061\u0075\u006c\u0074\u0052\u0047\u0042\u0020\u0063\u006fl\u006f\u0075r\u0020\u0073\u0070\u0061\u0063\u0065\u0020\u0068\u0061\u0073\u0020b\u0065\u0065\u006e\u0020s\u0065\u0074 \u0077\u0068\u0065\u006e\u0020\u0074\u0068\u0065\u0020\u0044\u0065\u0076\u0069\u0063\u0065\u0052\u0047\u0042\u0020c\u006flou\u0072\u0020\u0073\u0070\u0061\u0063\u0065\u0020i\u0073\u0020\u0075\u0073\u0065\u0064\u002c\u0020\u006f\u0072\u0020if\u0020\u0074\u0068\u0065\u0020\u0066\u0069\u006c\u0065\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0050\u0044F\u002f\u0041\u0020\u004fut\u0070\u0075\u0074\u0049\u006e\u0074\u0065n\u0074\u0020t\u0068\u0061t\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0073\u0020\u0061\u006e\u0020\u0052\u0047\u0042\u0020\u0064\u0065\u0073\u0074\u0069\u006e\u0061\u0074io\u006e\u0020\u0070\u0072\u006f\u0066\u0069\u006c\u0065\u002e"));
_cbdc =true ;if _ddgb (){return true ;};};};case *_b .PdfColorspaceDeviceCMYK :if !_fdgbde {if !_bafbe ||_dega .ColorSpace !=_aa .ColorSpaceCMYK {_gdgd =append (_gdgd ,_ab ("\u0036.\u0032\u002e\u0034\u002e\u0033\u002d3","\u0044e\u0076\u0069c\u0065\u0043\u004d\u0059\u004b\u0020\u0073hal\u006c\u0020\u006f\u006e\u006c\u0079\u0020\u0062\u0065\u0020\u0075\u0073\u0065\u0064\u0020\u0069\u0066\u0020\u0061\u0020\u0064\u0065\u0076\u0069\u0063\u0065\u0020\u0069\u006e\u0064\u0065\u0070\u0065\u006e\u0064\u0065\u006e\u0074\u0020\u0044ef\u0061\u0075\u006c\u0074\u0043\u004d\u0059K\u0020\u0063\u006f\u006c\u006f\u0075\u0072\u0020\u0073\u0070\u0061\u0063\u0065\u0020\u0068\u0061s\u0020\u0062\u0065\u0065\u006e \u0073\u0065\u0074\u0020\u006fr \u0069\u0066\u0020\u0061\u0020\u0044e\u0076\u0069\u0063\u0065\u004e\u002d\u0062\u0061\u0073\u0065\u0064\u0020\u0044\u0065f\u0061\u0075\u006c\u0074\u0043\u004d\u0059\u004b\u0020c\u006f\u006c\u006f\u0075r\u0020\u0073\u0070\u0061\u0063e\u0020\u0068\u0061\u0073\u0020\u0062\u0065\u0065\u006e\u0020\u0073\u0065\u0074\u0020\u0077\u0068\u0065\u006e\u0020\u0074h\u0065\u0020\u0044\u0065\u0076\u0069c\u0065\u0043\u004d\u0059\u004b\u0020c\u006f\u006c\u006fu\u0072\u0020\u0073\u0070\u0061\u0063\u0065\u0020\u0069\u0073\u0020\u0075\u0073\u0065\u0064\u0020\u006f\u0072\u0020t\u0068\u0065\u0020\u0066\u0069l\u0065\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0050\u0044\u0046\u002f\u0041\u0020\u004f\u0075\u0074p\u0075\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0020\u0074\u0068\u0061\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0073\u0020\u0061\u0020\u0043\u004d\u0059\u004b\u0020d\u0065\u0073\u0074\u0069\u006e\u0061t\u0069\u006f\u006e\u0020\u0070r\u006f\u0066\u0069\u006c\u0065\u002e"));
_fdgbde =true ;if _ddgb (){return true ;};};};case *_b .PdfColorspaceICCBased :if !_abad {_fdbg ,_ebbgb :=_aa .ParseHeader (_fece .Data );if _ebbgb !=nil {_ae .Log .Debug ("\u0070\u0061\u0072si\u006e\u0067\u0020\u0049\u0043\u0043\u0042\u0061\u0073e\u0064 \u0068e\u0061d\u0065\u0072\u0020\u0066\u0061\u0069\u006c\u0065\u0064\u003a\u0020\u0025\u0076",_ebbgb );
_gdgd =append (_gdgd ,func ()ViolatedRule {return _ab ("\u0036.\u0032\u002e\u0034\u002e\u0032\u002d1","\u0054\u0068e\u0020\u0070\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u0074\u0068\u0061\u0074\u0020\u0066o\u0072\u006d\u0073\u0020\u0074\u0068\u0065\u0020\u0073\u0074r\u0065\u0061\u006d o\u0066\u0020\u0061\u006e\u0020\u0049C\u0043\u0042\u0061\u0073\u0065\u0064\u0020\u0063\u006fl\u006f\u0075\u0072\u0020\u0073p\u0061\u0063\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0020\u0074o\u0020\u0049\u0043\u0043.\u0031\u003a\u0031\u0039\u0039\u0038-\u0030\u0039,\u0020\u0049\u0043\u0043\u002e\u0031\u003a\u0032\u0030\u0030\u0031\u002d\u00312\u002c\u0020\u0049\u0043\u0043\u002e\u0031\u003a\u0032\u0030\u0030\u0033\u002d\u0030\u0039\u0020\u006f\u0072\u0020I\u0053\u004f\u0020\u0031\u0035\u0030\u0037\u0036\u002d\u0031\u002e");
}());_abad =true ;if _ddgb (){return true ;};};if !_abad {var _efaab ,_ggfb bool ;switch _fdbg .DeviceClass {case _aa .DeviceClassPRTR ,_aa .DeviceClassMNTR ,_aa .DeviceClassSCNR ,_aa .DeviceClassSPAC :default:_efaab =true ;};switch _fdbg .ColorSpace {case _aa .ColorSpaceRGB ,_aa .ColorSpaceCMYK ,_aa .ColorSpaceGRAY ,_aa .ColorSpaceLAB :default:_ggfb =true ;
};if _efaab ||_ggfb {_gdgd =append (_gdgd ,_ab ("\u0036.\u0032\u002e\u0034\u002e\u0032\u002d1","\u0054\u0068e\u0020\u0070\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u0074\u0068\u0061\u0074\u0020\u0066o\u0072\u006d\u0073\u0020\u0074\u0068\u0065\u0020\u0073\u0074r\u0065\u0061\u006d o\u0066\u0020\u0061\u006e\u0020\u0049C\u0043\u0042\u0061\u0073\u0065\u0064\u0020\u0063\u006fl\u006f\u0075\u0072\u0020\u0073p\u0061\u0063\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0020\u0074o\u0020\u0049\u0043\u0043.\u0031\u003a\u0031\u0039\u0039\u0038-\u0030\u0039,\u0020\u0049\u0043\u0043\u002e\u0031\u003a\u0032\u0030\u0030\u0031\u002d\u00312\u002c\u0020\u0049\u0043\u0043\u002e\u0031\u003a\u0032\u0030\u0030\u0033\u002d\u0030\u0039\u0020\u006f\u0072\u0020I\u0053\u004f\u0020\u0031\u0035\u0030\u0037\u0036\u002d\u0031\u002e"));
_abad =true ;if _ddgb (){return true ;};};};};if _fece .Alternate !=nil {return _cabb (_fece .Alternate );};};return false ;};for _ ,_adadf :=range _gcecg .GetObjectNums (){_aefg ,_egfga :=_gcecg .GetIndirectObjectByNumber (_adadf );if _egfga !=nil {continue ;
};_fccf ,_bbgfd :=_gd .GetStream (_aefg );if !_bbgfd {continue ;};_acdaf ,_bbgfd :=_gd .GetName (_fccf .Get ("\u0054\u0079\u0070\u0065"));if !_bbgfd ||_acdaf .String ()!="\u0058O\u0062\u006a\u0065\u0063\u0074"{continue ;};_acfg ,_bbgfd :=_gd .GetName (_fccf .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));
if !_bbgfd {continue ;};_afegeg [_fccf ]=struct{}{};switch _acfg .String (){case "\u0049\u006d\u0061g\u0065":_bbgag ,_gfbf :=_b .NewXObjectImageFromStream (_fccf );if _gfbf !=nil {continue ;};_afegeg [_fccf ]=struct{}{};if _cabb (_bbgag .ColorSpace ){return _gdgd ;
};case "\u0046\u006f\u0072\u006d":_efee ,_aacf :=_gd .GetDict (_fccf .Get ("\u0047\u0072\u006fu\u0070"));if !_aacf {continue ;};_adgaa :=_efee .Get ("\u0043\u0053");if _adgaa ==nil {continue ;};_aaaa ,_becab :=_b .NewPdfColorspaceFromPdfObject (_adgaa );
if _becab !=nil {continue ;};if _cabb (_aaaa ){return _gdgd ;};};};for _ ,_afaf :=range _gcecg .PageList {_ecgd ,_gbafg :=_afaf .GetContentStreams ();if _gbafg !=nil {continue ;};for _ ,_ccdba :=range _ecgd {_cdbfb ,_fbfec :=_dc .NewContentStreamParser (_ccdba ).Parse ();
if _fbfec !=nil {continue ;};for _ ,_fgbe :=range *_cdbfb {if len (_fgbe .Params )> 1{continue ;};switch _fgbe .Operand {case "\u0042\u0049":_gadba ,_cfff :=_fgbe .Params [0].(*_dc .ContentStreamInlineImage );if !_cfff {continue ;};_gbgca ,_ffge :=_gadba .GetColorSpace (_afaf .Resources );
if _ffge !=nil {continue ;};if _cabb (_gbgca ){return _gdgd ;};case "\u0044\u006f":_feef ,_faca :=_gd .GetName (_fgbe .Params [0]);if !_faca {continue ;};_bfcg ,_ddcge :=_afaf .Resources .GetXObjectByName (*_feef );if _ ,_fabdd :=_afegeg [_bfcg ];_fabdd {continue ;
};switch _ddcge {case _b .XObjectTypeImage :_aeac ,_eagf :=_b .NewXObjectImageFromStream (_bfcg );if _eagf !=nil {continue ;};_afegeg [_bfcg ]=struct{}{};if _cabb (_aeac .ColorSpace ){return _gdgd ;};case _b .XObjectTypeForm :_edgfb ,_fage :=_gd .GetDict (_bfcg .Get ("\u0047\u0072\u006fu\u0070"));
if !_fage {continue ;};_adbc ,_fage :=_gd .GetName (_edgfb .Get ("\u0043\u0053"));if !_fage {continue ;};_fdffef ,_abgec :=_b .NewPdfColorspaceFromPdfObject (_adbc );if _abgec !=nil {continue ;};_afegeg [_bfcg ]=struct{}{};if _cabb (_fdffef ){return _gdgd ;
};};};};};};return _gdgd ;};func _cafa (_dgfg ,_deadgc ,_befd ,_cgeg string )(string ,bool ){_gec :=_ef .Index (_dgfg ,_deadgc );if _gec ==-1{return "",false ;};_bfda :=_ef .Index (_dgfg ,_befd );if _bfda ==-1{return "",false ;};if _bfda < _gec {return "",false ;
};return _dgfg [:_gec ]+_deadgc +_cgeg +_dgfg [_bfda :],true ;};func _bbcb (_fefd *_b .CompliancePdfReader )ViolatedRule {return _fc };func _bgbg (_dfbda *_b .CompliancePdfReader ,_gdfg bool )(_fgfe []ViolatedRule ){var _fdbb ,_fgde ,_fcfe ,_bgffd ,_bgfc ,_gbac ,_cfd bool ;
_dfedb :=func ()bool {return _fdbb &&_fgde &&_fcfe &&_bgffd &&_bgfc &&_gbac &&_cfd };_ccge ,_ccc :=_eadb (_dfbda );var _acee _aa .ProfileHeader ;if _ccc {_acee ,_ =_aa .ParseHeader (_ccge .DestOutputProfile );};var _cgdec bool ;_agd :=map[_gd .PdfObject ]struct{}{};
var _accb func (_egfdb _b .PdfColorspace )bool ;_accb =func (_bgeb _b .PdfColorspace )bool {switch _bfdf :=_bgeb .(type ){case *_b .PdfColorspaceDeviceGray :if !_gbac {if !_ccc {_cgdec =true ;_fgfe =append (_fgfe ,_ab ("\u0036.\u0032\u002e\u0033\u002d\u0034","\u0044\u0065\u0076\u0069\u0063\u0065G\u0072\u0061\u0079\u0020\u006da\u0079\u0020\u0062\u0065\u0020\u0075s\u0065\u0064\u0020\u006f\u006el\u0079\u0020\u0069\u0066\u0020\u0074\u0068\u0065\u0020\u0066\u0069\u006ce\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0050\u0044\u0046\u002f\u0041\u002d\u0031\u0020O\u0075\u0074\u0070\u0075\u0074\u0049\u006e\u0074e\u006e\u0074\u002e"));
_gbac =true ;if _dfedb (){return true ;};};};case *_b .PdfColorspaceDeviceRGB :if !_bgffd {if !_ccc ||_acee .ColorSpace !=_aa .ColorSpaceRGB {_cgdec =true ;_fgfe =append (_fgfe ,_ab ("\u0036.\u0032\u002e\u0033\u002d\u0032","\u0044\u0065\u0076\u0069\u0063\u0065\u0052\u0047\u0042\u0020\u006d\u0061\u0079\u0020\u0062\u0065\u0020\u0075\u0073\u0065\u0064\u0020\u006f\u006e\u006c\u0079\u0020\u0069\u0066\u0020\u0074\u0068\u0065 \u0066\u0069\u006c\u0065\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0050\u0044\u0046\u002f\u0041\u002d\u0031\u0020\u004f\u0075\u0074\u0070\u0075\u0074In\u0074\u0065\u006e\u0074\u0020\u0074\u0068\u0061\u0074\u0020u\u0073es\u0020a\u006e\u0020\u0052\u0047\u0042\u0020\u0063o\u006c\u006f\u0072\u0020\u0073\u0070\u0061\u0063\u0065\u002e"));
_bgffd =true ;if _dfedb (){return true ;};};};case *_b .PdfColorspaceDeviceCMYK :if !_bgfc {if !_ccc ||_acee .ColorSpace !=_aa .ColorSpaceCMYK {_cgdec =true ;_fgfe =append (_fgfe ,_ab ("\u0036.\u0032\u002e\u0033\u002d\u0033","\u0044\u0065\u0076\u0069\u0063e\u0043\u004d\u0059\u004b \u006d\u0061\u0079\u0020\u0062\u0065\u0020\u0075\u0073\u0065\u0064\u0020\u006f\u006e\u006c\u0079\u0020\u0069\u0066\u0020\u0074h\u0065\u0020\u0066\u0069\u006ce \u0068\u0061\u0073\u0020\u0061 \u0050\u0044\u0046\u002f\u0041\u002d\u0031\u0020\u004f\u0075\u0074p\u0075\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0020\u0074\u0068a\u0074\u0020\u0075\u0073\u0065\u0073\u0020\u0061\u006e \u0043\u004d\u0059\u004b\u0020\u0063\u006f\u006c\u006f\u0072\u0020s\u0070\u0061\u0063e\u002e"));
_bgfc =true ;if _dfedb (){return true ;};};};case *_b .PdfColorspaceICCBased :if !_fcfe ||!_cfd {_beca ,_efbb :=_aa .ParseHeader (_bfdf .Data );if _efbb !=nil {_ae .Log .Debug ("\u0070\u0061\u0072si\u006e\u0067\u0020\u0049\u0043\u0043\u0042\u0061\u0073e\u0064 \u0068e\u0061d\u0065\u0072\u0020\u0066\u0061\u0069\u006c\u0065\u0064\u003a\u0020\u0025\u0076",_efbb );
_fgfe =append (_fgfe ,func ()ViolatedRule {return _ab ("\u0036.\u0032\u002e\u0033\u002d\u0031","\u0041\u006cl \u0049\u0043\u0043\u0042\u0061\u0073\u0065\u0064\u0020\u0063\u006f\u006co\u0072\u0020\u0073\u0070a\u0063e\u0073\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065d\u0020\u0061\u0073\u0020\u0049\u0043\u0043 \u0070\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u0073\u0074\u0072\u0065a\u006d\u0073 \u0061\u0073\u0020d\u0065\u0073\u0063\u0072\u0069\u0062\u0065\u0064\u0020\u0069\u006e\u0020\u0050\u0044\u0046\u0020R\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0034\u002e\u0035");
}());_fcfe =true ;if _dfedb (){return true ;};};if !_fcfe {var _gbaf ,_baeg bool ;switch _beca .DeviceClass {case _aa .DeviceClassPRTR ,_aa .DeviceClassMNTR ,_aa .DeviceClassSCNR ,_aa .DeviceClassSPAC :default:_gbaf =true ;};switch _beca .ColorSpace {case _aa .ColorSpaceRGB ,_aa .ColorSpaceCMYK ,_aa .ColorSpaceGRAY ,_aa .ColorSpaceLAB :default:_baeg =true ;
};if _gbaf ||_baeg {_fgfe =append (_fgfe ,_ab ("\u0036.\u0032\u002e\u0033\u002d\u0031","\u0041\u006cl \u0049\u0043\u0043\u0042\u0061\u0073\u0065\u0064\u0020\u0063\u006f\u006co\u0072\u0020\u0073\u0070a\u0063e\u0073\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065d\u0020\u0061\u0073\u0020\u0049\u0043\u0043 \u0070\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u0073\u0074\u0072\u0065a\u006d\u0073 \u0061\u0073\u0020d\u0065\u0073\u0063\u0072\u0069\u0062\u0065\u0064\u0020\u0069\u006e\u0020\u0050\u0044\u0046\u0020R\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0034\u002e\u0035"));
_fcfe =true ;if _dfedb (){return true ;};};};if !_cfd {_ebfg ,_ :=_gd .GetStream (_bfdf .GetContainingPdfObject ());if _ebfg .Get ("\u004e")==nil ||(_bfdf .N ==1&&_beca .ColorSpace !=_aa .ColorSpaceGRAY )||(_bfdf .N ==3&&!(_beca .ColorSpace ==_aa .ColorSpaceRGB ||_beca .ColorSpace ==_aa .ColorSpaceLAB ))||(_bfdf .N ==4&&_beca .ColorSpace !=_aa .ColorSpaceCMYK ){_fgfe =append (_fgfe ,_ab ("\u0036.\u0032\u002e\u0033\u002d\u0035","\u0049\u0066\u0020a\u006e\u0020u\u006e\u0063\u0061\u006c\u0069\u0062\u0072a\u0074\u0065\u0064\u0020\u0063\u006fl\u006f\u0072 \u0073\u0070\u0061c\u0065\u0020\u0069\u0073\u0020\u0075\u0073\u0065\u0064\u0020\u0069\u006e\u0020\u0061\u0020\u0066\u0069\u006c\u0065 \u0074\u0068\u0065\u006e \u0074\u0068\u0061\u0074 \u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063o\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u0020\u0050\u0044\u0046\u002f\u0041-\u0031\u0020\u004f\u0075\u0074\u0070\u0075\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u002c\u0020\u0061\u0073\u0020\u0064\u0065\u0066\u0069\u006e\u0065d\u0020\u0069\u006e\u0020\u0036\u002e\u0032\u002e\u0032\u002e"));
_cfd =true ;if _dfedb (){return true ;};};};};if _bfdf .Alternate !=nil {return _accb (_bfdf .Alternate );};};return false ;};for _ ,_eeag :=range _dfbda .GetObjectNums (){_fdfe ,_cdcb :=_dfbda .GetIndirectObjectByNumber (_eeag );if _cdcb !=nil {continue ;
};_gdec ,_dfdge :=_gd .GetStream (_fdfe );if !_dfdge {continue ;};_baee ,_dfdge :=_gd .GetName (_gdec .Get ("\u0054\u0079\u0070\u0065"));if !_dfdge ||_baee .String ()!="\u0058O\u0062\u006a\u0065\u0063\u0074"{continue ;};_eeec ,_dfdge :=_gd .GetName (_gdec .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));
if !_dfdge {continue ;};_agd [_gdec ]=struct{}{};switch _eeec .String (){case "\u0049\u006d\u0061g\u0065":_acgff ,_bafbd :=_b .NewXObjectImageFromStream (_gdec );if _bafbd !=nil {continue ;};_agd [_gdec ]=struct{}{};if _accb (_acgff .ColorSpace ){return _fgfe ;
};case "\u0046\u006f\u0072\u006d":_abce ,_bgea :=_gd .GetDict (_gdec .Get ("\u0047\u0072\u006fu\u0070"));if !_bgea {continue ;};_bbd :=_abce .Get ("\u0043\u0053");if _bbd ==nil {continue ;};_fdfg ,_egbfb :=_b .NewPdfColorspaceFromPdfObject (_bbd );if _egbfb !=nil {continue ;
};if _accb (_fdfg ){return _fgfe ;};};};for _ ,_becc :=range _dfbda .PageList {_adaaf ,_ecde :=_becc .GetContentStreams ();if _ecde !=nil {continue ;};for _ ,_adfd :=range _adaaf {_dacc ,_aaag :=_dc .NewContentStreamParser (_adfd ).Parse ();if _aaag !=nil {continue ;
};for _ ,_ecee :=range *_dacc {if len (_ecee .Params )> 1{continue ;};switch _ecee .Operand {case "\u0042\u0049":_edaae ,_acdeg :=_ecee .Params [0].(*_dc .ContentStreamInlineImage );if !_acdeg {continue ;};_ccaa ,_gcdg :=_edaae .GetColorSpace (_becc .Resources );
if _gcdg !=nil {continue ;};if _accb (_ccaa ){return _fgfe ;};case "\u0044\u006f":_gcfc ,_dccf :=_gd .GetName (_ecee .Params [0]);if !_dccf {continue ;};_gdbd ,_bcaa :=_becc .Resources .GetXObjectByName (*_gcfc );if _ ,_edbe :=_agd [_gdbd ];_edbe {continue ;
};switch _bcaa {case _b .XObjectTypeImage :_gafgd ,_gafd :=_b .NewXObjectImageFromStream (_gdbd );if _gafd !=nil {continue ;};_agd [_gdbd ]=struct{}{};if _accb (_gafgd .ColorSpace ){return _fgfe ;};case _b .XObjectTypeForm :_bdga ,_fac :=_gd .GetDict (_gdbd .Get ("\u0047\u0072\u006fu\u0070"));
if !_fac {continue ;};_fgge ,_fac :=_gd .GetName (_bdga .Get ("\u0043\u0053"));if !_fac {continue ;};_eacc ,_aadfc :=_b .NewPdfColorspaceFromPdfObject (_fgge );if _aadfc !=nil {continue ;};_agd [_gdbd ]=struct{}{};if _accb (_eacc ){return _fgfe ;};};};
};};};if !_cgdec {return _fgfe ;};if (_acee .DeviceClass ==_aa .DeviceClassPRTR ||_acee .DeviceClass ==_aa .DeviceClassMNTR )&&(_acee .ColorSpace ==_aa .ColorSpaceRGB ||_acee .ColorSpace ==_aa .ColorSpaceCMYK ||_acee .ColorSpace ==_aa .ColorSpaceGRAY ){return _fgfe ;
};if !_gdfg {return _fgfe ;};_feba ,_bbgf :=_dbce (_dfbda );if !_bbgf {return _fgfe ;};_efbab ,_bbgf :=_gd .GetArray (_feba .Get ("\u004f\u0075\u0074\u0070\u0075\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0073"));if !_bbgf {_fgfe =append (_fgfe ,_ab ("\u0036.\u0032\u002e\u0032\u002d\u0031","\u0041\u0020\u0050\u0044\u0046\u002f\u0041\u002d\u0031\u0020\u004f\u0075\u0074p\u0075\u0074\u0049\u006e\u0074e\u006e\u0074\u0020\u0069\u0073\u0020a\u006e \u004f\u0075\u0074\u0070\u0075\u0074\u0049n\u0074\u0065\u006e\u0074\u0020\u0064i\u0063\u0074\u0069\u006fn\u0061\u0072\u0079\u002c\u0020\u0061\u0073\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0062y\u0020\u0050\u0044F\u0020\u0052\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065 \u0039\u002e\u0031\u0030.4\u002c\u0020\u0074\u0068\u0061\u0074\u0020\u0069\u0073 \u0069\u006e\u0063\u006c\u0075\u0064e\u0064\u0020i\u006e\u0020\u0074\u0068\u0065\u0020\u0066\u0069\u006c\u0065\u0027\u0073\u0020O\u0075\u0074p\u0075\u0074I\u006e\u0074\u0065\u006e\u0074\u0073\u0020\u0061\u0072\u0072\u0061\u0079\u0020a\u006e\u0064\u0020h\u0061\u0073\u0020\u0047\u0054\u0053\u005f\u0050\u0044\u0046\u0041\u0031\u0020\u0061\u0073 \u0074\u0068\u0065\u0020\u0076a\u006c\u0075e\u0020\u006f\u0066\u0020i\u0074\u0073 \u0053\u0020\u006b\u0065\u0079\u0020\u0061\u006e\u0064\u0020\u0061\u0020\u0076\u0061\u006c\u0069\u0064\u0020I\u0043\u0043\u0020\u0070\u0072\u006f\u0066\u0069\u006ce\u0020s\u0074\u0072\u0065\u0061\u006d \u0061\u0073\u0020\u0074h\u0065\u0020\u0076a\u006c\u0075\u0065\u0020\u0069\u0074\u0073\u0020\u0044\u0065\u0073t\u004f\u0075t\u0070\u0075\u0074P\u0072\u006f\u0066\u0069\u006c\u0065 \u006b\u0065\u0079\u002e"),_ab ("\u0036.\u0032\u002e\u0032\u002d\u0032","\u0049\u0066\u0020\u0061\u0020\u0066\u0069\u006c\u0065's\u0020O\u0075\u0074\u0070u\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0073 \u0061\u0072\u0072a\u0079\u0020\u0063\u006f\u006e\u0074\u0061\u0069n\u0073\u0020\u006d\u006f\u0072\u0065\u0020\u0074\u0068a\u006e\u0020\u006f\u006ee\u0020\u0065\u006e\u0074\u0072\u0079\u002c\u0020\u0074\u0068\u0065\u006e\u0020\u0061\u006c\u006c\u0020\u0065n\u0074\u0072\u0069\u0065\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e a \u0044\u0065\u0073\u0074\u004f\u0075\u0074\u0070\u0075\u0074\u0050\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u006b\u0065y\u0020\u0073\u0068\u0061\u006cl\u0020\u0068\u0061\u0076\u0065 \u0061\u0073\u0020\u0074\u0068\u0065 \u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068a\u0074\u0020\u006b\u0065\u0079 \u0074\u0068\u0065\u0020\u0073\u0061\u006d\u0065\u0020\u0069\u006e\u0064\u0069\u0072\u0065c\u0074\u0020\u006fb\u006ae\u0063t\u002c\u0020\u0077h\u0069\u0063\u0068\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065\u0020\u0061\u0020\u0076\u0061\u006c\u0069d\u0020\u0049\u0043\u0043\u0020\u0070\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u0073\u0074r\u0065\u0061m\u002e"));
return _fgfe ;};if _efbab .Len ()> 1{_gbcd :=map[*_gd .PdfObjectDictionary ]struct{}{};for _gdge :=0;_gdge < _efbab .Len ();_gdge ++{_afec ,_ddfg :=_gd .GetDict (_efbab .Get (_gdge ));if !_ddfg {continue ;};if _gdge ==0{_gbcd [_afec ]=struct{}{};continue ;
};if _ ,_gcfe :=_gbcd [_afec ];!_gcfe {_fgfe =append (_fgfe ,_ab ("\u0036.\u0032\u002e\u0032\u002d\u0032","\u0049\u0066\u0020\u0061\u0020\u0066\u0069\u006c\u0065's\u0020O\u0075\u0074\u0070u\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0073 \u0061\u0072\u0072a\u0079\u0020\u0063\u006f\u006e\u0074\u0061\u0069n\u0073\u0020\u006d\u006f\u0072\u0065\u0020\u0074\u0068a\u006e\u0020\u006f\u006ee\u0020\u0065\u006e\u0074\u0072\u0079\u002c\u0020\u0074\u0068\u0065\u006e\u0020\u0061\u006c\u006c\u0020\u0065n\u0074\u0072\u0069\u0065\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e a \u0044\u0065\u0073\u0074\u004f\u0075\u0074\u0070\u0075\u0074\u0050\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u006b\u0065y\u0020\u0073\u0068\u0061\u006cl\u0020\u0068\u0061\u0076\u0065 \u0061\u0073\u0020\u0074\u0068\u0065 \u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068a\u0074\u0020\u006b\u0065\u0079 \u0074\u0068\u0065\u0020\u0073\u0061\u006d\u0065\u0020\u0069\u006e\u0064\u0069\u0072\u0065c\u0074\u0020\u006fb\u006ae\u0063t\u002c\u0020\u0077h\u0069\u0063\u0068\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065\u0020\u0061\u0020\u0076\u0061\u006c\u0069d\u0020\u0049\u0043\u0043\u0020\u0070\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u0073\u0074r\u0065\u0061m\u002e"));
break ;};};};return _fgfe ;};func _efgfc (_dcfbf *_b .PdfFont ,_bbce *_gd .PdfObjectDictionary )ViolatedRule {const (_bbcbc ="\u0036.\u0033\u002e\u0037\u002d\u0033";_fadd ="\u0046\u006f\u006e\u0074\u0020\u0070\u0072\u006f\u0067\u0072\u0061\u006d\u0073\u0027\u0020\u0022\u0063\u006d\u0061\u0070\u0022\u0020\u0074\u0061\u0062\u006c\u0065\u0073\u0020\u0066\u006f\u0072\u0020\u0061\u006c\u006c\u0020\u0073\u0079\u006d\u0062o\u006c\u0069c\u0020\u0054\u0072\u0075e\u0054\u0079\u0070\u0065\u0020\u0066\u006f\u006e\u0074\u0073 \u0073\u0068\u0061\u006c\u006c\u0020\u0063\u006f\u006et\u0061\u0069\u006e\u0020\u0065\u0078\u0061\u0063\u0074\u006cy\u0020\u006f\u006ee\u0020\u0065\u006e\u0063\u006f\u0064\u0069n\u0067\u002e";
);var _gffec string ;if _begac ,_cecb :=_gd .GetName (_bbce .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_cecb {_gffec =_begac .String ();};if _gffec !="\u0054\u0072\u0075\u0065\u0054\u0079\u0070\u0065"{return _fc ;};_ebba :=_dcfbf .FontDescriptor ();
_fffd ,_abafd :=_gd .GetIntVal (_ebba .Flags );if !_abafd {_ae .Log .Debug ("\u0066\u006c\u0061\u0067\u0073 \u006e\u006f\u0074\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0066o\u0072\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0020\u0064\u0065\u0073\u0063\u0072\u0069\u0070\u0074\u006f\u0072");
return _ab (_bbcbc ,_fadd );};_fddaf :=(uint32 (_fffd )>>3)!=0;if !_fddaf {return _fc ;};return _fc ;};type documentColorspaceOptimizeFunc func (_gae *_da .Document ,_dcee []*_da .Image )error ;

// Part gets the PDF/A version level.
func (_eed *profile2 )Part ()int {return _eed ._efbd ._gb };func _ggbg (_bfade *_b .CompliancePdfReader )ViolatedRule {for _ ,_ecfca :=range _bfade .PageList {_fbab ,_adga :=_ecfca .GetContentStreams ();if _adga !=nil {continue ;};for _ ,_febe :=range _fbab {_ggaa :=_dc .NewContentStreamParser (_febe );
_ ,_adga =_ggaa .Parse ();if _adga !=nil {return _ab ("\u0036.\u0032\u002e\u0032\u002d\u0031","\u0041\u0020\u0063onten\u0074\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u0073\u0068\u0061\u006c\u006c n\u006f\u0074\u0020c\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u006e\u0079 \u006f\u0070\u0065\u0072\u0061\u0074\u006f\u0072\u0073\u0020\u006e\u006ft\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0069\u006e\u0020\u0050\u0044\u0046\u0020\u0052\u0065f\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0065\u0076\u0065\u006e\u0020\u0069\u0066\u0020s\u0075\u0063\u0068\u0020\u006f\u0070\u0065r\u0061\u0074\u006f\u0072\u0073\u0020\u0061\u0072\u0065\u0020\u0062\u0072\u0061\u0063\u006b\u0065\u0074\u0065\u0064\u0020\u0062\u0079\u0020\u0074\u0068\u0065\u0020\u0042\u0058\u002f\u0045\u0058\u0020\u0063\u006f\u006d\u0070\u0061\u0074\u0069\u0062i\u006c\u0069\u0074\u0079\u0020\u006f\u0070\u0065\u0072\u0061\u0074\u006f\u0072\u0073\u002e");
};};};return _fc ;};func _ageeb (_gdgbef *_b .CompliancePdfReader )ViolatedRule {return _fc };func _efcc (_caf *_b .PdfInfo ,_ada func ()_f .Time )error {var _gba *_b .PdfDate ;if _caf .CreationDate ==nil {_beff ,_bdfb :=_b .NewPdfDateFromTime (_ada ());
if _bdfb !=nil {return _bdfb ;};_gba =&_beff ;_caf .CreationDate =_gba ;};if _caf .ModifiedDate ==nil {if _gba !=nil {_bfef ,_acgg :=_b .NewPdfDateFromTime (_ada ());if _acgg !=nil {return _acgg ;};_gba =&_bfef ;};_caf .ModifiedDate =_gba ;};return nil ;
};func _gca (_eaf *_da .Document )error {for _ ,_gdb :=range _eaf .Objects {_edc ,_ede :=_gd .GetDict (_gdb );if !_ede {continue ;};_bgd :=_edc .Get ("\u0054\u0079\u0070\u0065");if _bgd ==nil {continue ;};if _gcd ,_dege :=_gd .GetName (_bgd );_dege &&_gcd .String ()!="\u0041\u0063\u0072\u006f\u0046\u006f\u0072\u006d"{continue ;
};_dgeb ,_ebe :=_gd .GetBool (_edc .Get ("\u004ee\u0065d\u0041\u0070\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0073"));if _ebe {if bool (*_dgeb ){_edc .Set ("\u004ee\u0065d\u0041\u0070\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0073",_gd .MakeBool (false ));
};};_bbe :=_edc .Get ("\u0041");if _bbe !=nil {_edc .Remove ("\u0041");};_ggd ,_ebe :=_gd .GetArray (_edc .Get ("\u0046\u0069\u0065\u006c\u0064\u0073"));if _ebe {for _dgcf :=0;_dgcf < _ggd .Len ();_dgcf ++{_eag ,_ddd :=_gd .GetDict (_ggd .Get (_dgcf ));
if !_ddd {continue ;};if _eag .Get ("\u0041\u0041")!=nil {_eag .Remove ("\u0041\u0041");};};};};return nil ;};func _aaaf (_daaec *_gd .PdfObjectDictionary ,_efgfd map[*_gd .PdfObjectStream ][]byte ,_dceb map[*_gd .PdfObjectStream ]*_ecd .CMap )ViolatedRule {const (_ffbe ="\u0036.\u0033\u002e\u0033\u002d\u0033";
_dfbcaa ="\u0041\u006cl \u0043\u004d\u0061\u0070\u0073\u0020\u0075\u0073e\u0064 \u0077i\u0074\u0068\u0069\u006e\u0020\u0061\u0020\u0063\u006f\u006e\u0066\u006f\u0072m\u0069n\u0067\u0020\u0066\u0069\u006c\u0065\u002c\u0020\u0065\u0078\u0063\u0065\u0070\u0074\u0020\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0048\u0020a\u006e\u0064\u0020\u0049\u0064\u0065\u006et\u0069\u0074\u0079-\u0056\u002c\u0020\u0073\u0068a\u006c\u006c \u0062\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065\u0064\u0020\u0069\u006e\u0020\u0074h\u0061\u0074\u0020\u0066\u0069\u006c\u0065\u0020\u0061\u0073\u0020\u0064es\u0063\u0072\u0069\u0062\u0065\u0064\u0020\u0069\u006e\u0020\u0050\u0044F\u0020\u0052\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u00205\u002e\u0036\u002e\u0034\u002e";
);var _cceb string ;if _abebb ,_affb :=_gd .GetName (_daaec .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_affb {_cceb =_abebb .String ();};if _cceb !="\u0054\u0079\u0070e\u0030"{return _fc ;};_cggb :=_daaec .Get ("\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067");
if _aebgf ,_gfd :=_gd .GetName (_cggb );_gfd {switch _aebgf .String (){case "\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0048","\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0056":return _fc ;default:return _ab (_ffbe ,_dfbcaa );};
};_fbce ,_bbgd :=_gd .GetStream (_cggb );if !_bbgd {return _ab (_ffbe ,_dfbcaa );};_ ,_bbcc :=_eaccc (_fbce ,_efgfd ,_dceb );if _bbcc !=nil {return _ab (_ffbe ,_dfbcaa );};return _fc ;};func _cdddb (_fdeb *_b .CompliancePdfReader )(_ffcdf []ViolatedRule ){_aefb ,_aeff :=_dbce (_fdeb );
if !_aeff {return _ffcdf ;};_feefd ,_aeff :=_gd .GetDict (_aefb .Get ("\u004e\u0061\u006de\u0073"));if !_aeff {return _ffcdf ;};if _feefd .Get ("\u0041\u006c\u0074\u0065rn\u0061\u0074\u0065\u0050\u0072\u0065\u0073\u0065\u006e\u0074\u0061\u0074\u0069\u006fn\u0073")!=nil {_ffcdf =append (_ffcdf ,_ab ("\u0036\u002e\u0031\u0030\u002d\u0031","T\u0068\u0065\u0072e\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u006e\u006f\u0020\u0041\u006c\u0074\u0065\u0072\u006e\u0061\u0074\u0065\u0050\u0072\u0065s\u0065\u006e\u0074a\u0074\u0069\u006f\u006e\u0073\u0020\u0065\u006e\u0074\u0072\u0079\u0020\u0069n\u0020\u0074\u0068\u0065 \u0064\u006f\u0063\u0075m\u0065\u006e\u0074\u0027\u0073\u0020\u006e\u0061\u006d\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006fn\u0061\u0072\u0079\u002e"));
};return _ffcdf ;};func _badf (_acfe *_b .CompliancePdfReader )(_ebef []ViolatedRule ){var _becd ,_dgda ,_cbfb ,_afecb ,_cgda ,_eecb bool ;_fbggb :=map[*_gd .PdfObjectStream ]struct{}{};for _ ,_deaec :=range _acfe .GetObjectNums (){if _becd &&_dgda &&_cgda &&_cbfb &&_afecb &&_eecb {return _ebef ;
};_fgdd ,_gecg :=_acfe .GetIndirectObjectByNumber (_deaec );if _gecg !=nil {continue ;};_dabf ,_cbbc :=_gd .GetStream (_fgdd );if !_cbbc {continue ;};if _ ,_cbbc =_fbggb [_dabf ];_cbbc {continue ;};_fbggb [_dabf ]=struct{}{};_beag ,_cbbc :=_gd .GetName (_dabf .Get ("\u0053u\u0062\u0054\u0079\u0070\u0065"));
if !_cbbc {continue ;};if !_afecb {if _dabf .Get ("\u0052\u0065\u0066")!=nil {_ebef =append (_ebef ,_ab ("\u0036.\u0032\u002e\u0036\u002d\u0031","\u0041\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068a\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u006e\u0079\u0020\u0072\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0058O\u0062\u006a\u0065\u0063\u0074s\u002e"));
_afecb =true ;};};if _beag .String ()=="\u0050\u0053"{if !_eecb {_ebef =append (_ebef ,_ab ("\u0036.\u0032\u002e\u0037\u002d\u0031","A \u0063\u006fn\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066i\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u006e\u0079\u0020\u0050\u006f\u0073t\u0053c\u0072\u0069\u0070\u0074\u0020\u0058\u004f\u0062j\u0065c\u0074\u0073."));
_eecb =true ;continue ;};};if _beag .String ()=="\u0046\u006f\u0072\u006d"{if _dgda &&_cbfb &&_afecb {continue ;};if !_dgda &&_dabf .Get ("\u004f\u0050\u0049")!=nil {_ebef =append (_ebef ,_ab ("\u0036.\u0032\u002e\u0034\u002d\u0032","\u0041\u006e\u0020\u0058\u004f\u0062\u006a\u0065\u0063\u0074\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072y\u0020\u0028\u0049\u006d\u0061\u0067\u0065\u0020\u006f\u0072\u0020\u0046\u006f\u0072\u006d\u0029\u0020\u0073\u0068\u0061\u006cl\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074h\u0065\u0020\u004fP\u0049\u0020\u006b\u0065\u0079\u002e"));
_dgda =true ;};if !_cbfb {if _dabf .Get ("\u0050\u0053")!=nil {_cbfb =true ;};if _gccf :=_dabf .Get ("\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0032");_gccf !=nil &&!_cbfb {if _egdf ,_gdgbd :=_gd .GetName (_gccf );_gdgbd &&*_egdf =="\u0050\u0053"{_cbfb =true ;
};};if _cbfb {_ebef =append (_ebef ,_ab ("\u0036.\u0032\u002e\u0035\u002d\u0031","A\u0020\u0066\u006fr\u006d\u0020\u0058\u004f\u0062\u006a\u0065\u0063\u0074\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006ft\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e \u0074\u0068\u0065\u0020\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0032\u0020\u006b\u0065\u0079 \u0077\u0069\u0074\u0068\u0020a\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0050\u0053\u0020o\u0072\u0020\u0074\u0068e\u0020\u0050\u0053\u0020\u006b\u0065\u0079\u002e"));
};};continue ;};if _beag .String ()!="\u0049\u006d\u0061g\u0065"{continue ;};if !_becd &&_dabf .Get ("\u0041\u006c\u0074\u0065\u0072\u006e\u0061\u0074\u0065\u0073")!=nil {_ebef =append (_ebef ,_ab ("\u0036.\u0032\u002e\u0034\u002d\u0031","\u0041\u006e\u0020\u0049m\u0061\u0067\u0065\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006et\u0061\u0069\u006e\u0020\u0074h\u0065\u0020\u0041\u006c\u0074\u0065\u0072\u006e\u0061\u0074\u0065\u0073\u0020\u006b\u0065\u0079\u002e"));
_becd =true ;};if !_cgda &&_dabf .Get ("I\u006e\u0074\u0065\u0072\u0070\u006f\u006c\u0061\u0074\u0065")!=nil {_dbbd ,_afeg :=_gd .GetBool (_dabf .Get ("I\u006e\u0074\u0065\u0072\u0070\u006f\u006c\u0061\u0074\u0065"));if _afeg &&bool (*_dbbd ){continue ;
};_ebef =append (_ebef ,_ab ("\u0036.\u0032\u002e\u0034\u002d\u0033","\u0049\u0066 a\u006e\u0020\u0049\u006d\u0061\u0067\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0063o\u006e\u0074\u0061\u0069n\u0073\u0020\u0074\u0068e \u0049\u006et\u0065r\u0070\u006f\u006c\u0061\u0074\u0065 \u006b\u0065\u0079,\u0020\u0069t\u0073\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020b\u0065\u0020\u0066\u0061\u006c\u0073\u0065\u002e"));
_cgda =true ;};};return _ebef ;};func _beef (_dcfb *_da .Document ){if _dcfb .ID [0]!=""&&_dcfb .ID [1]!=""{return ;};_dcfb .UseHashBasedID =true ;};func _gbdd (_agca *_b .CompliancePdfReader )(_efgbe ViolatedRule ){_ffbd ,_cebe :=_dbce (_agca );if !_cebe {return _fc ;
};if _ffbd .Get ("\u0052\u0065\u0071u\u0069\u0072\u0065\u006d\u0065\u006e\u0074\u0073")!=nil {return _ab ("\u0036\u002e\u0031\u0031\u002d\u0031","Th\u0065\u0020d\u006f\u0063\u0075\u006d\u0065\u006e\u0074\u0020\u0063a\u0074\u0061\u006c\u006f\u0067\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074\u0068\u0065\u0020R\u0065q\u0075\u0069\u0072\u0065\u006d\u0065\u006e\u0074s\u0020k\u0065\u0079.");
};return _fc ;};

// Profile1Options are the options that changes the way how optimizer may try to adapt document into PDF/A standard.
type Profile1Options struct{

// CMYKDefaultColorSpace is an option that refers PDF/A-1
CMYKDefaultColorSpace bool ;

// Now is a function that returns current time.
Now func ()_f .Time ;

// Xmp is the xmp options information.
Xmp XmpOptions ;};

// ViolatedRule is the structure that defines violated PDF/A rule.
type ViolatedRule struct{RuleNo string ;Detail string ;};func _gaddeg (_gcbe *_b .CompliancePdfReader )(_gabab []ViolatedRule ){_ffef :=func (_ffeg *_gd .PdfObjectDictionary ,_bbdca *[]string ,_dddgg *[]ViolatedRule )error {_gefa :=_ffeg .Get ("\u004e\u0061\u006d\u0065");
if _gefa ==nil ||len (_gefa .String ())==0{*_dddgg =append (*_dddgg ,_ab ("\u0036\u002e\u0039-\u0031","\u0045\u0061\u0063\u0068\u0020o\u0070\u0074\u0069\u006f\u006e\u0061l\u0020\u0063\u006f\u006e\u0074\u0065\u006et\u0020\u0063\u006fn\u0066\u0069\u0067\u0075r\u0061\u0074\u0069\u006f\u006e\u0020d\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063o\u006e\u0074\u0061\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u004e\u0061\u006d\u0065\u0020\u006b\u0065\u0079\u002e"));
};for _ ,_dcffc :=range *_bbdca {if _dcffc ==_gefa .String (){*_dddgg =append (*_dddgg ,_ab ("\u0036\u002e\u0039-\u0032","\u0045\u0061\u0063\u0068\u0020\u006f\u0070\u0074\u0069\u006f\u006e\u0061l\u0020\u0063\u006f\u006e\u0074\u0065\u006e\u0074\u0020\u0063\u006f\u006e\u0066\u0069\u0067\u0075\u0072a\u0074\u0069\u006fn\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068a\u006c\u006c\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074\u0068\u0065\u0020N\u0061\u006d\u0065\u0020\u006b\u0065\u0079\u002c w\u0068\u006fs\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020s\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0075ni\u0071\u0075\u0065 \u0061\u006d\u006f\u006e\u0067\u0073\u0074\u0020\u0061\u006c\u006c\u0020o\u0070\u0074\u0069\u006f\u006e\u0061\u006c\u0020\u0063\u006fn\u0074\u0065\u006e\u0074 \u0063\u006f\u006e\u0066\u0069\u0067u\u0072\u0061\u0074\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074i\u006fn\u0061\u0072\u0069\u0065\u0073\u0020\u0077\u0069\u0074\u0068\u0069\u006e\u0020\u0074\u0068e\u0020\u0050\u0044\u0046\u002fA\u002d\u0032\u0020\u0066\u0069l\u0065\u002e"));
}else {*_bbdca =append (*_bbdca ,_gefa .String ());};};if _ffeg .Get ("\u0041\u0053")!=nil {*_dddgg =append (*_dddgg ,_ab ("\u0036\u002e\u0039-\u0034","Th\u0065\u0020\u0041\u0053\u0020\u006b\u0065y \u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0061\u0070\u0070\u0065\u0061r\u0020\u0069\u006e\u0020\u0061\u006e\u0079\u0020\u006f\u0070\u0074\u0069\u006f\u006e\u0061\u006c\u0020\u0063\u006f\u006et\u0065\u006e\u0074\u0020\u0063\u006fn\u0066\u0069\u0067\u0075\u0072\u0061\u0074\u0069\u006fn\u0020d\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002e"));
};return nil ;};_ggda ,_bbfe :=_dbce (_gcbe );if !_bbfe {return _gabab ;};_acbaf ,_bbfe :=_gd .GetDict (_ggda .Get ("\u004f\u0043\u0050r\u006f\u0070\u0065\u0072\u0074\u0069\u0065\u0073"));if !_bbfe {return _gabab ;};var _eeaeg []string ;_gcegca ,_bbfe :=_gd .GetDict (_acbaf .Get ("\u0044"));
if _bbfe {_ffef (_gcegca ,&_eeaeg ,&_gabab );};_fffg ,_bbfe :=_gd .GetArray (_acbaf .Get ("\u0043o\u006e\u0066\u0069\u0067\u0073"));if _bbfe {for _gaafg :=0;_gaafg < _fffg .Len ();_gaafg ++{_cacce ,_baeee :=_gd .GetDict (_fffg .Get (_gaafg ));if !_baeee {continue ;
};_ffef (_cacce ,&_eeaeg ,&_gabab );};};return _gabab ;};func _aaff (_geed *_da .Document )error {_cegc ,_gdgf :=_geed .FindCatalog ();if !_gdgf {return _age .New ("\u0063\u0061\u0074\u0061\u006c\u006f\u0067\u0020\u006e\u006f\u0074\u0020f\u006f\u0075\u006e\u0064");
};_gcad ,_gdgf :=_gd .GetDict (_cegc .Object .Get ("\u004f\u0043\u0050r\u006f\u0070\u0065\u0072\u0074\u0069\u0065\u0073"));if !_gdgf {return nil ;};_bagb ,_gdgf :=_gd .GetDict (_gcad .Get ("\u0044"));if _gdgf {if _bagb .Get ("\u0041\u0053")!=nil {_bagb .Remove ("\u0041\u0053");
};};_cgac ,_gdgf :=_gd .GetArray (_gcad .Get ("\u0043o\u006e\u0066\u0069\u0067\u0073"));if _gdgf {for _abff :=0;_abff < _cgac .Len ();_abff ++{_efba ,_cbcf :=_gd .GetDict (_cgac .Get (_abff ));if !_cbcf {continue ;};if _efba .Get ("\u0041\u0053")!=nil {_efba .Remove ("\u0041\u0053");
};};};return nil ;};func _fccbc (_gdca *_b .CompliancePdfReader )ViolatedRule {_gegf :=_gdca .ParserMetadata ().HeaderCommentBytes ();if _gegf [0]> 127&&_gegf [1]> 127&&_gegf [2]> 127&&_gegf [3]> 127{return _fc ;};return _ab ("\u0036.\u0031\u002e\u0032\u002d\u0032","\u0054\u0068\u0065\u0020\u0066\u0069\u006c\u0065\u0020\u0068\u0065\u0061\u0064\u0065\u0072\u0020\u006c\u0069\u006e\u0065\u0020\u0073\u0068\u0061\u006c\u006c b\u0065\u0020i\u006d\u006d\u0065\u0064\u0069a\u0074\u0065\u006c\u0079 \u0066\u006f\u006c\u006co\u0077\u0065\u0064\u0020\u0062\u0079\u0020\u0061\u0020\u0063\u006f\u006d\u006d\u0065n\u0074\u0020\u0063\u006f\u006e\u0073\u0069s\u0074\u0069\u006e\u0067\u0020o\u0066\u0020\u0061\u0020\u0025\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u0066\u006f\u006c\u006c\u006fwe\u0064\u0020\u0062y\u0020a\u0074\u0009\u006c\u0065a\u0073\u0074\u0020f\u006f\u0075\u0072\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065r\u0073\u002c\u0020e\u0061\u0063\u0068\u0020\u006f\u0066\u0020\u0077\u0068\u006f\u0073\u0065 \u0065\u006e\u0063\u006f\u0064e\u0064\u0020\u0062\u0079\u0074e\u0020\u0076\u0061\u006c\u0075\u0065s\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0068\u0061\u0076\u0065\u0020\u0061\u0020\u0064e\u0063\u0069\u006d\u0061\u006c \u0076\u0061\u006c\u0075\u0065\u0020\u0067\u0072\u0065\u0061\u0074\u0065\u0072\u0020\u0074\u0068\u0061\u006e\u0020\u0031\u0032\u0037\u002e");
};func _fccfe (_fcgd *_b .CompliancePdfReader )(_ddcc ViolatedRule ){_gdba ,_cdeea :=_dbce (_fcgd );if !_cdeea {return _fc ;};_eceff ,_cdeea :=_gd .GetDict (_gdba .Get ("\u0041\u0063\u0072\u006f\u0046\u006f\u0072\u006d"));if !_cdeea {return _fc ;};_fcda ,_cdeea :=_gd .GetArray (_eceff .Get ("\u0046\u0069\u0065\u006c\u0064\u0073"));
if !_cdeea {return _fc ;};for _bgfe :=0;_bgfe < _fcda .Len ();_bgfe ++{_dbgf ,_ffgde :=_gd .GetDict (_fcda .Get (_bgfe ));if !_ffgde {continue ;};if _dbgf .Get ("\u0041")!=nil {return _ab ("\u0036.\u0034\u002e\u0031\u002d\u0032","\u0041\u0020\u0046\u0069\u0065\u006c\u0064\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006ea\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020c\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0041 o\u0072\u0020\u0041\u0041\u0020\u006b\u0065\u0079\u0073\u002e");
};if _dbgf .Get ("\u0041\u0041")!=nil {return _ab ("\u0036.\u0034\u002e\u0031\u002d\u0032","\u0041\u0020\u0046\u0069\u0065\u006c\u0064\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006ea\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020c\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0041 o\u0072\u0020\u0041\u0041\u0020\u006b\u0065\u0079\u0073\u002e");
};};return _fc ;};func _dgedb (_fgga *_b .PdfFont ,_affba *_gd .PdfObjectDictionary )ViolatedRule {const (_eabc ="\u0036\u002e\u0032\u002e\u0031\u0031\u002e\u0036\u002d\u0033";_baefa ="\u0041l\u006c\u0020\u0073\u0079\u006d\u0062\u006f\u006c\u0069\u0063\u0020\u0054\u0072u\u0065\u0054\u0079p\u0065\u0020\u0066\u006f\u006e\u0074s\u0020\u0073h\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0073\u0070\u0065\u0063\u0069\u0066\u0079\u0020\u0061\u006e\u0020\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067\u0020\u0065n\u0074\u0072\u0079\u0020\u0069n\u0020\u0074\u0068e\u0020\u0066\u006f\u006e\u0074 \u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002e";
);var _afaa string ;if _cgcb ,_bbef :=_gd .GetName (_affba .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_bbef {_afaa =_cgcb .String ();};if _afaa !="\u0054\u0072\u0075\u0065\u0054\u0079\u0070\u0065"{return _fc ;};_bebd :=_fgga .FontDescriptor ();_agea ,_eaad :=_gd .GetIntVal (_bebd .Flags );
if !_eaad {_ae .Log .Debug ("\u0066\u006c\u0061\u0067\u0073 \u006e\u006f\u0074\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0066o\u0072\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0020\u0064\u0065\u0073\u0063\u0072\u0069\u0070\u0074\u006f\u0072");
return _ab (_eabc ,_baefa );};_edga :=(uint32 (_agea )>>3)&1;_ebca :=_edga !=0;if !_ebca {return _fc ;};if _affba .Get ("\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067")!=nil {return _ab (_eabc ,_baefa );};return _fc ;};func _aede (_aceb *_b .PdfFont ,_bgdb *_gd .PdfObjectDictionary )ViolatedRule {const (_aadac ="\u0036.\u0033\u002e\u0035\u002d\u0033";
_gcee ="\u0046\u006f\u0072\u0020\u0061\u006c\u006c\u0020\u0043\u0049\u0044\u0046\u006f\u006e\u0074\u0020\u0073\u0075\u0062\u0073\u0065\u0074\u0073 \u0072e\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0064\u0020\u0077i\u0074\u0068\u0069n\u0020\u0061\u0020c\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069l\u0065\u002c\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006et\u0020\u0064\u0065s\u0063\u0072\u0069\u0070\u0074\u006f\u0072\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061r\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0069\u006e\u0063\u006c\u0075\u0064\u0065\u0020\u0061\u0020\u0043\u0049\u0044\u0053\u0065\u0074\u0020s\u0074\u0072\u0065\u0061\u006d\u0020\u0069\u0064\u0065\u006e\u0074\u0069\u0066\u0079\u0069\u006eg\u0020\u0077\u0068i\u0063\u0068\u0020\u0043\u0049\u0044\u0073 \u0061\u0072e\u0020\u0070\u0072\u0065\u0073\u0065\u006e\u0074\u0020\u0069\u006e \u0074\u0068\u0065\u0020\u0065\u006d\u0062\u0065\u0064d\u0065\u0064\u0020\u0043\u0049D\u0046\u006f\u006e\u0074\u0020\u0066\u0069l\u0065,\u0020\u0061\u0073 \u0064\u0065\u0073\u0063\u0072\u0069b\u0065\u0064 \u0069\u006e\u0020\u0050\u0044\u0046\u0020\u0052\u0065\u0066\u0065\u0072\u0065\u006e\u0063e\u0020\u0054ab\u006c\u0065\u0020\u0035.\u00320\u002e";
);var _dagca string ;if _agcg ,_ffbb :=_gd .GetName (_bgdb .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_ffbb {_dagca =_agcg .String ();};switch _dagca {case "\u0043\u0049\u0044F\u006f\u006e\u0074\u0054\u0079\u0070\u0065\u0030","\u0043\u0049\u0044F\u006f\u006e\u0074\u0054\u0079\u0070\u0065\u0032":_fcgfd :=_aceb .FontDescriptor ();
if _fcgfd .CIDSet ==nil {return _ab (_aadac ,_gcee );};return _fc ;default:return _fc ;};};func _bgg (_bfdae *_gd .PdfObjectDictionary ,_cacgg map[*_gd .PdfObjectStream ][]byte ,_adad map[*_gd .PdfObjectStream ]*_ecd .CMap )ViolatedRule {const (_bffc ="\u0046\u006f\u0072 \u0061\u006e\u0079\u0020\u0067\u0069\u0076\u0065\u006e\u0020\u0063\u006f\u006d\u0070\u006f\u0073\u0069\u0074\u0065\u0020\u0028\u0054\u0079\u0070\u0065\u0020\u0030\u0029\u0020\u0066\u006f\u006et \u0072\u0065\u0066\u0065\u0072\u0065\u006ec\u0065\u0064 \u0077\u0069\u0074\u0068\u0069\u006e\u0020\u0061\u0020\u0063\u006fn\u0066\u006fr\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u002c\u0020\u0074\u0068\u0065\u0020\u0043I\u0044\u0053y\u0073\u0074\u0065\u006d\u0049nf\u006f\u0020\u0065\u006e\u0074\u0072\u0069\u0065\u0073\u0020\u006f\u0066\u0020i\u0074\u0073\u0020\u0043\u0049\u0044\u0046\u006f\u006e\u0074\u0020\u0061\u006e\u0064 \u0043\u004d\u0061\u0070 \u0064\u0069\u0063\u0074i\u006f\u006e\u0061\u0072\u0069\u0065\u0073\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0063\u006f\u006d\u0070\u0061\u0074i\u0062\u006c\u0065\u002e\u0020\u0049\u006e\u0020o\u0074\u0068\u0065\u0072\u0020\u0077\u006f\u0072\u0064\u0073\u002c\u0020\u0074\u0068\u0065\u0020R\u0065\u0067\u0069\u0073\u0074\u0072\u0079\u0020a\u006e\u0064\u0020\u004fr\u0064\u0065\u0072\u0069\u006e\u0067 \u0073\u0074\u0072i\u006e\u0067\u0073\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0043\u0049\u0044\u0053\u0079\u0073\u0074\u0065\u006d\u0049\u006e\u0066\u006f\u0020\u0064\u0069\u0063\u0074i\u006f\u006e\u0061\u0072\u0069\u0065\u0073\u0020\u0066\u006f\u0072 \u0074\u0068\u0061\u0074\u0020\u0066o\u006e\u0074\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0069\u0064\u0065\u006e\u0074\u0069\u0063\u0061\u006c\u002c\u0020u\u006el\u0065ss \u0074\u0068\u0065\u0020\u0076a\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0045\u006e\u0063\u006f\u0064\u0069\u006eg\u0020\u006b\u0065\u0079\u0020\u0069\u006e\u0020\u0074h\u0065 \u0066\u006f\u006e\u0074\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0069\u0073 \u0049\u0064\u0065\u006e\u0074\u0069t\u0079\u002d\u0048\u0020o\u0072\u0020\u0049\u0064\u0065\u006e\u0074\u0069\u0074y\u002dV\u002e";
_gaaa ="\u0036.\u0033\u002e\u0033\u002d\u0031";);var _ceaa string ;if _cfge ,_abdf :=_gd .GetName (_bfdae .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_abdf {_ceaa =_cfge .String ();};if _ceaa !="\u0054\u0079\u0070e\u0030"{return _fc ;};_aadfb :=_bfdae .Get ("\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067");
if _adbd ,_cfgea :=_gd .GetName (_aadfb );_cfgea {switch _adbd .String (){case "\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0048","\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0056":return _fc ;};_fbcg ,_cfae :=_ecd .LoadPredefinedCMap (_adbd .String ());
if _cfae !=nil {return _ab (_gaaa ,_bffc );};_dddf :=_fbcg .CIDSystemInfo ();if _dddf .Ordering !=_dddf .Registry {return _ab (_gaaa ,_bffc );};return _fc ;};_egce ,_gdgbe :=_gd .GetStream (_aadfb );if !_gdgbe {return _ab (_gaaa ,_bffc );};_bgdc ,_edbd :=_eaccc (_egce ,_cacgg ,_adad );
if _edbd !=nil {return _ab (_gaaa ,_bffc );};_gegd :=_bgdc .CIDSystemInfo ();if _gegd .Ordering !=_gegd .Registry {return _ab (_gaaa ,_bffc );};return _fc ;};func _efgb (_ecdff *_da .Document ,_ebf int )error {for _ ,_fdgb :=range _ecdff .Objects {_deadg ,_ecb :=_gd .GetDict (_fdgb );
if !_ecb {continue ;};_edcf :=_deadg .Get ("\u0054\u0079\u0070\u0065");if _edcf ==nil {continue ;};if _aab ,_bbc :=_gd .GetName (_edcf );_bbc &&_aab .String ()!="\u0041\u0063\u0074\u0069\u006f\u006e"{continue ;};_gfbd ,_bea :=_gd .GetName (_deadg .Get ("\u0053"));
if !_bea {continue ;};switch _b .PdfActionType (*_gfbd ){case _b .ActionTypeLaunch ,_b .ActionTypeSound ,_b .ActionTypeMovie ,_b .ActionTypeResetForm ,_b .ActionTypeImportData ,_b .ActionTypeJavaScript :_deadg .Remove ("\u0053");case _b .ActionTypeHide ,_b .ActionTypeSetOCGState ,_b .ActionTypeRendition ,_b .ActionTypeTrans ,_b .ActionTypeGoTo3DView :if _ebf ==2{_deadg .Remove ("\u0053");
};case _b .ActionTypeNamed :_cgc ,_bag :=_gd .GetName (_deadg .Get ("\u004e"));if !_bag {continue ;};switch *_cgc {case "\u004e\u0065\u0078\u0074\u0050\u0061\u0067\u0065","\u0050\u0072\u0065\u0076\u0050\u0061\u0067\u0065","\u0046i\u0072\u0073\u0074\u0050\u0061\u0067e","\u004c\u0061\u0073\u0074\u0050\u0061\u0067\u0065":default:_deadg .Remove ("\u004e");
};};};return nil ;};type profile1 struct{_gaeg standardType ;_cgfb Profile1Options ;};func _eceda (_gdcgg *_b .CompliancePdfReader )(_fagc []ViolatedRule ){return _fagc };func _aca (_ecbd *_b .PdfPageResources ,_fbe *_dc .ContentStreamOperations ,_bcaf bool )([]byte ,error ){var _adfa bool ;
for _ ,_cadd :=range *_fbe {_aef :switch _cadd .Operand {case "\u0042\u0049":_ffd ,_dbded :=_cadd .Params [0].(*_dc .ContentStreamInlineImage );if !_dbded {break ;};_faff ,_agae :=_ffd .GetColorSpace (_ecbd );if _agae !=nil {return nil ,_agae ;};switch _faff .(type ){case *_b .PdfColorspaceDeviceCMYK :if _bcaf {break _aef ;
};case *_b .PdfColorspaceDeviceGray :case *_b .PdfColorspaceDeviceRGB :if !_bcaf {break _aef ;};default:break _aef ;};_adfa =true ;_gfcd ,_agae :=_ffd .ToImage (_ecbd );if _agae !=nil {return nil ,_agae ;};_gdc ,_agae :=_gfcd .ToGoImage ();if _agae !=nil {return nil ,_agae ;
};if _bcaf {_gdc ,_agae =_fg .CMYKConverter .Convert (_gdc );}else {_gdc ,_agae =_fg .NRGBAConverter .Convert (_gdc );};if _agae !=nil {return nil ,_agae ;};_cdff ,_dbded :=_gdc .(_fg .Image );if !_dbded {return nil ,_age .New ("\u0069\u006d\u0061\u0067\u0065\u0020\u0064\u006f\u0065\u0073\u006e\u0027\u0074 \u0069\u006d\u0070\u006c\u0065\u006de\u006e\u0074\u0020\u0069\u006d\u0061\u0067\u0065\u0075\u0074\u0069\u006c\u002eI\u006d\u0061\u0067\u0065");
};_bdbe :=_cdff .Base ();_aebg :=_b .Image {Width :int64 (_bdbe .Width ),Height :int64 (_bdbe .Height ),BitsPerComponent :int64 (_bdbe .BitsPerComponent ),ColorComponents :_bdbe .ColorComponents ,Data :_bdbe .Data };_aebg .SetDecode (_bdbe .Decode );_aebg .SetAlpha (_bdbe .Alpha );
_cbe ,_agae :=_ffd .GetEncoder ();if _agae !=nil {_cbe =_gd .NewFlateEncoder ();};_baa ,_agae :=_dc .NewInlineImageFromImage (_aebg ,_cbe );if _agae !=nil {return nil ,_agae ;};_cadd .Params [0]=_baa ;case "\u0047","\u0067":if len (_cadd .Params )!=1{break ;
};_bab ,_acde :=_gd .GetNumberAsFloat (_cadd .Params [0]);if _acde !=nil {break ;};if _bcaf {_cadd .Params =[]_gd .PdfObject {_gd .MakeFloat (0),_gd .MakeFloat (0),_gd .MakeFloat (0),_gd .MakeFloat (1-_bab )};_deac :="\u004b";if _cadd .Operand =="\u0067"{_deac ="\u006b";
};_cadd .Operand =_deac ;}else {_cadd .Params =[]_gd .PdfObject {_gd .MakeFloat (_bab ),_gd .MakeFloat (_bab ),_gd .MakeFloat (_bab )};_gaf :="\u0052\u0047";if _cadd .Operand =="\u0067"{_gaf ="\u0072\u0067";};_cadd .Operand =_gaf ;};_adfa =true ;case "\u0052\u0047","\u0072\u0067":if !_bcaf {break ;
};if len (_cadd .Params )!=3{break ;};_ebff ,_dbdd :=_gd .GetNumbersAsFloat (_cadd .Params );if _dbdd !=nil {break ;};_adfa =true ;_abf ,_dcdb ,_acdb :=_ebff [0],_ebff [1],_ebff [2];_dcbf ,_egba ,_fgae ,_daf :=_ag .RGBToCMYK (uint8 (_abf *255),uint8 (_dcdb *255),uint8 (255*_acdb ));
_cadd .Params =[]_gd .PdfObject {_gd .MakeFloat (float64 (_dcbf )/255),_gd .MakeFloat (float64 (_egba )/255),_gd .MakeFloat (float64 (_fgae )/255),_gd .MakeFloat (float64 (_daf )/255)};_effe :="\u004b";if _cadd .Operand =="\u0072\u0067"{_effe ="\u006b";
};_cadd .Operand =_effe ;case "\u004b","\u006b":if _bcaf {break ;};if len (_cadd .Params )!=4{break ;};_cbca ,_eafb :=_gd .GetNumbersAsFloat (_cadd .Params );if _eafb !=nil {break ;};_cbea ,_fagg ,_bbg ,_ffcdg :=_cbca [0],_cbca [1],_cbca [2],_cbca [3];
_cbab ,_aggc ,_agb :=_ag .CMYKToRGB (uint8 (255*_cbea ),uint8 (255*_fagg ),uint8 (255*_bbg ),uint8 (255*_ffcdg ));_cadd .Params =[]_gd .PdfObject {_gd .MakeFloat (float64 (_cbab )/255),_gd .MakeFloat (float64 (_aggc )/255),_gd .MakeFloat (float64 (_agb )/255)};
_bebb :="\u0052\u0047";if _cadd .Operand =="\u006b"{_bebb ="\u0072\u0067";};_cadd .Operand =_bebb ;_adfa =true ;};};if !_adfa {return nil ,nil ;};_dgge :=_dc .NewContentCreator ();for _ ,_gbef :=range *_fbe {_dgge .AddOperand (*_gbef );};_eeb :=_dgge .Bytes ();
return _eeb ,nil ;};func _gbe ()standardType {return standardType {_gb :2,_dcd :"\u0042"}};func _efdgb (_cgcg *_b .CompliancePdfReader )(_fgca []ViolatedRule ){for _ ,_fbae :=range _cgcg .GetObjectNums (){_daeae ,_dfded :=_cgcg .GetIndirectObjectByNumber (_fbae );
if _dfded !=nil {continue ;};_bffcd ,_agebe :=_gd .GetDict (_daeae );if !_agebe {continue ;};_caeff ,_agebe :=_gd .GetName (_bffcd .Get ("\u0054\u0079\u0070\u0065"));if !_agebe {continue ;};if _caeff .String ()!="\u0041\u0063\u0072\u006f\u0046\u006f\u0072\u006d"{continue ;
};_dgfc ,_agebe :=_gd .GetBool (_bffcd .Get ("\u004ee\u0065d\u0041\u0070\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0073"));if _agebe &&bool (*_dgfc ){_fgca =append (_fgca ,_ab ("\u0036.\u0034\u002e\u0031\u002d\u0033","\u0054\u0068\u0065\u0020\u004e\u0065e\u0064\u0041\u0070\u0070\u0065a\u0072\u0061\u006e\u0063\u0065\u0073\u0020\u0066\u006c\u0061\u0067\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0069\u006e\u0074\u0065\u0072\u0061\u0063\u0074\u0069\u0076e\u0020\u0066\u006f\u0072\u006d \u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0065\u0069\u0074\u0068\u0065\u0072\u0020\u006e\u006f\u0074\u0020b\u0065\u0020\u0070\u0072\u0065se\u006e\u0074\u0020\u006f\u0072\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0066\u0061\u006c\u0073\u0065\u002e"));
};if _bffcd .Get ("\u0058\u0046\u0041")!=nil {_fgca =append (_fgca ,_ab ("\u0036.\u0034\u002e\u0032\u002d\u0031","\u0054\u0068\u0065\u0020\u0064o\u0063\u0075\u006d\u0065\u006e\u0074\u0027\u0073\u0020i\u006e\u0074\u0065\u0072\u0061\u0063\u0074\u0069\u0076\u0065\u0020\u0066\u006f\u0072\u006d\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061r\u0079\u0020t\u0068\u0061\u0074\u0020f\u006f\u0072\u006d\u0073\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065 \u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0041\u0063\u0072\u006f\u0046\u006f\u0072\u006d \u006b\u0065\u0079\u0020i\u006e\u0020\u0074\u0068\u0065\u0020\u0064\u006f\u0063\u0075\u006d\u0065\u006e\u0074\u0027\u0073\u0020\u0043\u0061\u0074\u0061\u006c\u006f\u0067\u0020\u006f\u0066 \u0061 \u0050\u0044F\u002fA\u002d\u0032\u0020\u0066ile\u002c\u0020\u0069\u0066\u0020\u0070\u0072\u0065\u0073\u0065n\u0074\u002c\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006ft\u0020\u0063\u006f\u006e\u0074a\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0058\u0046\u0041\u0020\u006b\u0065y."));
};};_bcddd ,_dafed :=_dbce (_cgcg );if _dafed &&_bcddd .Get ("\u004e\u0065\u0065\u0064\u0073\u0052\u0065\u006e\u0064e\u0072\u0069\u006e\u0067")!=nil {_fgca =append (_fgca ,_ab ("\u0036.\u0034\u002e\u0032\u002d\u0032","\u0041\u0020\u0064\u006f\u0063\u0075\u006d\u0065\u006e\u0074\u0027\u0073\u0020\u0043\u0061\u0074\u0061\u006cog\u0020s\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006et\u0061\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u004e\u0065\u0065\u0064\u0073\u0052\u0065\u006e\u0064e\u0072\u0069\u006e\u0067\u0020\u006b\u0065\u0079\u002e"));
};return _fgca ;};func _efaa (_dfcac *_b .CompliancePdfReader )ViolatedRule {_begaa ,_eadad :=_dfcac .PdfReader .GetTrailer ();if _eadad !=nil {return _ab ("\u0036.\u0031\u002e\u0033\u002d\u0031","\u006d\u0069\u0073s\u0069\u006e\u0067\u0020t\u0072\u0061\u0069\u006c\u0065\u0072\u0020i\u006e\u0020\u0074\u0068\u0065\u0020\u0064\u006f\u0063\u0075\u006d\u0065\u006e\u0074");
};if _begaa .Get ("\u0049\u0044")==nil {return _ab ("\u0036.\u0031\u002e\u0033\u002d\u0031","\u0054\u0068\u0065\u0020\u0066\u0069\u006c\u0065\u0020\u0074\u0072\u0061\u0069\u006c\u0065\u0072\u0020\u0064\u0069\u0063t\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068a\u006c\u006c\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074\u0068e\u0020\u0027\u0049\u0044\u0027\u0020k\u0065\u0079\u0077o\u0072\u0064");
};if _begaa .Get ("\u0045n\u0063\u0072\u0079\u0070\u0074")!=nil {return _ab ("\u0036.\u0031\u002e\u0033\u002d\u0032","\u0054\u0068\u0065\u0020\u006b\u0065y\u0077\u006f\u0072\u0064\u0020'\u0045\u006e\u0063\u0072\u0079\u0070t\u0027\u0020\u0073\u0068\u0061l\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0075\u0073\u0065d\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0074\u0072\u0061\u0069\u006c\u0065\u0072 \u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061r\u0079\u002e\u0020");
};return _fc ;};func _fdgd (_cacb *_b .CompliancePdfReader )(_dceba []ViolatedRule ){var _fcfg ,_bfgb ,_afae ,_cbfae ,_debb ,_bdbdg ,_geeee bool ;_ddcbb :=func ()bool {return _fcfg &&_bfgb &&_afae &&_cbfae &&_debb &&_bdbdg &&_geeee };_bbge :=func (_dfbe *_gd .PdfObjectDictionary )bool {if !_fcfg &&_dfbe .Get ("\u0054\u0052")!=nil {_fcfg =true ;
_dceba =append (_dceba ,_ab ("\u0036.\u0032\u002e\u0035\u002d\u0031","\u0041\u006e\u0020\u0045\u0078\u0074\u0047\u0053\u0074\u0061\u0074e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006ea\u0072y\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e \u0074\u0068\u0065\u0020\u0054\u0052\u0020\u006b\u0065\u0079\u002e"));
};if _aebd :=_dfbe .Get ("\u0054\u0052\u0032");!_bfgb &&_aebd !=nil {_ggbde ,_affg :=_gd .GetName (_aebd );if !_affg ||(_affg &&*_ggbde !="\u0044e\u0066\u0061\u0075\u006c\u0074"){_bfgb =true ;_dceba =append (_dceba ,_ab ("\u0036.\u0032\u002e\u0035\u002d\u0032","\u0041\u006e \u0045\u0078\u0074G\u0053\u0074\u0061\u0074\u0065 \u0064\u0069\u0063\u0074\u0069on\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074a\u0069n\u0020\u0074\u0068\u0065\u0020\u0054R2 \u006b\u0065\u0079\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u0020\u0076al\u0075e\u0020\u006f\u0074\u0068e\u0072 \u0074h\u0061\u006e \u0044\u0065fa\u0075\u006c\u0074\u002e"));
if _ddcbb (){return true ;};};};if !_afae &&_dfbe .Get ("\u0048\u0054\u0050")!=nil {_afae =true ;_dceba =append (_dceba ,_ab ("\u0036.\u0032\u002e\u0035\u002d\u0033","\u0041\u006e\u0020\u0045\u0078\u0074\u0047\u0053\u0074\u0061\u0074\u0065\u0020\u0064\u0069c\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c \u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020th\u0065\u0020\u0048\u0054\u0050\u0020\u006b\u0065\u0079\u002e"));
};_cada ,_fbffc :=_gd .GetDict (_dfbe .Get ("\u0048\u0054"));if _fbffc {if _edgfe :=_cada .Get ("\u0048\u0061\u006cf\u0074\u006f\u006e\u0065\u0054\u0079\u0070\u0065");!_cbfae &&_edgfe !=nil {_aabd ,_accd :=_gd .GetInt (_edgfe );if !_accd ||(_accd &&!(*_aabd ==1||*_aabd ==5)){_dceba =append (_dceba ,_ab ("\u0020\u0036\u002e\u0032\u002e\u0035\u002d\u0034","\u0041\u006c\u006c\u0020\u0068\u0061\u006c\u0066\u0074\u006f\u006e\u0065\u0073\u0020\u0069\u006e\u0020\u0061\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0050\u0044\u0046\u002f\u0041\u002d\u0032\u0020\u0066\u0069\u006ce\u0020\u0073h\u0061\u006c\u006c\u0020h\u0061\u0076\u0065\u0020\u0074\u0068\u0065\u0020\u0076\u0061l\u0075\u0065\u0020\u0031\u0020\u006f\u0072\u0020\u0035 \u0066\u006f\u0072\u0020\u0074\u0068\u0065\u0020\u0048\u0061l\u0066\u0074\u006fn\u0065\u0054\u0079\u0070\u0065\u0020\u006be\u0079\u002e"));
if _ddcbb (){return true ;};};};if _aebgc :=_cada .Get ("\u0048\u0061\u006cf\u0074\u006f\u006e\u0065\u004e\u0061\u006d\u0065");!_debb &&_aebgc !=nil {_debb =true ;_dceba =append (_dceba ,_ab ("\u0036.\u0032\u002e\u0035\u002d\u0035","\u0048\u0061\u006c\u0066\u0074o\u006e\u0065\u0073\u0020\u0069\u006e\u0020a\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0050\u0044\u0046\u002f\u0041\u002d\u0032\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061i\u006e\u0020\u0061\u0020\u0048\u0061\u006c\u0066\u0074\u006f\u006e\u0065N\u0061\u006d\u0065\u0020\u006b\u0065y\u002e"));
if _ddcbb (){return true ;};};};_ ,_dacdf :=_eadb (_cacb );var _fcdd bool ;_aegc ,_fbffc :=_gd .GetDict (_dfbe .Get ("\u0047\u0072\u006fu\u0070"));if _fbffc {_ ,_abgcd :=_gd .GetName (_aegc .Get ("\u0043\u0053"));if _abgcd {_fcdd =true ;};};if _ebecg :=_dfbe .Get ("\u0042\u004d");
!_bdbdg &&!_geeee &&_ebecg !=nil {_ddec ,_bfgbf :=_gd .GetName (_ebecg );if _bfgbf {switch _ddec .String (){case "\u004e\u006f\u0072\u006d\u0061\u006c","\u0043\u006f\u006d\u0070\u0061\u0074\u0069\u0062\u006c\u0065","\u004d\u0075\u006c\u0074\u0069\u0070\u006c\u0079","\u0053\u0063\u0072\u0065\u0065\u006e","\u004fv\u0065\u0072\u006c\u0061\u0079","\u0044\u0061\u0072\u006b\u0065\u006e","\u004ci\u0067\u0068\u0074\u0065\u006e","\u0043\u006f\u006c\u006f\u0072\u0044\u006f\u0064\u0067\u0065","\u0043o\u006c\u006f\u0072\u0042\u0075\u0072n","\u0048a\u0072\u0064\u004c\u0069\u0067\u0068t","\u0053o\u0066\u0074\u004c\u0069\u0067\u0068t","\u0044\u0069\u0066\u0066\u0065\u0072\u0065\u006e\u0063\u0065","\u0045x\u0063\u006c\u0075\u0073\u0069\u006fn","\u0048\u0075\u0065","\u0053\u0061\u0074\u0075\u0072\u0061\u0074\u0069\u006f\u006e","\u0043\u006f\u006co\u0072","\u004c\u0075\u006d\u0069\u006e\u006f\u0073\u0069\u0074\u0079":default:_bdbdg =true ;
_dceba =append (_dceba ,_ab ("\u0036\u002e\u0032\u002e\u0031\u0030\u002d\u0031","\u004f\u006el\u0079\u0020\u0062\u006c\u0065\u006e\u0064\u0020\u006d\u006f\u0064\u0065\u0073\u0020\u0074h\u0061\u0074\u0020\u0061\u0072\u0065\u0020\u0073\u0070\u0065c\u0069\u0066\u0069ed\u0020\u0069\u006e\u0020\u0049\u0053O\u0020\u0033\u0032\u0030\u0030\u0030\u002d\u0031\u003a2\u0030\u0030\u0038\u0020\u0073h\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0075\u0073\u0065\u0064\u0020\u0066\u006f\u0072\u0020\u0074\u0068\u0065 \u0076\u0061\u006c\u0075e\u0020\u006f\u0066\u0020\u0074\u0068e\u0020\u0042M\u0020\u006b\u0065\u0079\u0020\u0069\u006e\u0020\u0061\u006e\u0020\u0065\u0078t\u0065\u006e\u0064\u0065\u0064\u0020\u0067\u0072\u0061\u0070\u0068\u0069\u0063\u0020\u0073\u0074\u0061\u0074\u0065 \u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002e"));
if _ddcbb (){return true ;};};if _ddec .String ()!="\u004e\u006f\u0072\u006d\u0061\u006c"&&!_dacdf &&!_fcdd {_geeee =true ;_dceba =append (_dceba ,_ab ("\u0036\u002e\u0032\u002e\u0031\u0030\u002d\u0032","\u0049\u0066\u0020\u0074\u0068\u0065 \u0064\u006f\u0063\u0075\u006de\u006e\u0074\u0020\u0064\u006f\u0065\u0073\u0020\u006e\u006f\u0074\u0020c\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u0020P\u0044\u0046\u002f\u0041\u0020\u004f\u0075\u0074\u0070u\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u002c\u0020\u0074\u0068\u0065\u006e\u0020\u0061\u006c\u006c\u0020\u0050\u0061\u0067\u0065\u0020\u006f\u0062\u006a\u0065\u0063t\u0073\u0020\u0074\u0068a\u0074 \u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020t\u0072\u0061\u006e\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0069\u006e\u0063l\u0075\u0064\u0065\u0020\u0074\u0068\u0065\u0020\u0047\u0072\u006f\u0075\u0070\u0020\u006b\u0065y\u002c a\u006e\u0064\u0020\u0074\u0068\u0065\u0020\u0061\u0074\u0074\u0072\u0069\u0062\u0075\u0074\u0065\u0020\u0064\u0069c\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0074\u0068\u0061\u0074\u0020\u0066\u006f\u0072\u006d\u0073\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006cu\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0061\u0074\u0020\u0047\u0072\u006fu\u0070\u0020\u006b\u0065y\u0020sh\u0061\u006c\u006c\u0020\u0069\u006e\u0063\u006c\u0075d\u0065\u0020\u0061\u0020\u0043\u0053\u0020\u0065\u006e\u0074\u0072\u0079\u0020\u0077\u0068\u006fs\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065 \u0075\u0073\u0065\u0064\u0020\u0061\u0073\u0020\u0074\u0068\u0065\u0020\u0064\u0065\u0066\u0061\u0075\u006c\u0074\u0020\u0062\u006c\u0065\u006e\u0064\u0069n\u0067 \u0063\u006f\u006c\u006f\u0075\u0072\u0020\u0073p\u0061\u0063\u0065\u002e"));
if _ddcbb (){return true ;};};};};if _ ,_fbffc =_gd .GetDict (_dfbe .Get ("\u0053\u004d\u0061s\u006b"));!_geeee &&_fbffc &&!_dacdf &&!_fcdd {_geeee =true ;_dceba =append (_dceba ,_ab ("\u0036\u002e\u0032\u002e\u0031\u0030\u002d\u0032","\u0049\u0066\u0020\u0074\u0068\u0065 \u0064\u006f\u0063\u0075\u006de\u006e\u0074\u0020\u0064\u006f\u0065\u0073\u0020\u006e\u006f\u0074\u0020c\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u0020P\u0044\u0046\u002f\u0041\u0020\u004f\u0075\u0074\u0070u\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u002c\u0020\u0074\u0068\u0065\u006e\u0020\u0061\u006c\u006c\u0020\u0050\u0061\u0067\u0065\u0020\u006f\u0062\u006a\u0065\u0063t\u0073\u0020\u0074\u0068a\u0074 \u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020t\u0072\u0061\u006e\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0069\u006e\u0063l\u0075\u0064\u0065\u0020\u0074\u0068\u0065\u0020\u0047\u0072\u006f\u0075\u0070\u0020\u006b\u0065y\u002c a\u006e\u0064\u0020\u0074\u0068\u0065\u0020\u0061\u0074\u0074\u0072\u0069\u0062\u0075\u0074\u0065\u0020\u0064\u0069c\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0074\u0068\u0061\u0074\u0020\u0066\u006f\u0072\u006d\u0073\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006cu\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0061\u0074\u0020\u0047\u0072\u006fu\u0070\u0020\u006b\u0065y\u0020sh\u0061\u006c\u006c\u0020\u0069\u006e\u0063\u006c\u0075d\u0065\u0020\u0061\u0020\u0043\u0053\u0020\u0065\u006e\u0074\u0072\u0079\u0020\u0077\u0068\u006fs\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065 \u0075\u0073\u0065\u0064\u0020\u0061\u0073\u0020\u0074\u0068\u0065\u0020\u0064\u0065\u0066\u0061\u0075\u006c\u0074\u0020\u0062\u006c\u0065\u006e\u0064\u0069n\u0067 \u0063\u006f\u006c\u006f\u0075\u0072\u0020\u0073p\u0061\u0063\u0065\u002e"));
if _ddcbb (){return true ;};};if _dfbfb :=_dfbe .Get ("\u0043\u0041");!_geeee &&_dfbfb !=nil &&!_dacdf &&!_fcdd {_afad ,_afab :=_gd .GetNumberAsFloat (_dfbfb );if _afab ==nil &&_afad < 1.0{_geeee =true ;_dceba =append (_dceba ,_ab ("\u0036\u002e\u0032\u002e\u0031\u0030\u002d\u0032","\u0049\u0066\u0020\u0074\u0068\u0065 \u0064\u006f\u0063\u0075\u006de\u006e\u0074\u0020\u0064\u006f\u0065\u0073\u0020\u006e\u006f\u0074\u0020c\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u0020P\u0044\u0046\u002f\u0041\u0020\u004f\u0075\u0074\u0070u\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u002c\u0020\u0074\u0068\u0065\u006e\u0020\u0061\u006c\u006c\u0020\u0050\u0061\u0067\u0065\u0020\u006f\u0062\u006a\u0065\u0063t\u0073\u0020\u0074\u0068a\u0074 \u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020t\u0072\u0061\u006e\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0069\u006e\u0063l\u0075\u0064\u0065\u0020\u0074\u0068\u0065\u0020\u0047\u0072\u006f\u0075\u0070\u0020\u006b\u0065y\u002c a\u006e\u0064\u0020\u0074\u0068\u0065\u0020\u0061\u0074\u0074\u0072\u0069\u0062\u0075\u0074\u0065\u0020\u0064\u0069c\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0074\u0068\u0061\u0074\u0020\u0066\u006f\u0072\u006d\u0073\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006cu\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0061\u0074\u0020\u0047\u0072\u006fu\u0070\u0020\u006b\u0065y\u0020sh\u0061\u006c\u006c\u0020\u0069\u006e\u0063\u006c\u0075d\u0065\u0020\u0061\u0020\u0043\u0053\u0020\u0065\u006e\u0074\u0072\u0079\u0020\u0077\u0068\u006fs\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065 \u0075\u0073\u0065\u0064\u0020\u0061\u0073\u0020\u0074\u0068\u0065\u0020\u0064\u0065\u0066\u0061\u0075\u006c\u0074\u0020\u0062\u006c\u0065\u006e\u0064\u0069n\u0067 \u0063\u006f\u006c\u006f\u0075\u0072\u0020\u0073p\u0061\u0063\u0065\u002e"));
if _ddcbb (){return true ;};};};if _afdee :=_dfbe .Get ("\u0063\u0061");!_geeee &&_afdee !=nil &&!_dacdf &&!_fcdd {_beaef ,_eeaab :=_gd .GetNumberAsFloat (_afdee );if _eeaab ==nil &&_beaef < 1.0{_geeee =true ;_dceba =append (_dceba ,_ab ("\u0036\u002e\u0032\u002e\u0031\u0030\u002d\u0032","\u0049\u0066\u0020\u0074\u0068\u0065 \u0064\u006f\u0063\u0075\u006de\u006e\u0074\u0020\u0064\u006f\u0065\u0073\u0020\u006e\u006f\u0074\u0020c\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u0020P\u0044\u0046\u002f\u0041\u0020\u004f\u0075\u0074\u0070u\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u002c\u0020\u0074\u0068\u0065\u006e\u0020\u0061\u006c\u006c\u0020\u0050\u0061\u0067\u0065\u0020\u006f\u0062\u006a\u0065\u0063t\u0073\u0020\u0074\u0068a\u0074 \u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020t\u0072\u0061\u006e\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0069\u006e\u0063l\u0075\u0064\u0065\u0020\u0074\u0068\u0065\u0020\u0047\u0072\u006f\u0075\u0070\u0020\u006b\u0065y\u002c a\u006e\u0064\u0020\u0074\u0068\u0065\u0020\u0061\u0074\u0074\u0072\u0069\u0062\u0075\u0074\u0065\u0020\u0064\u0069c\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0074\u0068\u0061\u0074\u0020\u0066\u006f\u0072\u006d\u0073\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006cu\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0061\u0074\u0020\u0047\u0072\u006fu\u0070\u0020\u006b\u0065y\u0020sh\u0061\u006c\u006c\u0020\u0069\u006e\u0063\u006c\u0075d\u0065\u0020\u0061\u0020\u0043\u0053\u0020\u0065\u006e\u0074\u0072\u0079\u0020\u0077\u0068\u006fs\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065 \u0075\u0073\u0065\u0064\u0020\u0061\u0073\u0020\u0074\u0068\u0065\u0020\u0064\u0065\u0066\u0061\u0075\u006c\u0074\u0020\u0062\u006c\u0065\u006e\u0064\u0069n\u0067 \u0063\u006f\u006c\u006f\u0075\u0072\u0020\u0073p\u0061\u0063\u0065\u002e"));
if _ddcbb (){return true ;};};};return false ;};for _ ,_cade :=range _cacb .PageList {_aabf :=_cade .Resources ;if _aabf ==nil {continue ;};if _aabf .ExtGState ==nil {continue ;};_bcbab ,_bbacg :=_gd .GetDict (_aabf .ExtGState );if !_bbacg {continue ;};
_baad :=_bcbab .Keys ();for _ ,_cecbc :=range _baad {_bbddf ,_cggd :=_gd .GetDict (_bcbab .Get (_cecbc ));if !_cggd {continue ;};if _bbge (_bbddf ){return _dceba ;};};};for _ ,_dccfb :=range _cacb .PageList {_agbg :=_dccfb .Resources ;if _agbg ==nil {continue ;
};_aeeg ,_agfd :=_gd .GetDict (_agbg .XObject );if !_agfd {continue ;};for _ ,_gefb :=range _aeeg .Keys (){_efac ,_fcfc :=_gd .GetStream (_aeeg .Get (_gefb ));if !_fcfc {continue ;};_fdgbg ,_fcfc :=_gd .GetDict (_efac .Get ("\u0052e\u0073\u006f\u0075\u0072\u0063\u0065s"));
if !_fcfc {continue ;};_abcec ,_fcfc :=_gd .GetDict (_fdgbg .Get ("\u0045x\u0074\u0047\u0053\u0074\u0061\u0074e"));if !_fcfc {continue ;};for _ ,_dbdf :=range _abcec .Keys (){_gadde ,_egbbf :=_gd .GetDict (_abcec .Get (_dbdf ));if !_egbbf {continue ;};
if _bbge (_gadde ){return _dceba ;};};};};return _dceba ;};func _fdffe (_gabae *_b .CompliancePdfReader )(_eede []ViolatedRule ){_fbac :=true ;_cbbg ,_gfed :=_gabae .GetCatalogMarkInfo ();if !_gfed {_fbac =false ;}else {_eadf ,_ecge :=_gd .GetDict (_cbbg );
if _ecge {_egcde ,_gggf :=_gd .GetBool (_eadf .Get ("\u004d\u0061\u0072\u006b\u0065\u0064"));if !bool (*_egcde )||!_gggf {_fbac =false ;};}else {_fbac =false ;};};if !_fbac {_eede =append (_eede ,_ab ("\u0036.\u0038\u002e\u0032\u002d\u0031","\u0054\u0068\u0065\u0020\u0064\u006f\u0063\u0075\u006d\u0065\u006e\u0074\u0020\u0063\u0061\u0074\u0061\u006cog\u0020d\u0069\u0063\u0074\u0069\u006f\u006e\u0061r\u0079 \u0073\u0068\u0061\u006c\u006c\u0020\u0069\u006e\u0063\u006c\u0075\u0064\u0065\u0020\u0061\u0020M\u0061r\u006b\u0049\u006e\u0066\u006f\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006ea\u0072\u0079\u0020\u0077\u0069\u0074\u0068\u0020\u0061 \u004d\u0061\u0072\u006b\u0065\u0064\u0020\u0065\u006et\u0072\u0079\u0020\u0069\u006e\u0020\u0069\u0074,\u0020\u0077\u0068\u006f\u0073\u0065\u0020\u0076\u0061lu\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0074\u0072\u0075\u0065"));
};_bcbb ,_gfed :=_gabae .GetCatalogStructTreeRoot ();if !_gfed {_eede =append (_eede ,_ab ("\u0036.\u0038\u002e\u0033\u002d\u0031","\u0054\u0068\u0065\u0020\u006c\u006f\u0067\u0069\u0063\u0061\u006c\u0020\u0073\u0074\u0072\u0075\u0063\u0074\u0075r\u0065\u0020\u006f\u0066\u0020\u0074\u0068e\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067 \u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0064\u0065\u0073\u0063\u0072\u0069\u0062\u0065d \u0062\u0079\u0020a\u0020s\u0074\u0072\u0075\u0063\u0074\u0075\u0072e\u0020\u0068\u0069\u0065\u0072\u0061\u0072\u0063\u0068\u0079\u0020\u0072\u006f\u006ft\u0065\u0064\u0020i\u006e\u0020\u0074\u0068\u0065\u0020\u0053\u0074\u0072\u0075\u0063\u0074\u0054\u0072\u0065\u0065\u0052\u006f\u006f\u0074\u0020\u0065\u006e\u0074r\u0079\u0020\u006f\u0066\u0020\u0074h\u0065\u0020d\u006fc\u0075\u006d\u0065\u006e\u0074\u0020\u0063\u0061t\u0061\u006c\u006fg \u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002c\u0020\u0061\u0073\u0020\u0064\u0065\u0073\u0063\u0072\u0069\u0062\u0065\u0064\u0020\u0069n\u0020\u0050\u0044\u0046\u0020\u0052\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065 \u0039\u002e\u0036\u002e"));
};_fbff ,_gfed :=_gd .GetDict (_bcbb );if _gfed {_cfgg ,_ddcfe :=_gd .GetName (_fbff .Get ("\u0052o\u006c\u0065\u004d\u0061\u0070"));if _ddcfe {_bbeae ,_ceece :=_gd .GetDict (_cfgg );if _ceece {for _ ,_agddd :=range _bbeae .Keys (){_baagc :=_bbeae .Get (_agddd );
if _baagc ==nil {_eede =append (_eede ,_ab ("\u0036.\u0038\u002e\u0033\u002d\u0032","\u0041\u006c\u006c\u0020\u006eo\u006e\u002ds\u0074\u0061\u006e\u0064\u0061\u0072\u0064\u0020\u0073t\u0072\u0075\u0063\u0074ure\u0020\u0074\u0079\u0070\u0065s\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065\u0020\u006d\u0061\u0070\u0070\u0065d\u0020\u0074\u006f\u0020\u0074\u0068\u0065\u0020n\u0065\u0061\u0072\u0065\u0073\u0074\u0020\u0066\u0075\u006e\u0063t\u0069\u006f\u006e\u0061\u006c\u006c\u0079\u0020\u0065\u0071\u0075\u0069\u0076\u0061\u006c\u0065\u006e\u0074\u0020\u0073\u0074a\u006ed\u0061r\u0064\u0020\u0074\u0079\u0070\u0065\u002c\u0020\u0061\u0073\u0020\u0064\u0065\u0066\u0069\u006ee\u0064\u0020\u0069\u006e\u0020\u0050\u0044\u0046\u0020\u0052\u0065\u0066\u0065re\u006e\u0063e\u0020\u0039\u002e\u0037\u002e\u0034\u002c\u0020i\u006e\u0020\u0074\u0068e\u0020\u0072\u006fl\u0065\u0020\u006d\u0061p \u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u006f\u0066 \u0074h\u0065\u0020\u0073\u0074\u0072\u0075c\u0074\u0075r\u0065\u0020\u0074\u0072e\u0065\u0020\u0072\u006f\u006ft\u002e"));
};};};};};return _eede ;};func _ggace (_gcdec string ,_bfebd string ,_fdee string )(string ,bool ){_cecef :=_ef .Index (_gcdec ,_bfebd );if _cecef ==-1{return "",false ;};_cecef +=len (_bfebd );_edca :=_ef .Index (_gcdec [_cecef :],_fdee );if _edca ==-1{return "",false ;
};_edca =_cecef +_edca ;return _gcdec [_cecef :_edca ],true ;};func _ecfd (_aagcb *_b .CompliancePdfReader )ViolatedRule {return _fc };func _cdgfg (_dgbde *_da .Document ,_degf int )error {_dag :=map[*_gd .PdfObjectStream ]struct{}{};for _ ,_dad :=range _dgbde .Objects {_aafe ,_agac :=_gd .GetStream (_dad );
if !_agac {continue ;};if _ ,_agac =_dag [_aafe ];_agac {continue ;};_dag [_aafe ]=struct{}{};_bedc ,_agac :=_gd .GetName (_aafe .Get ("\u0053u\u0062\u0054\u0079\u0070\u0065"));if !_agac {continue ;};if _aafe .Get ("\u0052\u0065\u0066")!=nil {_aafe .Remove ("\u0052\u0065\u0066");
};if _bedc .String ()=="\u0050\u0053"{_aafe .Remove ("\u0050\u0053");continue ;};if _bedc .String ()=="\u0046\u006f\u0072\u006d"{if _aafe .Get ("\u004f\u0050\u0049")!=nil {_aafe .Remove ("\u004f\u0050\u0049");};if _aafe .Get ("\u0050\u0053")!=nil {_aafe .Remove ("\u0050\u0053");
};if _efe :=_aafe .Get ("\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0032");_efe !=nil {if _ace ,_ceee :=_gd .GetName (_efe );_ceee &&*_ace =="\u0050\u0053"{_aafe .Remove ("\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0032");};};continue ;};if _bedc .String ()=="\u0049\u006d\u0061g\u0065"{_dca ,_ebbf :=_gd .GetBool (_aafe .Get ("I\u006e\u0074\u0065\u0072\u0070\u006f\u006c\u0061\u0074\u0065"));
if _ebbf &&bool (*_dca ){_aafe .Set ("I\u006e\u0074\u0065\u0072\u0070\u006f\u006c\u0061\u0074\u0065",_gd .MakeBool (false ));};if _degf ==2{if _aafe .Get ("\u004f\u0050\u0049")!=nil {_aafe .Remove ("\u004f\u0050\u0049");};};if _aafe .Get ("\u0041\u006c\u0074\u0065\u0072\u006e\u0061\u0074\u0065\u0073")!=nil {_aafe .Remove ("\u0041\u006c\u0074\u0065\u0072\u006e\u0061\u0074\u0065\u0073");
};continue ;};};return nil ;};func _edbf (_fgcc *_b .CompliancePdfReader )(_dcgg []ViolatedRule ){_agaaa :=_fgcc .ParserMetadata ();if _agaaa .HasInvalidSubsectionHeader (){_dcgg =append (_dcgg ,_ab ("\u0036.\u0031\u002e\u0034\u002d\u0031","\u006e\u0020\u0061\u0020\u0063\u0072\u006f\u0073\u0073\u0020\u0072\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0073\u0075\u0062\u0073\u0065c\u0074\u0069\u006f\u006e\u0020h\u0065a\u0064\u0065\u0072\u0020t\u0068\u0065\u0020\u0073\u0074\u0061\u0072t\u0069\u006e\u0067\u0020\u006fb\u006a\u0065\u0063\u0074 \u006e\u0075\u006d\u0062\u0065\u0072\u0020\u0061\u006e\u0064\u0020\u0074\u0068\u0065\u0020\u0072\u0061n\u0067e\u0020s\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0073\u0065\u0070\u0061\u0072\u0061\u0074\u0065\u0064\u0020\u0062\u0079\u0020\u0061\u0020s\u0069\u006e\u0067\u006c\u0065\u0020\u0053\u0050\u0041C\u0045\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074e\u0072\u0020\u0028\u0032\u0030\u0068\u0029\u002e"));
};if _agaaa .HasInvalidSeparationAfterXRef (){_dcgg =append (_dcgg ,_ab ("\u0036.\u0031\u002e\u0034\u002d\u0032","\u0054\u0068\u0065 \u0078\u0072\u0065\u0066\u0020\u006b\u0065\u0079\u0077\u006fr\u0064\u0020\u0061\u006e\u0064\u0020\u0074\u0068\u0065\u0020\u0063\u0072\u006f\u0073s\u0020\u0072\u0065\u0066e\u0072\u0065\u006e\u0063\u0065 s\u0075b\u0073\u0065\u0063ti\u006f\u006e\u0020\u0068\u0065\u0061\u0064e\u0072\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0073\u0065\u0070\u0061\u0072\u0061\u0074\u0065\u0064\u0020\u0062\u0079 \u0061\u0020\u0073i\u006e\u0067\u006c\u0065\u0020\u0045\u004fL\u0020\u006d\u0061\u0072\u006b\u0065\u0072\u002e"));
};return _dcgg ;};func _cae (_bged *_da .Document )error {_baf :=map[string ]*_gd .PdfObjectDictionary {};_bdc :=_gf .NewFinder (&_gf .FinderOpts {Extensions :[]string {"\u002e\u0074\u0074\u0066"}});_fcc :=map[_gd .PdfObject ]struct{}{};_abe :=map[_gd .PdfObject ]struct{}{};
for _ ,_geeg :=range _bged .Objects {_dcf ,_bee :=_gd .GetDict (_geeg );if !_bee {continue ;};_ead :=_dcf .Get ("\u0054\u0079\u0070\u0065");if _ead ==nil {continue ;};if _geb ,_fgd :=_gd .GetName (_ead );_fgd &&_geb .String ()!="\u0046\u006f\u006e\u0074"{continue ;
};if _ ,_agg :=_fcc [_geeg ];_agg {continue ;};_cbg ,_feb :=_b .NewPdfFontFromPdfObject (_dcf );if _feb !=nil {_ae .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020\u0063\u006f\u0075\u006c\u0064\u0020\u006e\u006f\u0074\u0020\u006c\u006f\u0061\u0064\u0020\u0066\u006fn\u0074\u0020\u0066\u0072\u006fm\u0020\u006fb\u006a\u0065\u0063\u0074");
return _feb ;};_dge ,_feb :=_cbg .GetFontDescriptor ();if _feb !=nil {return _feb ;};if _dge !=nil &&(_dge .FontFile !=nil ||_dge .FontFile2 !=nil ||_dge .FontFile3 !=nil ){continue ;};_bac :=_cbg .BaseFont ();if _bac ==""{return _d .Errorf ("\u006f\u006e\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0020\u006f\u0062\u006a\u0065c\u0074\u0073\u0020\u0073\u0079\u006e\u0074\u0061\u0078\u0020\u0069\u0073\u0020\u006e\u006f\u0074\u0020\u0076\u0061\u006c\u0069d\u0020\u002d\u0020\u0042\u0061\u0073\u0065\u0046\u006f\u006e\u0074\u0020\u0075\u006ed\u0065\u0066\u0069n\u0065\u0064\u003a\u0020\u0025\u0073",_dcf .String ());
};_afa ,_bcda :=_baf [_bac ];if !_bcda {if len (_bac )> 7&&_bac [6]=='+'{_bac =_bac [7:];};_fgcb :=[]string {_bac ,"\u0054i\u006de\u0073\u0020\u004e\u0065\u0077\u0020\u0052\u006f\u006d\u0061\u006e","\u0041\u0072\u0069a\u006c","D\u0065\u006a\u0061\u0056\u0075\u0020\u0053\u0061\u006e\u0073"};
for _ ,_gfa :=range _fgcb {_ae .Log .Debug ("\u0044\u0045\u0042\u0055\u0047\u003a \u0073\u0065\u0061\u0072\u0063\u0068\u0069\u006e\u0067\u0020\u0073\u0079\u0073t\u0065\u006d\u0020\u0066\u006f\u006e\u0074 \u0060\u0025\u0073\u0060",_gfa );if _afa ,_bcda =_baf [_gfa ];
_bcda {break ;};_fef :=_bdc .Match (_gfa );if _fef ==nil {_ae .Log .Debug ("c\u006f\u0075\u006c\u0064\u0020\u006eo\u0074\u0020\u0066\u0069\u006e\u0064\u0020\u0066\u006fn\u0074\u0020\u0066i\u006ce\u0020\u0025\u0073",_gfa );continue ;};_cdbg ,_ffb :=_b .NewPdfFontFromTTFFile (_fef .Filename );
if _ffb !=nil {return _ffb ;};_gea :=_cdbg .FontDescriptor ();if _gea .FontFile !=nil {if _ ,_bcda =_abe [_gea .FontFile ];!_bcda {_bged .Objects =append (_bged .Objects ,_gea .FontFile );_abe [_gea .FontFile ]=struct{}{};};};if _gea .FontFile2 !=nil {if _ ,_bcda =_abe [_gea .FontFile2 ];
!_bcda {_bged .Objects =append (_bged .Objects ,_gea .FontFile2 );_abe [_gea .FontFile2 ]=struct{}{};};};if _gea .FontFile3 !=nil {if _ ,_bcda =_abe [_gea .FontFile3 ];!_bcda {_bged .Objects =append (_bged .Objects ,_gea .FontFile3 );_abe [_gea .FontFile3 ]=struct{}{};
};};_egc ,_eeg :=_cdbg .ToPdfObject ().(*_gd .PdfIndirectObject );if !_eeg {_ae .Log .Debug ("\u0066\u006f\u006e\u0074\u0020\u0069\u0073\u0020\u006e\u006ft\u0020\u0061\u006e\u0020\u0069\u006e\u0064i\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0065\u0063\u0074");
continue ;};_efg ,_eeg :=_egc .PdfObject .(*_gd .PdfObjectDictionary );if !_eeg {_ae .Log .Debug ("\u0046\u006fn\u0074\u0020\u0074\u0079p\u0065\u0020i\u0073\u0020\u006e\u006f\u0074\u0020\u0061\u006e \u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079");
continue ;};_baf [_gfa ]=_efg ;_afa =_efg ;break ;};if _afa ==nil {_ae .Log .Debug ("\u004e\u006f\u0020\u006d\u0061\u0074\u0063\u0068\u0069\u006eg\u0020\u0066\u006f\u006e\u0074\u0020\u0066o\u0075\u006e\u0064\u0020\u0066\u006f\u0072\u003a\u0020\u0025\u0073",_cbg .BaseFont ());
return _age .New ("\u006e\u006f m\u0061\u0074\u0063h\u0069\u006e\u0067\u0020fon\u0074 f\u006f\u0075\u006e\u0064\u0020\u0069\u006e t\u0068\u0065\u0020\u0073\u0079\u0073\u0074e\u006d");};};for _ ,_gfe :=range _afa .Keys (){_dcf .Set (_gfe ,_afa .Get (_gfe ));
};_bacb :=_afa .Get ("\u0057\u0069\u0064\u0074\u0068\u0073");if _bacb !=nil {if _ ,_bcda =_abe [_bacb ];!_bcda {_bged .Objects =append (_bged .Objects ,_bacb );_abe [_bacb ]=struct{}{};};};_fcc [_geeg ]=struct{}{};_gab :=_dcf .Get ("\u0046\u006f\u006e\u0074\u0044\u0065\u0073\u0063\u0072i\u0070\u0074\u006f\u0072");
if _gab !=nil {_bged .Objects =append (_bged .Objects ,_gab );_abe [_gab ]=struct{}{};};};return nil ;};func _agdf (_aaagb *_gd .PdfObjectDictionary ,_acdfa map[*_gd .PdfObjectStream ][]byte ,_cegg map[*_gd .PdfObjectStream ]*_ecd .CMap )ViolatedRule {const (_deefg ="\u0036\u002e\u0032\u002e\u0031\u0031\u002e\u0033\u002d\u0033";
_egbfbg ="\u0041\u006c\u006c \u0043\u004d\u0061\u0070s\u0020\u0075\u0073ed\u0020\u0077\u0069\u0074\u0068i\u006e\u0020\u0061\u0020\u0050\u0044\u0046\u002f\u0041\u002d\u0032\u0020\u0066\u0069\u006c\u0065\u002c\u0020\u0065\u0078\u0063\u0065\u0070\u0074 th\u006f\u0073\u0065\u0020\u006ci\u0073\u0074\u0065\u0064\u0020i\u006e\u0020\u0049\u0053\u004f\u0020\u0033\u00320\u00300\u002d1\u003a\u0032\u0030\u0030\u0038\u002c\u0020\u0039\u002e\u0037\u002e\u0035\u002e\u0032\u002c\u0020\u0054\u0061\u0062\u006c\u0065 \u0031\u00318,\u0020\u0073h\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065\u0064\u0020\u0069\u006e \u0074\u0068\u0061\u0074\u0020\u0066\u0069\u006c\u0065\u0020\u0061\u0073\u0020\u0064e\u0073\u0063\u0072\u0069\u0062\u0065\u0064\u0020\u0069\u006e\u0020\u0049\u0053\u004f\u0020\u0033\u0032\u00300\u0030-\u0031\u003a\u0032\u0030\u0030\u0038\u002c\u00209\u002e\u0037\u002e\u0035\u002e";
);var _bdcgd string ;if _fgeb ,_fafg :=_gd .GetName (_aaagb .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_fafg {_bdcgd =_fgeb .String ();};if _bdcgd !="\u0054\u0079\u0070e\u0030"{return _fc ;};_bggg :=_aaagb .Get ("\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067");
if _dcgffe ,_ggec :=_gd .GetName (_bggg );_ggec {switch _dcgffe .String (){case "\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0048","\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0056":return _fc ;default:return _ab (_deefg ,_egbfbg );
};};_dafe ,_cgba :=_gd .GetStream (_bggg );if !_cgba {return _ab (_deefg ,_egbfbg );};_ ,_dbgac :=_eaccc (_dafe ,_acdfa ,_cegg );if _dbgac !=nil {return _ab (_deefg ,_egbfbg );};return _fc ;};func _aedg (_decec *_b .CompliancePdfReader )ViolatedRule {_babe :=map[*_gd .PdfObjectStream ]struct{}{};
for _ ,_abdfe :=range _decec .PageList {if _abdfe .Resources ==nil &&_abdfe .Contents ==nil {continue ;};if _ffdg :=_abdfe .GetPageDict ();_ffdg !=nil {_dfbcg ,_cbfa :=_gd .GetDict (_ffdg .Get ("\u0047\u0072\u006fu\u0070"));if _cbfa {if _caebd :=_dfbcg .Get ("\u0053");
_caebd !=nil {_cecbf ,_eeae :=_gd .GetName (_caebd );if _eeae &&_cecbf .String ()=="\u0054\u0072\u0061n\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079"{return _ab ("\u0036\u002e\u0034-\u0033","\u0041\u0020\u0047\u0072\u006f\u0075\u0070\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u006e\u0020\u0053\u0020\u0078Ob\u006a\u0065c\u0074\u0020\u0077\u0069\u0074h\u0020\u0061\u0020\u0076a\u006c\u0075\u0065\u0020o\u0066\u0020\u0054\u0072\u0061\u006e\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079 \u0073\u0068\u0061\u006c\u006c\u0020\u006eo\u0074\u0020\u0062\u0065\u0020i\u006e\u0063\u006c\u0075\u0064\u0065\u0064\u0020\u0069\u006e\u0020\u0061\u0020\u0066\u006f\u0072\u006d\u0020\u0058\u004f\u0062je\u0063\u0074\u002e\n\u0041 \u0047\u0072\u006f\u0075p\u0020\u006f\u0062j\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u006e\u0020S\u0020\u0078\u004fb\u006a\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u0020v\u0061\u006c\u0075\u0065\u0020o\u0066\u0020\u0054\u0072\u0061n\u0073\u0070\u0061\u0072\u0065\u006ec\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020i\u006e\u0063\u006c\u0075\u0064e\u0064\u0020\u0069\u006e\u0020\u0061\u0020\u0070\u0061\u0067\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002e");
};};};};if _abdfe .Resources !=nil {if _afde ,_gcbb :=_gd .GetDict (_abdfe .Resources .XObject );_gcbb {for _ ,_dcgff :=range _afde .Keys (){_ggeb ,_cgae :=_gd .GetStream (_afde .Get (_dcgff ));if !_cgae {continue ;};if _ ,_fgbac :=_babe [_ggeb ];_fgbac {continue ;
};_dbcd ,_cgae :=_gd .GetDict (_ggeb .Get ("\u0047\u0072\u006fu\u0070"));if !_cgae {_babe [_ggeb ]=struct{}{};continue ;};_fcef :=_dbcd .Get ("\u0053");if _fcef !=nil {_dafa ,_aefa :=_gd .GetName (_fcef );if _aefa &&_dafa .String ()=="\u0054\u0072\u0061n\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079"{return _ab ("\u0036\u002e\u0034-\u0033","\u0041\u0020\u0047\u0072\u006f\u0075\u0070\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u006e\u0020\u0053\u0020\u0078Ob\u006a\u0065c\u0074\u0020\u0077\u0069\u0074h\u0020\u0061\u0020\u0076a\u006c\u0075\u0065\u0020o\u0066\u0020\u0054\u0072\u0061\u006e\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079 \u0073\u0068\u0061\u006c\u006c\u0020\u006eo\u0074\u0020\u0062\u0065\u0020i\u006e\u0063\u006c\u0075\u0064\u0065\u0064\u0020\u0069\u006e\u0020\u0061\u0020\u0066\u006f\u0072\u006d\u0020\u0058\u004f\u0062je\u0063\u0074\u002e\n\u0041 \u0047\u0072\u006f\u0075p\u0020\u006f\u0062j\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u006e\u0020S\u0020\u0078\u004fb\u006a\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u0020v\u0061\u006c\u0075\u0065\u0020o\u0066\u0020\u0054\u0072\u0061n\u0073\u0070\u0061\u0072\u0065\u006ec\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020i\u006e\u0063\u006c\u0075\u0064e\u0064\u0020\u0069\u006e\u0020\u0061\u0020\u0070\u0061\u0067\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002e");
};};_babe [_ggeb ]=struct{}{};continue ;};};};if _abdfe .Contents !=nil {_aegg ,_fafc :=_abdfe .GetContentStreams ();if _fafc !=nil {continue ;};for _ ,_efadd :=range _aegg {_ceafb ,_deeec :=_dc .NewContentStreamParser (_efadd ).Parse ();if _deeec !=nil {continue ;
};for _ ,_fgcge :=range *_ceafb {if len (_fgcge .Params )==0{continue ;};_efbad ,_ddbde :=_gd .GetName (_fgcge .Params [0]);if !_ddbde {continue ;};_ggad ,_ffgc :=_abdfe .Resources .GetXObjectByName (*_efbad );if _ffgc !=_b .XObjectTypeForm {continue ;
};if _ ,_febaf :=_babe [_ggad ];_febaf {continue ;};_gacg ,_ddbde :=_gd .GetDict (_ggad .Get ("\u0047\u0072\u006fu\u0070"));if !_ddbde {_babe [_ggad ]=struct{}{};continue ;};_aacc :=_gacg .Get ("\u0053");if _aacc !=nil {_fafca ,_gaae :=_gd .GetName (_aacc );
if _gaae &&_fafca .String ()=="\u0054\u0072\u0061n\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079"{return _ab ("\u0036\u002e\u0034-\u0033","\u0041\u0020\u0047\u0072\u006f\u0075\u0070\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u006e\u0020\u0053\u0020\u0078Ob\u006a\u0065c\u0074\u0020\u0077\u0069\u0074h\u0020\u0061\u0020\u0076a\u006c\u0075\u0065\u0020o\u0066\u0020\u0054\u0072\u0061\u006e\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079 \u0073\u0068\u0061\u006c\u006c\u0020\u006eo\u0074\u0020\u0062\u0065\u0020i\u006e\u0063\u006c\u0075\u0064\u0065\u0064\u0020\u0069\u006e\u0020\u0061\u0020\u0066\u006f\u0072\u006d\u0020\u0058\u004f\u0062je\u0063\u0074\u002e\n\u0041 \u0047\u0072\u006f\u0075p\u0020\u006f\u0062j\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u006e\u0020S\u0020\u0078\u004fb\u006a\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u0020v\u0061\u006c\u0075\u0065\u0020o\u0066\u0020\u0054\u0072\u0061n\u0073\u0070\u0061\u0072\u0065\u006ec\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020i\u006e\u0063\u006c\u0075\u0064e\u0064\u0020\u0069\u006e\u0020\u0061\u0020\u0070\u0061\u0067\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002e");
};};_babe [_ggad ]=struct{}{};};};};};return _fc ;};

// NewProfile1A creates a new Profile1A with given options.
func NewProfile1A (options *Profile1Options )*Profile1A {if options ==nil {options =DefaultProfile1Options ();};_dfdd (options );return &Profile1A {profile1 {_cgfb :*options ,_gaeg :_dba ()}};};func _bge ()standardType {return standardType {_gb :2,_dcd :"\u0041"}};
func _aecc (_ebac *_b .CompliancePdfReader )(_bccfg []ViolatedRule ){var _abfcd ,_gdcg ,_efec ,_fdac ,_fgagc ,_abagg ,_gdae bool ;_egcgf :=map[*_gd .PdfObjectStream ]struct{}{};for _ ,_eacfe :=range _ebac .GetObjectNums (){if _abfcd &&_gdcg &&_fgagc &&_efec &&_fdac &&_abagg &&_gdae {return _bccfg ;
};_babec ,_afge :=_ebac .GetIndirectObjectByNumber (_eacfe );if _afge !=nil {continue ;};_fbcf ,_abdea :=_gd .GetStream (_babec );if !_abdea {continue ;};if _ ,_abdea =_egcgf [_fbcf ];_abdea {continue ;};_egcgf [_fbcf ]=struct{}{};_edfcb ,_abdea :=_gd .GetName (_fbcf .Get ("\u0053u\u0062\u0054\u0079\u0070\u0065"));
if !_abdea {continue ;};if !_fdac {if _fbcf .Get ("\u0052\u0065\u0066")!=nil {_bccfg =append (_bccfg ,_ab ("\u0036.\u0032\u002e\u0039\u002d\u0032","\u0041\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068a\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u006e\u0079\u0020\u0072\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0058O\u0062\u006a\u0065\u0063\u0074s\u002e"));
_fdac =true ;};};if _edfcb .String ()=="\u0050\u0053"{if !_abagg {_bccfg =append (_bccfg ,_ab ("\u0036.\u0032\u002e\u0039\u002d\u0033","A \u0063\u006fn\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066i\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u006e\u0079\u0020\u0050\u006f\u0073t\u0053c\u0072\u0069\u0070\u0074\u0020\u0058\u004f\u0062j\u0065c\u0074\u0073."));
_abagg =true ;continue ;};};if _edfcb .String ()=="\u0046\u006f\u0072\u006d"{if _gdcg &&_efec &&_fdac {continue ;};if !_gdcg &&_fbcf .Get ("\u004f\u0050\u0049")!=nil {_bccfg =append (_bccfg ,_ab ("\u0036.\u0032\u002e\u0039\u002d\u0031","\u0041\u0020\u0066\u006f\u0072\u006d \u0058\u004f\u0062j\u0065\u0063\u0074 \u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079 \u0073\u0068\u0061\u006c\u006c n\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u004f\u0050\u0049\u0020\u006b\u0065\u0079\u002e"));
_gdcg =true ;};if !_efec {if _fbcf .Get ("\u0050\u0053")!=nil {_efec =true ;};if _ddgg :=_fbcf .Get ("\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0032");_ddgg !=nil &&!_efec {if _gffa ,_cdabe :=_gd .GetName (_ddgg );_cdabe &&*_gffa =="\u0050\u0053"{_efec =true ;
};};if _efec {_bccfg =append (_bccfg ,_ab ("\u0036.\u0032\u002e\u0039\u002d\u0031","\u0041\u0020\u0066\u006f\u0072\u006d\u0020\u0058\u004f\u0062\u006a\u0065\u0063\u0074\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006eo\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0032\u0020\u006b\u0065y \u0077\u0069\u0074\u0068\u0020\u0061\u0020\u0076\u0061\u006cu\u0065 o\u0066 \u0050\u0053\u0020\u0061\u006e\u0064\u0020t\u0068\u0065\u0020\u0050\u0053\u0020\u006b\u0065\u0079\u002e"));
};};continue ;};if _edfcb .String ()!="\u0049\u006d\u0061g\u0065"{continue ;};if !_abfcd &&_fbcf .Get ("\u0041\u006c\u0074\u0065\u0072\u006e\u0061\u0074\u0065\u0073")!=nil {_bccfg =append (_bccfg ,_ab ("\u0036.\u0032\u002e\u0038\u002d\u0031","\u0041\u006e\u0020\u0049m\u0061\u0067\u0065\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006et\u0061\u0069\u006e\u0020\u0074h\u0065\u0020\u0041\u006c\u0074\u0065\u0072\u006e\u0061\u0074\u0065\u0073\u0020\u006b\u0065\u0079\u002e"));
_abfcd =true ;};if !_gdae &&_fbcf .Get ("\u004f\u0050\u0049")!=nil {_bccfg =append (_bccfg ,_ab ("\u0036.\u0032\u002e\u0038\u002d\u0032","\u0041\u006e\u0020\u0049\u006d\u0061\u0067\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072y\u0020\u0073\u0068\u0061\u006c\u006c\u0020n\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020t\u0068\u0065\u0020\u004f\u0050\u0049\u0020\u006b\u0065\u0079\u002e"));
_gdae =true ;};if !_fgagc &&_fbcf .Get ("I\u006e\u0074\u0065\u0072\u0070\u006f\u006c\u0061\u0074\u0065")!=nil {_gdfc ,_fabcf :=_gd .GetBool (_fbcf .Get ("I\u006e\u0074\u0065\u0072\u0070\u006f\u006c\u0061\u0074\u0065"));if _fabcf &&bool (*_gdfc ){continue ;
};_bccfg =append (_bccfg ,_ab ("\u0036.\u0032\u002e\u0038\u002d\u0033","\u0049\u0066 a\u006e\u0020\u0049\u006d\u0061\u0067\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0063o\u006e\u0074\u0061\u0069n\u0073\u0020\u0074\u0068e \u0049\u006et\u0065r\u0070\u006f\u006c\u0061\u0074\u0065 \u006b\u0065\u0079,\u0020\u0069t\u0073\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020b\u0065\u0020\u0066\u0061\u006c\u0073\u0065\u002e"));
_fgagc =true ;};};return _bccfg ;};

// ApplyStandard tries to change the content of the writer to match the PDF/A-2 standard.
// Implements model.StandardApplier.
func (_cbeb *profile2 )ApplyStandard (document *_da .Document )(_dagcf error ){_afc (document ,7);if _dagcf =_cdgea (document ,_cbeb ._cfg .Now );_dagcf !=nil {return _dagcf ;};if _dagcf =_ecdg (document );_dagcf !=nil {return _dagcf ;};_acbb ,_dddg :=_dbf (_cbeb ._cfg .CMYKDefaultColorSpace ,_cbeb ._efbd );
_dagcf =_gag (document ,[]pageColorspaceOptimizeFunc {_acbb },[]documentColorspaceOptimizeFunc {_dddg });if _dagcf !=nil {return _dagcf ;};_beef (document );if _dagcf =_acfd (document );_dagcf !=nil {return _dagcf ;};if _dagcf =_cdgfg (document ,_cbeb ._efbd ._gb );
_dagcf !=nil {return _dagcf ;};if _dagcf =_bdeb (document );_dagcf !=nil {return _dagcf ;};if _dagcf =_fgg (document );_dagcf !=nil {return _dagcf ;};if _dagcf =_cae (document );_dagcf !=nil {return _dagcf ;};if _dagcf =_adb (document );_dagcf !=nil {return _dagcf ;
};if _cbeb ._efbd ._dcd =="\u0041"{_edfc (document );};if _dagcf =_efgb (document ,_cbeb ._efbd ._gb );_dagcf !=nil {return _dagcf ;};if _dagcf =_eecg (document );_dagcf !=nil {return _dagcf ;};if _cafc :=_edbc (document ,_cbeb ._efbd ,_cbeb ._cfg .Xmp );
_cafc !=nil {return _cafc ;};if _cbeb ._efbd ==_bge (){if _dagcf =_edb (document );_dagcf !=nil {return _dagcf ;};};if _dagcf =_aaff (document );_dagcf !=nil {return _dagcf ;};if _dagcf =_dbef (document );_dagcf !=nil {return _dagcf ;};if _dagcf =_ceeb (document );
_dagcf !=nil {return _dagcf ;};return nil ;};func (_bgff *documentImages )hasOnlyDeviceCMYK ()bool {return _bgff ._ff &&!_bgff ._ce &&!_bgff ._ad };

// XmpOptions are the options used by the optimization of the XMP metadata.
type XmpOptions struct{

// Copyright information.
Copyright string ;

// OriginalDocumentID is the original document identifier.
// By default, if this field is empty the value is extracted from the XMP Metadata or generated UUID.
OriginalDocumentID string ;

// DocumentID is the original document identifier.
// By default, if this field is empty the value is extracted from the XMP Metadata or generated UUID.
DocumentID string ;

// InstanceID is the original document identifier.
// By default, if this field is empty the value is set to generated UUID.
InstanceID string ;

// NewDocumentVersion is a flag that defines if a document was overwritten.
// If the new document was created this should be true. On changing given document file, and overwriting it it should be true.
NewDocumentVersion bool ;

// MarshalIndent defines marshaling indent of the XMP metadata.
MarshalIndent string ;

// MarshalPrefix defines marshaling prefix of the XMP metadata.
MarshalPrefix string ;};func _aegb (_bbfb *_b .CompliancePdfReader )ViolatedRule {if _bbfb .ParserMetadata ().HeaderPosition ()!=0{return _ab ("\u0036.\u0031\u002e\u0032\u002d\u0031","h\u0065\u0061\u0064\u0065\u0072\u0020\u0070\u006f\u0073\u0069\u0074\u0069\u006f\u006e\u0020\u0069\u0073\u0020n\u006f\u0074\u0020\u0061\u0074\u0020\u0074\u0068\u0065\u0020fi\u0072\u0073\u0074 \u0062y\u0074\u0065");
};if _bbfb .PdfVersion ().Major !=1{return _ab ("\u0036.\u0031\u002e\u0032\u002d\u0031","\u0054\u0068\u0065\u0020\u0066\u0069l\u0065\u0020\u0068\u0065\u0061\u0064e\u0072 \u0073\u0068\u0061\u006c\u006c\u0020c\u006f\u006e\u0073\u0069s\u0074 \u006f\u0066\u0020\u201c%\u0050\u0044\u0046\u002d\u0031\u002e\u006e\u201d\u0020\u0066\u006f\u006c\u006c\u006f\u0077\u0065\u0064\u0020\u0062\u0079\u0020\u0061\u0020\u0073\u0069\u006e\u0067\u006c\u0065 \u0045\u004f\u004c\u0020ma\u0072\u006b\u0065\u0072\u002c \u0077\u0068\u0065\u0072\u0065\u0020\u0027\u006e\u0027\u0020\u0069s\u0020\u0061\u0020\u0073\u0069\u006e\u0067\u006c\u0065\u0020\u0064\u0069\u0067\u0069t\u0020\u006e\u0075\u006d\u0062e\u0072\u0020\u0062\u0065\u0074\u0077\u0065\u0065\u006e\u0020\u0030\u0020(\u0033\u0030h\u0029\u0020\u0061\u006e\u0064\u0020\u0037\u0020\u0028\u0033\u0037\u0068\u0029");
};if _bbfb .PdfVersion ().Minor < 0||_bbfb .PdfVersion ().Minor > 7{return _ab ("\u0036.\u0031\u002e\u0032\u002d\u0031","\u0054\u0068\u0065\u0020\u0066\u0069l\u0065\u0020\u0068\u0065\u0061\u0064e\u0072 \u0073\u0068\u0061\u006c\u006c\u0020c\u006f\u006e\u0073\u0069s\u0074 \u006f\u0066\u0020\u201c%\u0050\u0044\u0046\u002d\u0031\u002e\u006e\u201d\u0020\u0066\u006f\u006c\u006c\u006f\u0077\u0065\u0064\u0020\u0062\u0079\u0020\u0061\u0020\u0073\u0069\u006e\u0067\u006c\u0065 \u0045\u004f\u004c\u0020ma\u0072\u006b\u0065\u0072\u002c \u0077\u0068\u0065\u0072\u0065\u0020\u0027\u006e\u0027\u0020\u0069s\u0020\u0061\u0020\u0073\u0069\u006e\u0067\u006c\u0065\u0020\u0064\u0069\u0067\u0069t\u0020\u006e\u0075\u006d\u0062e\u0072\u0020\u0062\u0065\u0074\u0077\u0065\u0065\u006e\u0020\u0030\u0020(\u0033\u0030h\u0029\u0020\u0061\u006e\u0064\u0020\u0037\u0020\u0028\u0033\u0037\u0068\u0029");
};return _fc ;};func _fbgcd (_gfgfd *_b .CompliancePdfReader ,_bffg standardType )(_aecbg []ViolatedRule ){var _abead ,_efbgf ,_gcca ,_gageda ,_gfcc ,_bbacd ,_bdgea bool ;_efcad :=func ()bool {return _abead &&_efbgf &&_gcca &&_gageda &&_gfcc &&_bbacd &&_bdgea };
_ecgdg :=map[*_gd .PdfObjectStream ]*_ecd .CMap {};_bgedf :=map[*_gd .PdfObjectStream ][]byte {};_bcgbg :=map[_gd .PdfObject ]*_b .PdfFont {};for _ ,_cdbfa :=range _gfgfd .GetObjectNums (){_dbfd ,_gfedb :=_gfgfd .GetIndirectObjectByNumber (_cdbfa );if _gfedb !=nil {continue ;
};_eadd ,_gfaa :=_gd .GetDict (_dbfd );if !_gfaa {continue ;};_dgbdf ,_gfaa :=_gd .GetName (_eadd .Get ("\u0054\u0079\u0070\u0065"));if !_gfaa {continue ;};if *_dgbdf !="\u0046\u006f\u006e\u0074"{continue ;};_edfe ,_gfedb :=_b .NewPdfFontFromPdfObject (_eadd );
if _gfedb !=nil {_ae .Log .Debug ("g\u0065\u0074\u0074\u0069\u006e\u0067 \u0066\u006f\u006e\u0074\u0020\u0066r\u006f\u006d\u0020\u006f\u0062\u006a\u0065c\u0074\u0020\u0066\u0061\u0069\u006c\u0065\u0064\u003a\u0020%\u0076",_gfedb );continue ;};_bcgbg [_eadd ]=_edfe ;
};for _ ,_ebbag :=range _gfgfd .PageList {_egea ,_ecfce :=_ebbag .GetContentStreams ();if _ecfce !=nil {_ae .Log .Debug ("G\u0065\u0074\u0074\u0069\u006e\u0067 \u0070\u0061\u0067\u0065\u0020\u0063o\u006e\u0074\u0065\u006e\u0074\u0020\u0073t\u0072\u0065\u0061\u006d\u0073\u0020\u0066\u0061\u0069\u006ce\u0064");
continue ;};for _ ,_cbfdd :=range _egea {_gaca :=_dc .NewContentStreamParser (_cbfdd );_cfffg ,_feca :=_gaca .Parse ();if _feca !=nil {_ae .Log .Debug ("\u0070\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u0063\u006f\u006e\u0074\u0065\u006e\u0074s\u0074r\u0065\u0061\u006d\u0020\u0066\u0061\u0069\u006c\u0065\u0064\u003a\u0020\u0025\u0076",_feca );
continue ;};var _ddfb bool ;for _ ,_efgeb :=range *_cfffg {if _efgeb .Operand !="\u0054\u0072"{continue ;};if len (_efgeb .Params )!=1{_ae .Log .Debug ("\u0069\u006e\u0076\u0061\u006ci\u0064\u0020\u006e\u0075\u006d\u0062\u0065r\u0020\u006f\u0066\u0020\u0070\u0061\u0072\u0061\u006d\u0065\u0074\u0065\u0072\u0073\u0020\u0066\u006f\u0072\u0020\u0074\u0068\u0065\u0020\u0027\u0054\u0072\u0027\u0020\u006f\u0070\u0065\u0072\u0061\u006e\u0064\u002c\u0020\u0065\u0078\u0070e\u0063\u0074\u0065\u0064\u0020\u0027\u0031\u0027\u0020\u0062\u0075\u0074 \u0069\u0073\u003a\u0020\u0027\u0025d\u0027",len (_efgeb .Params ));
continue ;};_cfbf ,_cdged :=_gd .GetIntVal (_efgeb .Params [0]);if !_cdged {_ae .Log .Debug ("\u0072\u0065\u006e\u0064\u0065\u0072\u0069\u006e\u0067\u0020\u006d\u006f\u0064\u0065\u0020i\u0073 \u006e\u006f\u0074\u0020\u0061\u006e\u0020\u0069\u006e\u0074\u0065\u0067\u0065\u0072");
continue ;};if _cfbf ==3{_ddfb =true ;break ;};};for _ ,_abfa :=range *_cfffg {if _abfa .Operand !="\u0054\u0066"{continue ;};if len (_abfa .Params )!=2{_ae .Log .Debug ("i\u006eva\u006ci\u0064 \u006e\u0075\u006d\u0062\u0065r\u0020\u006f\u0066 \u0070\u0061\u0072\u0061\u006de\u0074\u0065\u0072s\u0020\u0066\u006f\u0072\u0020\u0074\u0068\u0065\u0020\u0027\u0054f\u0027\u0020\u006fper\u0061\u006e\u0064\u002c\u0020\u0065x\u0070\u0065\u0063\u0074\u0065\u0064\u0020\u0027\u0032\u0027\u0020\u0069s\u003a \u0027\u0025\u0064\u0027",len (_abfa .Params ));
continue ;};_fagac ,_ebfd :=_gd .GetName (_abfa .Params [0]);if !_ebfd {_ae .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a \u0054\u0066\u0020\u006f\u0070\u003d\u0025\u0073\u0020\u0047\u0065\u0074\u004ea\u006d\u0065\u0056\u0061\u006c\u0020\u0066a\u0069\u006c\u0065\u0064",_abfa );
continue ;};_bgcg ,_gdbg :=_ebbag .Resources .GetFontByName (*_fagac );if !_gdbg {_ae .Log .Debug ("\u0066\u006f\u006e\u0074\u0020\u006e\u006f\u0074\u0020f\u006f\u0075\u006e\u0064");continue ;};_fbbd ,_ebfd :=_gd .GetDict (_bgcg );if !_ebfd {_ae .Log .Debug ("\u0066\u006f\u006e\u0074 d\u0069\u0063\u0074\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075\u006e\u0064");
continue ;};_efdd ,_ebfd :=_bcgbg [_fbbd ];if !_ebfd {var _baggc error ;_efdd ,_baggc =_b .NewPdfFontFromPdfObject (_fbbd );if _baggc !=nil {_ae .Log .Debug ("\u0067\u0065\u0074\u0074i\u006e\u0067\u0020\u0066\u006f\u006e\u0074\u0020\u0066\u0072o\u006d \u006f\u0062\u006a\u0065\u0063\u0074\u003a \u0025\u0076",_baggc );
continue ;};_bcgbg [_fbbd ]=_efdd ;};if !_abead {_adbda :=_daabd (_fbbd ,_bgedf ,_ecgdg );if _adbda !=_fc {_aecbg =append (_aecbg ,_adbda );_abead =true ;if _efcad (){return _aecbg ;};};};if !_efbgf {_gfgg :=_gdde (_fbbd );if _gfgg !=_fc {_aecbg =append (_aecbg ,_gfgg );
_efbgf =true ;if _efcad (){return _aecbg ;};};};if !_gcca {_fcade :=_agdf (_fbbd ,_bgedf ,_ecgdg );if _fcade !=_fc {_aecbg =append (_aecbg ,_fcade );_gcca =true ;if _efcad (){return _aecbg ;};};};if !_gageda {_cgfbf :=_gfedg (_fbbd ,_bgedf ,_ecgdg );if _cgfbf !=_fc {_aecbg =append (_aecbg ,_cgfbf );
_gageda =true ;if _efcad (){return _aecbg ;};};};if !_gfcc {_cefed :=_ggba (_efdd ,_fbbd ,_ddfb );if _cefed !=_fc {_gfcc =true ;_aecbg =append (_aecbg ,_cefed );if _efcad (){return _aecbg ;};};};if !_bbacd {_abae :=_dgedb (_efdd ,_fbbd );if _abae !=_fc {_bbacd =true ;
_aecbg =append (_aecbg ,_abae );if _efcad (){return _aecbg ;};};};if !_bdgea &&(_bffg ._dcd =="\u0041"||_bffg ._dcd =="\u0055"){_ebgc :=_aacfe (_fbbd ,_bgedf ,_ecgdg );if _ebgc !=_fc {_bdgea =true ;_aecbg =append (_aecbg ,_ebgc );if _efcad (){return _aecbg ;
};};};};};};return _aecbg ;};func _gegfg (_dcgb *_b .CompliancePdfReader ,_bgae standardType )(_agaf []ViolatedRule ){var _ccca ,_dfgb ,_begb ,_egeg ,_cdbf ,_agaac ,_gbbg ,_ccfe ,_dgdc ,_dgfe ,_adc bool ;_eabd :=func ()bool {return _ccca &&_dfgb &&_begb &&_egeg &&_cdbf &&_agaac &&_gbbg &&_ccfe &&_dgdc &&_dgfe &&_adc ;
};_aegf :=map[*_gd .PdfObjectStream ]*_ecd .CMap {};_aaeac :=map[*_gd .PdfObjectStream ][]byte {};_egddb :=map[_gd .PdfObject ]*_b .PdfFont {};for _ ,_cdggd :=range _dcgb .GetObjectNums (){_bdcg ,_bbcfe :=_dcgb .GetIndirectObjectByNumber (_cdggd );if _bbcfe !=nil {continue ;
};_cgbg ,_gcbf :=_gd .GetDict (_bdcg );if !_gcbf {continue ;};_gbfc ,_gcbf :=_gd .GetName (_cgbg .Get ("\u0054\u0079\u0070\u0065"));if !_gcbf {continue ;};if *_gbfc !="\u0046\u006f\u006e\u0074"{continue ;};_adaf ,_bbcfe :=_b .NewPdfFontFromPdfObject (_cgbg );
if _bbcfe !=nil {_ae .Log .Debug ("g\u0065\u0074\u0074\u0069\u006e\u0067 \u0066\u006f\u006e\u0074\u0020\u0066r\u006f\u006d\u0020\u006f\u0062\u006a\u0065c\u0074\u0020\u0066\u0061\u0069\u006c\u0065\u0064\u003a\u0020%\u0076",_bbcfe );continue ;};_egddb [_cgbg ]=_adaf ;
};for _ ,_dbbdg :=range _dcgb .PageList {_ebgd ,_fceg :=_dbbdg .GetContentStreams ();if _fceg !=nil {_ae .Log .Debug ("G\u0065\u0074\u0074\u0069\u006e\u0067 \u0070\u0061\u0067\u0065\u0020\u0063o\u006e\u0074\u0065\u006e\u0074\u0020\u0073t\u0072\u0065\u0061\u006d\u0073\u0020\u0066\u0061\u0069\u006ce\u0064");
continue ;};for _ ,_cfba :=range _ebgd {_egbb :=_dc .NewContentStreamParser (_cfba );_agfc ,_dafg :=_egbb .Parse ();if _dafg !=nil {_ae .Log .Debug ("\u0070\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u0063\u006f\u006e\u0074\u0065\u006e\u0074s\u0074r\u0065\u0061\u006d\u0020\u0066\u0061\u0069\u006c\u0065\u0064\u003a\u0020\u0025\u0076",_dafg );
continue ;};var _cgea bool ;for _ ,_gdecc :=range *_agfc {if _gdecc .Operand !="\u0054\u0072"{continue ;};if len (_gdecc .Params )!=1{_ae .Log .Debug ("\u0069\u006e\u0076\u0061\u006ci\u0064\u0020\u006e\u0075\u006d\u0062\u0065r\u0020\u006f\u0066\u0020\u0070\u0061\u0072\u0061\u006d\u0065\u0074\u0065\u0072\u0073\u0020\u0066\u006f\u0072\u0020\u0074\u0068\u0065\u0020\u0027\u0054\u0072\u0027\u0020\u006f\u0070\u0065\u0072\u0061\u006e\u0064\u002c\u0020\u0065\u0078\u0070e\u0063\u0074\u0065\u0064\u0020\u0027\u0031\u0027\u0020\u0062\u0075\u0074 \u0069\u0073\u003a\u0020\u0027\u0025d\u0027",len (_gdecc .Params ));
continue ;};_gfcfb ,_cebc :=_gd .GetIntVal (_gdecc .Params [0]);if !_cebc {_ae .Log .Debug ("\u0072\u0065\u006e\u0064\u0065\u0072\u0069\u006e\u0067\u0020\u006d\u006f\u0064\u0065\u0020i\u0073 \u006e\u006f\u0074\u0020\u0061\u006e\u0020\u0069\u006e\u0074\u0065\u0067\u0065\u0072");
continue ;};if _gfcfb ==3{_cgea =true ;break ;};};for _ ,_cebcf :=range *_agfc {if _cebcf .Operand !="\u0054\u0066"{continue ;};if len (_cebcf .Params )!=2{_ae .Log .Debug ("i\u006eva\u006ci\u0064 \u006e\u0075\u006d\u0062\u0065r\u0020\u006f\u0066 \u0070\u0061\u0072\u0061\u006de\u0074\u0065\u0072s\u0020\u0066\u006f\u0072\u0020\u0074\u0068\u0065\u0020\u0027\u0054f\u0027\u0020\u006fper\u0061\u006e\u0064\u002c\u0020\u0065x\u0070\u0065\u0063\u0074\u0065\u0064\u0020\u0027\u0032\u0027\u0020\u0069s\u003a \u0027\u0025\u0064\u0027",len (_cebcf .Params ));
continue ;};_geaf ,_dfdc :=_gd .GetName (_cebcf .Params [0]);if !_dfdc {_ae .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a \u0054\u0066\u0020\u006f\u0070\u003d\u0025\u0073\u0020\u0047\u0065\u0074\u004ea\u006d\u0065\u0056\u0061\u006c\u0020\u0066a\u0069\u006c\u0065\u0064",_cebcf );
continue ;};_fcae ,_ddbd :=_dbbdg .Resources .GetFontByName (*_geaf );if !_ddbd {_ae .Log .Debug ("\u0066\u006f\u006e\u0074\u0020\u006e\u006f\u0074\u0020f\u006f\u0075\u006e\u0064");continue ;};_ecfdc ,_dfdc :=_gd .GetDict (_fcae );if !_dfdc {_ae .Log .Debug ("\u0066\u006f\u006e\u0074 d\u0069\u0063\u0074\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075\u006e\u0064");
continue ;};_faad ,_dfdc :=_egddb [_ecfdc ];if !_dfdc {var _abfe error ;_faad ,_abfe =_b .NewPdfFontFromPdfObject (_ecfdc );if _abfe !=nil {_ae .Log .Debug ("\u0067\u0065\u0074\u0074i\u006e\u0067\u0020\u0066\u006f\u006e\u0074\u0020\u0066\u0072o\u006d \u006f\u0062\u006a\u0065\u0063\u0074\u003a \u0025\u0076",_abfe );
continue ;};_egddb [_ecfdc ]=_faad ;};if !_ccca {_ccee :=_bgg (_ecfdc ,_aaeac ,_aegf );if _ccee !=_fc {_agaf =append (_agaf ,_ccee );_ccca =true ;if _eabd (){return _agaf ;};};};if !_dfgb {_efaf :=_ddbg (_ecfdc );if _efaf !=_fc {_agaf =append (_agaf ,_efaf );
_dfgb =true ;if _eabd (){return _agaf ;};};};if !_begb {_abde :=_aaaf (_ecfdc ,_aaeac ,_aegf );if _abde !=_fc {_agaf =append (_agaf ,_abde );_begb =true ;if _eabd (){return _agaf ;};};};if !_egeg {_gbgg :=_cgbbf (_ecfdc ,_aaeac ,_aegf );if _gbgg !=_fc {_agaf =append (_agaf ,_gbgg );
_egeg =true ;if _eabd (){return _agaf ;};};};if !_cdbf {_agcf :=_acag (_faad ,_ecfdc ,_cgea );if _agcf !=_fc {_cdbf =true ;_agaf =append (_agaf ,_agcf );if _eabd (){return _agaf ;};};};if !_agaac {_cgeae :=_bcac (_faad ,_ecfdc );if _cgeae !=_fc {_agaac =true ;
_agaf =append (_agaf ,_cgeae );if _eabd (){return _agaf ;};};};if !_gbbg {_dcdg :=_aede (_faad ,_ecfdc );if _dcdg !=_fc {_gbbg =true ;_agaf =append (_agaf ,_dcdg );if _eabd (){return _agaf ;};};};if !_ccfe {_ccad :=_edgfc (_faad ,_ecfdc );if _ccad !=_fc {_ccfe =true ;
_agaf =append (_agaf ,_ccad );if _eabd (){return _agaf ;};};};if !_dgdc {_caca :=_ffdf (_faad ,_ecfdc );if _caca !=_fc {_dgdc =true ;_agaf =append (_agaf ,_caca );if _eabd (){return _agaf ;};};};if !_dgfe {_bfbcb :=_efgfc (_faad ,_ecfdc );if _bfbcb !=_fc {_dgfe =true ;
_agaf =append (_agaf ,_bfbcb );if _eabd (){return _agaf ;};};};if !_adc &&_bgae ._dcd =="\u0041"{_ffcac :=_cbeaf (_ecfdc ,_aaeac ,_aegf );if _ffcac !=_fc {_adc =true ;_agaf =append (_agaf ,_ffcac );if _eabd (){return _agaf ;};};};};};};return _agaf ;};
func _ebce (_gggad *_b .CompliancePdfReader )(_ebdb []ViolatedRule ){var _afced ,_fbda ,_bfcec ,_ddea ,_daggg ,_ebacd ,_gcab bool ;_dcaac :=func ()bool {return _afced &&_fbda &&_bfcec &&_ddea &&_daggg &&_ebacd &&_gcab };for _ ,_gdfefc :=range _gggad .PageList {_bgeeb ,_agacc :=_gdfefc .GetAnnotations ();
if _agacc !=nil {_ae .Log .Trace ("\u006c\u006f\u0061\u0064\u0069\u006e\u0067\u0020\u0061\u006en\u006f\u0074\u0061\u0074\u0069\u006f\u006es\u0020\u0066\u0061\u0069\u006c\u0065\u0064\u003a\u0020\u0025\u0076",_agacc );continue ;};for _ ,_afbee :=range _bgeeb {if !_afced {switch _afbee .GetContext ().(type ){case *_b .PdfAnnotationScreen ,*_b .PdfAnnotation3D ,*_b .PdfAnnotationSound ,*_b .PdfAnnotationMovie ,nil :_ebdb =append (_ebdb ,_ab ("\u0036.\u0033\u002e\u0031\u002d\u0031","\u0041nn\u006f\u0074\u0061\u0074i\u006f\u006e t\u0079\u0070\u0065\u0073\u0020\u006e\u006f\u0074\u0020\u0064\u0065f\u0069\u006e\u0065\u0064\u0020i\u006e\u0020\u0050\u0044\u0046\u0020\u0052\u0065\u0066\u0065\u0072e\u006e\u0063\u0065\u0020\u0073\u0068\u0061\u006cl\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0070\u0065r\u006d\u0069t\u0074\u0065\u0064\u002e\u0020\u0041\u0064d\u0069\u0074\u0069\u006f\u006e\u0061\u006c\u006c\u0079\u002c\u0020\u0074\u0068\u0065\u0020\u0033\u0044\u002c\u0020\u0053\u006f\u0075\u006e\u0064\u002c\u0020\u0053\u0063\u0072\u0065\u0065\u006e\u0020\u0061n\u0064\u0020\u004d\u006f\u0076\u0069\u0065\u0020\u0074\u0079\u0070\u0065\u0073\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074\u0065\u0064\u002e"));
_afced =true ;if _dcaac (){return _ebdb ;};};};_cbec ,_dfcag :=_gd .GetDict (_afbee .GetContainingPdfObject ());if !_dfcag {continue ;};_ ,_ecdcf :=_afbee .GetContext ().(*_b .PdfAnnotationPopup );if !_ecdcf &&!_fbda {_ ,_deca :=_gd .GetIntVal (_cbec .Get ("\u0046"));
if !_deca {_ebdb =append (_ebdb ,_ab ("\u0036.\u0033\u002e\u0032\u002d\u0031","\u0045\u0078\u0063\u0065\u0070\u0074\u0020\u0066\u006f\u0072\u0020\u0061\u006e\u006e\u006f\u0074\u0061\u0074\u0069o\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072i\u0065\u0073\u0020\u0077\u0068\u006fs\u0065\u0020\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0020\u0076\u0061l\u0075\u0065\u0020\u0069\u0073\u0020\u0050\u006f\u0070u\u0070\u002c\u0020\u0061\u006c\u006c\u0020\u0061\u006e\u006e\u006f\u0074\u0061\u0074\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0069\u0065\u0073\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0046 \u006b\u0065y."));
_fbda =true ;if _dcaac (){return _ebdb ;};};};if !_bfcec {_eebc ,_gcgd :=_gd .GetIntVal (_cbec .Get ("\u0046"));if _gcgd &&!(_eebc &4==4&&_eebc &1==0&&_eebc &2==0&&_eebc &32==0&&_eebc &256==0){_ebdb =append (_ebdb ,_ab ("\u0036.\u0033\u002e\u0032\u002d\u0032","I\u0066\u0020\u0070\u0072\u0065\u0073\u0065\u006e\u0074\u002c\u0020\u0074\u0068\u0065\u0020\u0046 \u006b\u0065\u0079\u0027\u0073\u0020\u0050\u0072\u0069\u006e\u0074\u0020\u0066\u006c\u0061\u0067\u0020\u0062\u0069\u0074\u0020\u0073\u0068\u0061l\u006c\u0020\u0062\u0065\u0020\u0073\u0065\u0074\u0020\u0074\u006f\u0020\u0031\u0020\u0061\u006e\u0064\u0020\u0069\u0074\u0073\u0020\u0048\u0069\u0064\u0064\u0065\u006e\u002c\u0020\u0049\u006e\u0076\u0069\u0073\u0069\u0062\u006c\u0065\u002c\u0020\u0054\u006f\u0067\u0067\u006c\u0065\u004e\u006f\u0056\u0069\u0065\u0077\u002c\u0020\u0061\u006e\u0064 \u004eo\u0056\u0069\u0065\u0077\u0020\u0066\u006c\u0061\u0067\u0020\u0062\u0069\u0074\u0073\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020s\u0065\u0074\u0020t\u006f\u0020\u0030."));
_bfcec =true ;if _dcaac (){return _ebdb ;};};};_ ,_becaa :=_afbee .GetContext ().(*_b .PdfAnnotationText );if _becaa &&!_ddea {_afda ,_ebcf :=_gd .GetIntVal (_cbec .Get ("\u0046"));if _ebcf &&!(_afda &8==8&&_afda &16==16){_ebdb =append (_ebdb ,_ab ("\u0036.\u0033\u002e\u0032\u002d\u0033","\u0054\u0065\u0078\u0074\u0020a\u006e\u006e\u006f\u0074\u0061t\u0069o\u006e\u0020\u0068\u0061\u0073\u0020\u006f\u006e\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0066\u006ca\u0067\u0073\u0020\u004e\u006f\u005a\u006f\u006f\u006d\u0020\u006f\u0072\u0020\u004e\u006f\u0052\u006f\u0074\u0061\u0074\u0065\u0020\u0073\u0065t\u0020\u0074\u006f\u0020\u0030\u002e"));
_ddea =true ;if _dcaac (){return _ebdb ;};};};if !_daggg {_fgaff ,_bfgf :=_gd .GetDict (_cbec .Get ("\u0041\u0050"));if _bfgf {_cbgd :=_fgaff .Get ("\u004e");if _cbgd ==nil ||len (_fgaff .Keys ())> 1{_ebdb =append (_ebdb ,_ab ("\u0036.\u0033\u002e\u0033\u002d\u0032","\u0046\u006f\u0072\u0020\u0061\u006c\u006c\u0020\u0061\u006e\u006e\u006ft\u0061\u0074\u0069\u006f\u006e\u0020d\u0069\u0063t\u0069\u006f\u006ea\u0072\u0069\u0065\u0073 \u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0069\u006e\u0067\u0020\u0061\u006e\u0020\u0041\u0050 \u006b\u0065\u0079\u002c\u0020\u0074\u0068\u0065\u0020\u0061p\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0074\u0068\u0061\u0074\u0020\u0069\u0074\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0073\u0020\u0061\u0073\u0020it\u0073\u0020\u0076\u0061\u006cu\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0074\u0061i\u006e\u0020o\u006e\u006c\u0079\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u002e\u0020\u0049\u0066\u0020\u0061\u006e\u0020\u0061\u006e\u006e\u006f\u0074\u0061\u0074\u0069\u006f\u006e\u0020\u0064i\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0027\u0073\u0020\u0053\u0075\u0062ty\u0070\u0065\u0020\u006b\u0065\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0057\u0069\u0064g\u0065\u0074\u0020\u0061\u006e\u0064\u0020\u0069\u0074s\u0020\u0046\u0054 \u006be\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020B\u0074\u006e,\u0020\u0074he \u0076a\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0073\u0075\u0062\u0064\u0069\u0063\u0074\u0069\u006fn\u0061r\u0079; \u006f\u0074\u0068\u0065\u0072\u0077\u0069s\u0065\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020th\u0065\u0020N\u0020\u006b\u0065y\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062e\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061n\u0063\u0065\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u002e"));
_daggg =true ;if _dcaac (){return _ebdb ;};continue ;};_ ,_ffae :=_afbee .GetContext ().(*_b .PdfAnnotationWidget );if _ffae {_gfbc ,_ggbe :=_gd .GetName (_cbec .Get ("\u0046\u0054"));if _ggbe &&*_gfbc =="\u0042\u0074\u006e"{if _ ,_fbbbd :=_gd .GetDict (_cbgd );
!_fbbbd {_ebdb =append (_ebdb ,_ab ("\u0036.\u0033\u002e\u0033\u002d\u0032","\u0046\u006f\u0072\u0020\u0061\u006c\u006c\u0020\u0061\u006e\u006e\u006ft\u0061\u0074\u0069\u006f\u006e\u0020d\u0069\u0063t\u0069\u006f\u006ea\u0072\u0069\u0065\u0073 \u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0069\u006e\u0067\u0020\u0061\u006e\u0020\u0041\u0050 \u006b\u0065\u0079\u002c\u0020\u0074\u0068\u0065\u0020\u0061p\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0074\u0068\u0061\u0074\u0020\u0069\u0074\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0073\u0020\u0061\u0073\u0020it\u0073\u0020\u0076\u0061\u006cu\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0074\u0061i\u006e\u0020o\u006e\u006c\u0079\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u002e\u0020\u0049\u0066\u0020\u0061\u006e\u0020\u0061\u006e\u006e\u006f\u0074\u0061\u0074\u0069\u006f\u006e\u0020\u0064i\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0027\u0073\u0020\u0053\u0075\u0062ty\u0070\u0065\u0020\u006b\u0065\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0057\u0069\u0064g\u0065\u0074\u0020\u0061\u006e\u0064\u0020\u0069\u0074s\u0020\u0046\u0054 \u006be\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020B\u0074\u006e,\u0020\u0074he \u0076a\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0073\u0075\u0062\u0064\u0069\u0063\u0074\u0069\u006fn\u0061r\u0079; \u006f\u0074\u0068\u0065\u0072\u0077\u0069s\u0065\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020th\u0065\u0020N\u0020\u006b\u0065y\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062e\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061n\u0063\u0065\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u002e"));
_daggg =true ;if _dcaac (){return _ebdb ;};continue ;};};};_ ,_ecfgb :=_gd .GetStream (_cbgd );if !_ecfgb {_ebdb =append (_ebdb ,_ab ("\u0036.\u0033\u002e\u0033\u002d\u0032","\u0046\u006f\u0072\u0020\u0061\u006c\u006c\u0020\u0061\u006e\u006e\u006ft\u0061\u0074\u0069\u006f\u006e\u0020d\u0069\u0063t\u0069\u006f\u006ea\u0072\u0069\u0065\u0073 \u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0069\u006e\u0067\u0020\u0061\u006e\u0020\u0041\u0050 \u006b\u0065\u0079\u002c\u0020\u0074\u0068\u0065\u0020\u0061p\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0074\u0068\u0061\u0074\u0020\u0069\u0074\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0073\u0020\u0061\u0073\u0020it\u0073\u0020\u0076\u0061\u006cu\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0074\u0061i\u006e\u0020o\u006e\u006c\u0079\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u002e\u0020\u0049\u0066\u0020\u0061\u006e\u0020\u0061\u006e\u006e\u006f\u0074\u0061\u0074\u0069\u006f\u006e\u0020\u0064i\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0027\u0073\u0020\u0053\u0075\u0062ty\u0070\u0065\u0020\u006b\u0065\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0057\u0069\u0064g\u0065\u0074\u0020\u0061\u006e\u0064\u0020\u0069\u0074s\u0020\u0046\u0054 \u006be\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020B\u0074\u006e,\u0020\u0074he \u0076a\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0073\u0075\u0062\u0064\u0069\u0063\u0074\u0069\u006fn\u0061r\u0079; \u006f\u0074\u0068\u0065\u0072\u0077\u0069s\u0065\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020th\u0065\u0020N\u0020\u006b\u0065y\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062e\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061n\u0063\u0065\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u002e"));
_daggg =true ;if _dcaac (){return _ebdb ;};continue ;};};};_abfbg ,_ecga :=_afbee .GetContext ().(*_b .PdfAnnotationWidget );if !_ecga {continue ;};if !_ebacd {if _abfbg .A !=nil {_ebdb =append (_ebdb ,_ab ("\u0036.\u0034\u002e\u0031\u002d\u0031","A \u0057\u0069d\u0067\u0065\u0074\u0020\u0061\u006e\u006e\u006f\u0074a\u0074\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0069\u006ec\u006cu\u0064\u0065\u0020\u0061\u006e\u0020\u0041\u0020e\u006et\u0072\u0079."));
_ebacd =true ;if _dcaac (){return _ebdb ;};};};if !_gcab {if _abfbg .AA !=nil {_ebdb =append (_ebdb ,_ab ("\u0036.\u0034\u002e\u0031\u002d\u0031","\u0041\u0020\u0057\u0069\u0064\u0067\u0065\u0074\u0020\u0061\u006e\u006eo\u0074\u0061\u0074i\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061r\u0079\u0020\u0073h\u0061\u006c\u006c\u0020n\u006f\u0074\u0020\u0069\u006e\u0063\u006c\u0075\u0064\u0065\u0020\u0061\u006e\u0020\u0041\u0041\u0020\u0065\u006e\u0074\u0072\u0079\u0020\u0066\u006f\u0072\u0020\u0061\u006e\u0020\u0061d\u0064\u0069\u0074\u0069\u006f\u006e\u0061\u006c\u002d\u0061\u0063t\u0069\u006f\u006e\u0073\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002e"));
_gcab =true ;if _dcaac (){return _ebdb ;};};};};};return _ebdb ;};

// Profile1A is the implementation of the PDF/A-1A standard profile.
// Implements model.StandardImplementer, Profile interfaces.
type Profile1A struct{profile1 };func _effb (_bgda *_da .Document ,_gdee *_da .Page ,_fdaee []*_da .Image )error {for _ ,_gdbc :=range _fdaee {if _gdbc .SMask ==nil {continue ;};_ecbe ,_ecc :=_b .NewXObjectImageFromStream (_gdbc .Stream );if _ecc !=nil {return _ecc ;
};_efea ,_ecc :=_ecbe .ToImage ();if _ecc !=nil {return _ecc ;};_feg ,_ecc :=_efea .ToGoImage ();if _ecc !=nil {return _ecc ;};_afe ,_ecc :=_fg .RGBAConverter .Convert (_feg );if _ecc !=nil {return _ecc ;};_gbc :=_afe .Base ();_fgfb :=&_b .Image {Width :int64 (_gbc .Width ),Height :int64 (_gbc .Height ),BitsPerComponent :int64 (_gbc .BitsPerComponent ),ColorComponents :_gbc .ColorComponents ,Data :_gbc .Data };
_fgfb .SetDecode (_gbc .Decode );_fgfb .SetAlpha (_gbc .Alpha );if _ecc =_ecbe .SetImage (_fgfb ,nil );_ecc !=nil {return _ecc ;};_ecbe .SMask =_gd .MakeNull ();var _fagf _gd .PdfObject ;_gbce :=-1;for _gbce ,_fagf =range _bgda .Objects {if _fagf ==_gdbc .SMask .Stream {break ;
};};if _gbce !=-1{_bgda .Objects =append (_bgda .Objects [:_gbce ],_bgda .Objects [_gbce +1:]...);};_gdbc .SMask =nil ;_ecbe .ToPdfObject ();};return nil ;};

// DefaultProfile1Options are the default options for the Profile1.
func DefaultProfile1Options ()*Profile1Options {return &Profile1Options {Now :_f .Now ,Xmp :XmpOptions {MarshalIndent :"\u0009"}};};

// Profile1B is the implementation of the PDF/A-1B standard profile.
// Implements model.StandardImplementer, Profile interfaces.
type Profile1B struct{profile1 };func _edaa (_gaed *_b .CompliancePdfReader )(_efdb []ViolatedRule ){var _bcfdc ,_ffbc ,_adg bool ;if _gaed .ParserMetadata ().HasNonConformantStream (){_efdb =[]ViolatedRule {_ab ("\u0036.\u0031\u002e\u0037\u002d\u0031","T\u0068\u0065\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006b\u0065\u0079\u0077\u006fr\u0064\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065\u0020f\u006f\u006cl\u006fw\u0065\u0064\u0020e\u0069\u0074h\u0065\u0072\u0020\u0062\u0079\u0020\u0061 \u0043\u0041\u0052\u0052I\u0041\u0047\u0045\u0020\u0052E\u0054\u0055\u0052\u004e\u0020\u00280\u0044\u0068\u0029\u0020\u0061\u006e\u0064\u0020\u004c\u0049\u004e\u0045\u0020F\u0045\u0045\u0044\u0020\u0028\u0030\u0041\u0068\u0029\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u0073\u0065\u0071\u0075\u0065\u006e\u0063\u0065\u0020o\u0072\u0020\u0062\u0079\u0020\u0061 \u0073\u0069ng\u006c\u0065\u0020\u004cIN\u0045 \u0046\u0045\u0045\u0044 \u0063\u0068\u0061r\u0061\u0063\u0074\u0065\u0072\u002e\u0020T\u0068\u0065\u0020e\u006e\u0064\u0073\u0074r\u0065\u0061\u006d\u0020\u006b\u0065\u0079\u0077\u006fr\u0064\u0020\u0073\u0068\u0061\u006c\u006c \u0062e\u0020p\u0072\u0065\u0063\u0065\u0064\u0065\u0064\u0020\u0062\u0079\u0020\u0061n\u0020\u0045\u004f\u004c \u006d\u0061\u0072\u006b\u0065\u0072\u002e")};
};for _ ,_eedc :=range _gaed .GetObjectNums (){_cfa ,_ :=_gaed .GetIndirectObjectByNumber (_eedc );if _cfa ==nil {continue ;};_cdggg ,_ffgd :=_gd .GetStream (_cfa );if !_ffgd {continue ;};if !_bcfdc {_eecgc :=_cdggg .Get ("\u004c\u0065\u006e\u0067\u0074\u0068");
if _eecgc ==nil {_efdb =append (_efdb ,_ab ("\u0036.\u0031\u002e\u0037\u002d\u0032","\u006e\u006f\u0020'\u004c\u0065\u006e\u0067\u0074\u0068\u0027\u0020\u006b\u0065\u0079\u0020\u0066\u006f\u0075\u006e\u0064\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0073\u0074\u0072\u0065a\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074"));
_bcfdc =true ;}else {_dagbg ,_egfb :=_gd .GetIntVal (_eecgc );if !_egfb {_efdb =append (_efdb ,_ab ("\u0036.\u0031\u002e\u0037\u002d\u0032","s\u0074\u0072\u0065\u0061\u006d\u0020\u0027\u004c\u0065\u006e\u0067\u0074\u0068\u0027\u0020\u006b\u0065\u0079 \u0073\u0068\u006f\u0075\u006c\u0064\u0020\u0062\u0065\u0020an\u0020\u0069\u006et\u0065g\u0065\u0072"));
_bcfdc =true ;}else {if len (_cdggg .Stream )!=_dagbg {_efdb =append (_efdb ,_ab ("\u0036.\u0031\u002e\u0037\u002d\u0032","\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u006c\u0065\u006e\u0067th\u0020v\u0061\u006c\u0075\u0065\u0020\u0073\u0068\u006f\u0075\u006c\u0064\u0020m\u0061\u0074\u0063\u0068\u0020\u0074\u0068\u0065\u0020\u0073\u0069\u007a\u0065\u0020\u006f\u0066\u0020t\u0068\u0065\u0020\u0073\u0074\u0072\u0065\u0061\u006d"));
_bcfdc =true ;};};};};if !_ffbc {if _cdggg .Get ("\u0046")!=nil {_ffbc =true ;_efdb =append (_efdb ,_ab ("\u0036.\u0031\u002e\u0037\u002d\u0033","\u0073\u0074r\u0065\u0061\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0068\u006f\u0075\u006c\u0064\u0020\u006eo\u0074\u0020\u0063\u006f\u006e\u0074a\u0069\u006e\u0020\u0027\u0046\u0027\u002c\u0027\u0046\u0046\u0069\u006c\u0074\u0065r\u0027\u002c'\u0046\u0044\u0065\u0063o\u0064\u0065\u0050\u0061\u0072a\u006d\u0073\u0027\u0020\u006b\u0065\u0079"));
};if _cdggg .Get ("\u0046F\u0069\u006c\u0074\u0065\u0072")!=nil &&!_ffbc {_ffbc =true ;_efdb =append (_efdb ,_ab ("\u0036.\u0031\u002e\u0037\u002d\u0033","\u0073\u0074r\u0065\u0061\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0068\u006f\u0075\u006c\u0064\u0020\u006eo\u0074\u0020\u0063\u006f\u006e\u0074a\u0069\u006e\u0020\u0027\u0046\u0027\u002c\u0027\u0046\u0046\u0069\u006c\u0074\u0065r\u0027\u002c'\u0046\u0044\u0065\u0063o\u0064\u0065\u0050\u0061\u0072a\u006d\u0073\u0027\u0020\u006b\u0065\u0079"));
continue ;};if _cdggg .Get ("\u0046\u0044\u0065\u0063\u006f\u0064\u0065\u0050\u0061\u0072\u0061\u006d\u0073")!=nil &&!_ffbc {_ffbc =true ;_efdb =append (_efdb ,_ab ("\u0036.\u0031\u002e\u0037\u002d\u0033","\u0073\u0074r\u0065\u0061\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0068\u006f\u0075\u006c\u0064\u0020\u006eo\u0074\u0020\u0063\u006f\u006e\u0074a\u0069\u006e\u0020\u0027\u0046\u0027\u002c\u0027\u0046\u0046\u0069\u006c\u0074\u0065r\u0027\u002c'\u0046\u0044\u0065\u0063o\u0064\u0065\u0050\u0061\u0072a\u006d\u0073\u0027\u0020\u006b\u0065\u0079"));
continue ;};};if !_adg {_dagg ,_gdac :=_gd .GetName (_gd .TraceToDirectObject (_cdggg .Get ("\u0046\u0069\u006c\u0074\u0065\u0072")));if !_gdac {continue ;};if *_dagg ==_gd .StreamEncodingFilterNameLZW {_adg =true ;_efdb =append (_efdb ,_ab ("\u0036\u002e\u0031\u002e\u0031\u0030\u002d\u0031","\u0054h\u0065\u0020L\u005a\u0057\u0044\u0065c\u006f\u0064\u0065 \u0066\u0069\u006c\u0074\u0065\u0072\u0020\u0073\u0068al\u006c\u0020\u006eo\u0074\u0020b\u0065\u0020\u0070\u0065\u0072\u006di\u0074\u0074e\u0064\u002e"));
};};};return _efdb ;};func _fafae (_fbfc *_da .Document ,_cge standardType ,_eebf *_da .OutputIntents )error {var (_aff *_b .PdfOutputIntent ;_edgf error ;);if _fbfc .Version .Minor <=7{_aff ,_edgf =_aa .NewSRGBv2OutputIntent (_cge .outputIntentSubtype ());
}else {_aff ,_edgf =_aa .NewSRGBv4OutputIntent (_cge .outputIntentSubtype ());};if _edgf !=nil {return _edgf ;};if _edgf =_eebf .Add (_aff .ToPdfObject ());_edgf !=nil {return _edgf ;};return nil ;};func _bdgd (_egff standardType ,_bbfa *_da .OutputIntents )error {_fgaeg ,_dfed :=_aa .NewISOCoatedV2Gray1CBasOutputIntent (_egff .outputIntentSubtype ());
if _dfed !=nil {return _dfed ;};if _dfed =_bbfa .Add (_fgaeg .ToPdfObject ());_dfed !=nil {return _dfed ;};return nil ;};func _cbgc (_cccc *_b .CompliancePdfReader )ViolatedRule {for _ ,_bgfb :=range _cccc .GetObjectNums (){_fbfed ,_fdbc :=_cccc .GetIndirectObjectByNumber (_bgfb );
if _fdbc !=nil {continue ;};_edfca ,_ccdb :=_gd .GetStream (_fbfed );if !_ccdb {continue ;};_eacb ,_ccdb :=_gd .GetName (_edfca .Get ("\u0054\u0079\u0070\u0065"));if !_ccdb {continue ;};if *_eacb !="\u0058O\u0062\u006a\u0065\u0063\u0074"{continue ;};if _edfca .Get ("\u0053\u004d\u0061s\u006b")!=nil {return _ab ("\u0036\u002e\u0034-\u0032","\u0041\u006e\u0020\u0058\u004f\u0062\u006a\u0065\u0063\u0074\u0020\u0064\u0069\u0063\u0074i\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006eo\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074\u0068e \u0053\u004d\u0061\u0073\u006b\u0020\u006b\u0065\u0079\u002e");
};};return _fc ;};type imageInfo struct{ColorSpace _gd .PdfObjectName ;BitsPerComponent int ;ColorComponents int ;Width int ;Height int ;Stream *_gd .PdfObjectStream ;_gdd bool ;};func _dged (_cfc *_da .Document ,_egfc bool )error {_cga ,_bebg :=_cfc .GetPages ();
if !_bebg {return nil ;};for _ ,_agec :=range _cga {_dcg :=_agec .FindXObjectForms ();for _ ,_befe :=range _dcg {_fgad ,_bgaf :=_b .NewXObjectFormFromStream (_befe );if _bgaf !=nil {return _bgaf ;};_gacc ,_bgaf :=_fgad .GetContentStream ();if _bgaf !=nil {return _bgaf ;
};_cace :=_dc .NewContentStreamParser (string (_gacc ));_cee ,_bgaf :=_cace .Parse ();if _bgaf !=nil {return _bgaf ;};_cad ,_bgaf :=_aca (_fgad .Resources ,_cee ,_egfc );if _bgaf !=nil {return _bgaf ;};if len (_cad )==0{continue ;};if _bgaf =_fgad .SetContentStream (_cad ,_gd .NewFlateEncoder ());
_bgaf !=nil {return _bgaf ;};_fgad .ToPdfObject ();};};return nil ;};func _eadb (_dfcc *_b .CompliancePdfReader )(*_b .PdfOutputIntent ,bool ){_bccfb ,_aagd :=_cefb (_dfcc );if !_aagd {return nil ,false ;};_gbga ,_eeab :=_b .NewPdfOutputIntentFromPdfObject (_bccfb );
if _eeab !=nil {return nil ,false ;};return _gbga ,true ;};func _ggba (_fdfc *_b .PdfFont ,_ebag *_gd .PdfObjectDictionary ,_cebcg bool )ViolatedRule {const (_aadg ="\u0036\u002e\u0032\u002e\u0031\u0031\u002e\u0034\u002d\u0031";_bfae ="\u0054\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0020\u0070\u0072\u006f\u0067\u0072\u0061\u006ds\u0020\u0066\u006fr\u0020\u0061\u006c\u006c\u0020f\u006f\u006e\u0074\u0073\u0020\u0075\u0073\u0065\u0064\u0020\u0066\u006f\u0072\u0020\u0072e\u006e\u0064\u0065\u0072\u0069\u006eg\u0020\u0077\u0069\u0074\u0068\u0069\u006e\u0020\u0061\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065\u0064\u0020w\u0069t\u0068\u0069\u006e\u0020\u0074\u0068\u0061\u0074\u0020\u0066\u0069\u006c\u0065\u002c \u0061\u0073\u0020\u0064\u0065\u0066\u0069n\u0065\u0064 \u0069\u006e\u0020\u0049S\u004f\u0020\u0033\u0032\u00300\u0030\u002d\u0031\u003a\u0032\u0030\u0030\u0038\u002c\u0020\u0039\u002e\u0039\u002e";
);if _cebcg {return _fc ;};_gdgab :=_fdfc .FontDescriptor ();var _gefff string ;if _gabg ,_dfbfd :=_gd .GetName (_ebag .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_dfbfd {_gefff =_gabg .String ();};switch _gefff {case "\u0054\u0079\u0070e\u0031":if _gdgab .FontFile ==nil {return _ab (_aadg ,_bfae );
};case "\u0054\u0072\u0075\u0065\u0054\u0079\u0070\u0065":if _gdgab .FontFile2 ==nil {return _ab (_aadg ,_bfae );};case "\u0054\u0079\u0070e\u0030","\u0054\u0079\u0070e\u0033":default:if _gdgab .FontFile3 ==nil {return _ab (_aadg ,_bfae );};};return _fc ;
};var _ Profile =(*Profile1A )(nil );func _cefb (_dcgae *_b .CompliancePdfReader )(*_gd .PdfObjectDictionary ,bool ){_dcdbe ,_gfbba :=_dbce (_dcgae );if !_gfbba {return nil ,false ;};_cefec ,_gfbba :=_gd .GetArray (_dcdbe .Get ("\u004f\u0075\u0074\u0070\u0075\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0073"));
if !_gfbba {return nil ,false ;};if _cefec .Len ()==0{return nil ,false ;};return _gd .GetDict (_cefec .Get (0));};func _edcc (_gcde *_b .CompliancePdfReader )(_cgab ViolatedRule ){_eddd ,_cdgae :=_dbce (_gcde );if !_cdgae {return _fc ;};_eccd ,_cdgae :=_gd .GetDict (_eddd .Get ("\u0041\u0063\u0072\u006f\u0046\u006f\u0072\u006d"));
if !_cdgae {return _fc ;};_accbd ,_cdgae :=_gd .GetArray (_eccd .Get ("\u0046\u0069\u0065\u006c\u0064\u0073"));if !_cdgae {return _fc ;};for _dadb :=0;_dadb < _accbd .Len ();_dadb ++{_egcc ,_gedg :=_gd .GetDict (_accbd .Get (_dadb ));if !_gedg {continue ;
};if _egcc .Get ("\u0041\u0041")!=nil {return _ab ("\u0036.\u0036\u002e\u0032\u002d\u0032","\u0041\u0020F\u0069\u0065\u006cd\u0020\u0064\u0069\u0063\u0074i\u006f\u006e\u0061\u0072\u0079 s\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0069\u006e\u0063\u006c\u0075\u0064\u0065\u0020\u0061n\u0020A\u0041\u0020\u0065\u006e\u0074\u0072y f\u006f\u0072\u0020\u0061\u006e\u0020\u0061\u0064\u0064\u0069\u0074\u0069on\u0061l\u002d\u0061\u0063\u0074i\u006fn\u0073 \u0064\u0069c\u0074\u0069on\u0061\u0072\u0079\u002e");
};};return _fc ;};

// Profile2U is the implementation of the PDF/A-2U standard profile.
// Implements model.StandardImplementer, Profile interfaces.
type Profile2U struct{profile2 };func (_bg standardType )outputIntentSubtype ()_b .PdfOutputIntentType {switch _bg ._gb {case 1:return _b .PdfOutputIntentTypeA1 ;case 2:return _b .PdfOutputIntentTypeA2 ;case 3:return _b .PdfOutputIntentTypeA3 ;case 4:return _b .PdfOutputIntentTypeA4 ;
default:return 0;};};func _bbcee (_agag *_b .CompliancePdfReader )(_cfcd []ViolatedRule ){if _agag .ParserMetadata ().HasOddLengthHexStrings (){_cfcd =append (_cfcd ,_ab ("\u0036.\u0031\u002e\u0036\u002d\u0031","\u0068\u0065\u0078a\u0064\u0065\u0063\u0069\u006d\u0061\u006c\u0020\u0073\u0074\u0072\u0069\u006e\u0067\u0073\u0020\u0073\u0068\u006f\u0075\u006c\u0064\u0020\u0062\u0065\u0020\u006f\u0066\u0020e\u0076\u0065\u006e\u0020\u0073\u0069\u007a\u0065"));
};if _agag .ParserMetadata ().HasOddLengthHexStrings (){_cfcd =append (_cfcd ,_ab ("\u0036.\u0031\u002e\u0036\u002d\u0032","\u0068\u0065\u0078\u0061\u0064\u0065\u0063\u0069\u006da\u006c\u0020s\u0074\u0072\u0069\u006e\u0067\u0073\u0020\u0073\u0068o\u0075\u006c\u0064\u0020c\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u006f\u006e\u006c\u0079\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0073\u0020\u0066\u0072\u006f\u006d\u0020\u0072\u0061n\u0067\u0065\u0020[\u0030\u002d\u0039\u003b\u0041\u002d\u0046\u003b\u0061\u002d\u0066\u005d"));
};return _cfcd ;};var _ Profile =(*Profile2A )(nil );func _deba (_gbea *_da .Document ,_fcce bool )error {_bfd ,_cgd :=_gbea .GetPages ();if !_cgd {return nil ;};for _ ,_egd :=range _bfd {_fca ,_gef :=_egd .GetContents ();if !_gef {continue ;};var _dggd *_b .PdfPageResources ;
_eaeb ,_gef :=_egd .GetResources ();if _gef {_dggd ,_ =_b .NewPdfPageResourcesFromDict (_eaeb );};for _edg ,_cef :=range _fca {_fcgf ,_cgb :=_cef .GetData ();if _cgb !=nil {continue ;};_acbe :=_dc .NewContentStreamParser (string (_fcgf ));_cdgf ,_cgb :=_acbe .Parse ();
if _cgb !=nil {continue ;};_afbd ,_cgb :=_aca (_dggd ,_cdgf ,_fcce );if _cgb !=nil {return _cgb ;};if _afbd ==nil {continue ;};if _cgb =(&_fca [_edg ]).SetData (_afbd );_cgb !=nil {return _cgb ;};};};return nil ;};func _fdb (_abedg *_b .CompliancePdfReader )ViolatedRule {for _ ,_cbaa :=range _abedg .PageList {_gbeg :=_cbaa .GetContentStreamObjs ();
for _ ,_dfff :=range _gbeg {_dfff =_gd .TraceToDirectObject (_dfff );var _geee string ;switch _ggaf :=_dfff .(type ){case *_gd .PdfObjectString :_geee =_ggaf .Str ();case *_gd .PdfObjectStream :_bbac ,_fgba :=_gd .GetName (_gd .TraceToDirectObject (_ggaf .Get ("\u0046\u0069\u006c\u0074\u0065\u0072")));
if _fgba {if *_bbac ==_gd .StreamEncodingFilterNameLZW {return _ab ("\u0036\u002e\u0031\u002e\u0031\u0030\u002d\u0032","\u0054h\u0065\u0020L\u005a\u0057\u0044\u0065c\u006f\u0064\u0065 \u0066\u0069\u006c\u0074\u0065\u0072\u0020\u0073\u0068al\u006c\u0020\u006eo\u0074\u0020b\u0065\u0020\u0070\u0065\u0072\u006di\u0074\u0074e\u0064\u002e");
};};_fdag ,_dga :=_gd .DecodeStream (_ggaf );if _dga !=nil {_ae .Log .Debug ("\u0045r\u0072\u003a\u0020\u0025\u0076",_dga );continue ;};_geee =string (_fdag );default:_ae .Log .Debug ("\u0049\u006e\u0076\u0061\u006c\u0069d\u0020\u0063\u006f\u006e\u0074\u0065\u006e\u0074\u0020\u0073\u0074\u0072\u0065a\u006d\u0020\u006f\u0062\u006a\u0065\u0063t\u003a\u0020\u0025\u0054",_dfff );
continue ;};_cgfe :=_dc .NewContentStreamParser (_geee );_ccde ,_ebcc :=_cgfe .Parse ();if _ebcc !=nil {_ae .Log .Debug ("\u0049\u006e\u0076\u0061\u006c\u0069\u0064\u0020\u0063\u006f\u006et\u0065\u006e\u0074\u0020\u0073\u0074\u0072\u0065\u0061\u006d:\u0020\u0025\u0076",_ebcc );
continue ;};for _ ,_cbba :=range *_ccde {if !(_cbba .Operand =="\u0042\u0049"&&len (_cbba .Params )==1){continue ;};_dcff ,_eacg :=_cbba .Params [0].(*_dc .ContentStreamInlineImage );if !_eacg {continue ;};_daea ,_dcga :=_dcff .GetEncoder ();if _dcga !=nil {_ae .Log .Debug ("\u0067\u0065\u0074\u0074\u0069\u006e\u0067\u0020\u0069\u006e\u006c\u0069\u006ee\u0020\u0069\u006d\u0061\u0067\u0065 \u0065\u006e\u0063\u006f\u0064\u0065\u0072\u0020\u0066\u0061\u0069\u006c\u0065d\u003a\u0020\u0025\u0076",_dcga );
continue ;};if _daea .GetFilterName ()==_gd .StreamEncodingFilterNameLZW {return _ab ("\u0036\u002e\u0031\u002e\u0031\u0030\u002d\u0032","\u0054h\u0065\u0020L\u005a\u0057\u0044\u0065c\u006f\u0064\u0065 \u0066\u0069\u006c\u0074\u0065\u0072\u0020\u0073\u0068al\u006c\u0020\u006eo\u0074\u0020b\u0065\u0020\u0070\u0065\u0072\u006di\u0074\u0074e\u0064\u002e");
};};};};return _fc ;};

// DefaultProfile2Options are the default options for the Profile2.
func DefaultProfile2Options ()*Profile2Options {return &Profile2Options {Now :_f .Now ,Xmp :XmpOptions {MarshalIndent :"\u0009"}};};func _egfd (_daff *_da .Document )error {_ceaf ,_eeaa :=_daff .GetPages ();if !_eeaa {return nil ;};for _ ,_bdge :=range _ceaf {_gega :=_bdge .FindXObjectForms ();
for _ ,_bafb :=range _gega {_ddg ,_gad :=_gd .GetDict (_bafb .Get ("\u0047\u0072\u006fu\u0070"));if _gad {if _eeef :=_ddg .Get ("\u0053");_eeef !=nil {_eab ,_gadc :=_gd .GetName (_eeef );if _gadc &&_eab .String ()=="\u0054\u0072\u0061n\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079"{_bafb .Remove ("\u0047\u0072\u006fu\u0070");
};};};};_cce ,_fgcd :=_bdge .GetResourcesXObject ();if _fgcd {_dbff ,_gbd :=_gd .GetDict (_cce .Get ("\u0047\u0072\u006fu\u0070"));if _gbd {_dagb :=_dbff .Get ("\u0053");if _dagb !=nil {_fgbf ,_fdfa :=_gd .GetName (_dagb );if _fdfa &&_fgbf .String ()=="\u0054\u0072\u0061n\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079"{_cce .Remove ("\u0047\u0072\u006fu\u0070");
};};};};_bagg ,_caae :=_gd .GetDict (_bdge .Object .Get ("\u0047\u0072\u006fu\u0070"));if _caae {_gadf :=_bagg .Get ("\u0053");if _gadf !=nil {_bdce ,_geff :=_gd .GetName (_gadf );if _geff &&_bdce .String ()=="\u0054\u0072\u0061n\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079"{_bdge .Object .Remove ("\u0047\u0072\u006fu\u0070");
};};};};return nil ;};func _dfde (_aege *_da .Document )(*_gd .PdfObjectDictionary ,bool ){_dcca ,_degb :=_aege .FindCatalog ();if !_degb {return nil ,false ;};_ddeb ,_degb :=_gd .GetArray (_dcca .Object .Get ("\u004f\u0075\u0074\u0070\u0075\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0073"));
if !_degb {return nil ,false ;};if _ddeb .Len ()==0{return nil ,false ;};return _gd .GetDict (_ddeb .Get (0));};func _degc (_dagcg *_b .CompliancePdfReader )(_fdcfd []ViolatedRule ){var _bfc ,_ebdfa ,_dafd ,_ebcca ,_gccec ,_bceec ,_bgbgd bool ;_gdccc :=func ()bool {return _bfc &&_ebdfa &&_dafd &&_ebcca &&_gccec &&_bceec &&_bgbgd };
for _ ,_bgab :=range _dagcg .PageList {if _bgab .Resources ==nil {continue ;};_gdga ,_bdgg :=_gd .GetDict (_bgab .Resources .Font );if !_bdgg {continue ;};for _ ,_dbaf :=range _gdga .Keys (){_ddaa ,_fgadf :=_gd .GetDict (_gdga .Get (_dbaf ));if !_fgadf {if !_bfc {_fdcfd =append (_fdcfd ,_ab ("\u0036.\u0033\u002e\u0032\u002d\u0031","\u0041\u006c\u006c\u0020\u0066\u006fn\u0074\u0073\u0020\u0075\u0073e\u0064\u0020\u0069\u006e\u0020\u0061\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020c\u006f\u006e\u0066\u006f\u0072m\u0020\u0074\u006f\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0020\u0073\u0070\u0065\u0063\u0069\u0066\u0069\u0063\u0061\u0074\u0069\u006f\u006e\u0073\u0020d\u0065\u0066\u0069\u006e\u0065d \u0069\u006e\u0020\u0050\u0044\u0046\u0020\u0052\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0035\u002e\u0035\u002e"));
_bfc =true ;if _gdccc (){return _fdcfd ;};};continue ;};if _bgcaf ,_ged :=_gd .GetName (_ddaa .Get ("\u0054\u0079\u0070\u0065"));!_bfc &&(!_ged ||_bgcaf .String ()!="\u0046\u006f\u006e\u0074"){_fdcfd =append (_fdcfd ,_ab ("\u0036.\u0033\u002e\u0032\u002d\u0031","\u0054\u0079\u0070e\u0020\u002d\u0020\u006e\u0061\u006d\u0065\u0020\u002d\u0020\u0028\u0052\u0065\u0071\u0075i\u0072\u0065\u0064\u0029 Th\u0065\u0020\u0074\u0079\u0070\u0065\u0020\u006f\u0066 \u0050\u0044\u0046\u0020\u006fbj\u0065\u0063\u0074\u0020\u0074\u0068\u0061t\u0020\u0074\u0068\u0069s\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0064\u0065\u0073c\u0072\u0069\u0062\u0065\u0073\u003b\u0020\u006d\u0075\u0073t\u0020\u0062\u0065\u0020\u0046\u006f\u006e\u0074\u0020\u0066\u006fr\u0020\u0061\u0020\u0066\u006f\u006e\u0074\u0020\u0064\u0069\u0063t\u0069\u006f\u006e\u0061\u0072\u0079\u002e"));
_bfc =true ;if _gdccc (){return _fdcfd ;};};_afege ,_ggge :=_b .NewPdfFontFromPdfObject (_ddaa );if _ggge !=nil {continue ;};var _deaed string ;if _dgcff ,_bcgg :=_gd .GetName (_ddaa .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_bcgg {_deaed =_dgcff .String ();
};if !_ebdfa {switch _deaed {case "\u0054\u0079\u0070e\u0030","\u0054\u0079\u0070e\u0031","\u004dM\u0054\u0079\u0070\u0065\u0031","\u0054\u0072\u0075\u0065\u0054\u0079\u0070\u0065","\u0043\u0049\u0044F\u006f\u006e\u0074\u0054\u0079\u0070\u0065\u0030","\u0043\u0049\u0044F\u006f\u006e\u0074\u0054\u0079\u0070\u0065\u0032":default:_ebdfa =true ;
_fdcfd =append (_fdcfd ,_ab ("\u0036.\u0033\u002e\u0032\u002d\u0032","\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0020\u002d\u0020\u006e\u0061\u006d\u0065\u0020\u002d\u0020\u0028\u0052\u0065\u0071\u0075\u0069\u0072\u0065d\u0029\u0020\u0054\u0068e \u0074\u0079\u0070\u0065 \u006f\u0066\u0020\u0066\u006f\u006et\u003b\u0020\u006d\u0075\u0073\u0074\u0020b\u0065\u0020\u0022\u0054\u0079\u0070\u0065\u0031\u0022\u0020f\u006f\u0072\u0020\u0054\u0079\u0070\u0065\u0020\u0031\u0020f\u006f\u006e\u0074\u0073\u002c\u0020\u0022\u004d\u004d\u0054\u0079\u0070\u0065\u0031\u0022\u0020\u0066\u006f\u0072\u0020\u006d\u0075\u006c\u0074\u0069\u0070\u006c\u0065\u0020\u006da\u0073\u0074e\u0072\u0020\u0066\u006f\u006e\u0074s\u002c\u0020\u0022\u0054\u0072\u0075\u0065T\u0079\u0070\u0065\u0022\u0020\u0066\u006f\u0072\u0020\u0054\u0072\u0075\u0065T\u0079\u0070\u0065\u0020\u0066\u006f\u006e\u0074\u0073\u0020\u0022\u0054\u0079\u0070\u0065\u0033\u0022\u0020\u0066\u006f\u0072\u0020\u0054\u0079\u0070e\u0020\u0033\u0020\u0066\u006f\u006e\u0074\u0073\u002c\u0020\"\u0054\u0079\u0070\u0065\u0030\"\u0020\u0066\u006f\u0072\u0020\u0054\u0079\u0070\u0065\u0020\u0030\u0020\u0066\u006f\u006e\u0074\u0073\u0020\u0061\u006ed\u0020\u0022\u0043\u0049\u0044\u0046\u006fn\u0074\u0054\u0079\u0070\u0065\u0030\u0022 \u006f\u0072\u0020\u0022\u0043\u0049\u0044\u0046\u006f\u006e\u0074T\u0079\u0070e\u0032\u0022\u0020\u0066\u006f\u0072\u0020\u0043\u0049\u0044\u0020\u0066\u006f\u006e\u0074\u0073\u002e"));
if _gdccc (){return _fdcfd ;};};};if !_dafd {if _deaed !="\u0054\u0079\u0070e\u0033"{_aecgd ,_fbgb :=_gd .GetName (_ddaa .Get ("\u0042\u0061\u0073\u0065\u0046\u006f\u006e\u0074"));if !_fbgb ||_aecgd .String ()==""{_fdcfd =append (_fdcfd ,_ab ("\u0036.\u0033\u002e\u0032\u002d\u0033","B\u0061\u0073\u0065\u0046\u006f\u006e\u0074\u0020\u002d\u0020\u006e\u0061\u006d\u0065\u0020\u002d\u0020\u0028\u0052\u0065\u0071\u0075\u0069\u0072\u0065\u0064)\u0020T\u0068\u0065\u0020\u0050o\u0073\u0074S\u0063\u0072\u0069\u0070\u0074\u0020\u006e\u0061\u006d\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u002e"));
_dafd =true ;if _gdccc (){return _fdcfd ;};};};};if _deaed !="\u0054\u0079\u0070e\u0031"{continue ;};_ebdfe :=_ee .IsStdFont (_ee .StdFontName (_afege .BaseFont ()));if _ebdfe {continue ;};_degcf ,_fdda :=_gd .GetIntVal (_ddaa .Get ("\u0046i\u0072\u0073\u0074\u0043\u0068\u0061r"));
if !_fdda &&!_ebcca {_fdcfd =append (_fdcfd ,_ab ("\u0036.\u0033\u002e\u0032\u002d\u0034","\u0046\u0069r\u0073t\u0043\u0068\u0061\u0072\u0020\u002d\u0020\u0069\u006e\u0074\u0065\u0067\u0065\u0072\u0020\u002d\u0020\u0028\u0052\u0065\u0071\u0075i\u0072\u0065\u0064\u0020\u0065\u0078\u0063\u0065\u0070t\u0020\u0066\u006f\u0072\u0020\u0074h\u0065\u0020\u0073\u0074\u0061\u006e\u0064\u0061\u0072d\u0020\u0031\u0034\u0020\u0066\u006f\u006e\u0074\u0073\u0029\u0020\u0054\u0068\u0065\u0020\u0066\u0069\u0072\u0073\u0074\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u0063\u006f\u0064e\u0020\u0064\u0065\u0066i\u006ee\u0064\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0027\u0073\u0020\u0057i\u0064\u0074\u0068\u0073 \u0061r\u0072\u0061y\u002e"));
_ebcca =true ;if _gdccc (){return _fdcfd ;};};_begc ,_gbgc :=_gd .GetIntVal (_ddaa .Get ("\u004c\u0061\u0073\u0074\u0043\u0068\u0061\u0072"));if !_gbgc &&!_gccec {_fdcfd =append (_fdcfd ,_ab ("\u0036.\u0033\u002e\u0032\u002d\u0035","\u004c\u0061\u0073t\u0043\u0068\u0061\u0072\u0020\u002d\u0020\u0069n\u0074\u0065\u0067e\u0072 \u002d\u0020\u0028\u0052\u0065\u0071u\u0069\u0072\u0065d\u0020\u0065\u0078\u0063\u0065\u0070\u0074\u0020\u0066\u006f\u0072\u0020t\u0068\u0065 s\u0074\u0061\u006e\u0064\u0061\u0072\u0064\u0020\u0031\u0034\u0020\u0066\u006f\u006ets\u0029\u0020\u0054\u0068\u0065\u0020\u006c\u0061\u0073t\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u0063\u006f\u0064\u0065\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0027\u0073\u0020\u0057\u0069\u0064\u0074h\u0073\u0020\u0061\u0072\u0072\u0061\u0079\u002e"));
_gccec =true ;if _gdccc (){return _fdcfd ;};};if !_bceec {_decg ,_gceg :=_gd .GetArray (_ddaa .Get ("\u0057\u0069\u0064\u0074\u0068\u0073"));if !_gceg ||!_fdda ||!_gbgc ||_decg .Len ()!=_begc -_degcf +1{_fdcfd =append (_fdcfd ,_ab ("\u0036.\u0033\u002e\u0032\u002d\u0036","\u0057\u0069\u0064\u0074\u0068\u0073\u0020\u002d a\u0072\u0072\u0061y \u002d\u0020\u0028\u0052\u0065\u0071\u0075\u0069\u0072\u0065\u0064\u0020\u0065\u0078\u0063\u0065\u0070t\u0020\u0066\u006f\u0072\u0020\u0074\u0068\u0065\u0020\u0073\u0074a\u006e\u0064a\u0072\u0064\u00201\u0034\u0020\u0066\u006f\u006e\u0074\u0073\u003b\u0020\u0069\u006ed\u0069\u0072\u0065\u0063\u0074\u0020\u0072\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0070\u0072\u0065\u0066e\u0072\u0072e\u0064\u0029\u0020\u0041\u006e \u0061\u0072\u0072\u0061\u0079\u0020\u006f\u0066\u0020\u0028\u004c\u0061\u0073\u0074\u0043\u0068\u0061\u0072\u0020\u2212 F\u0069\u0072\u0073\u0074\u0043\u0068\u0061\u0072\u0020\u002b\u00201\u0029\u0020\u0077\u0069\u0064\u0074\u0068\u0073."));
_bceec =true ;if _gdccc (){return _fdcfd ;};};};};};return _fdcfd ;};func _bgbb (_ebccc *_b .CompliancePdfReader )(_dcag ViolatedRule ){for _ ,_eabb :=range _ebccc .GetObjectNums (){_gbeab ,_cdcee :=_ebccc .GetIndirectObjectByNumber (_eabb );if _cdcee !=nil {continue ;
};_eaab ,_bgbbc :=_gd .GetStream (_gbeab );if !_bgbbc {continue ;};_faeb ,_bgbbc :=_gd .GetName (_eaab .Get ("\u0054\u0079\u0070\u0065"));if !_bgbbc {continue ;};if *_faeb !="\u0058O\u0062\u006a\u0065\u0063\u0074"{continue ;};_ddef ,_bgbbc :=_gd .GetName (_eaab .Get ("\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0032"));
if !_bgbbc {continue ;};if *_ddef =="\u0050\u0053"{return _ab ("\u0036.\u0032\u002e\u0035\u002d\u0031","A\u0020\u0066\u006fr\u006d\u0020\u0058\u004f\u0062\u006a\u0065\u0063\u0074\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006ft\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e \u0074\u0068\u0065\u0020\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0032\u0020\u006b\u0065\u0079 \u0077\u0069\u0074\u0068\u0020a\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0050\u0053\u0020o\u0072\u0020\u0074\u0068e\u0020\u0050\u0053\u0020\u006b\u0065\u0079\u002e");
};if _eaab .Get ("\u0050\u0053")!=nil {return _ab ("\u0036.\u0032\u002e\u0035\u002d\u0031","A\u0020\u0066\u006fr\u006d\u0020\u0058\u004f\u0062\u006a\u0065\u0063\u0074\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006ft\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e \u0074\u0068\u0065\u0020\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0032\u0020\u006b\u0065\u0079 \u0077\u0069\u0074\u0068\u0020a\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0050\u0053\u0020o\u0072\u0020\u0074\u0068e\u0020\u0050\u0053\u0020\u006b\u0065\u0079\u002e");
};};return _dcag ;};func (_gbeb *documentImages )hasOnlyDeviceRGB ()bool {return _gbeb ._ce &&!_gbeb ._ff &&!_gbeb ._ad };func _dcda (_egcg *_b .CompliancePdfReader )(_bgca []ViolatedRule ){if _egcg .ParserMetadata ().HasOddLengthHexStrings (){_bgca =append (_bgca ,_ab ("\u0036.\u0031\u002e\u0036\u002d\u0031","\u0068\u0065\u0078a\u0064\u0065\u0063\u0069\u006d\u0061\u006c\u0020\u0073\u0074\u0072\u0069\u006e\u0067\u0073\u0020\u0073\u0068\u006f\u0075\u006c\u0064\u0020\u0062\u0065\u0020\u006f\u0066\u0020e\u0076\u0065\u006e\u0020\u0073\u0069\u007a\u0065"));
};if _egcg .ParserMetadata ().HasOddLengthHexStrings (){_bgca =append (_bgca ,_ab ("\u0036.\u0031\u002e\u0036\u002d\u0032","\u0068\u0065\u0078\u0061\u0064\u0065\u0063\u0069\u006da\u006c\u0020s\u0074\u0072\u0069\u006e\u0067\u0073\u0020\u0073\u0068o\u0075\u006c\u0064\u0020c\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u006f\u006e\u006c\u0079\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0073\u0020\u0066\u0072\u006f\u006d\u0020\u0072\u0061n\u0067\u0065\u0020[\u0030\u002d\u0039\u003b\u0041\u002d\u0046\u003b\u0061\u002d\u0066\u005d"));
};return _bgca ;};var _ Profile =(*Profile2B )(nil );func _fcbfa (_fcbg *_b .CompliancePdfReader )ViolatedRule {for _ ,_afbbe :=range _fcbg .PageList {_ceba ,_dbeg :=_afbbe .GetContentStreams ();if _dbeg !=nil {continue ;};for _ ,_gddag :=range _ceba {_gbcc :=_dc .NewContentStreamParser (_gddag );
_ ,_dbeg =_gbcc .Parse ();if _dbeg !=nil {return _ab ("\u0036\u002e\u0032\u002e\u0031\u0030\u002d\u0031","\u0041\u0020\u0063onten\u0074\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u0073\u0068\u0061\u006c\u006c n\u006f\u0074\u0020c\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u006e\u0079 \u006f\u0070\u0065\u0072\u0061\u0074\u006f\u0072\u0073\u0020\u006e\u006ft\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0069\u006e\u0020\u0050\u0044\u0046\u0020\u0052\u0065f\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0065\u0076\u0065\u006e\u0020\u0069\u0066\u0020s\u0075\u0063\u0068\u0020\u006f\u0070\u0065r\u0061\u0074\u006f\u0072\u0073\u0020\u0061\u0072\u0065\u0020\u0062\u0072\u0061\u0063\u006b\u0065\u0074\u0065\u0064\u0020\u0062\u0079\u0020\u0074\u0068\u0065\u0020\u0042\u0058\u002f\u0045\u0058\u0020\u0063\u006f\u006d\u0070\u0061\u0074\u0069\u0062i\u006c\u0069\u0074\u0079\u0020\u006f\u0070\u0065\u0072\u0061\u0074\u006f\u0072\u0073\u002e");
};};};return _fc ;};func _ceef (_cdfa *_b .CompliancePdfReader )(_acggf []ViolatedRule ){for _ ,_dddd :=range _cdfa .GetObjectNums (){_dgac ,_efcb :=_cdfa .GetIndirectObjectByNumber (_dddd );if _efcb !=nil {continue ;};_abfd ,_eeagb :=_gd .GetDict (_dgac );
if !_eeagb {continue ;};_ecdfa ,_eeagb :=_gd .GetName (_abfd .Get ("\u0054\u0079\u0070\u0065"));if !_eeagb {continue ;};if _ecdfa .String ()!="\u0041\u0063\u0072\u006f\u0046\u006f\u0072\u006d"{continue ;};_acbbf ,_eeagb :=_gd .GetBool (_abfd .Get ("\u004ee\u0065d\u0041\u0070\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0073"));
if !_eeagb {return _acggf ;};if bool (*_acbbf ){_acggf =append (_acggf ,_ab ("\u0036\u002e\u0039-\u0031","\u0054\u0068\u0065\u0020\u004e\u0065e\u0064\u0041\u0070\u0070\u0065a\u0072\u0061\u006e\u0063\u0065\u0073\u0020\u0066\u006c\u0061\u0067\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0069\u006e\u0074\u0065\u0072\u0061\u0063\u0074\u0069\u0076e\u0020\u0066\u006f\u0072\u006d \u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0065\u0069\u0074\u0068\u0065\u0072\u0020\u006e\u006f\u0074\u0020b\u0065\u0020\u0070\u0072\u0065se\u006e\u0074\u0020\u006f\u0072\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0066\u0061\u006c\u0073\u0065\u002e"));
};};return _acggf ;};type imageModifications struct{_gfb *colorspaceModification ;_abg _gd .StreamEncoder ;};func _bcac (_cebcc *_b .PdfFont ,_acfb *_gd .PdfObjectDictionary )ViolatedRule {const (_cecc ="\u0036.\u0033\u002e\u0035\u002d\u0032";_bafe ="\u0046\u006f\u0072\u0020\u0061l\u006c\u0020\u0054\u0079\u0070\u0065\u0020\u0031\u0020\u0066\u006f\u006e\u0074 \u0073\u0075bs\u0065\u0074\u0073 \u0072\u0065\u0066e\u0072\u0065\u006e\u0063\u0065\u0064\u0020\u0077\u0069\u0074\u0068\u0069\u006e\u0020\u0061\u0020\u0063\u006fn\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u002c\u0020\u0074he\u0020f\u006f\u006e\u0074\u0020\u0064\u0065s\u0063r\u0069\u0070\u0074o\u0072\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0069\u006ec\u006c\u0075\u0064e\u0020\u0061\u0020\u0043\u0068\u0061\u0072\u0053\u0065\u0074\u0020\u0073\u0074\u0072\u0069\u006e\u0067\u0020\u006c\u0069\u0073\u0074\u0069\u006e\u0067\u0020\u0074\u0068\u0065\u0020\u0063\u0068\u0061\u0072a\u0063\u0074\u0065\u0072 \u006e\u0061\u006d\u0065\u0073\u0020d\u0065\u0066i\u006e\u0065\u0064\u0020i\u006e\u0020\u0074\u0068\u0065\u0020f\u006f\u006e\u0074\u0020s\u0075\u0062\u0073\u0065\u0074, \u0061\u0073 \u0064\u0065s\u0063\u0072\u0069\u0062\u0065\u0064\u0020\u0069\u006e \u0050\u0044\u0046\u0020\u0052e\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0054\u0061\u0062\u006ce\u0020\u0035\u002e1\u0038\u002e";
);var _gggc string ;if _gaged ,_edgb :=_gd .GetName (_acfb .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_edgb {_gggc =_gaged .String ();};if _gggc !="\u0054\u0079\u0070e\u0031"{return _fc ;};if _ee .IsStdFont (_ee .StdFontName (_cebcc .BaseFont ())){return _fc ;
};_dedc :=_cebcc .FontDescriptor ();if _dedc .CharSet ==nil {return _ab (_cecc ,_bafe );};return _fc ;};func _ffdf (_bfcb *_b .PdfFont ,_bcaad *_gd .PdfObjectDictionary )ViolatedRule {const (_abdee ="\u0036.\u0033\u002e\u0037\u002d\u0032";_abeaf ="\u0041l\u006c\u0020\u0073\u0079\u006d\u0062\u006f\u006c\u0069\u0063\u0020\u0054\u0072u\u0065\u0054\u0079p\u0065\u0020\u0066\u006f\u006e\u0074s\u0020\u0073h\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0073\u0070\u0065\u0063\u0069\u0066\u0079\u0020\u0061\u006e\u0020\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067\u0020\u0065n\u0074\u0072\u0079\u0020\u0069n\u0020\u0074\u0068e\u0020\u0066\u006f\u006e\u0074 \u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002e";
);var _gdfe string ;if _bbff ,_gcceb :=_gd .GetName (_bcaad .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_gcceb {_gdfe =_bbff .String ();};if _gdfe !="\u0054\u0072\u0075\u0065\u0054\u0079\u0070\u0065"{return _fc ;};_dfdeb :=_bfcb .FontDescriptor ();
_cafb ,_cceec :=_gd .GetIntVal (_dfdeb .Flags );if !_cceec {_ae .Log .Debug ("\u0066\u006c\u0061\u0067\u0073 \u006e\u006f\u0074\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0066o\u0072\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0020\u0064\u0065\u0073\u0063\u0072\u0069\u0070\u0074\u006f\u0072");
return _ab (_abdee ,_abeaf );};_agdd :=(uint32 (_cafb )>>3)&1;_dbfb :=_agdd !=0;if !_dbfb {return _fc ;};if _bcaad .Get ("\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067")!=nil {return _ab (_abdee ,_abeaf );};return _fc ;};func _geef (_efdbe *_b .CompliancePdfReader )(_ggga []ViolatedRule ){var _cdbgb ,_cdab ,_bgbgf ,_fdef ,_ebfce ,_fcee ,_aaec bool ;
_cggee :=func ()bool {return _cdbgb &&_cdab &&_bgbgf &&_fdef &&_ebfce &&_fcee &&_aaec };for _ ,_cdfb :=range _efdbe .PageList {_bgcc ,_abcc :=_cdfb .GetAnnotations ();if _abcc !=nil {_ae .Log .Trace ("\u006c\u006f\u0061\u0064\u0069\u006e\u0067\u0020\u0061\u006en\u006f\u0074\u0061\u0074\u0069\u006f\u006es\u0020\u0066\u0061\u0069\u006c\u0065\u0064\u003a\u0020\u0025\u0076",_abcc );
continue ;};for _ ,_agab :=range _bgcc {if !_cdbgb {switch _agab .GetContext ().(type ){case *_b .PdfAnnotationFileAttachment ,*_b .PdfAnnotationSound ,*_b .PdfAnnotationMovie ,nil :_ggga =append (_ggga ,_ab ("\u0036.\u0035\u002e\u0032\u002d\u0031","\u0041\u006e\u006e\u006f\u0074\u0061\u0074\u0069\u006f\u006e\u0020\u0074\u0079\u0070\u0065\u0073\u0020\u006e\u006f\u0074 \u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020i\u006e\u0020\u0050\u0044\u0046\u0020\u0052\u0065\u0066\u0065\u0072\u0065\u006ec\u0065\u0020\u0073\u0068\u0061l\u006c\u0020\u006e\u006f\u0074 \u0062\u0065\u0020p\u0065\u0072m\u0069\u0074\u0074\u0065\u0064\u002e\u0020\u0041d\u0064\u0069\u0074\u0069\u006f\u006e\u0061\u006c\u006c\u0079\u002c\u0020\u0074\u0068\u0065\u0020F\u0069\u006c\u0065\u0041\u0074\u0074\u0061\u0063\u0068\u006de\u006e\u0074\u002c\u0020\u0053\u006f\u0075\u006e\u0064\u0020\u0061\u006e\u0064\u0020\u004d\u006f\u0076\u0069e\u0020\u0074\u0079\u0070\u0065s \u0073ha\u006c\u006c\u0020\u006eo\u0074\u0020\u0062\u0065\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074\u0065\u0064\u002e"));
_cdbgb =true ;if _cggee (){return _ggga ;};};};_ccfc ,_ebfcd :=_gd .GetDict (_agab .GetContainingPdfObject ());if !_ebfcd {continue ;};if !_cdab {_eedcg ,_cdafb :=_gd .GetFloatVal (_ccfc .Get ("\u0043\u0041"));if _cdafb &&_eedcg !=1.0{_ggga =append (_ggga ,_ab ("\u0036.\u0035\u002e\u0033\u002d\u0031","\u0041\u006e\u0020\u0061\u006e\u006e\u006ft\u0061\u0074\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073h\u0061\u006c\u006c\u0020\u006eo\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e \u0074\u0068\u0065\u0020\u0043\u0041\u0020\u006b\u0065\u0079\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0074\u0068\u0065\u0072\u0020\u0074\u0068\u0061\u006e\u0020\u0031\u002e\u0030\u002e"));
_cdab =true ;if _cggee (){return _ggga ;};};};if !_bgbgf {_aabe ,_bddg :=_gd .GetIntVal (_ccfc .Get ("\u0046"));if !(_bddg &&_aabe &4==4&&_aabe &1==0&&_aabe &2==0&&_aabe &32==0){_ggga =append (_ggga ,_ab ("\u0036.\u0035\u002e\u0033\u002d\u0032","\u0041\u006e\u0020\u0061\u006e\u006e\u006f\u0074\u0061\u0074i\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079 \u0073\u0068\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0074\u0061\u0069n\u0020\u0074\u0068\u0065\u0020\u0046\u0020\u006b\u0065\u0079\u002e\u0020\u0054\u0068\u0065\u0020\u0046\u0020\u006b\u0065\u0079\u0027\u0073\u0020\u0050\u0072\u0069\u006e\u0074\u0020\u0066\u006c\u0061\u0067\u0020\u0062\u0069\u0074\u0020\u0073h\u0061\u006c\u006c\u0020\u0062\u0065 s\u0065\u0074\u0020\u0074\u006f\u0020\u0031\u0020\u0061\u006e\u0064\u0020\u0069\u0074\u0073\u0020\u0048\u0069\u0064\u0064\u0065\u006e\u002c\u0020I\u006e\u0076\u0069\u0073\u0069\u0062\u006c\u0065\u0020\u0061\u006e\u0064\u0020\u004e\u006f\u0056\u0069\u0065\u0077\u0020\u0066\u006c\u0061\u0067\u0020b\u0069\u0074\u0073 \u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0073e\u0074\u0020t\u006f\u0020\u0030\u002e"));
_bgbgf =true ;if _cggee (){return _ggga ;};};};if !_fdef {_bcfdd ,_cbagg :=_gd .GetDict (_ccfc .Get ("\u0041\u0050"));if _cbagg {_bfcd :=_bcfdd .Get ("\u004e");if _bfcd ==nil ||len (_bcfdd .Keys ())> 1{_ggga =append (_ggga ,_ab ("\u0036.\u0035\u002e\u0033\u002d\u0034","\u0046\u006f\u0072\u0020\u0061\u006c\u006c\u0020\u0061\u006e\u006e\u006ft\u0061\u0074\u0069\u006f\u006e\u0020d\u0069\u0063t\u0069\u006f\u006ea\u0072\u0069\u0065\u0073 \u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0069\u006e\u0067\u0020\u0061\u006e\u0020\u0041\u0050 \u006b\u0065\u0079\u002c\u0020\u0074\u0068\u0065\u0020\u0061p\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0074\u0068\u0061\u0074\u0020\u0069\u0074\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0073\u0020\u0061\u0073\u0020it\u0073\u0020\u0076\u0061\u006cu\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0074\u0061i\u006e\u0020o\u006e\u006c\u0079\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u002e\u0020\u0049\u0066\u0020\u0061\u006e\u0020\u0061\u006e\u006e\u006f\u0074\u0061\u0074\u0069\u006f\u006e\u0020\u0064i\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0027\u0073\u0020\u0053\u0075\u0062ty\u0070\u0065\u0020\u006b\u0065\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0057\u0069\u0064g\u0065\u0074\u0020\u0061\u006e\u0064\u0020\u0069\u0074s\u0020\u0046\u0054 \u006be\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020B\u0074\u006e,\u0020\u0074he \u0076a\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0073\u0075\u0062\u0064\u0069\u0063\u0074\u0069\u006fn\u0061r\u0079; \u006f\u0074\u0068\u0065\u0072\u0077\u0069s\u0065\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020th\u0065\u0020N\u0020\u006b\u0065y\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062e\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061n\u0063\u0065\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u002e"));
_fdef =true ;if _cggee (){return _ggga ;};continue ;};_ ,_bbbdf :=_agab .GetContext ().(*_b .PdfAnnotationWidget );if _bbbdf {_eaae ,_faae :=_gd .GetName (_ccfc .Get ("\u0046\u0054"));if _faae &&*_eaae =="\u0042\u0074\u006e"{if _ ,_agde :=_gd .GetDict (_bfcd );
!_agde {_ggga =append (_ggga ,_ab ("\u0036.\u0035\u002e\u0033\u002d\u0034","\u0046\u006f\u0072\u0020\u0061\u006c\u006c\u0020\u0061\u006e\u006e\u006ft\u0061\u0074\u0069\u006f\u006e\u0020d\u0069\u0063t\u0069\u006f\u006ea\u0072\u0069\u0065\u0073 \u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0069\u006e\u0067\u0020\u0061\u006e\u0020\u0041\u0050 \u006b\u0065\u0079\u002c\u0020\u0074\u0068\u0065\u0020\u0061p\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0074\u0068\u0061\u0074\u0020\u0069\u0074\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0073\u0020\u0061\u0073\u0020it\u0073\u0020\u0076\u0061\u006cu\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0074\u0061i\u006e\u0020o\u006e\u006c\u0079\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u002e\u0020\u0049\u0066\u0020\u0061\u006e\u0020\u0061\u006e\u006e\u006f\u0074\u0061\u0074\u0069\u006f\u006e\u0020\u0064i\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0027\u0073\u0020\u0053\u0075\u0062ty\u0070\u0065\u0020\u006b\u0065\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0057\u0069\u0064g\u0065\u0074\u0020\u0061\u006e\u0064\u0020\u0069\u0074s\u0020\u0046\u0054 \u006be\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020B\u0074\u006e,\u0020\u0074he \u0076a\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0073\u0075\u0062\u0064\u0069\u0063\u0074\u0069\u006fn\u0061r\u0079; \u006f\u0074\u0068\u0065\u0072\u0077\u0069s\u0065\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020th\u0065\u0020N\u0020\u006b\u0065y\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062e\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061n\u0063\u0065\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u002e"));
_fdef =true ;if _cggee (){return _ggga ;};continue ;};};};_ ,_ffdgc :=_gd .GetStream (_bfcd );if !_ffdgc {_ggga =append (_ggga ,_ab ("\u0036.\u0035\u002e\u0033\u002d\u0034","\u0046\u006f\u0072\u0020\u0061\u006c\u006c\u0020\u0061\u006e\u006e\u006ft\u0061\u0074\u0069\u006f\u006e\u0020d\u0069\u0063t\u0069\u006f\u006ea\u0072\u0069\u0065\u0073 \u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0069\u006e\u0067\u0020\u0061\u006e\u0020\u0041\u0050 \u006b\u0065\u0079\u002c\u0020\u0074\u0068\u0065\u0020\u0061p\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0074\u0068\u0061\u0074\u0020\u0069\u0074\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0073\u0020\u0061\u0073\u0020it\u0073\u0020\u0076\u0061\u006cu\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0074\u0061i\u006e\u0020o\u006e\u006c\u0079\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u002e\u0020\u0049\u0066\u0020\u0061\u006e\u0020\u0061\u006e\u006e\u006f\u0074\u0061\u0074\u0069\u006f\u006e\u0020\u0064i\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0027\u0073\u0020\u0053\u0075\u0062ty\u0070\u0065\u0020\u006b\u0065\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0057\u0069\u0064g\u0065\u0074\u0020\u0061\u006e\u0064\u0020\u0069\u0074s\u0020\u0046\u0054 \u006be\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020B\u0074\u006e,\u0020\u0074he \u0076a\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0073\u0075\u0062\u0064\u0069\u0063\u0074\u0069\u006fn\u0061r\u0079; \u006f\u0074\u0068\u0065\u0072\u0077\u0069s\u0065\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020th\u0065\u0020N\u0020\u006b\u0065y\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062e\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061n\u0063\u0065\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u002e"));
_fdef =true ;if _cggee (){return _ggga ;};continue ;};};};if !_ebfce {if _ccfc .Get ("\u0043")!=nil ||_ccfc .Get ("\u0049\u0043")!=nil {_agcfe ,_gdgc :=_cefb (_efdbe );if !_gdgc {_ggga =append (_ggga ,_ab ("\u0036.\u0035\u002e\u0033\u002d\u0033","\u0041\u006e\u0020\u0061\u006e\u006e\u006f\u0074\u0061\u0074\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006ea\u0072\u0079\u0020\u0073\u0068\u0061l\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006fn\u0074a\u0069\u006e\u0020t\u0068e\u0020\u0043\u0020\u0061\u0072\u0072\u0061\u0079\u0020\u006f\u0072\u0020\u0074\u0068e\u0020\u0049\u0043\u0020\u0061\u0072\u0072\u0061\u0079\u0020\u0075\u006e\u006c\u0065\u0073\u0073\u0020\u0074\u0068\u0065\u0020\u0063o\u006c\u006f\u0072\u0020\u0073\u0070\u0061\u0063\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0044\u0065\u0073\u0074\u004f\u0075\u0074\u0070\u0075\u0074\u0050\u0072\u006ff\u0069\u006ce\u0020\u0069\u006e\u0020\u0074h\u0065\u0020\u0050\u0044\u0046\u002f\u0041\u002d\u0031\u0020\u004f\u0075\u0074\u0070\u0075\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0020\u0064\u0069\u0063t\u0069\u006f\u006e\u0061\u0072\u0079\u002c\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0069n\u0020\u0036\u002e\u0032\u002e2\u002c\u0020\u0069\u0073\u0020\u0052\u0047\u0042."));
_ebfce =true ;if _cggee (){return _ggga ;};}else {_gecf ,_dcfab :=_gd .GetIntVal (_agcfe .Get ("\u004e"));if !_dcfab ||_gecf !=3{_ggga =append (_ggga ,_ab ("\u0036.\u0035\u002e\u0033\u002d\u0033","\u0041\u006e\u0020\u0061\u006e\u006e\u006f\u0074\u0061\u0074\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006ea\u0072\u0079\u0020\u0073\u0068\u0061l\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006fn\u0074a\u0069\u006e\u0020t\u0068e\u0020\u0043\u0020\u0061\u0072\u0072\u0061\u0079\u0020\u006f\u0072\u0020\u0074\u0068e\u0020\u0049\u0043\u0020\u0061\u0072\u0072\u0061\u0079\u0020\u0075\u006e\u006c\u0065\u0073\u0073\u0020\u0074\u0068\u0065\u0020\u0063o\u006c\u006f\u0072\u0020\u0073\u0070\u0061\u0063\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0044\u0065\u0073\u0074\u004f\u0075\u0074\u0070\u0075\u0074\u0050\u0072\u006ff\u0069\u006ce\u0020\u0069\u006e\u0020\u0074h\u0065\u0020\u0050\u0044\u0046\u002f\u0041\u002d\u0031\u0020\u004f\u0075\u0074\u0070\u0075\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0020\u0064\u0069\u0063t\u0069\u006f\u006e\u0061\u0072\u0079\u002c\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0069n\u0020\u0036\u002e\u0032\u002e2\u002c\u0020\u0069\u0073\u0020\u0052\u0047\u0042."));
_ebfce =true ;if _cggee (){return _ggga ;};};};};};_aebega ,_ddfdd :=_agab .GetContext ().(*_b .PdfAnnotationWidget );if !_ddfdd {continue ;};if !_fcee {if _aebega .A !=nil {_ggga =append (_ggga ,_ab ("\u0036.\u0036\u002e\u0031\u002d\u0033","A \u0057\u0069d\u0067\u0065\u0074\u0020\u0061\u006e\u006e\u006f\u0074a\u0074\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0069\u006ec\u006cu\u0064\u0065\u0020\u0061\u006e\u0020\u0041\u0020e\u006et\u0072\u0079."));
_fcee =true ;if _cggee (){return _ggga ;};};};if !_aaec {if _aebega .AA !=nil {_ggga =append (_ggga ,_ab ("\u0036.\u0036\u002e\u0032\u002d\u0031","\u0041\u0020\u0057\u0069\u0064\u0067\u0065\u0074\u0020\u0061\u006e\u006eo\u0074\u0061\u0074i\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061r\u0079\u0020\u0073h\u0061\u006c\u006c\u0020n\u006f\u0074\u0020\u0069\u006e\u0063\u006c\u0075\u0064\u0065\u0020\u0061\u006e\u0020\u0041\u0041\u0020\u0065\u006e\u0074\u0072\u0079\u0020\u0066\u006f\u0072\u0020\u0061\u006e\u0020\u0061d\u0064\u0069\u0074\u0069\u006f\u006e\u0061\u006c\u002d\u0061\u0063t\u0069\u006f\u006e\u0073\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002e"));
_aaec =true ;if _cggee (){return _ggga ;};};};};};return _ggga ;};type standardType struct{_gb int ;_dcd string ;};

// Profile is the model.StandardImplementer enhanced by the information about the profile conformance level.
type Profile interface{_b .StandardImplementer ;Conformance ()string ;Part ()int ;};func _bdgec (_gdaf *_b .CompliancePdfReader )(_eaag ViolatedRule ){for _ ,_dbaef :=range _gdaf .GetObjectNums (){_bdddc ,_gbdc :=_gdaf .GetIndirectObjectByNumber (_dbaef );
if _gbdc !=nil {continue ;};_cfedc ,_cfedg :=_gd .GetStream (_bdddc );if !_cfedg {continue ;};_edbdc ,_cfedg :=_gd .GetName (_cfedc .Get ("\u0054\u0079\u0070\u0065"));if !_cfedg {continue ;};if *_edbdc !="\u0058O\u0062\u006a\u0065\u0063\u0074"{continue ;
};_ ,_cfedg =_gd .GetName (_cfedc .Get ("\u004f\u0050\u0049"));if _cfedg {return _ab ("\u0036.\u0032\u002e\u0039\u002d\u0031","\u0041\u0020\u0066\u006f\u0072m\u0020\u0058\u004f\u0062\u006a\u0065c\u0074\u0020\u0064i\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006ft\u0020\u0063\u006f\u006e\u0074\u0061\u0069n\u0020\u0061\u006e\u0079\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006c\u006c\u006f\u0077\u0069\u006e\u0067\u003a \u002d\u0020\u0074\u0068\u0065\u0020O\u0050\u0049\u0020\u006b\u0065\u0079\u003b \u002d\u0020\u0074\u0068e \u0053u\u0062\u0074\u0079\u0070\u0065\u0032 ke\u0079 \u0077\u0069t\u0068\u0020\u0061\u0020\u0076\u0061l\u0075\u0065\u0020\u006f\u0066\u0020\u0050\u0053\u003b\u0020\u002d \u0074\u0068\u0065\u0020\u0050\u0053\u0020\u006b\u0065\u0079\u002e");
};_feeff ,_cfedg :=_gd .GetName (_cfedc .Get ("\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0032"));if !_cfedg {continue ;};if *_feeff =="\u0050\u0053"{return _ab ("\u0036.\u0032\u002e\u0039\u002d\u0031","\u0041\u0020\u0066\u006f\u0072m\u0020\u0058\u004f\u0062\u006a\u0065c\u0074\u0020\u0064i\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006ft\u0020\u0063\u006f\u006e\u0074\u0061\u0069n\u0020\u0061\u006e\u0079\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006c\u006c\u006f\u0077\u0069\u006e\u0067\u003a \u002d\u0020\u0074\u0068\u0065\u0020O\u0050\u0049\u0020\u006b\u0065\u0079\u003b \u002d\u0020\u0074\u0068e \u0053u\u0062\u0074\u0079\u0070\u0065\u0032 ke\u0079 \u0077\u0069t\u0068\u0020\u0061\u0020\u0076\u0061l\u0075\u0065\u0020\u006f\u0066\u0020\u0050\u0053\u003b\u0020\u002d \u0074\u0068\u0065\u0020\u0050\u0053\u0020\u006b\u0065\u0079\u002e");
};if _cfedc .Get ("\u0050\u0053")!=nil {return _ab ("\u0036.\u0032\u002e\u0039\u002d\u0031","\u0041\u0020\u0066\u006f\u0072m\u0020\u0058\u004f\u0062\u006a\u0065c\u0074\u0020\u0064i\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006ft\u0020\u0063\u006f\u006e\u0074\u0061\u0069n\u0020\u0061\u006e\u0079\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006c\u006c\u006f\u0077\u0069\u006e\u0067\u003a \u002d\u0020\u0074\u0068\u0065\u0020O\u0050\u0049\u0020\u006b\u0065\u0079\u003b \u002d\u0020\u0074\u0068e \u0053u\u0062\u0074\u0079\u0070\u0065\u0032 ke\u0079 \u0077\u0069t\u0068\u0020\u0061\u0020\u0076\u0061l\u0075\u0065\u0020\u006f\u0066\u0020\u0050\u0053\u003b\u0020\u002d \u0074\u0068\u0065\u0020\u0050\u0053\u0020\u006b\u0065\u0079\u002e");
};};return _eaag ;};func _ecdg (_bbf *_da .Document )error {_afg ,_edf :=_bbf .FindCatalog ();if !_edf {return _age .New ("\u0063\u0061\u0074\u0061\u006c\u006f\u0067\u0020\u006e\u006f\u0074\u0020f\u006f\u0075\u006e\u0064");};_afg .SetVersion ();return nil ;
};

// Part gets the PDF/A version level.
func (_affd *profile1 )Part ()int {return _affd ._gaeg ._gb };func _eda (_fbee *_da .Document )error {_dgfd ,_geea :=_fbee .GetPages ();if !_geea {return nil ;};for _ ,_abgc :=range _dgfd {_acad ,_bde :=_gd .GetArray (_abgc .Object .Get ("\u0041\u006e\u006e\u006f\u0074\u0073"));
if !_bde {continue ;};for _ ,_ggc :=range _acad .Elements (){_ggc =_gd .ResolveReference (_ggc );if _ ,_bgac :=_ggc .(*_gd .PdfObjectNull );_bgac {continue ;};_cbac ,_agc :=_gd .GetDict (_ggc );if !_agc {continue ;};_bccf ,_ :=_gd .GetIntVal (_cbac .Get ("\u0046"));
_bccf &=^(1<<0);_bccf &=^(1<<1);_bccf &=^(1<<5);_bccf |=1<<2;_cbac .Set ("\u0046",_gd .MakeInteger (int64 (_bccf )));_cgce :=false ;if _fae :=_cbac .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065");_fae !=nil {_fbgc ,_caef :=_gd .GetName (_fae );if _caef &&_fbgc .String ()=="\u0057\u0069\u0064\u0067\u0065\u0074"{_cgce =true ;
if _cbac .Get ("\u0041\u0041")!=nil {_cbac .Remove ("\u0041\u0041");};};};if _cbac .Get ("\u0043")!=nil ||_cbac .Get ("\u0049\u0043")!=nil {_dfba ,_gcf :=_dfde (_fbee );if !_gcf {_cbac .Remove ("\u0043");_cbac .Remove ("\u0049\u0043");}else {_ffee ,_fafb :=_gd .GetIntVal (_dfba .Get ("\u004e"));
if !_fafb ||_ffee !=3{_cbac .Remove ("\u0043");_cbac .Remove ("\u0049\u0043");};};};_dfbc ,_agc :=_gd .GetDict (_cbac .Get ("\u0041\u0050"));if _agc {_bcfd :=_dfbc .Get ("\u004e");if _bcfd ==nil {continue ;};if len (_dfbc .Keys ())> 1{_dfbc .Clear ();_dfbc .Set ("\u004e",_bcfd );
};if _cgce {_gcag ,_dcbe :=_gd .GetName (_cbac .Get ("\u0046\u0054"));if _dcbe &&*_gcag =="\u0042\u0074\u006e"{continue ;};};};};};return nil ;};